/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ce=function(te){for(var e=[],D=0,F=te.length;D<F;D++)e[D]=ae[te[D]];return e};define(ae[123],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class D{static get(){const j=new Map,A=new Map,I=new Map,R=new Map;function S(l,$){l.has($.detail)||l.set($.detail,-$.timestamp)}function d(l,$){const p=l.get($.detail);p&&(p>=0||l.set($.detail,p+$.timestamp))}let P=[];typeof te=="function"&&typeof te.getStats=="function"&&(P=te.getStats().slice(0).sort((l,$)=>l.timestamp-$.timestamp));for(const l of P)switch(l.type){case 10:S(j,l);break;case 11:case 12:d(j,l);break;case 21:S(A,l);break;case 22:d(A,l);break;case 33:S(I,l);break;case 34:d(I,l);break;case 31:S(R,l);break;case 32:d(R,l);break}let E=0;I.forEach(l=>E+=l);function b(l){const $=[];return l.forEach((p,w)=>$.push([w,p])),$}return{amdLoad:b(j),amdInvoke:b(A),nodeRequire:b(I),nodeEval:b(R),nodeRequireTotal:E}}static toMarkdownTable(j,A){let I="";const R=[];return j.forEach((S,d)=>{R[d]=S.length}),A.forEach(S=>{S.forEach((d,P)=>{typeof d>"u"&&(d=S[P]="-");const E=d.toString().length;R[P]=Math.max(E,R[P])})}),j.forEach((S,d)=>{I+=`| ${S+" ".repeat(R[d]-S.toString().length)} `}),I+=`|
`,j.forEach((S,d)=>{I+=`| ${"-".repeat(R[d])} `}),I+=`|
`,A.forEach(S=>{S.forEach((d,P)=>{typeof d<"u"&&(I+=`| ${d+" ".repeat(R[P]-d.toString().length)} `)}),I+=`|
`}),I}}e.$T=D}),define(ae[124],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function D(p,w,c){const u=F(p,w);if(u!==-1)return p[u]}e.$eb=D;function F(p,w,c=p.length-1){for(let u=c;u>=0;u--){const f=p[u];if(w(f))return u}return-1}e.$fb=F;function j(p,w){const c=A(p,w);return c===-1?void 0:p[c]}e.$gb=j;function A(p,w,c=0,u=p.length){let f=c,m=u;for(;f<m;){const k=Math.floor((f+m)/2);w(p[k])?f=k+1:m=k}return f-1}e.$hb=A;function I(p,w){const c=R(p,w);return c===p.length?void 0:p[c]}e.$ib=I;function R(p,w,c=0,u=p.length){let f=c,m=u;for(;f<m;){const k=Math.floor((f+m)/2);w(p[k])?m=k:f=k+1}return f}e.$jb=R;function S(p,w,c=0,u=p.length){const f=R(p,w,c,u);return f===p.length?-1:f}e.$kb=S;class d{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(d.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!w(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const c=A(this.e,w,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$lb=d;function P(p,w){if(p.length===0)return;let c=p[0];for(let u=1;u<p.length;u++){const f=p[u];w(f,c)>0&&(c=f)}return c}e.$mb=P;function E(p,w){if(p.length===0)return;let c=p[0];for(let u=1;u<p.length;u++){const f=p[u];w(f,c)>=0&&(c=f)}return c}e.$nb=E;function b(p,w){return P(p,(c,u)=>-w(c,u))}e.$ob=b;function l(p,w){if(p.length===0)return-1;let c=0;for(let u=1;u<p.length;u++){const f=p[u];w(f,p[c])>0&&(c=u)}return c}e.$pb=l;function $(p,w){for(const c of p){const u=w(c);if(u!==void 0)return u}}e.$qb=$}),define(ae[125],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function D(I,R){const S=Object.create(null);for(const d of I){const P=R(d);let E=S[P];E||(E=S[P]=[]),E.push(d)}return S}e.$J=D;function F(I,R){const S=[],d=[];for(const P of I)R.has(P)||S.push(P);for(const P of R)I.has(P)||d.push(P);return{removed:S,added:d}}e.$K=F;function j(I,R){const S=[],d=[];for(const[P,E]of I)R.has(P)||S.push(E);for(const[P,E]of R)I.has(P)||d.push(E);return{removed:S,added:d}}e.$L=j;function A(I,R){const S=new Set;for(const d of R)I.has(d)&&S.add(d);return S}e.$M=A}),define(ae[84],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function D(I){return(R,S,d)=>{let P=null,E=null;if(typeof d.value=="function"?(P="value",E=d.value):typeof d.get=="function"&&(P="get",E=d.get),!E)throw new Error("not supported");d[P]=I(E,S)}}function F(I,R,S){let d=null,P=null;if(typeof S.value=="function"?(d="value",P=S.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(d="get",P=S.get),!P)throw new Error("not supported");const E=`$memoize$${R}`;S[d]=function(...b){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,b)}),this[E]}}e.$ih=F;function j(I,R,S){return D((d,P)=>{const E=`$debounce$${P}`,b=`$debounce$result$${P}`;return function(...l){this[b]||(this[b]=S?S():void 0),clearTimeout(this[E]),R&&(this[b]=R(this[b],...l),l=[this[b]]),this[E]=setTimeout(()=>{d.apply(this,l),this[b]=S?S():void 0},I)}})}e.$jh=j;function A(I,R,S){return D((d,P)=>{const E=`$throttle$timer$${P}`,b=`$throttle$result$${P}`,l=`$throttle$lastRun$${P}`,$=`$throttle$pending$${P}`;return function(...p){if(this[b]||(this[b]=S?S():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),R&&(this[b]=R(this[b],...p)),this[$])return;const w=this[l]+I;w<=Date.now()?(this[l]=Date.now(),d.apply(this,[this[b]]),this[b]=S?S():void 0):(this[$]=!0,this[E]=setTimeout(()=>{this[$]=!1,this[l]=Date.now(),d.apply(this,[this[b]]),this[b]=S?S():void 0},w-Date.now()))}})}e.$kh=A}),define(ae[7],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class D{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?f.isErrorNoTelemetry(s)?new f(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(a=>{a(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.$V=D,e.$W=new D;function F(k){e.$W.setUnexpectedErrorHandler(k)}e.setUnexpectedErrorHandler=F;function j(k){if(!k||typeof k!="object")return!1;const s=k;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.$Y=j;function A(k){d(k)||e.$W.onUnexpectedError(k)}e.$Z=A;function I(k){d(k)||e.$W.onUnexpectedExternalError(k)}e.$1=I;function R(k){if(k instanceof Error){const{name:s,message:a}=k,n=k.stacktrace||k.stack;return{$isError:!0,name:s,message:a,stack:n,noTelemetry:f.isErrorNoTelemetry(k)}}return k}e.$2=R;const S="Canceled";function d(k){return k instanceof P?!0:k instanceof Error&&k.name===S&&k.message===S}e.$3=d;class P extends Error{constructor(){super(S),this.name=this.message}}e.$4=P;function E(){const k=new Error(S);return k.name=k.message,k}e.$5=E;function b(k){return k?new Error(`Illegal argument: ${k}`):new Error("Illegal argument")}e.$6=b;function l(k){return k?new Error(`Illegal state: ${k}`):new Error("Illegal state")}e.$7=l;class $ extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=$;function p(k){return k?k.message?k.message:k.stack?k.stack.split(`
`)[0]:String(k):"Error"}e.$9=p;class w extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.$0=w;class c extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.$$=c;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=u;class f extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof f)return s;const a=new f;return a.message=s.message,a.stack=s.stack,a}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.$ab=f;class m extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.$bb=m}),define(ae[18],ce([0,1,7,124]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function j(N,W=0){return N[N.length-(1+W)]}e.$rb=j;function A(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.$sb=A;function I(N,W,G=(ie,oe)=>ie===oe){if(N===W)return!0;if(!N||!W||N.length!==W.length)return!1;for(let ie=0,oe=N.length;ie<oe;ie++)if(!G(N[ie],W[ie]))return!1;return!0}e.$tb=I;function R(N,W){const G=N.length-1;W<G&&(N[W]=N[G]),N.pop()}e.$ub=R;function S(N,W,G){return d(N.length,ie=>G(N[ie],W))}e.$vb=S;function d(N,W){let G=0,ie=N-1;for(;G<=ie;){const oe=(G+ie)/2|0,ue=W(oe);if(ue<0)G=oe+1;else if(ue>0)ie=oe-1;else return oe}return-(G+1)}e.$wb=d;function P(N,W,G){if(N=N|0,N>=W.length)throw new TypeError("invalid index");const ie=W[Math.floor(W.length*Math.random())],oe=[],ue=[],he=[];for(const $e of W){const de=G($e,ie);de<0?oe.push($e):de>0?ue.push($e):he.push($e)}return N<oe.length?P(N,oe,G):N<oe.length+he.length?he[0]:P(N-(oe.length+he.length),ue,G)}e.$xb=P;function E(N,W){const G=[];let ie;for(const oe of N.slice(0).sort(W))!ie||W(ie[0],oe)!==0?(ie=[oe],G.push(ie)):ie.push(oe);return G}e.$yb=E;function*b(N,W){let G,ie;for(const oe of N)ie!==void 0&&W(ie,oe)?G.push(oe):(G&&(yield G),G=[oe]),ie=oe;G&&(yield G)}e.$zb=b;function l(N,W){for(let G=0;G<=N.length;G++)W(G===0?void 0:N[G-1],G===N.length?void 0:N[G])}e.$Ab=l;function $(N,W){for(let G=0;G<N.length;G++)W(G===0?void 0:N[G-1],N[G],G+1===N.length?void 0:N[G+1])}e.$Bb=$;function p(N,W,G){const ie=[];function oe($e,de,we){if(de===0&&we.length===0)return;const ve=ie[ie.length-1];ve&&ve.start+ve.deleteCount===$e?(ve.deleteCount+=de,ve.toInsert.push(...we)):ie.push({start:$e,deleteCount:de,toInsert:we})}let ue=0,he=0;for(;;){if(ue===N.length){oe(ue,0,W.slice(he));break}if(he===W.length){oe(ue,N.length-ue,[]);break}const $e=N[ue],de=W[he],we=G($e,de);we===0?(ue+=1,he+=1):we<0?(oe(ue,1,[]),ue+=1):we>0&&(oe(ue,0,[de]),he+=1)}return ie}e.$Cb=p;function w(N,W,G){const ie=p(N,W,G),oe=[],ue=[];for(const he of ie)oe.push(...N.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:oe,added:ue}}e.$Db=w;function c(N,W,G){if(G===0)return[];const ie=N.slice(0,G).sort(W);return f(N,W,ie,G,N.length),ie}e.top=c;function u(N,W,G,ie,oe){return G===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const $e=N.length,de=N.slice(0,G).sort(W);for(let we=G,ve=Math.min(G+ie,$e);we<$e;we=ve,ve=Math.min(ve+ie,$e)){if(we>G&&await new Promise(Ie=>setTimeout(Ie)),oe&&oe.isCancellationRequested)throw new D.$4;f(N,W,de,we,ve)}return de})().then(ue,he)})}e.$Fb=u;function f(N,W,G,ie,oe){for(const ue=G.length;ie<oe;ie++){const he=N[ie];if(W(he,G[ue-1])<0){G.pop();const $e=(0,F.$jb)(G,de=>W(he,de)<0);G.splice($e,0,he)}}}function m(N){return N.filter(W=>!!W)}e.$Gb=m;function k(N){let W=0;for(let G=0;G<N.length;G++)N[G]&&(N[W]=N[G],W+=1);N.length=W}e.$Hb=k;function s(N,W,G){N.splice(G,0,N.splice(W,1)[0])}e.$Ib=s;function a(N){return!Array.isArray(N)||N.length===0}e.$Jb=a;function n(N){return Array.isArray(N)&&N.length>0}e.$Kb=n;function i(N,W=G=>G){const G=new Set;return N.filter(ie=>{const oe=W(ie);return G.has(oe)?!1:(G.add(oe),!0)})}e.$Lb=i;function t(N){const W=new Set;return G=>{const ie=N(G);return W.has(ie)?!1:(W.add(ie),!0)}}e.$Mb=t;function r(N,W){return N.length>0?N[0]:W}e.$Nb=r;function o(N,W){return N.length>0?N[N.length-1]:W}e.$Ob=o;function v(N,W,G=(ie,oe)=>ie===oe){let ie=0;for(let oe=0,ue=Math.min(N.length,W.length);oe<ue&&G(N[oe],W[oe]);oe++)ie++;return ie}e.$Pb=v;function y(N){return[].concat(...N)}e.$Qb=y;function h(N,W){let G=typeof W=="number"?N:0;typeof W=="number"?G=N:(G=0,W=N);const ie=[];if(G<=W)for(let oe=G;oe<W;oe++)ie.push(oe);else for(let oe=G;oe>W;oe--)ie.push(oe);return ie}e.$Rb=h;function g(N,W,G){return N.reduce((ie,oe)=>(ie[W(oe)]=G?G(oe):oe,ie),Object.create(null))}e.$Sb=g;function O(N,W){return N.push(W),()=>T(N,W)}e.$Tb=O;function T(N,W){const G=N.indexOf(W);if(G>-1)return N.splice(G,1),W}e.$Ub=T;function M(N,W,G){const ie=N.slice(0,W),oe=N.slice(W);return ie.concat(G,oe)}e.$Vb=M;function U(N,W){let G;if(typeof W=="number"){let ie=W;G=()=>{const oe=Math.sin(ie++)*179426549;return oe-Math.floor(oe)}}else G=Math.random;for(let ie=N.length-1;ie>0;ie-=1){const oe=Math.floor(G()*(ie+1)),ue=N[ie];N[ie]=N[oe],N[oe]=ue}}e.$Wb=U;function z(N,W){const G=N.indexOf(W);G>-1&&(N.splice(G,1),N.unshift(W))}e.$Xb=z;function Z(N,W){const G=N.indexOf(W);G>-1&&(N.splice(G,1),N.push(W))}e.$Yb=Z;function X(N,W){for(const G of W)N.push(G)}e.$Zb=X;function x(N,W){return Array.isArray(N)?N.map(W):W(N)}e.$1b=x;function H(N){return Array.isArray(N)?N:[N]}e.$2b=H;function K(N){return N[Math.floor(Math.random()*N.length)]}e.$3b=K;function J(N,W,G){const ie=ee(N,W),oe=N.length,ue=G.length;N.length=oe+ue;for(let he=oe-1;he>=ie;he--)N[he+ue]=N[he];for(let he=0;he<ue;he++)N[he+ie]=G[he]}e.$4b=J;function V(N,W,G,ie){const oe=ee(N,W);let ue=N.splice(oe,G);return ue===void 0&&(ue=[]),J(N,oe,ie),ue}e.$5b=V;function ee(N,W){return W<0?Math.max(W+N.length,0):Math.min(W,N.length)}var ne;(function(N){function W(ue){return ue<0}N.isLessThan=W;function G(ue){return ue<=0}N.isLessThanOrEqual=G;function ie(ue){return ue>0}N.isGreaterThan=ie;function oe(ue){return ue===0}N.isNeitherLessOrGreaterThan=oe,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(ne||(e.CompareResult=ne={}));function _(N,W){return(G,ie)=>W(N(G),N(ie))}e.$6b=_;function se(...N){return(W,G)=>{for(const ie of N){const oe=ie(W,G);if(!ne.isNeitherLessOrGreaterThan(oe))return oe}return ne.neitherLessOrGreaterThan}}e.$7b=se;const Q=(N,W)=>N-W;e.$8b=Q;const q=(N,W)=>(0,e.$8b)(N?1:0,W?1:0);e.$9b=q;function C(N){return(W,G)=>-N(W,G)}e.$0b=C;class L{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let G=this.c;for(;G<this.g.length&&W(this.g[G]);)G++;const ie=G===this.c?null:this.g.slice(this.c,G);return this.c=G,ie}takeFromEndWhile(W){let G=this.d;for(;G>=0&&W(this.g[G]);)G--;const ie=G===this.d?null:this.g.slice(G+1,this.d+1);return this.d=G,ie}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const G=this.g.slice(this.c,this.c+W);return this.c+=W,G}}e.$$b=L;class B{static{this.empty=new B(W=>{})}constructor(W){this.iterate=W}forEach(W){this.iterate(G=>(W(G),!0))}toArray(){const W=[];return this.iterate(G=>(W.push(G),!0)),W}filter(W){return new B(G=>this.iterate(ie=>W(ie)?G(ie):!0))}map(W){return new B(G=>this.iterate(ie=>G(W(ie))))}some(W){let G=!1;return this.iterate(ie=>(G=W(ie),!G)),G}findFirst(W){let G;return this.iterate(ie=>W(ie)?(G=ie,!1):!0),G}findLast(W){let G;return this.iterate(ie=>(W(ie)&&(G=ie),!0)),G}findLastMaxBy(W){let G,ie=!0;return this.iterate(oe=>((ie||ne.isGreaterThan(W(oe,G)))&&(ie=!1,G=oe),!0)),G}}e.$_b=B}),define(ae[126],ce([0,1,7]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function F(S,d){if(!S)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}e.ok=F;function j(S,d="Unreachable"){throw new Error(d)}e.$3c=j;function A(S){if(!S)throw new D.$bb("Assertion Failed")}e.$4c=A;function I(S){if(!S()){debugger;S(),(0,D.$Z)(new D.$bb("Assertion Failed"))}}e.$5c=I;function R(S,d){let P=0;for(;P<S.length-1;){const E=S[P],b=S[P+1];if(!d(E,b))return!1;P++}return!0}e.$6c=R}),define(ae[85],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function D(F){const j=this;let A=!1,I;return function(){return A||(A=!0,I=F.apply(j,arguments)),I}}e.$cb=D}),define(ae[60],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(F){function j(k){return k&&typeof k=="object"&&typeof k[Symbol.iterator]=="function"}F.is=j;const A=Object.freeze([]);function I(){return A}F.empty=I;function*R(k){yield k}F.single=R;function S(k){return j(k)?k:R(k)}F.wrap=S;function d(k){return k||A}F.from=d;function*P(k){for(let s=k.length-1;s>=0;s--)yield k[s]}F.reverse=P;function E(k){return!k||k[Symbol.iterator]().next().done===!0}F.isEmpty=E;function b(k){return k[Symbol.iterator]().next().value}F.first=b;function l(k,s){for(const a of k)if(s(a))return!0;return!1}F.some=l;function $(k,s){for(const a of k)if(s(a))return a}F.find=$;function*p(k,s){for(const a of k)s(a)&&(yield a)}F.filter=p;function*w(k,s){let a=0;for(const n of k)yield s(n,a++)}F.map=w;function*c(...k){for(const s of k)for(const a of s)yield a}F.concat=c;function u(k,s,a){let n=a;for(const i of k)n=s(n,i);return n}F.reduce=u;function*f(k,s,a=k.length){for(s<0&&(s+=k.length),a<0?a+=k.length:a>k.length&&(a=k.length);s<a;s++)yield k[s]}F.slice=f;function m(k,s=Number.POSITIVE_INFINITY){const a=[];if(s===0)return[a,k];const n=k[Symbol.iterator]();for(let i=0;i<s;i++){const t=n.next();if(t.done)return[a,F.empty()];a.push(t.value)}return[a,{[Symbol.iterator](){return n}}]}F.consume=m})(D||(e.Iterable=D={}))}),define(ae[35],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var F;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var j;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(j||(e.ParseErrorCode=j={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function I(s,a=!1){let n=0;const i=s.length;let t="",r=0,o=16,v=0;function y(z){let Z=0,X=0;for(;Z<z;){const x=s.charCodeAt(n);if(x>=48&&x<=57)X=X*16+x-48;else if(x>=65&&x<=70)X=X*16+x-65+10;else if(x>=97&&x<=102)X=X*16+x-97+10;else break;n++,Z++}return Z<z&&(X=-1),X}function h(z){n=z,t="",r=0,o=16,v=0}function g(){const z=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&d(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&d(s.charCodeAt(n)))for(n++;n<s.length&&d(s.charCodeAt(n));)n++;else return v=3,s.substring(z,n);let Z=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&d(s.charCodeAt(n))){for(n++;n<s.length&&d(s.charCodeAt(n));)n++;Z=n}else v=3;return s.substring(z,Z)}function O(){let z="",Z=n;for(;;){if(n>=i){z+=s.substring(Z,n),v=2;break}const X=s.charCodeAt(n);if(X===34){z+=s.substring(Z,n),n++;break}if(X===92){if(z+=s.substring(Z,n),n++,n>=i){v=2;break}switch(s.charCodeAt(n++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const H=y(4);H>=0?z+=String.fromCharCode(H):v=4;break}default:v=5}Z=n;continue}if(X>=0&&X<=31)if(S(X)){z+=s.substring(Z,n),v=2;break}else v=6;n++}return z}function T(){if(t="",v=0,r=n,n>=i)return r=i,o=17;let z=s.charCodeAt(n);if(R(z)){do n++,t+=String.fromCharCode(z),z=s.charCodeAt(n);while(R(z));return o=15}if(S(z))return n++,t+=String.fromCharCode(z),z===13&&s.charCodeAt(n)===10&&(n++,t+=`
`),o=14;switch(z){case 123:return n++,o=1;case 125:return n++,o=2;case 91:return n++,o=3;case 93:return n++,o=4;case 58:return n++,o=6;case 44:return n++,o=5;case 34:return n++,t=O(),o=10;case 47:{const Z=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!S(s.charCodeAt(n));)n++;return t=s.substring(Z,n),o=12}if(s.charCodeAt(n+1)===42){n+=2;const X=i-1;let x=!1;for(;n<X;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,v=1),t=s.substring(Z,n),o=13}return t+=String.fromCharCode(z),n++,o=16}case 45:if(t+=String.fromCharCode(z),n++,n===i||!d(s.charCodeAt(n)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=g(),o=11;default:for(;n<i&&M(z);)n++,z=s.charCodeAt(n);if(r!==n){switch(t=s.substring(r,n),t){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return t+=String.fromCharCode(z),n++,o=16}}function M(z){if(R(z)||S(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let z;do z=T();while(z>=12&&z<=15);return z}return{setPosition:h,getPosition:()=>n,scan:a?U:T,getToken:()=>o,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>v}}e.$Vm=I;function R(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function d(s){return s>=48&&s<=57}var P;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(P||(P={}));function E(s,a){const n=[],i=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function v(y,h,g,O){r.value=y,r.offset=h,r.length=g,r.type=O,r.colonOffset=void 0,t=r}try{f(s,{onObjectBegin:(y,h)=>{if(a<=y)throw i;t=void 0,o=a>y,n.push("")},onObjectProperty:(y,h,g)=>{if(a<h||(v(y,h,g,"property"),n[n.length-1]=y,a<=h+g))throw i},onObjectEnd:(y,h)=>{if(a<=y)throw i;t=void 0,n.pop()},onArrayBegin:(y,h)=>{if(a<=y)throw i;t=void 0,n.push(0)},onArrayEnd:(y,h)=>{if(a<=y)throw i;t=void 0,n.pop()},onLiteralValue:(y,h,g)=>{if(a<h||(v(y,h,g,k(y)),a<=h+g))throw i},onSeparator:(y,h,g)=>{if(a<=h)throw i;if(y===":"&&t&&t.type==="property")t.colonOffset=h,o=!1,t=void 0;else if(y===","){const O=n[n.length-1];typeof O=="number"?n[n.length-1]=O+1:(o=!0,n[n.length-1]=""),t=void 0}}})}catch(y){if(y!==i)throw y}return{path:n,previousNode:t,isAtPropertyKey:o,matches:y=>{let h=0;for(let g=0;h<y.length&&g<n.length;g++)if(y[h]===n[g]||y[h]==="*")h++;else if(y[h]!=="**")return!1;return h===y.length}}}e.$Wm=E;function b(s,a=[],n=A.DEFAULT){let i=null,t=[];const r=[];function o(y){Array.isArray(t)?t.push(y):i!==null&&(t[i]=y)}return f(s,{onObjectBegin:()=>{const y={};o(y),r.push(t),t=y,i=null},onObjectProperty:y=>{i=y},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const y=[];o(y),r.push(t),t=y,i=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:o,onError:(y,h,g)=>{a.push({error:y,offset:h,length:g})}},n),t[0]}e.$Xm=b;function l(s,a=[],n=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(y){i.type==="property"&&(i.length=y-i.offset,i=i.parent)}function r(y){return i.children.push(y),y}f(s,{onObjectBegin:y=>{i=r({type:"object",offset:y,length:-1,parent:i,children:[]})},onObjectProperty:(y,h,g)=>{i=r({type:"property",offset:h,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:y,offset:h,length:g,parent:i})},onObjectEnd:(y,h)=>{i.length=y+h-i.offset,i=i.parent,t(y+h)},onArrayBegin:(y,h)=>{i=r({type:"array",offset:y,length:-1,parent:i,children:[]})},onArrayEnd:(y,h)=>{i.length=y+h-i.offset,i=i.parent,t(y+h)},onLiteralValue:(y,h,g)=>{r({type:k(y),offset:h,length:g,parent:i,value:y}),t(h+g)},onSeparator:(y,h,g)=>{i.type==="property"&&(y===":"?i.colonOffset=h:y===","&&t(h))},onError:(y,h,g)=>{a.push({error:y,offset:h,length:g})}},n);const v=i.children[0];return v&&delete v.parent,v}e.$Ym=l;function $(s,a){if(!s)return;let n=s;for(const i of a)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===i){n=r.children[1],t=!0;break}if(!t)return}else{const t=i;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.$Zm=$;function p(s){if(!s.parent||!s.parent.children)return[];const a=p(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;a.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&a.push(n)}return a}e.$1m=p;function w(s){switch(s.type){case"array":return s.children.map(w);case"object":{const a=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(a[n.children[0].value]=w(i))}return a}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$2m=w;function c(s,a,n=!1){return a>=s.offset&&a<s.offset+s.length||n&&a===s.offset+s.length}e.$3m=c;function u(s,a,n=!1){if(c(s,a,n)){const i=s.children;if(Array.isArray(i))for(let t=0;t<i.length&&i[t].offset<=a;t++){const r=u(i[t],a,n);if(r)return r}return s}}e.$4m=u;function f(s,a,n=A.DEFAULT){const i=I(s,!1);function t(_){return _?()=>_(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(_){return _?se=>_(se,i.getTokenOffset(),i.getTokenLength()):()=>!0}const o=t(a.onObjectBegin),v=r(a.onObjectProperty),y=t(a.onObjectEnd),h=t(a.onArrayBegin),g=t(a.onArrayEnd),O=r(a.onLiteralValue),T=r(a.onSeparator),M=t(a.onComment),U=r(a.onError),z=n&&n.disallowComments,Z=n&&n.allowTrailingComma;function X(){for(;;){const _=i.scan();switch(i.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:z||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(_){case 12:case 13:z?x(10):M();break;case 16:x(1);break;case 15:case 14:break;default:return _}}}function x(_,se=[],Q=[]){if(U(_),se.length+Q.length>0){let q=i.getToken();for(;q!==17;){if(se.indexOf(q)!==-1){X();break}else if(Q.indexOf(q)!==-1)break;q=X()}}}function H(_){const se=i.getTokenValue();return _?O(se):v(se),X(),!0}function K(){switch(i.getToken()){case 11:{let _=0;try{_=JSON.parse(i.getTokenValue()),typeof _!="number"&&(x(2),_=0)}catch{x(2)}O(_);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return X(),!0}function J(){return i.getToken()!==10?(x(3,[],[2,5]),!1):(H(!1),i.getToken()===6?(T(":"),X(),ne()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function V(){o(),X();let _=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),T(","),X(),i.getToken()===2&&Z)break}else _&&x(6,[],[]);J()||x(4,[],[2,5]),_=!0}return y(),i.getToken()!==2?x(7,[2],[]):X(),!0}function ee(){h(),X();let _=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),T(","),X(),i.getToken()===4&&Z)break}else _&&x(6,[],[]);ne()||x(4,[],[4,5]),_=!0}return g(),i.getToken()!==4?x(8,[4],[]):X(),!0}function ne(){switch(i.getToken()){case 3:return ee();case 1:return V();case 10:return H(!0);default:return K()}}return X(),i.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):ne()?(i.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$5m=f;function m(s,a){const n=I(s),i=[];let t,r=0,o;do switch(o=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==o&&i.push(s.substring(r,o)),a!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,a)),r=n.getPosition();break}while(t!==17);return i.join("")}e.$6m=m;function k(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$7m=k}),define(ae[42],ce([0,1,35]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kT=e.$jT=e.$iT=e.$hT=void 0;function F(d,P,E){let b,l,$,p,w;if(P){for(p=P.offset,w=p+P.length,$=p;$>0&&!S(d,$-1);)$--;let o=w;for(;o<d.length&&!S(d,o);)o++;l=d.substring($,o),b=I(l,E)}else l=d,b=0,$=0,p=0,w=d.length;const c=R(E,d);let u=!1,f=0,m;E.insertSpaces?m=A(" ",E.tabSize||4):m="	";const k=(0,D.$Vm)(l,!1);let s=!1;function a(){return c+A(m,b+f)}function n(){let o=k.scan();for(u=!1;o===15||o===14;)u=u||o===14,o=k.scan();return s=o===16||k.getTokenError()!==0,o}const i=[];function t(o,v,y){!s&&v<w&&y>p&&d.substring(v,y)!==o&&i.push({offset:v,length:y-v,content:o})}let r=n();if(r!==17){const o=k.getTokenOffset()+$,v=A(m,b);t(v,$,o)}for(;r!==17;){let o=k.getTokenOffset()+k.getTokenLength()+$,v=n(),y="";for(;!u&&(v===12||v===13);){const g=k.getTokenOffset()+$;t(" ",o,g),o=k.getTokenOffset()+k.getTokenLength()+$,y=v===12?a():"",v=n()}if(v===2)r!==1&&(f--,y=a());else if(v===4)r!==3&&(f--,y=a());else{switch(r){case 3:case 1:f++,y=a();break;case 5:case 12:y=a();break;case 13:u?y=a():y=" ";break;case 6:y=" ";break;case 10:if(v===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?y=" ":v!==5&&v!==17&&(s=!0);break;case 16:s=!0;break}u&&(v===12||v===13)&&(y=a())}const h=k.getTokenOffset()+$;t(y,o,h),r=v}return i}e.$hT=F;function j(d,P){const E=JSON.stringify(d,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?E.replace(/\r\n|\r|\n/g,P.eol):E}e.$iT=j;function A(d,P){let E="";for(let b=0;b<P;b++)E+=d;return E}function I(d,P){let E=0,b=0;const l=P.tabSize||4;for(;E<d.length;){const $=d.charAt(E);if($===" ")b++;else if($==="	")b+=l;else break;E++}return Math.floor(b/l)}function R(d,P){for(let E=0;E<P.length;E++){const b=P.charAt(E);if(b==="\r")return E+1<P.length&&P.charAt(E+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return d&&d.eol||`
`}e.$jT=R;function S(d,P){return`\r
`.indexOf(d.charAt(P))!==-1}e.$kT=S}),define(ae[86],ce([0,1,35,42]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pT=e.$oT=e.$nT=e.$mT=e.$lT=void 0;function j(d,P,E){return A(d,P,void 0,E)}e.$lT=j;function A(d,P,E,b,l){const $=P.slice(),p=[],w=(0,D.$Ym)(d,p);let c,u;for(;$.length>0&&(u=$.pop(),c=(0,D.$Zm)(w,$),c===void 0&&E!==void 0);)typeof u=="string"?E={[u]:E}:E=[E];if(c)if(c.type==="object"&&typeof u=="string"&&Array.isArray(c.children)){const f=(0,D.$Zm)(c,[u]);if(f!==void 0)if(E===void 0){if(!f.parent)throw new Error("Malformed AST");const m=c.children.indexOf(f.parent);let k,s=f.parent.offset+f.parent.length;if(m>0){const a=c.children[m-1];k=a.offset+a.length}else k=c.offset+1,c.children.length>1&&(s=c.children[1].offset);return I(d,{offset:k,length:s-k,content:""},b)}else return I(d,{offset:f.offset,length:f.length,content:JSON.stringify(E)},b);else{if(E===void 0)return[];const m=`${JSON.stringify(u)}: ${JSON.stringify(E)}`,k=l?l(c.children.map(a=>a.children[0].value)):c.children.length;let s;if(k>0){const a=c.children[k-1];s={offset:a.offset+a.length,length:0,content:","+m}}else c.children.length===0?s={offset:c.offset+1,length:0,content:m}:s={offset:c.offset+1,length:0,content:m+","};return I(d,s,b)}}else if(c.type==="array"&&typeof u=="number"&&Array.isArray(c.children))if(E!==void 0){const f=`${JSON.stringify(E)}`;let m;if(c.children.length===0||u===0)m={offset:c.offset+1,length:0,content:c.children.length===0?f:f+","};else{const k=u===-1||u>c.children.length?c.children.length:u,s=c.children[k-1];m={offset:s.offset+s.length,length:0,content:","+f}}return I(d,m,b)}else{const f=u,m=c.children[f];let k;if(c.children.length===1)k={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===f){const s=c.children[f-1],a=s.offset+s.length,n=c.offset+c.length;k={offset:a,length:n-2-a,content:""}}else k={offset:m.offset,length:c.children[f+1].offset-m.offset,content:""};return I(d,k,b)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${c.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return I(d,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(E)},b)}}e.$mT=A;function I(d,P,E){let b=R(d,P),l=P.offset,$=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;l>0&&!(0,F.$kT)(b,l-1);)l--;for(;$<b.length&&!(0,F.$kT)(b,$);)$++}const p=(0,F.$hT)(b,{offset:l,length:$-l},E);for(let c=p.length-1;c>=0;c--){const u=p[c];b=R(b,u),l=Math.min(l,u.offset),$=Math.max($,u.offset+u.length),$+=u.content.length-u.length}const w=d.length-(b.length-$)-l;return[{offset:l,length:w,content:b.substring(l,$)}]}e.$nT=I;function R(d,P){return d.substring(0,P.offset)+P.content+d.substring(P.offset+P.length)}e.$oT=R;function S(d,P){const E=P.slice(0).sort((l,$)=>{const p=l.offset-$.offset;return p===0?l.length-$.length:p});let b=d.length;for(let l=E.length-1;l>=0;l--){const $=E[l];if($.offset+$.length<=b)d=R(d,$);else throw new Error("Overlapping edit");b=$.offset}return d}e.$pT=S}),define(ae[61],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class D{constructor(j){this.d=j,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(j){this.c=j}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=D}),define(ae[87],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(A){this.element=A,this.next=D.Undefined,this.prev=D.Undefined}}class F{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let A=this.a;for(;A!==D.Undefined;){const I=A.next;A.prev=D.Undefined,A.next=D.Undefined,A=I}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,I){const R=new D(A);if(this.a===D.Undefined)this.a=R,this.b=R;else if(I){const d=this.b;this.b=R,R.prev=d,d.next=R}else{const d=this.a;this.a=R,R.next=d,d.prev=R}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(R))}}shift(){if(this.a!==D.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==D.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==D.Undefined&&A.next!==D.Undefined){const I=A.prev;I.next=A.next,A.next.prev=I}else A.prev===D.Undefined&&A.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):A.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):A.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==D.Undefined;)yield A.element,A=A.next}}e.$1c=F}),define(ae[34],ce([0,1]),function(te,e){"use strict";var D,F,j;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function A(u,f,m){let k=u.get(f);return k===void 0&&(k=m,u.set(f,k)),k}e.$wc=A;function I(u){const f=[];return u.forEach((m,k)=>{f.push(`${k} => ${m}`)}),`Map(${u.size}) {${f.join(", ")}}`}e.$xc=I;function R(u){const f=[];return u.forEach(m=>{f.push(m)}),`Set(${u.size}) {${f.join(", ")}}`}e.$yc=R;class S{constructor(f,m){this.uri=f,this.value=m}}function d(u){return Array.isArray(u)}class P{static{this.a=f=>f.toString()}constructor(f,m){if(this[D]="ResourceMap",f instanceof P)this.b=new Map(f.b),this.c=m??P.a;else if(d(f)){this.b=new Map,this.c=m??P.a;for(const[k,s]of f)this.set(k,s)}else this.b=new Map,this.c=f??P.a}set(f,m){return this.b.set(this.c(f),new S(f,m)),this}get(f){return this.b.get(this.c(f))?.value}has(f){return this.b.has(this.c(f))}get size(){return this.b.size}clear(){this.b.clear()}delete(f){return this.b.delete(this.c(f))}forEach(f,m){typeof m<"u"&&(f=f.bind(m));for(const[k,s]of this.b)f(s.value,s.uri,this)}*values(){for(const f of this.b.values())yield f.value}*keys(){for(const f of this.b.values())yield f.uri}*entries(){for(const f of this.b.values())yield[f.uri,f.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,f]of this.b)yield[f.uri,f.value]}}e.$zc=P;class E{constructor(f,m){this[F]="ResourceSet",!f||typeof f=="function"?this.a=new P(f):(this.a=new P(m),f.forEach(this.add,this))}get size(){return this.a.size}add(f){return this.a.set(f,f),this}clear(){this.a.clear()}delete(f){return this.a.delete(f)}forEach(f,m){this.a.forEach((k,s)=>f.call(m,s,s,this))}has(f){return this.a.has(f)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=E;var b;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class l{constructor(){this[j]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(f){return this.a.has(f)}get(f,m=0){const k=this.a.get(f);if(k)return m!==0&&this.j(k,m),k.value}set(f,m,k=0){let s=this.a.get(f);if(s)s.value=m,k!==0&&this.j(s,k);else{switch(s={key:f,value:m,next:void 0,previous:void 0},k){case 0:this.h(s);break;case 1:this.g(s);break;case 2:this.h(s);break;default:this.h(s);break}this.a.set(f,s),this.d++}return this}delete(f){return!!this.remove(f)}remove(f){const m=this.a.get(f);if(m)return this.a.delete(f),this.i(m),this.d--,m.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const f=this.b;return this.a.delete(f.key),this.i(f),this.d--,f.value}forEach(f,m){const k=this.e;let s=this.b;for(;s;){if(m?f.bind(m)(s.value,s.key,this):f(s.value,s.key,this),this.e!==k)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const f=this,m=this.e;let k=this.b;const s={[Symbol.iterator](){return s},next(){if(f.e!==m)throw new Error("LinkedMap got modified during iteration.");if(k){const a={value:k.key,done:!1};return k=k.next,a}else return{value:void 0,done:!0}}};return s}values(){const f=this,m=this.e;let k=this.b;const s={[Symbol.iterator](){return s},next(){if(f.e!==m)throw new Error("LinkedMap got modified during iteration.");if(k){const a={value:k.value,done:!1};return k=k.next,a}else return{value:void 0,done:!0}}};return s}entries(){const f=this,m=this.e;let k=this.b;const s={[Symbol.iterator](){return s},next(){if(f.e!==m)throw new Error("LinkedMap got modified during iteration.");if(k){const a={value:[k.key,k.value],done:!1};return k=k.next,a}else return{value:void 0,done:!0}}};return s}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(f){if(f>=this.size)return;if(f===0){this.clear();return}let m=this.b,k=this.size;for(;m&&k>f;)this.a.delete(m.key),m=m.next,k--;this.b=m,this.d=k,m&&(m.previous=void 0),this.e++}g(f){if(!this.b&&!this.c)this.c=f;else if(this.b)f.next=this.b,this.b.previous=f;else throw new Error("Invalid list");this.b=f,this.e++}h(f){if(!this.b&&!this.c)this.b=f;else if(this.c)f.previous=this.c,this.c.next=f;else throw new Error("Invalid list");this.c=f,this.e++}i(f){if(f===this.b&&f===this.c)this.b=void 0,this.c=void 0;else if(f===this.b){if(!f.next)throw new Error("Invalid list");f.next.previous=void 0,this.b=f.next}else if(f===this.c){if(!f.previous)throw new Error("Invalid list");f.previous.next=void 0,this.c=f.previous}else{const m=f.next,k=f.previous;if(!m||!k)throw new Error("Invalid list");m.previous=k,k.next=m}f.next=void 0,f.previous=void 0,this.e++}j(f,m){if(!this.b||!this.c)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(f===this.b)return;const k=f.next,s=f.previous;f===this.c?(s.next=void 0,this.c=s):(k.previous=s,s.next=k),f.previous=void 0,f.next=this.b,this.b.previous=f,this.b=f,this.e++}else if(m===2){if(f===this.c)return;const k=f.next,s=f.previous;f===this.b?(k.previous=void 0,this.b=k):(k.previous=s,s.next=k),f.next=void 0,f.previous=this.c,this.c.next=f,this.c=f,this.e++}}}toJSON(){const f=[];return this.forEach((m,k)=>{f.push([k,m])}),f}fromJSON(f){this.clear();for(const[m,k]of f)this.set(m,k)}}e.$Bc=l;class $ extends l{constructor(f,m=1){super(),this.k=f,this.l=Math.min(Math.max(0,m),1)}get limit(){return this.k}set limit(f){this.k=f,this.m()}get ratio(){return this.l}set ratio(f){this.l=Math.min(Math.max(0,f),1),this.m()}get(f,m=2){return super.get(f,m)}peek(f){return super.get(f,0)}set(f,m){return super.set(f,m,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=$;class p{constructor(){this.a=new Map}add(f){return this.a.set(f,(this.a.get(f)||0)+1),this}delete(f){let m=this.a.get(f)||0;return m===0?!1:(m--,m===0?this.a.delete(f):this.a.set(f,m),!0)}has(f){return this.a.has(f)}}e.$Dc=p;class w{constructor(f){if(this.a=new Map,this.b=new Map,f)for(const[m,k]of f)this.set(m,k)}clear(){this.a.clear(),this.b.clear()}set(f,m){this.a.set(f,m),this.b.set(m,f)}get(f){return this.a.get(f)}getKey(f){return this.b.get(f)}delete(f){const m=this.a.get(f);return m===void 0?!1:(this.a.delete(f),this.b.delete(m),!0)}forEach(f,m){this.a.forEach((k,s)=>{f.call(m,k,s,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=w;class c{constructor(){this.a=new Map}add(f,m){let k=this.a.get(f);k||(k=new Set,this.a.set(f,k)),k.add(m)}delete(f,m){const k=this.a.get(f);k&&(k.delete(m),k.size===0&&this.a.delete(f))}forEach(f,m){const k=this.a.get(f);k&&k.forEach(m)}get(f){const m=this.a.get(f);return m||new Set}}e.$Fc=c}),define(ae[2],ce([0,1,18,125,34,85,60]),function(te,e,D,F,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const R=!1;let S=null;class d{constructor(){this.b=new Map}static{this.a=0}c(g){let O=this.b.get(g);return O||(O={parent:null,source:null,isSingleton:!1,value:g,idx:d.a++},this.b.set(g,O)),O}trackDisposable(g){const O=this.c(g);O.source||(O.source=new Error().stack)}setParent(g,O){const T=this.c(g);T.parent=O}markAsDisposed(g){this.b.delete(g)}markAsSingleton(g){this.c(g).isSingleton=!0}f(g,O){const T=O.get(g);if(T)return T;const M=g.parent?this.f(this.c(g.parent),O):g;return O.set(g,M),M}getTrackedDisposables(){const g=new Map;return[...this.b.entries()].filter(([,T])=>T.source!==null&&!this.f(T,g).isSingleton).flatMap(([T])=>T)}computeLeakingDisposables(g=10,O){let T;if(O)T=O;else{const X=new Map,x=[...this.b.values()].filter(K=>K.source!==null&&!this.f(K,X).isSingleton);if(x.length===0)return;const H=new Set(x.map(K=>K.value));if(T=x.filter(K=>!(K.parent&&H.has(K.parent))),T.length===0)throw new Error("There are cyclic diposable chains!")}if(!T)return;function M(X){function x(K,J){for(;K.length>0&&J.some(V=>typeof V=="string"?V===K[0]:K[0].match(V));)K.shift()}const H=X.source.split(`
`).map(K=>K.trim().replace("at ","")).filter(K=>K!=="");return x(H,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),H.reverse()}const U=new j.$Fc;for(const X of T){const x=M(X);for(let H=0;H<=x.length;H++)U.add(x.slice(0,H).join(`
`),X)}T.sort((0,D.$6b)(X=>X.idx,D.$8b));let z="",Z=0;for(const X of T.slice(0,g)){Z++;const x=M(X),H=[];for(let K=0;K<x.length;K++){let J=x[K];J=`(shared with ${U.get(x.slice(0,K+1).join(`
`)).size}/${T.length} leaks) at ${J}`;const ee=U.get(x.slice(0,K).join(`
`)),ne=(0,F.$J)([...ee].map(_=>M(_)[K]),_=>_);delete ne[x[K]];for(const[_,se]of Object.entries(ne))H.unshift(`    - stacktraces of ${se.length} other leaks continue with ${_}`);H.unshift(J)}z+=`


==================== Leaking disposable ${Z}/${T.length}: ${X.value.constructor.name} ====================
${H.join(`
`)}
============================================================

`}return T.length>g&&(z+=`


... and ${T.length-g} more leaking disposables

`),{leaks:T,details:z}}}e.$Gc=d;function P(h){S=h}if(e.$Hc=P,R){const h="__is_disposable_tracked__";P(new class{trackDisposable(g){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[h]||console.log(O)},3e3)}setParent(g,O){if(g&&g!==s.None)try{g[h]=!0}catch{}}markAsDisposed(g){if(g&&g!==s.None)try{g[h]=!0}catch{}}markAsSingleton(g){}})}function E(h){return S?.trackDisposable(h),h}e.$Ic=E;function b(h){S?.markAsDisposed(h)}e.$Jc=b;function l(h,g){S?.setParent(h,g)}function $(h,g){if(S)for(const O of h)S.setParent(O,g)}function p(h){return S?.markAsSingleton(h),h}e.$Kc=p;function w(h){return typeof h.dispose=="function"&&h.dispose.length===0}e.$Lc=w;function c(h){if(I.Iterable.is(h)){const g=[];for(const O of h)if(O)try{O.dispose()}catch(T){g.push(T)}if(g.length===1)throw g[0];if(g.length>1)throw new AggregateError(g,"Encountered errors while disposing of store");return Array.isArray(h)?[]:h}else if(h)return h.dispose(),h}e.$Mc=c;function u(h){for(const g of h)w(g)&&g.dispose();return[]}e.$Nc=u;function f(...h){const g=m(()=>c(h));return $(h,g),g}e.$Oc=f;function m(h){const g=E({dispose:(0,A.$cb)(()=>{b(g),h()})});return g}e.$Pc=m;class k{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return l(g,this),this.g?k.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(g),g}delete(g){if(g){if(g===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(g),g.dispose()}}deleteAndLeak(g){g&&this.f.has(g)&&(this.f.delete(g),l(g,null))}}e.$Qc=k;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new k,E(this),l(this.q,this)}dispose(){b(this),this.q.dispose()}B(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(g)}}e.$Rc=s;class a{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(g){this.b||g===this.a||(this.a?.dispose(),g&&l(g,this),this.a=g)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const g=this.a;return this.a=void 0,g&&l(g,null),g}}e.$Sc=a;class n{constructor(g){this.b=g,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Tc=n;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(g){let O=g;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,b(this))},this}}e.$Uc=i;class t{constructor(){this.a=new Map}acquire(g,...O){let T=this.a.get(g);T||(T={counter:0,object:this.b(g,...O)},this.a.set(g,T));const{object:M}=T,U=(0,A.$cb)(()=>{--T.counter===0&&(this.c(g,T.object),this.a.delete(g))});return T.counter++,{object:M,dispose:U}}}e.$Vc=t;class r{constructor(g){this.a=g}async acquire(g,...O){const T=this.a.acquire(g,...O);try{return{object:await T.object,dispose:()=>T.dispose()}}catch(M){throw T.dispose(),M}}}e.$Wc=r;class o{constructor(g){this.object=g}dispose(){}}e.$Xc=o;function v(h){const g=new k;try{h(g)}finally{g.dispose()}}e.$Yc=v;class y{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(g){return this.a.has(g)}get size(){return this.a.size}get(g){return this.a.get(g)}set(g,O,T=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),T||this.a.get(g)?.dispose(),this.a.set(g,O)}deleteAndDispose(g){this.a.get(g)?.dispose(),this.a.delete(g)}keys(){return this.a.keys()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Zc=y}),define(ae[88],ce([0,1,34]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.$pl=void 0;const F=new D.$Cc(1e4);function j(d){return S(d,"NFC",F)}e.$pl=j;const A=new D.$Cc(1e4);function I(d){return S(d,"NFD",A)}e.$ql=I;const R=/[^\u0000-\u0080]/;function S(d,P,E){if(!d)return d;const b=E.get(d);if(b)return b;let l;return R.test(d)?l=d.normalize(P):l=d,E.set(d,l),l}e.$rl=function(){const d=/[\u0300-\u036f]/g;return function(P){return I(P).replace(d,"")}}()}),function(){function te(j){const A=[];typeof j=="number"&&A.push("code/timeOrigin",j);function I(S){A.push(S,Date.now())}function R(){const S=[];for(let d=0;d<A.length;d+=2)S.push({name:A[d],startTime:A[d+1]});return S}return{mark:I,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(j){performance.mark(j)},getMarks(){let j=performance.timeOrigin;typeof j!="number"&&(j=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(j)}];for(const I of performance.getEntriesByType("mark"))A.push({name:I.name,startTime:Math.round(j+I.startTime)});return A}};if(typeof process=="object"){const j=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(j)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function D(j){return j.MonacoPerformanceMarks||(j.MonacoPerformanceMarks=e()),j.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=D(F))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var F in D)(typeof exports=="object"?exports:te)[F]=D[F]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function D(F){if(e[F])return e[F].exports;var j=e[F]={i:F,l:!1,exports:{}};return te[F].call(j.exports,j,j.exports,D),j.l=!0,j.exports}return D.m=te,D.c=e,D.d=function(F,j,A){D.o(F,j)||Object.defineProperty(F,j,{enumerable:!0,get:A})},D.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},D.t=function(F,j){if(1&j&&(F=D(F)),8&j||4&j&&typeof F=="object"&&F&&F.__esModule)return F;var A=Object.create(null);if(D.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:F}),2&j&&typeof F!="string")for(var I in F)D.d(A,I,function(R){return F[R]}.bind(null,I));return A},D.n=function(F){var j=F&&F.__esModule?function(){return F.default}:function(){return F};return D.d(j,"a",j),j},D.o=function(F,j){return Object.prototype.hasOwnProperty.call(F,j)},D.p="",D(D.s=0)}([function(te,e,D){(function(F){var j;e=te.exports=Q,j=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],S=e.src=[],d=0,P=d++;S[P]="0|[1-9]\\d*";var E=d++;S[E]="[0-9]+";var b=d++;S[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=d++;S[l]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var $=d++;S[$]="("+S[E]+")\\.("+S[E]+")\\.("+S[E]+")";var p=d++;S[p]="(?:"+S[P]+"|"+S[b]+")";var w=d++;S[w]="(?:"+S[E]+"|"+S[b]+")";var c=d++;S[c]="(?:-("+S[p]+"(?:\\."+S[p]+")*))";var u=d++;S[u]="(?:-?("+S[w]+"(?:\\."+S[w]+")*))";var f=d++;S[f]="[0-9A-Za-z-]+";var m=d++;S[m]="(?:\\+("+S[f]+"(?:\\."+S[f]+")*))";var k=d++,s="v?"+S[l]+S[c]+"?"+S[m]+"?";S[k]="^"+s+"$";var a="[v=\\s]*"+S[$]+S[u]+"?"+S[m]+"?",n=d++;S[n]="^"+a+"$";var i=d++;S[i]="((?:<|>)?=?)";var t=d++;S[t]=S[E]+"|x|X|\\*";var r=d++;S[r]=S[P]+"|x|X|\\*";var o=d++;S[o]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[c]+")?"+S[m]+"?)?)?";var v=d++;S[v]="[v=\\s]*("+S[t]+")(?:\\.("+S[t]+")(?:\\.("+S[t]+")(?:"+S[u]+")?"+S[m]+"?)?)?";var y=d++;S[y]="^"+S[i]+"\\s*"+S[o]+"$";var h=d++;S[h]="^"+S[i]+"\\s*"+S[v]+"$";var g=d++;S[g]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=d++;S[O]="(?:~>?)";var T=d++;S[T]="(\\s*)"+S[O]+"\\s+",R[T]=new RegExp(S[T],"g");var M=d++;S[M]="^"+S[O]+S[o]+"$";var U=d++;S[U]="^"+S[O]+S[v]+"$";var z=d++;S[z]="(?:\\^)";var Z=d++;S[Z]="(\\s*)"+S[z]+"\\s+",R[Z]=new RegExp(S[Z],"g");var X=d++;S[X]="^"+S[z]+S[o]+"$";var x=d++;S[x]="^"+S[z]+S[v]+"$";var H=d++;S[H]="^"+S[i]+"\\s*("+a+")$|^$";var K=d++;S[K]="^"+S[i]+"\\s*("+s+")$|^$";var J=d++;S[J]="(\\s*)"+S[i]+"\\s*("+a+"|"+S[o]+")",R[J]=new RegExp(S[J],"g");var V=d++;S[V]="^\\s*("+S[o]+")\\s+-\\s+("+S[o]+")\\s*$";var ee=d++;S[ee]="^\\s*("+S[v]+")\\s+-\\s+("+S[v]+")\\s*$";var ne=d++;S[ne]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)j(_,S[_]),R[_]||(R[_]=new RegExp(S[_]));function se(le,ge){if(le instanceof Q)return le;if(typeof le!="string"||le.length>A||!(ge?R[n]:R[k]).test(le))return null;try{return new Q(le,ge)}catch{return null}}function Q(le,ge){if(le instanceof Q){if(le.loose===ge)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof Q))return new Q(le,ge);j("SemVer",le,ge),this.loose=ge;var be=le.trim().match(ge?R[n]:R[k]);if(!be)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Ce=+Se;if(Ce>=0&&Ce<I)return Ce}return Se}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=se,e.valid=function(le,ge){var be=se(le,ge);return be?be.version:null},e.clean=function(le,ge){var be=se(le.trim().replace(/^[=v]+/,""),ge);return be?be.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(le){return j("SemVer.compare",this.version,this.loose,le),le instanceof Q||(le=new Q(le,this.loose)),this.compareMain(le)||this.comparePre(le)},Q.prototype.compareMain=function(le){return le instanceof Q||(le=new Q(le,this.loose)),C(this.major,le.major)||C(this.minor,le.minor)||C(this.patch,le.patch)},Q.prototype.comparePre=function(le){if(le instanceof Q||(le=new Q(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var ge=0;do{var be=this.prerelease[ge],Se=le.prerelease[ge];if(j("prerelease compare",ge,be,Se),be===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(be===void 0)return-1;if(be!==Se)return C(be,Se)}while(++ge)},Q.prototype.inc=function(le,ge){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,ge,be,Se){typeof be=="string"&&(Se=be,be=void 0);try{return new Q(le,be).inc(ge,Se).version}catch{return null}},e.diff=function(le,ge){if(W(le,ge))return null;var be=se(le),Se=se(ge);if(be.prerelease.length||Se.prerelease.length){for(var Ce in be)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&be[Ce]!==Se[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in be)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&be[Ce]!==Se[Ce])return Ce},e.compareIdentifiers=C;var q=/^[0-9]+$/;function C(le,ge){var be=q.test(le),Se=q.test(ge);return be&&Se&&(le=+le,ge=+ge),be&&!Se?-1:Se&&!be?1:le<ge?-1:le>ge?1:0}function L(le,ge,be){return new Q(le,be).compare(new Q(ge,be))}function B(le,ge,be){return L(le,ge,be)>0}function N(le,ge,be){return L(le,ge,be)<0}function W(le,ge,be){return L(le,ge,be)===0}function G(le,ge,be){return L(le,ge,be)!==0}function ie(le,ge,be){return L(le,ge,be)>=0}function oe(le,ge,be){return L(le,ge,be)<=0}function ue(le,ge,be,Se){var Ce;switch(ge){case"===":typeof le=="object"&&(le=le.version),typeof be=="object"&&(be=be.version),Ce=le===be;break;case"!==":typeof le=="object"&&(le=le.version),typeof be=="object"&&(be=be.version),Ce=le!==be;break;case"":case"=":case"==":Ce=W(le,be,Se);break;case"!=":Ce=G(le,be,Se);break;case">":Ce=B(le,be,Se);break;case">=":Ce=ie(le,be,Se);break;case"<":Ce=N(le,be,Se);break;case"<=":Ce=oe(le,be,Se);break;default:throw new TypeError("Invalid operator: "+ge)}return Ce}function he(le,ge){if(le instanceof he){if(le.loose===ge)return le;le=le.value}if(!(this instanceof he))return new he(le,ge);j("comparator",le,ge),this.loose=ge,this.parse(le),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,j("comp",this)}e.rcompareIdentifiers=function(le,ge){return C(ge,le)},e.major=function(le,ge){return new Q(le,ge).major},e.minor=function(le,ge){return new Q(le,ge).minor},e.patch=function(le,ge){return new Q(le,ge).patch},e.compare=L,e.compareLoose=function(le,ge){return L(le,ge,!0)},e.rcompare=function(le,ge,be){return L(ge,le,be)},e.sort=function(le,ge){return le.sort(function(be,Se){return e.compare(be,Se,ge)})},e.rsort=function(le,ge){return le.sort(function(be,Se){return e.rcompare(be,Se,ge)})},e.gt=B,e.lt=N,e.eq=W,e.neq=G,e.gte=ie,e.lte=oe,e.cmp=ue,e.Comparator=he;var $e={};function de(le,ge){if(le instanceof de)return le.loose===ge?le:new de(le.raw,ge);if(le instanceof he)return new de(le.value,ge);if(!(this instanceof de))return new de(le,ge);if(this.loose=ge,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function we(le){return!le||le.toLowerCase()==="x"||le==="*"}function ve(le,ge,be,Se,Ce,Ue,je,qe,Te,re,fe,me,pe){return((ge=we(be)?"":we(Se)?">="+be+".0.0":we(Ce)?">="+be+"."+Se+".0":">="+ge)+" "+(qe=we(Te)?"":we(re)?"<"+(+Te+1)+".0.0":we(fe)?"<"+Te+"."+(+re+1)+".0":me?"<="+Te+"."+re+"."+fe+"-"+me:"<="+qe)).trim()}function Ie(le,ge){for(var be=0;be<le.length;be++)if(!le[be].test(ge))return!1;if(ge.prerelease.length){for(be=0;be<le.length;be++)if(j(le[be].semver),le[be].semver!==$e&&le[be].semver.prerelease.length>0){var Se=le[be].semver;if(Se.major===ge.major&&Se.minor===ge.minor&&Se.patch===ge.patch)return!0}return!1}return!0}function Le(le,ge,be){try{ge=new de(ge,be)}catch{return!1}return ge.test(le)}function Me(le,ge,be,Se){var Ce,Ue,je,qe,Te;switch(le=new Q(le,Se),ge=new de(ge,Se),be){case">":Ce=B,Ue=oe,je=N,qe=">",Te=">=";break;case"<":Ce=N,Ue=ie,je=B,qe="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(le,ge,Se))return!1;for(var re=0;re<ge.set.length;++re){var fe=ge.set[re],me=null,pe=null;if(fe.forEach(function(ke){ke.semver===$e&&(ke=new he(">=0.0.0")),me=me||ke,pe=pe||ke,Ce(ke.semver,me.semver,Se)?me=ke:je(ke.semver,pe.semver,Se)&&(pe=ke)}),me.operator===qe||me.operator===Te||(!pe.operator||pe.operator===qe)&&Ue(le,pe.semver)||pe.operator===Te&&je(le,pe.semver))return!1}return!0}he.prototype.parse=function(le){var ge=this.loose?R[H]:R[K],be=le.match(ge);if(!be)throw new TypeError("Invalid comparator: "+le);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new Q(be[2],this.loose):this.semver=$e},he.prototype.toString=function(){return this.value},he.prototype.test=function(le){return j("Comparator.test",le,this.loose),this.semver===$e||(typeof le=="string"&&(le=new Q(le,this.loose)),ue(le,this.operator,this.semver,this.loose))},he.prototype.intersects=function(le,ge){if(!(le instanceof he))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(le.value,ge),Le(this.value,be,ge);if(le.operator==="")return be=new de(this.value,ge),Le(le.semver,be,ge);var Se=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Ue=this.semver.version===le.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),qe=ue(this.semver,"<",le.semver,ge)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Te=ue(this.semver,">",le.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Se||Ce||Ue&&je||qe||Te},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(le){var ge=this.loose;le=le.trim(),j("range",le,ge);var be=ge?R[ee]:R[V];le=le.replace(be,ve),j("hyphen replace",le),le=le.replace(R[J],"$1$2$3"),j("comparator trim",le,R[J]),le=(le=(le=le.replace(R[T],"$1~")).replace(R[Z],"$1^")).split(/\s+/).join(" ");var Se=ge?R[H]:R[K],Ce=le.split(" ").map(function(Ue){return function(je,qe){return j("comp",je),je=function(Te,re){return Te.trim().split(/\s+/).map(function(fe){return function(me,pe){j("caret",me,pe);var ke=pe?R[x]:R[X];return me.replace(ke,function(Re,Pe,De,Oe,Ne){var Fe;return j("caret",me,Re,Pe,De,Oe,Ne),we(Pe)?Fe="":we(De)?Fe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":we(Oe)?Fe=Pe==="0"?">="+Pe+"."+De+".0 <"+Pe+"."+(+De+1)+".0":">="+Pe+"."+De+".0 <"+(+Pe+1)+".0.0":Ne?(j("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Fe=Pe==="0"?De==="0"?">="+Pe+"."+De+"."+Oe+Ne+" <"+Pe+"."+De+"."+(+Oe+1):">="+Pe+"."+De+"."+Oe+Ne+" <"+Pe+"."+(+De+1)+".0":">="+Pe+"."+De+"."+Oe+Ne+" <"+(+Pe+1)+".0.0"):(j("no pr"),Fe=Pe==="0"?De==="0"?">="+Pe+"."+De+"."+Oe+" <"+Pe+"."+De+"."+(+Oe+1):">="+Pe+"."+De+"."+Oe+" <"+Pe+"."+(+De+1)+".0":">="+Pe+"."+De+"."+Oe+" <"+(+Pe+1)+".0.0"),j("caret return",Fe),Fe})}(fe,re)}).join(" ")}(je,qe),j("caret",je),je=function(Te,re){return Te.trim().split(/\s+/).map(function(fe){return function(me,pe){var ke=pe?R[U]:R[M];return me.replace(ke,function(Re,Pe,De,Oe,Ne){var Fe;return j("tilde",me,Re,Pe,De,Oe,Ne),we(Pe)?Fe="":we(De)?Fe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":we(Oe)?Fe=">="+Pe+"."+De+".0 <"+Pe+"."+(+De+1)+".0":Ne?(j("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Fe=">="+Pe+"."+De+"."+Oe+Ne+" <"+Pe+"."+(+De+1)+".0"):Fe=">="+Pe+"."+De+"."+Oe+" <"+Pe+"."+(+De+1)+".0",j("tilde return",Fe),Fe})}(fe,re)}).join(" ")}(je,qe),j("tildes",je),je=function(Te,re){return j("replaceXRanges",Te,re),Te.split(/\s+/).map(function(fe){return function(me,pe){me=me.trim();var ke=pe?R[h]:R[y];return me.replace(ke,function(Re,Pe,De,Oe,Ne,Fe){j("xRange",me,Re,Pe,De,Oe,Ne,Fe);var Be=we(De),ze=Be||we(Oe),Ve=ze||we(Ne);return Pe==="="&&Ve&&(Pe=""),Be?Re=Pe===">"||Pe==="<"?"<0.0.0":"*":Pe&&Ve?(ze&&(Oe=0),Ve&&(Ne=0),Pe===">"?(Pe=">=",ze?(De=+De+1,Oe=0,Ne=0):Ve&&(Oe=+Oe+1,Ne=0)):Pe==="<="&&(Pe="<",ze?De=+De+1:Oe=+Oe+1),Re=Pe+De+"."+Oe+"."+Ne):ze?Re=">="+De+".0.0 <"+(+De+1)+".0.0":Ve&&(Re=">="+De+"."+Oe+".0 <"+De+"."+(+Oe+1)+".0"),j("xRange return",Re),Re})}(fe,re)}).join(" ")}(je,qe),j("xrange",je),je=function(Te,re){return j("replaceStars",Te,re),Te.trim().replace(R[ne],"")}(je,qe),j("stars",je),je}(Ue,ge)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Ue){return!!Ue.match(Se)})),Ce=Ce.map(function(Ue){return new he(Ue,ge)})},de.prototype.intersects=function(le,ge){if(!(le instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(Se){return le.set.some(function(Ce){return Ce.every(function(Ue){return Se.intersects(Ue,ge)})})})})},e.toComparators=function(le,ge){return new de(le,ge).set.map(function(be){return be.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},de.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new Q(le,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Ie(this.set[ge],le))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function(le,ge,be){var Se=null,Ce=null;try{var Ue=new de(ge,be)}catch{return null}return le.forEach(function(je){Ue.test(je)&&(Se&&Ce.compare(je)!==-1||(Ce=new Q(Se=je,be)))}),Se},e.minSatisfying=function(le,ge,be){var Se=null,Ce=null;try{var Ue=new de(ge,be)}catch{return null}return le.forEach(function(je){Ue.test(je)&&(Se&&Ce.compare(je)!==1||(Ce=new Q(Se=je,be)))}),Se},e.validRange=function(le,ge){try{return new de(le,ge).range||"*"}catch{return null}},e.ltr=function(le,ge,be){return Me(le,ge,"<",be)},e.gtr=function(le,ge,be){return Me(le,ge,">",be)},e.outside=Me,e.prerelease=function(le,ge){var be=se(le,ge);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(le,ge,be){return le=new de(le,be),ge=new de(ge,be),le.intersects(ge)},e.coerce=function(le){if(le instanceof Q)return le;if(typeof le!="string")return null;var ge=le.match(R[g]);return ge==null?null:se((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,D(1))},function(te,e){var D,F,j=te.exports={};function A(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function R(w){if(D===setTimeout)return setTimeout(w,0);if((D===A||!D)&&setTimeout)return D=setTimeout,setTimeout(w,0);try{return D(w,0)}catch{try{return D.call(null,w,0)}catch{return D.call(this,w,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:A}catch{D=A}try{F=typeof clearTimeout=="function"?clearTimeout:I}catch{F=I}})();var S,d=[],P=!1,E=-1;function b(){P&&S&&(P=!1,S.length?d=S.concat(d):E=-1,d.length&&l())}function l(){if(!P){var w=R(b);P=!0;for(var c=d.length;c;){for(S=d,d=[];++E<c;)S&&S[E].run();E=-1,c=d.length}S=null,P=!1,function(u){if(F===clearTimeout)return clearTimeout(u);if((F===I||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(u);try{F(u)}catch{try{return F.call(null,u)}catch{return F.call(this,u)}}}(w)}}function $(w,c){this.fun=w,this.array=c}function p(){}j.nextTick=function(w){var c=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)c[u-1]=arguments[u];d.push(new $(w,c)),d.length!==1||P||R(l)},$.prototype.run=function(){this.fun.apply(null,this.array)},j.title="browser",j.browser=!0,j.env={},j.argv=[],j.version="",j.versions={},j.on=p,j.addListener=p,j.once=p,j.off=p,j.removeListener=p,j.removeAllListeners=p,j.emit=p,j.prependListener=p,j.prependOnceListener=p,j.listeners=function(w){return[]},j.binding=function(w){throw new Error("process.binding is not supported")},j.cwd=function(){return"/"},j.chdir=function(w){throw new Error("process.chdir is not supported")},j.umask=function(){return 0}}])}),define(ae[127],ce([0,1]),function(te,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;class F{constructor(R,S,d){this.level=R,this.key=S,this.value=d,this.forward=[]}}const j=void 0;class A{constructor(R,S=2**16){this.comparator=R,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(S)|0),this.e=new F(this.c,j,j)}get size(){return this.f}clear(){this.e=new F(this.c,j,j),this.f=0}has(R){return!!A.g(this,R,this.comparator)}get(R){return A.g(this,R,this.comparator)?.value}set(R,S){return A.h(this,R,S,this.comparator)&&(this.f+=1),this}delete(R){const S=A.k(this,R,this.comparator);return S&&(this.f-=1),S}forEach(R,S){let d=this.e.forward[0];for(;d;)R.call(S,d.value,d.key,this),d=d.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",S=this.e.forward[0];for(;S;)R+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return R}static g(R,S,d){let P=R.e;for(let E=R.d-1;E>=0;E--)for(;P.forward[E]&&d(P.forward[E].key,S)<0;)P=P.forward[E];if(P=P.forward[0],P&&d(P.key,S)===0)return P}static h(R,S,d,P){const E=[];let b=R.e;for(let l=R.d-1;l>=0;l--){for(;b.forward[l]&&P(b.forward[l].key,S)<0;)b=b.forward[l];E[l]=b}if(b=b.forward[0],b&&P(b.key,S)===0)return b.value=d,!1;{const l=A.j(R);if(l>R.d){for(let $=R.d;$<l;$++)E[$]=R.e;R.d=l}b=new F(l,S,d);for(let $=0;$<l;$++)b.forward[$]=E[$].forward[$],E[$].forward[$]=b;return!0}}static j(R,S=.5){let d=1;for(;Math.random()<S&&d<R.c;)d+=1;return d}static k(R,S,d){const P=[];let E=R.e;for(let b=R.d-1;b>=0;b--){for(;E.forward[b]&&d(E.forward[b].key,S)<0;)E=E.forward[b];P[b]=E}if(E=E.forward[0],!E||d(E.key,S)!==0)return!1;for(let b=0;b<R.d&&P[b].forward[b]===E;b++)P[b].forward[b]=E.forward[b];for(;R.d>0&&R.e.forward[R.d-1]===j;)R.d-=1;return!0}}e.$zr=A}),define(ae[62],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(A){return new F(A)}constructor(A){this.c=D&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Jd=F}),define(ae[3],ce([0,1,7,85,2,87,62]),function(te,e,D,F,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.Event=void 0;const R=!1,S=!1;var d;(function(y){y.None=()=>j.$Rc.None;function h(ue){if(S){const{onDidAddListener:he}=ue,$e=$.create();let de=0;ue.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),he?.()}}}function g(ue,he){return K(ue,()=>{},0,void 0,!0,void 0,he)}y.defer=g;function O(ue){return(he,$e=null,de)=>{let we=!1,ve;return ve=ue(Ie=>{if(!we)return ve?ve.dispose():we=!0,he.call($e,Ie)},null,de),we&&ve.dispose(),ve}}y.once=O;function T(ue,he,$e){return x((de,we=null,ve)=>ue(Ie=>de.call(we,he(Ie)),null,ve),$e)}y.map=T;function M(ue,he,$e){return x((de,we=null,ve)=>ue(Ie=>{he(Ie),de.call(we,Ie)},null,ve),$e)}y.forEach=M;function U(ue,he,$e){return x((de,we=null,ve)=>ue(Ie=>he(Ie)&&de.call(we,Ie),null,ve),$e)}y.filter=U;function z(ue){return ue}y.signal=z;function Z(...ue){return(he,$e=null,de)=>{const we=(0,j.$Oc)(...ue.map(ve=>ve(Ie=>he.call($e,Ie))));return H(we,de)}}y.any=Z;function X(ue,he,$e,de){let we=$e;return T(ue,ve=>(we=he(we,ve),we),de)}y.reduce=X;function x(ue,he){let $e;const de={onWillAddFirstListener(){$e=ue(we.fire,we)},onDidRemoveLastListener(){$e?.dispose()}};he||h(de);const we=new f(de);return he?.add(we),we.event}function H(ue,he){return he instanceof Array?he.push(ue):he&&he.add(ue),ue}function K(ue,he,$e=100,de=!1,we=!1,ve,Ie){let Le,Me,le,ge=0,be;const Se={leakWarningThreshold:ve,onWillAddFirstListener(){Le=ue(Ue=>{ge++,Me=he(Me,Ue),de&&!le&&(Ce.fire(Me),Me=void 0),be=()=>{const je=Me;Me=void 0,le=void 0,(!de||ge>1)&&Ce.fire(je),ge=0},typeof $e=="number"?(clearTimeout(le),le=setTimeout(be,$e)):le===void 0&&(le=0,queueMicrotask(be))})},onWillRemoveListener(){we&&ge>0&&be?.()},onDidRemoveLastListener(){be=void 0,Le.dispose()}};Ie||h(Se);const Ce=new f(Se);return Ie?.add(Ce),Ce.event}y.debounce=K;function J(ue,he=0,$e){return y.debounce(ue,(de,we)=>de?(de.push(we),de):[we],he,void 0,!0,void 0,$e)}y.accumulate=J;function V(ue,he=(de,we)=>de===we,$e){let de=!0,we;return U(ue,ve=>{const Ie=de||!he(ve,we);return de=!1,we=ve,Ie},$e)}y.latch=V;function ee(ue,he,$e){return[y.filter(ue,he,$e),y.filter(ue,de=>!he(de),$e)]}y.split=ee;function ne(ue,he=!1,$e=[],de){let we=$e.slice(),ve=ue(Me=>{we?we.push(Me):Le.fire(Me)});de&&de.add(ve);const Ie=()=>{we?.forEach(Me=>Le.fire(Me)),we=null},Le=new f({onWillAddFirstListener(){ve||(ve=ue(Me=>Le.fire(Me)),de&&de.add(ve))},onDidAddFirstListener(){we&&(he?setTimeout(Ie):Ie())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return de&&de.add(Le),Le.event}y.buffer=ne;function _(ue,he){return(de,we,ve)=>{const Ie=he(new Q);return ue(function(Le){const Me=Ie.evaluate(Le);Me!==se&&de.call(we,Me)},void 0,ve)}}y.chain=_;const se=Symbol("HaltChainable");class Q{constructor(){this.f=[]}map(he){return this.f.push(he),this}forEach(he){return this.f.push($e=>(he($e),$e)),this}filter(he){return this.f.push($e=>he($e)?$e:se),this}reduce(he,$e){let de=$e;return this.f.push(we=>(de=he(de,we),de)),this}latch(he=($e,de)=>$e===de){let $e=!0,de;return this.f.push(we=>{const ve=$e||!he(we,de);return $e=!1,de=we,ve?we:se}),this}evaluate(he){for(const $e of this.f)if(he=$e(he),he===se)break;return he}}function q(ue,he,$e=de=>de){const de=(...Le)=>Ie.fire($e(...Le)),we=()=>ue.on(he,de),ve=()=>ue.removeListener(he,de),Ie=new f({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Ie.event}y.fromNodeEventEmitter=q;function C(ue,he,$e=de=>de){const de=(...Le)=>Ie.fire($e(...Le)),we=()=>ue.addEventListener(he,de),ve=()=>ue.removeEventListener(he,de),Ie=new f({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Ie.event}y.fromDOMEventEmitter=C;function L(ue){return new Promise(he=>O(ue)(he))}y.toPromise=L;function B(ue){const he=new f;return ue.then($e=>{he.fire($e)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}y.fromPromise=B;function N(ue,he,$e){return he($e),ue(de=>he(de))}y.runAndSubscribe=N;function W(ue,he){let $e=null;function de(ve){$e?.dispose(),$e=new j.$Qc,he(ve,$e)}de(void 0);const we=ue(ve=>de(ve));return(0,j.$Pc)(()=>{we.dispose(),$e?.dispose()})}y.runAndSubscribeWithStore=W;class G{constructor(he,$e){this._observable=he,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};$e||h(de),this.emitter=new f(de),$e&&$e.add(this.emitter)}beginUpdate(he){this.f++}handlePossibleChange(he){}handleChange(he,$e){this.g=!0}endUpdate(he){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ie(ue,he){return new G(ue,he).emitter.event}y.fromObservable=ie;function oe(ue){return he=>{let $e=0,de=!1;const we={beginUpdate(){$e++},endUpdate(){$e--,$e===0&&(ue.reportChanges(),de&&(de=!1,he()))},handlePossibleChange(){},handleChange(){de=!0}};return ue.addObserver(we),ue.reportChanges(),{dispose(){ue.removeObserver(we)}}}}y.fromObservableLight=oe})(d||(e.Event=d={}));class P{static{this.all=new Set}static{this.f=0}constructor(h){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${h}_${P.f++}`,P.all.add(this)}start(h){this.g=new I.$Jd,this.listenerCount=h}stop(){if(this.g){const h=this.g.elapsed();this.durations.push(h),this.elapsedOverall+=h,this.invocationCount+=1,this.g=void 0}}}e.$Ld=P;let E=-1;function b(y){const h=E;return E=y,{dispose(){E=h}}}e.$Md=b;class l{constructor(h,g=Math.random().toString(18).slice(2,5)){this.threshold=h,this.name=g,this.g=0}dispose(){this.f?.clear()}check(h,g){const O=this.threshold;if(O<=0||g<O)return;this.f||(this.f=new Map);const T=this.f.get(h.value)||0;if(this.f.set(h.value,T+1),this.g-=1,this.g<=0){this.g=O*.5;let M,U=0;for(const[z,Z]of this.f)(!M||U<Z)&&(M=z,U=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${U}):`),console.warn(M)}return()=>{const M=this.f.get(h.value)||0;this.f.set(h.value,M-1)}}}class ${static create(){return new $(new Error().stack??"")}constructor(h){this.value=h}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class w{constructor(h){this.value=h,this.id=p++}}const c=2,u=(y,h)=>{if(y instanceof w)h(y);else for(let g=0;g<y.length;g++){const O=y[g];O&&h(O)}};class f{constructor(h){this.w=0,this.f=h,this.g=E>0||this.f?.leakWarningThreshold?new l(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(R){const h=this.t;queueMicrotask(()=>{u(h,g=>g.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(h,g,O)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),j.$Rc.None;if(this.m)return j.$Rc.None;g&&(h=h.bind(g));const T=new w(h);let M,U;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=$.create(),M=this.g.check(T.stack,this.w+1)),R&&(T.stack=U??$.create()),this.t?this.t instanceof w?(this.u??=new k,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const z=(0,j.$Pc)(()=>{M?.(),this.x(T)});return O instanceof j.$Qc?O.add(z):Array.isArray(O)&&O.push(z),z},this.q}x(h){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const g=this.t,O=g.indexOf(h);if(O===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,g[O]=void 0;const T=this.u.current===this;if(this.w*c<=g.length){let M=0;for(let U=0;U<g.length;U++)g[U]?g[M++]=g[U]:T&&(this.u.end--,M<this.u.i&&this.u.i--);g.length=M}}y(h,g){if(!h)return;const O=this.f?.onListenerError||D.$Z;if(!O){h.value(g);return}try{h.value(g)}catch(T){O(T)}}z(h){const g=h.current.t;for(;h.i<h.end;)this.y(g[h.i++],h.value);h.reset()}fire(h){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof w)this.y(this.t,h);else{const g=this.u;g.enqueue(this,h,this.t.length),this.z(g)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Nd=f;const m=()=>new k;e.$Od=m;class k{constructor(){this.i=-1,this.end=0}enqueue(h,g,O){this.i=0,this.end=O,this.current=h,this.value=g}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends f{async fireAsync(h,g,O){if(this.t)for(this.h||(this.h=new A.$1c),u(this.t,T=>this.h.push([T.value,h]));this.h.size>0&&!g.isCancellationRequested;){const[T,M]=this.h.shift(),U=[],z={...M,token:g,waitUntil:Z=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");O&&(Z=O(Z,T)),U.push(Z)}};try{T(z)}catch(Z){(0,D.$Z)(Z);continue}Object.freeze(U),await Promise.allSettled(U).then(Z=>{for(const X of Z)X.status==="rejected"&&(0,D.$Z)(X.reason)})}}}e.$Pd=s;class a extends f{get isPaused(){return this.h!==0}constructor(h){super(h),this.h=0,this.s=new A.$1c,this.A=h?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const h=Array.from(this.s);this.s.clear(),super.fire(this.A(h))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(h){this.w&&(this.h!==0?this.s.push(h):super.fire(h))}}e.$Qd=a;class n extends a{constructor(h){super(h),this.k=h.delay??100}fire(h){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(h)}}e.$Rd=n;class i extends f{constructor(h){super(h),this.h=[],this.k=h?.merge}fire(h){this.hasListeners()&&(this.h.push(h),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(g=>super.fire(g)),this.h=[]}))}}e.$Sd=i;class t{constructor(){this.g=!1,this.h=[],this.f=new f({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(h){const g={event:h,listener:null};this.h.push(g),this.g&&this.m(g);const O=()=>{this.g&&this.o(g);const T=this.h.indexOf(g);this.h.splice(T,1)};return(0,j.$Pc)((0,F.$cb)(O))}j(){this.g=!0,this.h.forEach(h=>this.m(h))}k(){this.g=!1,this.h.forEach(h=>this.o(h))}m(h){h.listener=h.event(g=>this.f.fire(g))}o(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.f.dispose()}}e.$Td=t;class r{constructor(h,g,O,T){this.f=new j.$Qc;const M=this.f.add(new t),U=this.f.add(new j.$Zc);function z(Z){U.set(Z,M.add(T(Z)))}for(const Z of h)z(Z);this.f.add(g(Z=>{z(Z)})),this.f.add(O(Z=>{U.deleteAndDispose(Z)})),this.event=M.event}dispose(){this.f.dispose()}}e.$Ud=r;class o{constructor(){this.f=[]}wrapEvent(h){return(g,O,T)=>h(M=>{const U=this.f[this.f.length-1];U?U.push(()=>g.call(O,M)):g.call(O,M)},void 0,T)}bufferEvents(h){const g=[];this.f.push(g);const O=h();return this.f.pop(),g.forEach(T=>T()),O}}e.$Vd=o;class v{constructor(){this.f=!1,this.g=d.None,this.h=j.$Rc.None,this.j=new f({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(h){this.g=h,this.f&&(this.h.dispose(),this.h=h(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Wd=v}),define(ae[26],ce([0,1,3]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.CancellationToken=void 0;const F=Object.freeze(function(R,S){const d=setTimeout(R.bind(S),0);return{dispose(){clearTimeout(d)}}});var j;(function(R){function S(d){return d===R.None||d===R.Cancelled||d instanceof A?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}R.isCancellationToken=S,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(j||(e.CancellationToken=j={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new D.$Nd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(S){this.f=void 0,this.g=void 0,this.g=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=j.Cancelled}dispose(S=!1){S&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=j.None}}e.$Xd=I}),define(ae[128],ce([0,1,26]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=void 0;class F{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new D.$Xd,S=this.b(R.token);return this.a={promise:S,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$we=F;class j{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const S=JSON.stringify(R);return this.b!==S&&(this.b=S,this.a=this.c(R)),this.a}}e.$xe=j;class A{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const S=this.b(R);return this.a.set(R,S),S}}e.$ye=A}),define(ae[46],ce([0,1,7,2]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function j(m){const k=m;return k?typeof k.read=="function":!1}e.$Yd=j;function A(m){const k=m;return k?[k.on,k.pause,k.resume,k.destroy].every(s=>typeof s=="function"):!1}e.$Zd=A;function I(m){const k=m;return k?A(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.$1d=I;function R(m,k){return new S(m,k)}e.$2d=R;class S{constructor(k,s){this.e=k,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(k){if(!this.a.destroyed){if(this.a.flowing)this.g(k);else if(this.b.data.push(k),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(k){this.a.destroyed||(this.a.flowing?this.h(k):this.b.error.push(k))}end(k){this.a.destroyed||(typeof k<"u"&&this.write(k),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(k){this.c.data.slice(0).forEach(s=>s(k))}h(k){this.c.error.length===0?(0,D.$Z)(k):this.c.error.slice(0).forEach(s=>s(k))}i(){this.c.end.slice(0).forEach(k=>k())}on(k,s){if(!this.a.destroyed)switch(k){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(k,s){if(this.a.destroyed)return;let a;switch(k){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const n=a.indexOf(s);n>=0&&a.splice(n,1)}}j(){if(this.b.data.length>0){const k=this.e(this.b.data);this.g(k),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const k of this.b.error)this.h(k);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(m,k){const s=[];let a;for(;(a=m.read())!==null;)s.push(a);return k(s)}e.$3d=d;function P(m,k,s){const a=[];let n;for(;(n=m.read())!==null&&a.length<s;)a.push(n);return n===null&&a.length>0?k(a):{read:()=>{if(a.length>0)return a.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return m.read()}}}e.$4d=P;function E(m,k){return new Promise((s,a)=>{const n=[];b(m,{onData:i=>{k&&n.push(i)},onError:i=>{k?a(i):s(void 0)},onEnd:()=>{s(k?k(n):void 0)}})})}e.$5d=E;function b(m,k,s){m.on("error",a=>{s?.isCancellationRequested||k.onError(a)}),m.on("end",()=>{s?.isCancellationRequested||k.onEnd()}),m.on("data",a=>{s?.isCancellationRequested||k.onData(a)})}e.$6d=b;function l(m,k){return new Promise((s,a)=>{const n=new F.$Qc,i=[],t=v=>{if(i.push(v),i.length>k)return n.dispose(),m.pause(),s({stream:m,buffer:i,ended:!1})},r=v=>(n.dispose(),a(v)),o=()=>(n.dispose(),s({stream:m,buffer:i,ended:!0}));n.add((0,F.$Pc)(()=>m.removeListener("error",r))),m.on("error",r),n.add((0,F.$Pc)(()=>m.removeListener("end",o))),m.on("end",o),n.add((0,F.$Pc)(()=>m.removeListener("data",t))),m.on("data",t)})}e.$7d=l;function $(m,k){const s=R(k);return s.end(m),s}e.$8d=$;function p(){const m=R(()=>{throw new Error("not supported")});return m.end(),m}e.$9d=p;function w(m){let k=!1;return{read:()=>k?null:(k=!0,m)}}e.$0d=w;function c(m,k,s){const a=R(s);return b(m,{onData:n=>a.write(k.data(n)),onError:n=>a.error(k.error?k.error(n):n),onEnd:()=>a.end()}),a}e.$$d=c;function u(m,k,s){let a=!1;return{read:()=>{const n=k.read();return a?n:(a=!0,n!==null?s([m,n]):m)}}}e.$_d=u;function f(m,k,s){let a=!1;const n=R(s);return b(k,{onData:i=>a?n.write(i):(a=!0,n.write(s([m,i]))),onError:i=>n.error(i),onEnd:()=>{a||(a=!0,n.write(m)),n.end()}}),n}e.$ae=f}),define(ae[15],ce([0,1,61,46]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const j=typeof Buffer<"u",A=new D.$U(()=>new Uint8Array(256));let I,R;class S{static alloc(g){return j?new S(Buffer.allocUnsafe(g)):new S(new Uint8Array(g))}static wrap(g){return j&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new S(g)}static fromString(g,O){return!(O?.dontUseNodeBuffer||!1)&&j?new S(Buffer.from(g)):(I||(I=new TextEncoder),new S(I.encode(g)))}static fromByteArray(g){const O=S.alloc(g.length);for(let T=0,M=g.length;T<M;T++)O.buffer[T]=g[T];return O}static concat(g,O){if(typeof O>"u"){O=0;for(let U=0,z=g.length;U<z;U++)O+=g[U].byteLength}const T=S.alloc(O);let M=0;for(let U=0,z=g.length;U<z;U++){const Z=g[U];T.set(Z,M),M+=Z.byteLength}return T}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=S.alloc(this.byteLength);return g.set(this),g}toString(){return j?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(g,O){return new S(this.buffer.subarray(g,O))}set(g,O){if(g instanceof S)this.buffer.set(g.buffer,O);else if(g instanceof Uint8Array)this.buffer.set(g,O);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),O);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return b(this.buffer,g)}writeUInt32BE(g,O){l(this.buffer,g,O)}readUInt32LE(g){return $(this.buffer,g)}writeUInt32LE(g,O){p(this.buffer,g,O)}readUInt8(g){return w(this.buffer,g)}writeUInt8(g,O){c(this.buffer,g,O)}indexOf(g,O=0){return d(this.buffer,g instanceof S?g.buffer:g,O)}}e.$be=S;function d(h,g,O=0){const T=g.byteLength,M=h.byteLength;if(T===0)return 0;if(T===1)return h.indexOf(g[0]);if(T>M-O)return-1;const U=A.value;U.fill(g.length);for(let x=0;x<g.length;x++)U[g[x]]=g.length-x-1;let z=O+g.length-1,Z=z,X=-1;for(;z<M;)if(h[z]===g[Z]){if(Z===0){X=z;break}z--,Z--}else z+=Math.max(g.length-Z,U[h[z]]),Z=g.length-1;return X}e.$ce=d;function P(h,g){return h[g+0]<<0>>>0|h[g+1]<<8>>>0}e.$de=P;function E(h,g,O){h[O+0]=g&255,g=g>>>8,h[O+1]=g&255}e.$ee=E;function b(h,g){return h[g]*2**24+h[g+1]*2**16+h[g+2]*2**8+h[g+3]}e.$fe=b;function l(h,g,O){h[O+3]=g,g=g>>>8,h[O+2]=g,g=g>>>8,h[O+1]=g,g=g>>>8,h[O]=g}e.$ge=l;function $(h,g){return h[g+0]<<0>>>0|h[g+1]<<8>>>0|h[g+2]<<16>>>0|h[g+3]<<24>>>0}e.$he=$;function p(h,g,O){h[O+0]=g&255,g=g>>>8,h[O+1]=g&255,g=g>>>8,h[O+2]=g&255,g=g>>>8,h[O+3]=g&255}e.$ie=p;function w(h,g){return h[g]}e.$je=w;function c(h,g,O){h[O]=g}e.$ke=c;function u(h){return F.$3d(h,g=>S.concat(g))}e.$le=u;function f(h){return F.$0d(h)}e.$me=f;function m(h){return F.$5d(h,g=>S.concat(g))}e.$ne=m;async function k(h){return h.ended?S.concat(h.buffer):S.concat([...h.buffer,await m(h.stream)])}e.$oe=k;function s(h){return F.$8d(h,g=>S.concat(g))}e.$pe=s;function a(h){return F.$$d(h,{data:g=>typeof g=="string"?S.fromString(g):S.wrap(g)},g=>S.concat(g))}e.$qe=a;function n(h){return F.$2d(g=>S.concat(g),h)}e.$re=n;function i(h,g){return F.$_d(h,g,O=>S.concat(O))}e.$se=i;function t(h,g){return F.$ae(h,g,O=>S.concat(O))}e.$te=t;function r(h){let g=0,O=0,T=0;const M=new Uint8Array(Math.floor(h.length/4*3)),U=Z=>{switch(O){case 3:M[T++]=g|Z,O=0;break;case 2:M[T++]=g|Z>>>2,g=Z<<6,O=3;break;case 1:M[T++]=g|Z>>>4,g=Z<<4,O=2;break;default:g=Z<<2,O=1}};for(let Z=0;Z<h.length;Z++){const X=h.charCodeAt(Z);if(X>=65&&X<=90)U(X-65);else if(X>=97&&X<=122)U(X-97+26);else if(X>=48&&X<=57)U(X-48+52);else if(X===43||X===45)U(62);else if(X===47||X===95)U(63);else{if(X===61)break;throw new SyntaxError(`Unexpected base64 character ${h[Z]}`)}}const z=T;for(;O>0;)U(0);return S.wrap(M).slice(0,z)}e.$ue=r;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:h},g=!0,O=!1){const T=O?v:o;let M="";const U=h.byteLength%3;let z=0;for(;z<h.byteLength-U;z+=3){const Z=h[z+0],X=h[z+1],x=h[z+2];M+=T[Z>>>2],M+=T[(Z<<4|X>>>4)&63],M+=T[(X<<2|x>>>6)&63],M+=T[x&63]}if(U===1){const Z=h[z+0];M+=T[Z>>>2],M+=T[Z<<4&63],g&&(M+="==")}else if(U===2){const Z=h[z+0],X=h[z+1];M+=T[Z>>>2],M+=T[(Z<<4|X>>>4)&63],M+=T[X<<2&63],g&&(M+="=")}return M}e.$ve=y}),define(ae[27],ce([0,1,128,61]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xf=e.$wf=e.$vf=e.$uf=e.GraphemeBreakType=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=void 0;function j(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.$Be=j;const A=/{(\d+)}/g;function I(re,...fe){return fe.length===0?re:re.replace(A,function(me,pe){const ke=parseInt(pe,10);return isNaN(ke)||ke<0||ke>=fe.length?me:fe[ke]})}e.$Ce=I;const R=/{([^}]+)}/g;function S(re,fe){return Object.keys(fe).length===0?re:re.replace(R,(me,pe)=>fe[pe]??me)}e.$De=S;function d(re){return re.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$Ee=d;function P(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Fe=P;function E(re,fe){let me=0;const pe=fe.charCodeAt(0);for(let ke=re.length-1;ke>=0;ke--)re.charCodeAt(ke)===pe&&me++;return me}e.$Ge=E;function b(re,fe,me="\u2026"){return re.length<=fe?re:`${re.substr(0,fe)}${me}`}e.$He=b;function l(re,fe=" "){const me=$(re,fe);return p(me,fe)}e.$Ie=l;function $(re,fe){if(!re||!fe)return re;const me=fe.length;if(me===0||re.length===0)return re;let pe=0;for(;re.indexOf(fe,pe)===pe;)pe=pe+me;return re.substring(pe)}e.$Je=$;function p(re,fe){if(!re||!fe)return re;const me=fe.length,pe=re.length;if(me===0||pe===0)return re;let ke=pe,Re=-1;for(;Re=re.lastIndexOf(fe,ke-1),!(Re===-1||Re+me!==ke);){if(Re===0)return"";ke=Re}return re.substring(0,ke)}e.$Ke=p;function w(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Le=w;function c(re){return re.replace(/\*/g,"")}e.$Me=c;function u(re,fe,me={}){if(!re)throw new Error("Cannot create regex from empty string");fe||(re=P(re)),me.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let pe="";return me.global&&(pe+="g"),me.matchCase||(pe+="i"),me.multiline&&(pe+="m"),me.unicode&&(pe+="u"),new RegExp(re,pe)}e.$Ne=u;function f(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.$Oe=f;function m(re){return re.split(/\r\n|\r|\n/)}e.$Pe=m;function k(re){for(let fe=0,me=re.length;fe<me;fe++){const pe=re.charCodeAt(fe);if(pe!==32&&pe!==9)return fe}return-1}e.$Qe=k;function s(re,fe=0,me=re.length){for(let pe=fe;pe<me;pe++){const ke=re.charCodeAt(pe);if(ke!==32&&ke!==9)return re.substring(fe,pe)}return re.substring(fe,me)}e.$Re=s;function a(re,fe=re.length-1){for(let me=fe;me>=0;me--){const pe=re.charCodeAt(me);if(pe!==32&&pe!==9)return me}return-1}e.$Se=a;function n(re,fe,me){const pe=[];let ke=0;for(const Re of re.matchAll(fe)){if(pe.push(re.slice(ke,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");ke=Re.index+Re[0].length,pe.push(me(Re[0],...Re.slice(1),Re.index,re,Re.groups))}return pe.push(re.slice(ke)),Promise.all(pe).then(Re=>Re.join(""))}e.$Te=n;function i(re,fe){return re<fe?-1:re>fe?1:0}e.$Ue=i;function t(re,fe,me=0,pe=re.length,ke=0,Re=fe.length){for(;me<pe&&ke<Re;me++,ke++){const Oe=re.charCodeAt(me),Ne=fe.charCodeAt(ke);if(Oe<Ne)return-1;if(Oe>Ne)return 1}const Pe=pe-me,De=Re-ke;return Pe<De?-1:Pe>De?1:0}e.$Ve=t;function r(re,fe){return o(re,fe,0,re.length,0,fe.length)}e.$We=r;function o(re,fe,me=0,pe=re.length,ke=0,Re=fe.length){for(;me<pe&&ke<Re;me++,ke++){let Oe=re.charCodeAt(me),Ne=fe.charCodeAt(ke);if(Oe===Ne)continue;if(Oe>=128||Ne>=128)return t(re.toLowerCase(),fe.toLowerCase(),me,pe,ke,Re);y(Oe)&&(Oe-=32),y(Ne)&&(Ne-=32);const Fe=Oe-Ne;if(Fe!==0)return Fe}const Pe=pe-me,De=Re-ke;return Pe<De?-1:Pe>De?1:0}e.$Xe=o;function v(re){return re>=48&&re<=57}e.$Ye=v;function y(re){return re>=97&&re<=122}e.$Ze=y;function h(re){return re>=65&&re<=90}e.$1e=h;function g(re,fe){return re.length===fe.length&&o(re,fe)===0}e.$2e=g;function O(re,fe){const me=fe.length;return fe.length>re.length?!1:o(re,fe,0,me)===0}e.$3e=O;function T(re,fe){const me=Math.min(re.length,fe.length);let pe;for(pe=0;pe<me;pe++)if(re.charCodeAt(pe)!==fe.charCodeAt(pe))return pe;return me}e.$4e=T;function M(re,fe){const me=Math.min(re.length,fe.length);let pe;const ke=re.length-1,Re=fe.length-1;for(pe=0;pe<me;pe++)if(re.charCodeAt(ke-pe)!==fe.charCodeAt(Re-pe))return pe;return me}e.$5e=M;function U(re){return 55296<=re&&re<=56319}e.$6e=U;function z(re){return 56320<=re&&re<=57343}e.$7e=z;function Z(re,fe){return(re-55296<<10)+(fe-56320)+65536}e.$8e=Z;function X(re,fe,me){const pe=re.charCodeAt(me);if(U(pe)&&me+1<fe){const ke=re.charCodeAt(me+1);if(z(ke))return Z(pe,ke)}return pe}e.$9e=X;function x(re,fe){const me=re.charCodeAt(fe-1);if(z(me)&&fe>1){const pe=re.charCodeAt(fe-2);if(U(pe))return Z(pe,me)}return me}class H{get offset(){return this.e}constructor(fe,me=0){this.c=fe,this.d=fe.length,this.e=me}setOffset(fe){this.e=fe}prevCodePoint(){const fe=x(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=X(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$0e=H;class K{get offset(){return this.c.offset}constructor(fe,me=0){this.c=new H(fe,me)}nextGraphemeLength(){const fe=ge.getInstance(),me=this.c,pe=me.offset;let ke=fe.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Re=me.offset,Pe=fe.getGraphemeBreakType(me.nextCodePoint());if(Me(ke,Pe)){me.setOffset(Re);break}ke=Pe}return me.offset-pe}prevGraphemeLength(){const fe=ge.getInstance(),me=this.c,pe=me.offset;let ke=fe.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Re=me.offset,Pe=fe.getGraphemeBreakType(me.prevCodePoint());if(Me(Pe,ke)){me.setOffset(Re);break}ke=Pe}return pe-me.offset}eol(){return this.c.eol()}}e.$$e=K;function J(re,fe){return new K(re,fe).nextGraphemeLength()}e.$_e=J;function V(re,fe){return new K(re,fe).prevGraphemeLength()}e.$af=V;function ee(re,fe){fe>0&&z(re.charCodeAt(fe))&&fe--;const me=fe+J(re,fe);return[me-V(re,me),me]}e.$bf=ee;function ne(re){const fe=new K(re);let me=0;for(;!fe.eol();)me++,fe.nextGraphemeLength();return me}e.$cf=ne;let _;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Q(re){return _||(_=se()),_.test(re)}e.$df=Q;const q=/^[\t\n\r\x20-\x7E]*$/;function C(re){return q.test(re)}e.$ef=C,e.$ff=/[\u2028\u2029]/;function L(re){return e.$ff.test(re)}e.$gf=L;function B(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.$hf=B;function N(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.$if=N;function W(re,fe){if(re.length<fe)return re;const me=/\b/g;let pe=0;for(;me.test(re)&&!(re.length-me.lastIndex<fe);)pe=me.lastIndex,me.lastIndex+=1;return re.substring(pe).replace(/^\s/,"")}e.$jf=W;const G=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ie=/\x1b\].*?\x07/g;function oe(re){return re&&(re=re.replace(G,"").replace(ie,"")),re}e.$kf=oe,e.$lf=String.fromCharCode(65279);function ue(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.$mf=ue;function he(re){return ue(re)?re.substr(1):re}e.$nf=he;function $e(re,fe){if(!re||!fe||re.length<fe.length)return!1;const me=fe.length,pe=re.toLowerCase();let ke=0,Re=-1;for(;ke<me;){const Pe=pe.indexOf(fe[ke],Re+1);if(Pe<0)return!1;Re=Pe,ke++}return!0}e.$of=$e;function de(re,fe=!1){return re?(fe&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.$pf=de;function we(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.$qf=we;function ve(re,fe=1){if(fe===0)return"";let me=-1;do me=re.indexOf(`
`,me+1),fe--;while(fe>0&&me>=0);return me===-1?re:(re[me-1]==="\r"&&me--,re.substr(0,me))}e.$rf=ve;function Ie(re){return re=re%(2*26),re<26?String.fromCharCode(97+re):String.fromCharCode(65+re-26)}e.$sf=Ie;function Le(re){return ge.getInstance().getGraphemeBreakType(re)}e.$tf=Le;function Me(re,fe){return re===0?fe!==5&&fe!==7:re===2&&fe===3?!1:re===4||re===2||re===3||fe===4||fe===2||fe===3?!0:!(re===8&&(fe===8||fe===9||fe===11||fe===12)||(re===11||re===9)&&(fe===9||fe===10)||(re===12||re===10)&&fe===10||fe===5||fe===13||fe===7||re===1||re===13&&fe===14||re===6&&fe===6)}var le;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(le||(e.GraphemeBreakType=le={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=be()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const me=this.d,pe=me.length/3;let ke=1;for(;ke<=pe;)if(fe<me[3*ke])ke=2*ke;else if(fe>me[3*ke+1])ke=2*ke+1;else return me[3*ke+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Se(re,fe){if(re===0)return 0;const me=Ce(re,fe);if(me!==void 0)return me;const pe=new H(fe,re);return pe.prevCodePoint(),pe.offset}e.$uf=Se;function Ce(re,fe){const me=new H(fe,re);let pe=me.prevCodePoint();for(;Ue(pe)||pe===65039||pe===8419;){if(me.offset===0)return;pe=me.prevCodePoint()}if(!N(pe))return;let ke=me.offset;return ke>0&&me.prevCodePoint()===8205&&(ke=me.offset),ke}function Ue(re){return 127995<=re&&re<=127999}var je;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.$vf="\xA0";class qe{static{this.c=new F.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$xe(fe=>{function me(Fe){const Be=new Map;for(let ze=0;ze<Fe.length;ze+=2)Be.set(Fe[ze],Fe[ze+1]);return Be}function pe(Fe,Be){const ze=new Map(Fe);for(const[Ve,_e]of Be)ze.set(Ve,_e);return ze}function ke(Fe,Be){if(!Fe)return Be;const ze=new Map;for(const[Ve,_e]of Fe)Be.has(Ve)&&ze.set(Ve,_e);return ze}const Re=this.c.value;let Pe=fe.filter(Fe=>!Fe.startsWith("_")&&Fe in Re);Pe.length===0&&(Pe=["_default"]);let De;for(const Fe of Pe){const Be=me(Re[Fe]);De=ke(De,Be)}const Oe=me(Re._common),Ne=pe(Oe,De);return new qe(Ne)})}static getInstance(fe){return qe.d.get(Array.from(fe))}static{this.e=new F.$U(()=>Object.keys(qe.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return qe.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$wf=qe;class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter(fe){return Te.e().has(fe)}static get codePoints(){return Te.e()}}e.$xf=Te}),define(ae[52],ce([0,1,27]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;function F(c){return j(c,0)}e.$Ei=F;function j(c,u){switch(typeof c){case"object":return c===null?A(349,u):Array.isArray(c)?S(c,u):d(c,u);case"string":return R(c,u);case"boolean":return I(c,u);case"number":return A(c,u);case"undefined":return A(937,u);default:return A(617,u)}}e.$Fi=j;function A(c,u){return(u<<5)-u+c|0}e.$Gi=A;function I(c,u){return A(c?433:863,u)}function R(c,u){u=A(149417,u);for(let f=0,m=c.length;f<m;f++)u=A(c.charCodeAt(f),u);return u}e.$Hi=R;function S(c,u){return u=A(104579,u),c.reduce((f,m)=>j(m,f),u)}function d(c,u){return u=A(181387,u),Object.keys(c).sort().reduce((f,m)=>(f=R(m,f),j(c[m],f)),u)}class P{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=j(u,this.g),this.g}}e.$Ii=P;var E;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function b(c,u,f=32){const m=f-u,k=~((1<<m)-1);return(c<<u|(k&c)>>>m)>>>0}function l(c,u=0,f=c.byteLength,m=0){for(let k=0;k<f;k++)c[u+k]=m}function $(c,u,f="0"){for(;c.length<u;)c=f+c;return c}function p(c,u=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(f=>f.toString(16).padStart(2,"0")).join(""):$((c>>>0).toString(16),u/4)}e.$Ji=p;class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const f=u.length;if(f===0)return;const m=this.p;let k=this.r,s=this.u,a,n;for(s!==0?(a=s,n=-1,s=0):(a=u.charCodeAt(0),n=0);;){let i=a;if(D.$6e(a))if(n+1<f){const t=u.charCodeAt(n+1);D.$7e(t)?(n++,i=D.$8e(a,t)):i=65533}else{s=a;break}else D.$7e(a)&&(i=65533);if(k=this.w(m,k,i),n++,n<f)a=u.charCodeAt(n);else break}this.r=k,this.u=s}w(u,f,m){return m<128?u[f++]=m:m<2048?(u[f++]=192|(m&1984)>>>6,u[f++]=128|(m&63)>>>0):m<65536?(u[f++]=224|(m&61440)>>>12,u[f++]=128|(m&4032)>>>6,u[f++]=128|(m&63)>>>0):(u[f++]=240|(m&1835008)>>>18,u[f++]=128|(m&258048)>>>12,u[f++]=128|(m&4032)>>>6,u[f++]=128|(m&63)>>>0),f>=64&&(this.y(),f-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),f}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=w.g,f=this.q;for(let o=0;o<64;o+=4)u.setUint32(o,f.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)u.setUint32(o,b(u.getUint32(o-12,!1)^u.getUint32(o-32,!1)^u.getUint32(o-56,!1)^u.getUint32(o-64,!1),1),!1);let m=this.h,k=this.l,s=this.m,a=this.n,n=this.o,i,t,r;for(let o=0;o<80;o++)o<20?(i=k&s|~k&a,t=1518500249):o<40?(i=k^s^a,t=1859775393):o<60?(i=k&s|k&a|s&a,t=2400959708):(i=k^s^a,t=3395469782),r=b(m,5)+i+n+t+u.getUint32(o*4,!1)&4294967295,n=a,a=s,s=b(k,30),k=m,m=r;this.h=this.h+m&4294967295,this.l=this.l+k&4294967295,this.m=this.m+s&4294967295,this.n=this.n+a&4294967295,this.o=this.o+n&4294967295}}e.$Ki=w}),define(ae[89],ce([0,1,27]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(j){j[j.Ignore=0]="Ignore",j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(F||(F={})),function(j){const A="error",I="warning",R="warn",S="info",d="ignore";function P(b){return b?D.$2e(A,b)?j.Error:D.$2e(I,b)||D.$2e(R,b)?j.Warning:D.$2e(S,b)?j.Info:j.Ignore:j.Ignore}j.fromValue=P;function E(b){switch(b){case j.Error:return A;case j.Warning:return I;case j.Info:return S;default:return d}}j.toString=E}(F||(F={})),e.default=F}),define(ae[129],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(ae[47],ce([0,1,18,27]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=void 0;class j{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const $=l.charCodeAt(0),p=this.b.charCodeAt(this.c);return $-p}value(){return this.b[this.c]}}e.$Sh=j;class A{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,F.$Ve)(l,this.b,0,l.length,this.c,this.d):(0,F.$Xe)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Th=A;class I{constructor(l=!0,$=!0){this.f=l,this.g=$}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let $=l.length-1;$>=0;$--,this.c--){const p=this.b.charCodeAt($);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,F.$Ve)(l,this.b,0,l.length,this.d,this.e):(0,F.$Xe)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Uh=I;var R;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(R||(R={}));class S{constructor(l,$){this.f=l,this.g=$,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,F.$We)(l,this.c.scheme);if(this.d[this.e]===2)return(0,F.$We)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,F.$Ue)(l,this.c.query);if(this.d[this.e]===5)return(0,F.$Ue)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Vh=S;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(P||(P={}));class E{static forUris(l=()=>!1,$=()=>!1){return new E(new S(l,$))}static forPaths(l=!1){return new E(new I(void 0,!l))}static forStrings(){return new E(new j)}static forConfigKeys(){return new E(new A)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,$){if($){const p=$.slice(0);(0,D.$Wb)(p);for(const w of p)this.set(w,l)}else{const p=l.slice(0);(0,D.$Wb)(p);for(const w of p)this.set(w[0],w[1])}}set(l,$){const p=this.b.reset(l);let w;this.c||(this.c=new d,this.c.segment=p.value());const c=[];for(w=this.c;;){const f=p.cmp(w.segment);if(f>0)w.left||(w.left=new d,w.left.segment=p.value()),c.push([-1,w]),w=w.left;else if(f<0)w.right||(w.right=new d,w.right.segment=p.value()),c.push([1,w]),w=w.right;else if(p.hasNext())p.next(),w.mid||(w.mid=new d,w.mid.segment=p.value()),c.push([0,w]),w=w.mid;else break}const u=w.value;w.value=$,w.key=l;for(let f=c.length-1;f>=0;f--){const m=c[f][1];m.updateHeight();const k=m.balanceFactor();if(k<-1||k>1){const s=c[f][0],a=c[f+1][0];if(s===1&&a===1)c[f][1]=m.rotateLeft();else if(s===-1&&a===-1)c[f][1]=m.rotateRight();else if(s===1&&a===-1)m.right=c[f+1][1]=c[f+1][1].rotateRight(),c[f][1]=m.rotateLeft();else if(s===-1&&a===1)m.left=c[f+1][1]=c[f+1][1].rotateLeft(),c[f][1]=m.rotateRight();else throw new Error;if(f>0)switch(c[f-1][0]){case-1:c[f-1][1].left=c[f][1];break;case 1:c[f-1][1].right=c[f][1];break;case 0:c[f-1][1].mid=c[f][1];break}else this.c=c[0][1]}}return u}get(l){return this.d(l)?.value}d(l){const $=this.b.reset(l);let p=this.c;for(;p;){const w=$.cmp(p.segment);if(w>0)p=p.left;else if(w<0)p=p.right;else if($.hasNext())$.next(),p=p.mid;else break}return p}has(l){const $=this.d(l);return!($?.value===void 0&&$?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,$){const p=this.b.reset(l),w=[];let c=this.c;for(;c;){const u=p.cmp(c.segment);if(u>0)w.push([-1,c]),c=c.left;else if(u<0)w.push([1,c]),c=c.right;else if(p.hasNext())p.next(),w.push([0,c]),c=c.mid;else break}if(c){if($?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const u=this.f(c.right);if(u.key){const{key:f,value:m,segment:k}=u;this.e(u.key,!1),c.key=f,c.value=m,c.segment=k}}else{const u=c.left??c.right;if(w.length>0){const[f,m]=w[w.length-1];switch(f){case-1:m.left=u;break;case 0:m.mid=u;break;case 1:m.right=u;break}}else this.c=u}for(let u=w.length-1;u>=0;u--){const f=w[u][1];f.updateHeight();const m=f.balanceFactor();if(m>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),w[u][1]=f.rotateLeft()):m<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),w[u][1]=f.rotateRight()),u>0)switch(w[u-1][0]){case-1:w[u-1][1].left=w[u][1];break;case 1:w[u-1][1].right=w[u][1];break;case 0:w[u-1][1].mid=w[u][1];break}else this.c=w[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const $=this.b.reset(l);let p=this.c,w;for(;p;){const c=$.cmp(p.segment);if(c>0)p=p.left;else if(c<0)p=p.right;else if($.hasNext())$.next(),w=p.value||w,p=p.mid;else break}return p&&p.value||w}findSuperstr(l){return this.g(l,!1)}g(l,$){const p=this.b.reset(l);let w=this.c;for(;w;){const c=p.cmp(w.segment);if(c>0)w=w.left;else if(c<0)w=w.right;else if(p.hasNext())p.next(),w=w.mid;else return w.mid?this.h(w.mid):$?w.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[$,p]of this)l(p,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const $=[];return this.j(l,$),$[Symbol.iterator]()}j(l,$){l&&(l.left&&this.j(l.left,$),l.value&&$.push([l.key,l.value]),l.mid&&this.j(l.mid,$),l.right&&this.j(l.right,$))}_isBalanced(){const l=$=>{if(!$)return!0;const p=$.balanceFactor();return p<-1||p>1?!1:l($.left)&&l($.right)};return l(this.c)}}e.$Wh=E}),define(ae[12],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=void 0;function D(k){return typeof k=="string"}e.$yf=D;function F(k){return Array.isArray(k)&&k.every(s=>D(s))}e.$zf=F;function j(k){return typeof k=="object"&&k!==null&&!Array.isArray(k)&&!(k instanceof RegExp)&&!(k instanceof Date)}e.$Af=j;function A(k){const s=Object.getPrototypeOf(Uint8Array);return typeof k=="object"&&k instanceof s}e.$Bf=A;function I(k){return typeof k=="number"&&!isNaN(k)}e.$Cf=I;function R(k){return!!k&&typeof k[Symbol.iterator]=="function"}e.$Df=R;function S(k){return k===!0||k===!1}e.$Ef=S;function d(k){return typeof k>"u"}e.$Ff=d;function P(k){return!E(k)}e.$Gf=P;function E(k){return d(k)||k===null}e.$Hf=E;function b(k,s){if(!k)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.$If=b;function l(k){if(E(k))throw new Error("Assertion Failed: argument is undefined or null");return k}e.$Jf=l;function $(...k){const s=[];for(let a=0;a<k.length;a++){const n=k[a];if(E(n))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);s.push(n)}return s}e.$Kf=$;const p=Object.prototype.hasOwnProperty;function w(k){if(!j(k))return!1;for(const s in k)if(p.call(k,s))return!1;return!0}e.$Lf=w;function c(k){return typeof k=="function"}e.$Mf=c;function u(...k){return k.length>0&&k.every(c)}e.$Nf=u;function f(k,s){const a=Math.min(k.length,s.length);for(let n=0;n<a;n++)m(k[n],s[n])}e.$Of=f;function m(k,s){if(D(s)){if(typeof k!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(c(s)){try{if(k instanceof s)return}catch{}if(!E(k)&&k.constructor===s||s.length===1&&s.call(void 0,k)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Pf=m}),define(ae[30],ce([0,1,12]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=void 0;function F(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const u=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([f,m])=>{u[f]=m&&typeof m=="object"?F(m):m}),u}e.$8m=F;function j(c){if(!c||typeof c!="object")return c;const u=[c];for(;u.length>0;){const f=u.shift();Object.freeze(f);for(const m in f)if(A.call(f,m)){const k=f[m];typeof k=="object"&&!Object.isFrozen(k)&&!(0,D.$Bf)(k)&&u.push(k)}}return c}e.$9m=j;const A=Object.prototype.hasOwnProperty;function I(c,u){return R(c,u,new Set)}e.$0m=I;function R(c,u,f){if((0,D.$Hf)(c))return c;const m=u(c);if(typeof m<"u")return m;if(Array.isArray(c)){const k=[];for(const s of c)k.push(R(s,u,f));return k}if((0,D.$Af)(c)){if(f.has(c))throw new Error("Cannot clone recursive data-structure");f.add(c);const k={};for(const s in c)A.call(c,s)&&(k[s]=R(c[s],u,f));return f.delete(c),k}return c}function S(c,u,f=!0){return(0,D.$Af)(c)?((0,D.$Af)(u)&&Object.keys(u).forEach(m=>{m in c?f&&((0,D.$Af)(c[m])&&(0,D.$Af)(u[m])?S(c[m],u[m],f):c[m]=u[m]):c[m]=u[m]}),c):u}e.$$m=S;function d(c,u){if(c===u)return!0;if(c==null||u===null||u===void 0||typeof c!=typeof u||typeof c!="object"||Array.isArray(c)!==Array.isArray(u))return!1;let f,m;if(Array.isArray(c)){if(c.length!==u.length)return!1;for(f=0;f<c.length;f++)if(!d(c[f],u[f]))return!1}else{const k=[];for(m in c)k.push(m);k.sort();const s=[];for(m in u)s.push(m);if(s.sort(),!d(k,s))return!1;for(f=0;f<k.length;f++)if(!d(c[k[f]],u[k[f]]))return!1}return!0}e.$_m=d;function P(c){const u=new Set;return JSON.stringify(c,(f,m)=>{if((0,D.$Af)(m)||Array.isArray(m)){if(u.has(m))return"[Circular]";u.add(m)}return m})}e.$an=P;function E(c,u){const f=Object.create(null);return!c||!u||Object.keys(u).forEach(k=>{const s=c[k],a=u[k];d(s,a)||(f[k]=a)}),f}e.$bn=E;function b(c,u){const f=u.toLowerCase(),m=Object.keys(c).find(k=>k.toLowerCase()===f);return m?c[m]:c[u]}e.$cn=b;function l(c,u){const f=Object.create(null);for(const[m,k]of Object.entries(c))u(m,k)&&(f[m]=k);return f}e.$dn=l;function $(c){let u=[];for(;Object.prototype!==c;)u=u.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return u}e.$en=$;function p(c){const u=[];for(const f of $(c))typeof c[f]=="function"&&u.push(f);return u}e.$fn=p;function w(c,u){const f=k=>function(){const s=Array.prototype.slice.call(arguments,0);return u(k,s)},m={};for(const k of c)m[k]=f(k);return m}e.$gn=w}),define(ae[32],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(j){return D.test(j)}e.$dg=F,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let j;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?j=crypto.getRandomValues.bind(crypto):j=function(R){for(let S=0;S<R.length;S++)R[S]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),I=[];for(let R=0;R<256;R++)I.push(R.toString(16).padStart(2,"0"));return function(){j(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let S=0,d="";return d+=I[A[S++]],d+=I[A[S++]],d+=I[A[S++]],d+=I[A[S++]],d+="-",d+=I[A[S++]],d+=I[A[S++]],d+="-",d+=I[A[S++]],d+=I[A[S++]],d+="-",d+=I[A[S++]],d+=I[A[S++]],d+="-",d+=I[A[S++]],d+=I[A[S++]],d+=I[A[S++]],d+=I[A[S++]],d+=I[A[S++]],d+=I[A[S++]],d}}()}),define(ae[130],ce([0,1,36]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=void 0;const F=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function j(I){const R=I.replace(/\-/g,":").toLowerCase();return!F.has(R)}function A(){const I=(0,D.networkInterfaces)();for(const R in I){const S=I[R];if(S){for(const{mac:d}of S)if(j(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Rm=A}),define(ae[131],ce([0,1,267,15]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FT=void 0;class j extends D.Transform{constructor(I){if(super(),typeof I=="number")this.b=I,this.c=1;else{const R=Buffer.isBuffer(I)?I:Buffer.from(I);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(I,R,S){this.a?this.a=Buffer.concat([this.a,I]):this.a=I;let d=0;for(;d<this.a.length;){const P=typeof this.b=="number"?this.a.indexOf(this.b,d):(0,F.$ce)(this.a,this.b,d);if(P===-1)break;this.push(this.a.slice(d,P+this.c)),d=P+this.c}this.a=d===this.a.length?void 0:this.a.slice(d),S()}_flush(I){this.a&&this.push(this.a),I()}}e.$FT=j}),define(ae[132],ce([0,1,63]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=void 0;function F(R,S,d,P=1){let E=!1;return new Promise(b=>{const l=setTimeout(()=>{if(!E)return E=!0,b(0)},d);j(R,S,P,$=>{if(!E)return E=!0,clearTimeout(l),b($)})})}e.$gg=F;function j(R,S,d,P){if(S===0)return P(0);const E=new D.Socket;E.once("connect",()=>(I(E),j(R+d,S-1,d,P))),E.once("data",()=>{}),E.once("error",b=>(I(E),b.code!=="ECONNREFUSED"?j(R+d,S-1,d,P):P(R))),E.connect(R,"127.0.0.1")}e.$hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,S,d,P="127.0.0.1"){let E=!1,b,l=1;const $=D.createServer({pauseOnConnect:!0});function p(w,c){E||(E=!0,$.removeAllListeners(),$.close(),b&&clearTimeout(b),c(w))}return new Promise(w=>{b=setTimeout(()=>{p(0,w)},d),$.on("listening",()=>{p(R,w)}),$.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&l<S?(R++,l++,$.listen(R,P)):p(0,w)}),$.on("close",()=>{p(0,w)}),$.listen(R,P)})}e.$ig=A;function I(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(S){console.error(S)}}}),define(ae[133],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VT=void 0;function D(F){return!!F.parentPort}e.$VT=D}),define(ae[134],ce([13,9]),function(te,e){return te.create("vs/base/common/date",e)}),define(ae[64],ce([0,1,134]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=e.$em=void 0;const F=60,j=F*60,A=j*24,I=A*7,R=A*30,S=A*365;function d(E,b,l,$){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return(0,D.localize)(0,null,d(new Date().getTime()+p*1e3,!1));if(!$&&p<30)return(0,D.localize)(1,null);let w;return p<F?(w=p,b?w===1?l?(0,D.localize)(2,null,w):(0,D.localize)(3,null,w):l?(0,D.localize)(4,null,w):(0,D.localize)(5,null,w):w===1?l?(0,D.localize)(6,null,w):(0,D.localize)(7,null,w):l?(0,D.localize)(8,null,w):(0,D.localize)(9,null,w)):p<j?(w=Math.floor(p/F),b?w===1?l?(0,D.localize)(10,null,w):(0,D.localize)(11,null,w):l?(0,D.localize)(12,null,w):(0,D.localize)(13,null,w):w===1?l?(0,D.localize)(14,null,w):(0,D.localize)(15,null,w):l?(0,D.localize)(16,null,w):(0,D.localize)(17,null,w)):p<A?(w=Math.floor(p/j),b?w===1?l?(0,D.localize)(18,null,w):(0,D.localize)(19,null,w):l?(0,D.localize)(20,null,w):(0,D.localize)(21,null,w):w===1?l?(0,D.localize)(22,null,w):(0,D.localize)(23,null,w):l?(0,D.localize)(24,null,w):(0,D.localize)(25,null,w)):p<I?(w=Math.floor(p/A),b?w===1?(0,D.localize)(26,null,w):(0,D.localize)(27,null,w):w===1?(0,D.localize)(28,null,w):(0,D.localize)(29,null,w)):p<R?(w=Math.floor(p/I),b?w===1?l?(0,D.localize)(30,null,w):(0,D.localize)(31,null,w):l?(0,D.localize)(32,null,w):(0,D.localize)(33,null,w):w===1?l?(0,D.localize)(34,null,w):(0,D.localize)(35,null,w):l?(0,D.localize)(36,null,w):(0,D.localize)(37,null,w)):p<S?(w=Math.floor(p/R),b?w===1?l?(0,D.localize)(38,null,w):(0,D.localize)(39,null,w):l?(0,D.localize)(40,null,w):(0,D.localize)(41,null,w):w===1?l?(0,D.localize)(42,null,w):(0,D.localize)(43,null,w):l?(0,D.localize)(44,null,w):(0,D.localize)(45,null,w)):(w=Math.floor(p/S),b?w===1?l?(0,D.localize)(46,null,w):(0,D.localize)(47,null,w):l?(0,D.localize)(48,null,w):(0,D.localize)(49,null,w):w===1?l?(0,D.localize)(50,null,w):(0,D.localize)(51,null,w):l?(0,D.localize)(52,null,w):(0,D.localize)(53,null,w))}e.$em=d;function P(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$fm=P}),define(ae[135],ce([13,9]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(ae[38],ce([0,1,18,12,135]),function(te,e,D,F,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=void 0;function A(E,b){return b&&(E.stack||E.stacktrace)?j.localize(0,null,R(E),I(E.stack)||I(E.stacktrace)):R(E)}function I(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?j.localize(1,null,E.message):E.message||j.localize(2,null)}function S(E=null,b=!1){if(!E)return j.localize(3,null);if(Array.isArray(E)){const l=D.$Gb(E),$=S(l[0],b);return l.length>1?j.localize(4,null,$,l.length):$}if(F.$yf(E))return E;if(E.detail){const l=E.detail;if(l.error)return A(l.error,b);if(l.exception)return A(l.exception,b)}return E.stack?A(E,b):E.message?E.message:j.localize(5,null)}e.$Bi=S;function d(E){const b=E;return b instanceof Error&&Array.isArray(b.actions)}e.$Ci=d;function P(E,b){let l;return typeof E=="string"?l=new Error(E):l=E,l.actions=b,l}e.$Di=P}),define(ae[136],ce([13,9]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(ae[137],ce([0,1,136]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;function F(j){switch(j){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.$xp=F}),define(ae[138],ce([13,9]),function(te,e){return te.create("vs/base/common/platform",e)}),define(ae[5],ce([0,1,138]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let F=!1,j=!1,A=!1,I=!1,R=!1,S=!1,d=!1,P=!1,E=!1,b=!1,l,$=e.$g,p=e.$g,w,c;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?u=e.$h.vscode.process:typeof process<"u"&&(u=process);const f=typeof u?.versions?.electron=="string",m=f&&u?.type==="renderer";if(typeof navigator=="object"&&!m)c=navigator.userAgent,F=c.indexOf("Windows")>=0,j=c.indexOf("Macintosh")>=0,P=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=c.indexOf("Linux")>=0,b=c?.indexOf("Mobi")>=0,S=!0,l=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,$=l,p=navigator.language;else if(typeof u=="object"){F=u.platform==="win32",j=u.platform==="darwin",A=u.platform==="linux",I=A&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,d=f,E=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.$g,$=e.$g;const v=u.env.VSCODE_NLS_CONFIG;if(v)try{const y=JSON.parse(v),h=y.availableLanguages["*"];l=y.locale,p=y.osLocale,$=h||e.$g,w=y._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var k;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(k||(e.Platform=k={}));function s(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=s;let a=0;j?a=1:F?a=3:A&&(a=2),e.$j=F,e.$k=j,e.$l=A,e.$m=I,e.$n=R,e.$o=d,e.$p=S,e.$q=S&&typeof e.$h.importScripts=="function",e.$r=P,e.$s=b,e.$t=E,e.$u=a,e.$v=c,e.$w=$;var n;(function(v){function y(){return e.$w}v.value=y;function h(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}v.isDefaultVariant=h;function g(){return e.$w==="en"}v.isDefault=g})(n||(e.Language=n={})),e.$x=l,e.$y=p,e.$z=w,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const v=[];e.$h.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let g=0,O=v.length;g<O;g++){const T=v[g];if(T.id===h.data.vscodeScheduleAsyncWork){v.splice(g,1),T.callback();return}}});let y=0;return h=>{const g=++y;v.push({id:g,callback:h}),e.$h.postMessage({vscodeScheduleAsyncWork:g},"*")}}return v=>setTimeout(v)})();var i;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=j||P?2:F?1:3;let t=!0,r=!1;function o(){if(!r){r=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,t=new Uint16Array(v.buffer)[0]===(2<<8)+1}return t}e.$D=o,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ae[37],ce([0,1,5]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let F;if(typeof D.$h.vscode<"u"&&typeof D.$h.vscode.process<"u"){const j=D.$h.vscode.process;F={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return D.$j?"win32":D.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.$cc=F.platform,e.$dc=F.arch}),define(ae[16],ce([0,1,37]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const F=65,j=97,A=90,I=122,R=46,S=47,d=92,P=58,E=63;class b extends Error{constructor(a,n,i){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=a.indexOf(".")!==-1?"property":"argument";let o=`The "${a}" ${r} ${t} of type ${n}`;o+=`. Received type ${typeof i}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function l(s,a){if(s===null||typeof s!="object")throw new b(a,"Object",s)}function $(s,a){if(typeof s!="string")throw new b(a,"string",s)}const p=D.$cc==="win32";function w(s){return s===S||s===d}function c(s){return s===S}function u(s){return s>=F&&s<=A||s>=j&&s<=I}function f(s,a,n,i){let t="",r=0,o=-1,v=0,y=0;for(let h=0;h<=s.length;++h){if(h<s.length)y=s.charCodeAt(h);else{if(i(y))break;y=S}if(i(y)){if(!(o===h-1||v===1))if(v===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const g=t.lastIndexOf(n);g===-1?(t="",r=0):(t=t.slice(0,g),r=t.length-1-t.lastIndexOf(n)),o=h,v=0;continue}else if(t.length!==0){t="",r=0,o=h,v=0;continue}}a&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${s.slice(o+1,h)}`:t=s.slice(o+1,h),r=h-o-1;o=h,v=0}else y===R&&v!==-1?++v:v=-1}return t}function m(s,a){l(a,"pathObject");const n=a.dir||a.root,i=a.base||`${a.name||""}${a.ext||""}`;return n?n===a.root?`${n}${i}`:`${n}${s}${i}`:i}e.$ec={resolve(...s){let a="",n="",i=!1;for(let t=s.length-1;t>=-1;t--){let r;if(t>=0){if(r=s[t],$(r,"path"),r.length===0)continue}else a.length===0?r=D.cwd():(r=D.env[`=${a}`]||D.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===d)&&(r=`${a}\\`));const o=r.length;let v=0,y="",h=!1;const g=r.charCodeAt(0);if(o===1)w(g)&&(v=1,h=!0);else if(w(g))if(h=!0,w(r.charCodeAt(1))){let O=2,T=O;for(;O<o&&!w(r.charCodeAt(O));)O++;if(O<o&&O!==T){const M=r.slice(T,O);for(T=O;O<o&&w(r.charCodeAt(O));)O++;if(O<o&&O!==T){for(T=O;O<o&&!w(r.charCodeAt(O));)O++;(O===o||O!==T)&&(y=`\\\\${M}\\${r.slice(T,O)}`,v=O)}}}else v=1;else u(g)&&r.charCodeAt(1)===P&&(y=r.slice(0,2),v=2,o>2&&w(r.charCodeAt(2))&&(h=!0,v=3));if(y.length>0)if(a.length>0){if(y.toLowerCase()!==a.toLowerCase())continue}else a=y;if(i){if(a.length>0)break}else if(n=`${r.slice(v)}\\${n}`,i=h,h&&a.length>0)break}return n=f(n,!i,"\\",w),i?`${a}\\${n}`:`${a}${n}`||"."},normalize(s){$(s,"path");const a=s.length;if(a===0)return".";let n=0,i,t=!1;const r=s.charCodeAt(0);if(a===1)return c(r)?"\\":s;if(w(r))if(t=!0,w(s.charCodeAt(1))){let v=2,y=v;for(;v<a&&!w(s.charCodeAt(v));)v++;if(v<a&&v!==y){const h=s.slice(y,v);for(y=v;v<a&&w(s.charCodeAt(v));)v++;if(v<a&&v!==y){for(y=v;v<a&&!w(s.charCodeAt(v));)v++;if(v===a)return`\\\\${h}\\${s.slice(y)}\\`;v!==y&&(i=`\\\\${h}\\${s.slice(y,v)}`,n=v)}}}else n=1;else u(r)&&s.charCodeAt(1)===P&&(i=s.slice(0,2),n=2,a>2&&w(s.charCodeAt(2))&&(t=!0,n=3));let o=n<a?f(s.slice(n),!t,"\\",w):"";return o.length===0&&!t&&(o="."),o.length>0&&w(s.charCodeAt(a-1))&&(o+="\\"),i===void 0?t?`\\${o}`:o:t?`${i}\\${o}`:`${i}${o}`},isAbsolute(s){$(s,"path");const a=s.length;if(a===0)return!1;const n=s.charCodeAt(0);return w(n)||a>2&&u(n)&&s.charCodeAt(1)===P&&w(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let a,n;for(let r=0;r<s.length;++r){const o=s[r];$(o,"path"),o.length>0&&(a===void 0?a=n=o:a+=`\\${o}`)}if(a===void 0)return".";let i=!0,t=0;if(typeof n=="string"&&w(n.charCodeAt(0))){++t;const r=n.length;r>1&&w(n.charCodeAt(1))&&(++t,r>2&&(w(n.charCodeAt(2))?++t:i=!1))}if(i){for(;t<a.length&&w(a.charCodeAt(t));)t++;t>=2&&(a=`\\${a.slice(t)}`)}return e.$ec.normalize(a)},relative(s,a){if($(s,"from"),$(a,"to"),s===a)return"";const n=e.$ec.resolve(s),i=e.$ec.resolve(a);if(n===i||(s=n.toLowerCase(),a=i.toLowerCase(),s===a))return"";let t=0;for(;t<s.length&&s.charCodeAt(t)===d;)t++;let r=s.length;for(;r-1>t&&s.charCodeAt(r-1)===d;)r--;const o=r-t;let v=0;for(;v<a.length&&a.charCodeAt(v)===d;)v++;let y=a.length;for(;y-1>v&&a.charCodeAt(y-1)===d;)y--;const h=y-v,g=o<h?o:h;let O=-1,T=0;for(;T<g;T++){const U=s.charCodeAt(t+T);if(U!==a.charCodeAt(v+T))break;U===d&&(O=T)}if(T!==g){if(O===-1)return i}else{if(h>g){if(a.charCodeAt(v+T)===d)return i.slice(v+T+1);if(T===2)return i.slice(v+T)}o>g&&(s.charCodeAt(t+T)===d?O=T:T===2&&(O=3)),O===-1&&(O=0)}let M="";for(T=t+O+1;T<=r;++T)(T===r||s.charCodeAt(T)===d)&&(M+=M.length===0?"..":"\\..");return v+=O,M.length>0?`${M}${i.slice(v,y)}`:(i.charCodeAt(v)===d&&++v,i.slice(v,y))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const a=e.$ec.resolve(s);if(a.length<=2)return s;if(a.charCodeAt(0)===d){if(a.charCodeAt(1)===d){const n=a.charCodeAt(2);if(n!==E&&n!==R)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(u(a.charCodeAt(0))&&a.charCodeAt(1)===P&&a.charCodeAt(2)===d)return`\\\\?\\${a}`;return s},dirname(s){$(s,"path");const a=s.length;if(a===0)return".";let n=-1,i=0;const t=s.charCodeAt(0);if(a===1)return w(t)?s:".";if(w(t)){if(n=i=1,w(s.charCodeAt(1))){let v=2,y=v;for(;v<a&&!w(s.charCodeAt(v));)v++;if(v<a&&v!==y){for(y=v;v<a&&w(s.charCodeAt(v));)v++;if(v<a&&v!==y){for(y=v;v<a&&!w(s.charCodeAt(v));)v++;if(v===a)return s;v!==y&&(n=i=v+1)}}}}else u(t)&&s.charCodeAt(1)===P&&(n=a>2&&w(s.charCodeAt(2))?3:2,i=n);let r=-1,o=!0;for(let v=a-1;v>=i;--v)if(w(s.charCodeAt(v))){if(!o){r=v;break}}else o=!1;if(r===-1){if(n===-1)return".";r=n}return s.slice(0,r)},basename(s,a){a!==void 0&&$(a,"ext"),$(s,"path");let n=0,i=-1,t=!0,r;if(s.length>=2&&u(s.charCodeAt(0))&&s.charCodeAt(1)===P&&(n=2),a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let o=a.length-1,v=-1;for(r=s.length-1;r>=n;--r){const y=s.charCodeAt(r);if(w(y)){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),o>=0&&(y===a.charCodeAt(o)?--o===-1&&(i=r):(o=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=n;--r)if(w(s.charCodeAt(r))){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){$(s,"path");let a=0,n=-1,i=0,t=-1,r=!0,o=0;s.length>=2&&s.charCodeAt(1)===P&&u(s.charCodeAt(0))&&(a=i=2);for(let v=s.length-1;v>=a;--v){const y=s.charCodeAt(v);if(w(y)){if(!r){i=v+1;break}continue}t===-1&&(r=!1,t=v+1),y===R?n===-1?n=v:o!==1&&(o=1):n!==-1&&(o=-1)}return n===-1||t===-1||o===0||o===1&&n===t-1&&n===i+1?"":s.slice(n,t)},format:m.bind(null,"\\"),parse(s){$(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const n=s.length;let i=0,t=s.charCodeAt(0);if(n===1)return w(t)?(a.root=a.dir=s,a):(a.base=a.name=s,a);if(w(t)){if(i=1,w(s.charCodeAt(1))){let O=2,T=O;for(;O<n&&!w(s.charCodeAt(O));)O++;if(O<n&&O!==T){for(T=O;O<n&&w(s.charCodeAt(O));)O++;if(O<n&&O!==T){for(T=O;O<n&&!w(s.charCodeAt(O));)O++;O===n?i=O:O!==T&&(i=O+1)}}}}else if(u(t)&&s.charCodeAt(1)===P){if(n<=2)return a.root=a.dir=s,a;if(i=2,w(s.charCodeAt(2))){if(n===3)return a.root=a.dir=s,a;i=3}}i>0&&(a.root=s.slice(0,i));let r=-1,o=i,v=-1,y=!0,h=s.length-1,g=0;for(;h>=i;--h){if(t=s.charCodeAt(h),w(t)){if(!y){o=h+1;break}continue}v===-1&&(y=!1,v=h+1),t===R?r===-1?r=h:g!==1&&(g=1):r!==-1&&(g=-1)}return v!==-1&&(r===-1||g===0||g===1&&r===v-1&&r===o+1?a.base=a.name=s.slice(o,v):(a.name=s.slice(o,r),a.base=s.slice(o,v),a.ext=s.slice(r,v))),o>0&&o!==i?a.dir=s.slice(0,o-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const k=(()=>{if(p){const s=/\\/g;return()=>{const a=D.cwd().replace(s,"/");return a.slice(a.indexOf("/"))}}return()=>D.cwd()})();e.$fc={resolve(...s){let a="",n=!1;for(let i=s.length-1;i>=-1&&!n;i--){const t=i>=0?s[i]:k();$(t,"path"),t.length!==0&&(a=`${t}/${a}`,n=t.charCodeAt(0)===S)}return a=f(a,!n,"/",c),n?`/${a}`:a.length>0?a:"."},normalize(s){if($(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===S,n=s.charCodeAt(s.length-1)===S;return s=f(s,!a,"/",c),s.length===0?a?"/":n?"./":".":(n&&(s+="/"),a?`/${s}`:s)},isAbsolute(s){return $(s,"path"),s.length>0&&s.charCodeAt(0)===S},join(...s){if(s.length===0)return".";let a;for(let n=0;n<s.length;++n){const i=s[n];$(i,"path"),i.length>0&&(a===void 0?a=i:a+=`/${i}`)}return a===void 0?".":e.$fc.normalize(a)},relative(s,a){if($(s,"from"),$(a,"to"),s===a||(s=e.$fc.resolve(s),a=e.$fc.resolve(a),s===a))return"";const n=1,i=s.length,t=i-n,r=1,o=a.length-r,v=t<o?t:o;let y=-1,h=0;for(;h<v;h++){const O=s.charCodeAt(n+h);if(O!==a.charCodeAt(r+h))break;O===S&&(y=h)}if(h===v)if(o>v){if(a.charCodeAt(r+h)===S)return a.slice(r+h+1);if(h===0)return a.slice(r+h)}else t>v&&(s.charCodeAt(n+h)===S?y=h:h===0&&(y=0));let g="";for(h=n+y+1;h<=i;++h)(h===i||s.charCodeAt(h)===S)&&(g+=g.length===0?"..":"/..");return`${g}${a.slice(r+y)}`},toNamespacedPath(s){return s},dirname(s){if($(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===S;let n=-1,i=!0;for(let t=s.length-1;t>=1;--t)if(s.charCodeAt(t)===S){if(!i){n=t;break}}else i=!1;return n===-1?a?"/":".":a&&n===1?"//":s.slice(0,n)},basename(s,a){a!==void 0&&$(a,"ext"),$(s,"path");let n=0,i=-1,t=!0,r;if(a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let o=a.length-1,v=-1;for(r=s.length-1;r>=0;--r){const y=s.charCodeAt(r);if(y===S){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),o>=0&&(y===a.charCodeAt(o)?--o===-1&&(i=r):(o=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===S){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){$(s,"path");let a=-1,n=0,i=-1,t=!0,r=0;for(let o=s.length-1;o>=0;--o){const v=s.charCodeAt(o);if(v===S){if(!t){n=o+1;break}continue}i===-1&&(t=!1,i=o+1),v===R?a===-1?a=o:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||i===-1||r===0||r===1&&a===i-1&&a===n+1?"":s.slice(a,i)},format:m.bind(null,"/"),parse(s){$(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const n=s.charCodeAt(0)===S;let i;n?(a.root="/",i=1):i=0;let t=-1,r=0,o=-1,v=!0,y=s.length-1,h=0;for(;y>=i;--y){const g=s.charCodeAt(y);if(g===S){if(!v){r=y+1;break}continue}o===-1&&(v=!1,o=y+1),g===R?t===-1?t=y:h!==1&&(h=1):t!==-1&&(h=-1)}if(o!==-1){const g=r===0&&n?1:r;t===-1||h===0||h===1&&t===o-1&&t===r+1?a.base=a.name=s.slice(g,o):(a.name=s.slice(g,t),a.base=s.slice(g,o),a.ext=s.slice(t,o))}return r>0?a.dir=s.slice(0,r-1):n&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=p?e.$ec.normalize:e.$fc.normalize,e.$hc=p?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=p?e.$ec.join:e.$fc.join,e.$jc=p?e.$ec.resolve:e.$fc.resolve,e.$kc=p?e.$ec.relative:e.$fc.relative,e.$lc=p?e.$ec.dirname:e.$fc.dirname,e.$mc=p?e.$ec.basename:e.$fc.basename,e.$nc=p?e.$ec.extname:e.$fc.extname,e.$oc=p?e.$ec.format:e.$fc.format,e.$pc=p?e.$ec.parse:e.$fc.parse,e.$qc=p?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=p?e.$ec.sep:e.$fc.sep,e.$sc=p?e.$ec.delimiter:e.$fc.delimiter}),define(ae[48],ce([0,1,16,5,27,12]),function(te,e,D,F,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function I(r){return r===47||r===92}e.$Qf=I;function R(r){return r.replace(/[\\/]/g,D.$fc.sep)}e.$Rf=R;function S(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Sf=S;function d(r,o=D.$fc.sep){if(!r)return"";const v=r.length,y=r.charCodeAt(0);if(I(y)){if(I(r.charCodeAt(1))&&!I(r.charCodeAt(2))){let g=3;const O=g;for(;g<v&&!I(r.charCodeAt(g));g++);if(O!==g&&!I(r.charCodeAt(g+1))){for(g+=1;g<v;g++)if(I(r.charCodeAt(g)))return r.slice(0,g+1).replace(/[\\/]/g,o)}}return o}else if(c(y)&&r.charCodeAt(1)===58)return I(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let h=r.indexOf("://");if(h!==-1){for(h+=3;h<v;h++)if(I(r.charCodeAt(h)))return r.slice(0,h+1)}return""}e.$Tf=d;function P(r){if(!F.$j||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let v=2;const y=v;for(;v<r.length&&(o=r.charCodeAt(v),o!==92);v++);return!(y===v||(o=r.charCodeAt(v+1),isNaN(o)||o===92))}e.$Uf=P;const E=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(r,o=F.$j){const v=o?E:b;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||o&&l.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.$Vf=$;function p(r,o,v){const y=r===o;return!v||y?y:!r||!o?!1:(0,j.$2e)(r,o)}e.$Wf=p;function w(r,o,v,y=D.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(v){if(!(0,j.$3e)(r,o))return!1;if(o.length===r.length)return!0;let g=o.length;return o.charAt(o.length-1)===y&&g--,r.charAt(g)===y}return o.charAt(o.length-1)!==y&&(o+=y),r.indexOf(o)===0}e.$Xf=w;function c(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Yf=c;function u(r,o){return F.$j&&r.endsWith(":")&&(r+=D.sep),(0,D.$hc)(r)||(r=(0,D.$ic)(o,r)),r=(0,D.$gc)(r),F.$j?(r=(0,j.$Ke)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,j.$Ke)(r,D.sep),r||(r=D.sep)),r}e.$Zf=u;function f(r){const o=(0,D.$gc)(r);return F.$j?r.length>3?!1:m(o)&&(r.length===2||o.charCodeAt(2)===92):o===D.$fc.sep}e.$1f=f;function m(r,o=F.$j){return o?c(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$2f=m;function k(r,o=F.$j){return m(r,o)?r[0]:void 0}e.$3f=k;function s(r,o,v){return o.length>r.length?-1:r===o?0:(v&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.$4f=s;function a(r){const o=r.split(":");let v,y,h;for(const g of o){const O=Number(g);(0,A.$Cf)(O)?y===void 0?y=O:h===void 0&&(h=O):v=v?[v,g].join(":"):g}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:y!==void 0?y:void 0,column:h!==void 0?h:y!==void 0?1:void 0}}e.$5f=a;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,o,v=8){let y="";for(let g=0;g<v;g++){let O;g===0&&F.$j&&!o&&(v===3||v===4)?O=i:O=n,y+=O.charAt(Math.floor(Math.random()*O.length))}let h;return o?h=`${o}-${y}`:h=y,r?(0,D.$ic)(r,h):h}e.$6f=t}),define(ae[139],ce([0,1,16]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=e.$Tr=e.$Sr=e.$Rr=e.$Qr=void 0,e.$Qr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},j={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(P){const E=(0,D.$nc)(P),b=F[E.toLowerCase()];return b!==void 0?b:I(P)}e.$Rr=A;function I(P){const E=(0,D.$nc)(P);return j[E.toLowerCase()]}e.$Sr=I;function R(P){for(const E in j)if(j[E]===P)return E}e.$Tr=R;const S=/^(.+)\/(.+?)(;.+)?$/;function d(P,E){const b=S.exec(P);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:E?void 0:P}e.$Ur=d}),define(ae[90],ce([0,1,5]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.$Al=e.TerminateResponseCode=e.Source=void 0;var F;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(F||(e.Source=F={}));var j;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(j||(e.TerminateResponseCode=j={}));function A(R,...S){const d=S.reduce((b,l)=>(b[l]=!0,b),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(b=>!d[b]).forEach(b=>{for(let l=0;l<P.length;l++)if(b.search(P[l])!==-1){delete R[b];break}})}e.$Al=A;function I(R){R&&(delete R.DEBUG,D.$k&&delete R.DYLD_LIBRARY_PATH,D.$l&&delete R.LD_PRELOAD)}e.$Bl=I}),define(ae[10],ce([0,1,16,5]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const j=/^\w[\w\d+.-]*$/,A=/^\//,I=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!j.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(i,t){return!i&&!t?"file":i}function d(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const P="",E="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(t){return t instanceof l?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,o,v,y,h=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=S(t,h),this.authority=r||P,this.path=d(this.scheme,o||P),this.query=v||P,this.fragment=y||P,R(this,h))}get fsPath(){return m(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:o,path:v,query:y,fragment:h}=t;return r===void 0?r=this.scheme:r===null&&(r=P),o===void 0?o=this.authority:o===null&&(o=P),v===void 0?v=this.path:v===null&&(v=P),y===void 0?y=this.query:y===null&&(y=P),h===void 0?h=this.fragment:h===null&&(h=P),r===this.scheme&&o===this.authority&&v===this.path&&y===this.query&&h===this.fragment?this:new w(r,o,v,y,h)}static parse(t,r=!1){const o=b.exec(t);return o?new w(o[2]||P,n(o[4]||P),n(o[5]||P),n(o[7]||P),n(o[9]||P),r):new w(P,P,P,P,P)}static file(t){let r=P;if(F.$j&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const o=t.indexOf(E,2);o===-1?(r=t.substring(2),t=E):(r=t.substring(2,o),t=t.substring(o)||E)}return new w("file",r,t,P,P)}static from(t,r){return new w(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return F.$j&&t.scheme==="file"?o=l.file(D.$ec.join(m(t,!0),...r)).path:o=D.$fc.join(t.path,...r),t.with({path:o})}toString(t=!1){return k(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof l)return t;{const r=new w(t);return r._formatted=t.external??null,r._fsPath=t._sep===p?t.fsPath??null:null,r}}else return t}}e.URI=l;function $(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$uc=$;const p=F.$j?1:void 0;class w extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(t=!1){return t?k(this,!0):(this._formatted||(this._formatted=k(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=p),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,t,r){let o,v=-1;for(let y=0;y<i.length;y++){const h=i.charCodeAt(y);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||t&&h===47||r&&h===91||r&&h===93||r&&h===58)v!==-1&&(o+=encodeURIComponent(i.substring(v,y)),v=-1),o!==void 0&&(o+=i.charAt(y));else{o===void 0&&(o=i.substr(0,y));const g=c[h];g!==void 0?(v!==-1&&(o+=encodeURIComponent(i.substring(v,y)),v=-1),o+=g):v===-1&&(v=y)}}return v!==-1&&(o+=encodeURIComponent(i.substring(v))),o!==void 0?o:i}function f(i){let t;for(let r=0;r<i.length;r++){const o=i.charCodeAt(r);o===35||o===63?(t===void 0&&(t=i.substr(0,r)),t+=c[o]):t!==void 0&&(t+=i[r])}return t!==void 0?t:i}function m(i,t){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,F.$j&&(r=r.replace(/\//g,"\\")),r}e.$vc=m;function k(i,t){const r=t?f:u;let o="",{scheme:v,authority:y,path:h,query:g,fragment:O}=i;if(v&&(o+=v,o+=":"),(y||v==="file")&&(o+=E,o+=E),y){let T=y.indexOf("@");if(T!==-1){const M=y.substr(0,T);y=y.substr(T+1),T=M.lastIndexOf(":"),T===-1?o+=r(M,!1,!1):(o+=r(M.substr(0,T),!1,!1),o+=":",o+=r(M.substr(T+1),!1,!0)),o+="@"}y=y.toLowerCase(),T=y.lastIndexOf(":"),T===-1?o+=r(y,!1,!0):(o+=r(y.substr(0,T),!1,!0),o+=y.substr(T))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const T=h.charCodeAt(1);T>=65&&T<=90&&(h=`/${String.fromCharCode(T+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const T=h.charCodeAt(0);T>=65&&T<=90&&(h=`${String.fromCharCode(T+32)}:${h.substr(2)}`)}o+=r(h,!0,!1)}return g&&(o+="?",o+=r(g,!1,!1)),O&&(o+="#",o+=t?O:u(O,!1,!1)),o}function s(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(a)?i.replace(a,t=>s(t)):i}}),define(ae[140],ce([0,1,10]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$1p=e.$Zp=e.$Yp=void 0;function F(d){const P=d;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$Yp=F;function j(d){const P=[];let E;try{const b=JSON.parse(d.arguments),l=b[b.length-1];l&&l.__$stack&&(b.pop(),E=l.__$stack),P.push(...b)}catch{P.push("Unable to log remote console arguments",d.arguments)}return{args:P,stack:E}}e.$Zp=j;function A(d){if(typeof d!="string")return A(j(d).stack);const P=d;if(P){const E=I(P),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(b&&b.length===4)return{uri:D.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.$1p=A;function I(d){if(!d)return d;const P=d.indexOf(`
`);return P===-1?d:d.substring(0,P)}function R(d,P){const{args:E,stack:b}=j(d),l=typeof E[0]=="string"&&E.length===1;let $=I(b);$&&($=`(${$.trim()})`);let p=[];if(typeof E[0]=="string"?$&&l?p=[`%c[${P}] %c${E[0]} %c${$}`,S("blue"),S(""),S("grey")]:p=[`%c[${P}] %c${E[0]}`,S("blue"),S(""),...E.slice(1)]:p=[`%c[${P}]%`,S("blue"),...E],$&&!l&&p.push($),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,p)}e.log=R;function S(d){return`color: ${d}`}}),define(ae[65],ce([0,1,15,10]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=e.$mh=e.$lh=void 0;function j(S){return JSON.stringify(S,I)}e.$lh=j;function A(S){let d=JSON.parse(S);return d=R(d),d}e.$mh=A;function I(S,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:d.flags}:d}function R(S,d=0){if(!S||d>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return F.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 17:return new Date(S.source)}if(S instanceof D.$be||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let P=0;P<S.length;++P)S[P]=R(S[P],d+1);else for(const P in S)Object.hasOwnProperty.call(S,P)&&(S[P]=R(S[P],d+1))}return S}e.$nh=R}),define(ae[23],ce([0,1,7,5,10]),function(te,e,D,F,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var A;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.$7f="vscode-tkn",e.$8f="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${A.vscodeRemoteResource}`}set(P,E,b){this.a[P]=E,this.b[P]=b}setConnectionToken(P,E){this.c[P]=E}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(w){return D.$Z(w),P}const E=P.authority;let b=this.a[E];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const l=this.b[E],$=this.c[E];let p=`path=${encodeURIComponent(P.path)}`;return typeof $=="string"&&(p+=`&${e.$8f}=${encodeURIComponent($)}`),j.URI.from({scheme:F.$p?this.d:A.vscodeRemoteResource,authority:`${b}:${l}`,path:this.f,query:p})}}e.$9f=new I,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class R{static{this.a=e.$bg}asBrowserUri(P){const E=this.b(P,te);return this.uriToBrowserUri(E)}uriToBrowserUri(P){return P.scheme===A.vscodeRemote?e.$9f.rewrite(P):P.scheme===A.file&&(F.$n||F.$q&&F.$h.origin===`${A.vscodeFileResource}://${R.a}`)?P.with({scheme:A.vscodeFileResource,authority:P.authority||R.a,query:null,fragment:null}):P}asFileUri(P){const E=this.b(P,te);return this.uriToFileUri(E)}uriToFileUri(P){return P.scheme===A.vscodeFileResource?P.with({scheme:A.file,authority:P.authority!==R.a?P.authority:null,query:null,fragment:null}):P}b(P,E){return j.URI.isUri(P)?P:j.URI.parse(E.toUrl(P))}}e.$cg=new R;var S;(function(d){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(P.get("3"));const E="vscode-coi";function b($){let p;typeof $=="string"?p=new URL($).searchParams:$ instanceof URL?p=$.searchParams:j.URI.isUri($)&&(p=new URL($.toString(!0)).searchParams);const w=p?.get(E);if(w)return P.get(w)}d.getHeadersFromQuery=b;function l($,p,w){if(!globalThis.crossOriginIsolated)return;const c=p&&w?"3":w?"2":"1";$ instanceof URLSearchParams?$.set(E,c):$[E]=c}d.addSearchParam=l})(S||(e.COI=S={}))}),define(ae[141],ce([0,1,123,23,5,10]),function(te,e,D,F,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IC=void 0;class I{constructor(b,l,$){this.id=b,this.dependencies=l,this.callback=$}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,l,$)=>{typeof b!="string"&&($=l,l=b,b=null),(typeof l!="object"||!Array.isArray(l))&&($=l,l=null),this.c.push(new I(b,l,$))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const l=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!l)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}h(b){return new Promise((l,$)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const w=()=>{p.removeEventListener("load",c),p.removeEventListener("error",u)},c=f=>{w(),l(this.c.pop())},u=f=>{w(),$(f)};p.addEventListener("load",c),p.addEventListener("error",u),this.f&&(b=this.f.createScriptURL(b)),p.setAttribute("src",b),document.getElementsByTagName("head")[0].appendChild(p)})}i(b){return new Promise((l,$)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),l(this.c.pop())}catch(p){$(p)}})}async j(b){try{const l=globalThis._VSCODE_NODE_MODULES.fs,$=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,w=A.URI.parse(b).fsPath,c=l.readFileSync(w).toString(),u=p.wrap(c.replace(/^#!.*/,""));return new $.Script(u).runInThisContext().apply(),this.c.pop()}catch(l){throw l}}}const S=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function P(E,b,l){if(D.$S){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[E]&&(E=d[E]);const $=`${E}/${b}`;if(S.has($))return S.get($);let p;if(/^\w[\w\d+.-]*:\/\//.test($))p=$;else{const f=`${l&&!j.$p?F.$_f:F.$$f}/${$}`;p=F.$cg.asBrowserUri(f).toString(!0)}const w=R.INSTANCE.load(p);return S.set($,w),w}else return await new Promise(($,p)=>{te([E],$,p)})}e.$IC=P}),define(ae[19],ce([0,1,48,23,16,5,27,10]),function(te,e,D,F,j,A,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function S(l){return(0,R.$vc)(l,!0)}e.$jg=S;class d{constructor($){this.a=$}compare($,p,w=!1){return $===p?0:(0,I.$Ue)(this.getComparisonKey($,w),this.getComparisonKey(p,w))}isEqual($,p,w=!1){return $===p?!0:!$||!p?!1:this.getComparisonKey($,w)===this.getComparisonKey(p,w)}getComparisonKey($,p=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,p,w=!1){if($.scheme===p.scheme){if($.scheme===F.Schemas.file)return D.$Xf(S($),S(p),this.a($))&&$.query===p.query&&(w||$.fragment===p.fragment);if((0,e.$Ag)($.authority,p.authority))return D.$Xf($.path,p.path,this.a($),"/")&&$.query===p.query&&(w||$.fragment===p.fragment)}return!1}joinPath($,...p){return R.URI.joinPath($,...p)}basenameOrAuthority($){return(0,e.$sg)($)||$.authority}basename($){return j.$fc.basename($.path)}extname($){return j.$fc.extname($.path)}dirname($){if($.path.length===0)return $;let p;return $.scheme===F.Schemas.file?p=R.URI.file(j.$lc(S($))).path:(p=j.$fc.dirname($.path),$.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),p="/")),$.with({path:p})}normalizePath($){if(!$.path.length)return $;let p;return $.scheme===F.Schemas.file?p=R.URI.file(j.$gc(S($))).path:p=j.$fc.normalize($.path),$.with({path:p})}relativePath($,p){if($.scheme!==p.scheme||!(0,e.$Ag)($.authority,p.authority))return;if($.scheme===F.Schemas.file){const u=j.$kc(S($),S(p));return A.$j?D.$Rf(u):u}let w=$.path||"/";const c=p.path||"/";if(this.a($)){let u=0;for(const f=Math.min(w.length,c.length);u<f&&!(w.charCodeAt(u)!==c.charCodeAt(u)&&w.charAt(u).toLowerCase()!==c.charAt(u).toLowerCase());u++);w=c.substr(0,u)+w.substr(u)}return j.$fc.relative(w,c)}resolvePath($,p){if($.scheme===F.Schemas.file){const w=R.URI.file(j.$jc(S($),p));return $.with({authority:w.authority,path:w.path})}return p=D.$Sf(p),$.with({path:j.$fc.resolve($.path,p)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,p){return $===p||$!==void 0&&p!==void 0&&(0,I.$2e)($,p)}hasTrailingPathSeparator($,p=j.sep){if($.scheme===F.Schemas.file){const w=S($);return w.length>D.$Tf(w).length&&w[w.length-1]===p}else{const w=$.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,p=j.sep){return(0,e.$Bg)($,p)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,p=j.sep){let w=!1;if($.scheme===F.Schemas.file){const c=S($);w=c!==void 0&&c.length===D.$Tf(c).length&&c[c.length-1]===p}else{p="/";const c=$.path;w=c.length===1&&c.charCodeAt(c.length-1)===47}return!w&&!(0,e.$Bg)($,p)?$.with({path:$.path+"/"}):$}}e.$kg=d,e.$lg=new d(()=>!1),e.$mg=new d(l=>l.scheme===F.Schemas.file?!A.$l:!0),e.$ng=new d(l=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function P(l,$){const p=[];for(let w=0;w<l.length;w++){const c=$(l[w]);l.some((u,f)=>f===w?!1:(0,e.$pg)(c,$(u)))||p.push(l[w])}return p}e.$Eg=P;var E;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function $(p){const w=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(f=>{const[m,k]=f.split(":");m&&k&&w.set(m,k)});const u=p.path.substring(0,p.path.indexOf(";"));return u&&w.set(l.META_DATA_MIME,u),w}l.parseMetaData=$})(E||(e.DataUri=E={}));function b(l,$,p){if($){let w=l.path;return w&&w[0]!==j.$fc.sep&&(w=j.$fc.sep+w),l.with({scheme:p,authority:$,path:w})}return l.with({scheme:p})}e.$Fg=b}),define(ae[6],ce([0,1,26,7,3,2,19,5,129]),function(te,e,D,F,j,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=e.$eh=e.Promises=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function d(B){return!!B&&typeof B.then=="function"}e.$Gg=d;function P(B){const N=new D.$Xd,W=B(N.token),G=new Promise((ie,oe)=>{const ue=N.token.onCancellationRequested(()=>{ue.dispose(),N.dispose(),oe(new F.$4)});Promise.resolve(W).then(he=>{ue.dispose(),N.dispose(),ie(he)},he=>{ue.dispose(),N.dispose(),oe(he)})});return new class{cancel(){N.cancel()}then(ie,oe){return G.then(ie,oe)}catch(ie){return this.then(void 0,ie)}finally(ie){return G.finally(ie)}}}e.$Hg=P;function E(B,N,W){return new Promise((G,ie)=>{const oe=N.onCancellationRequested(()=>{oe.dispose(),G(W)});B.then(G,ie).finally(()=>oe.dispose())})}e.$Ig=E;function b(B,N){return new Promise((W,G)=>{const ie=N.onCancellationRequested(()=>{ie.dispose(),G(new F.$4)});B.then(W,G).finally(()=>ie.dispose())})}e.$Jg=b;async function l(B){let N=-1;const W=B.map((G,ie)=>G.then(oe=>(N=ie,oe)));try{return await Promise.race(W)}finally{B.forEach((G,ie)=>{ie!==N&&G.cancel()})}}e.$Kg=l;function $(B,N,W){let G;const ie=setTimeout(()=>{G?.(void 0),W?.()},N);return Promise.race([B.finally(()=>clearTimeout(ie)),new Promise(oe=>G=oe)])}e.$Lg=$;function p(B){return new Promise((N,W)=>{const G=B();d(G)?G.then(N,W):N(G)})}e.$Mg=p;class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(N){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=N,!this.b){const W=()=>{if(this.b=null,this.f)return;const G=this.queue(this.d);return this.d=null,G};this.b=new Promise(G=>{this.a.then(W,W).then(G)})}return new Promise((W,G)=>{this.b.then(W,G)})}return this.a=N(),new Promise((W,G)=>{this.a.then(ie=>{this.a=null,W(ie)},ie=>{this.a=null,G(ie)})})}dispose(){this.f=!0}}e.$Ng=w;class c{constructor(){this.a=Promise.resolve(null)}queue(N){return this.a=this.a.then(()=>N(),()=>N())}}e.$Og=c;class u{constructor(){this.a=new Map}queue(N,W){const ie=(this.a.get(N)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.a.get(N)===ie&&this.a.delete(N)});return this.a.set(N,ie),ie}}e.$Pg=u;const f=(B,N)=>{let W=!0;const G=setTimeout(()=>{W=!1,N()},B);return{isTriggered:()=>W,dispose:()=>{clearTimeout(G),W=!1}}},m=B=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,B())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};class k{constructor(N){this.defaultDelay=N,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(N,W=this.defaultDelay){this.g=N,this.h(),this.b||(this.b=new Promise((ie,oe)=>{this.d=ie,this.f=oe}).then(()=>{if(this.b=null,this.d=null,this.g){const ie=this.g;return this.g=null,ie()}}));const G=()=>{this.a=null,this.d?.(null)};return this.a=W===S.$Kd?m(G):f(W,G),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=k;class s{constructor(N){this.a=new k(N),this.b=new w}trigger(N,W){return this.a.trigger(()=>this.b.queue(N),W)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=s;class a{constructor(){this.a=!1,this.b=new Promise((N,W)=>{this.d=N})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=a;class n extends a{constructor(N){super(),this.f=setTimeout(()=>this.open(),N)}open(){clearTimeout(this.f),super.open()}}e.$Tg=n;function i(B,N){return N?new Promise((W,G)=>{const ie=setTimeout(()=>{oe.dispose(),W()},B),oe=N.onCancellationRequested(()=>{clearTimeout(ie),oe.dispose(),G(new F.$4)})}):P(W=>i(B,W))}e.$Ug=i;function t(B,N=0,W){const G=setTimeout(()=>{B(),W&&ie.dispose()},N),ie=(0,A.$Pc)(()=>{clearTimeout(G),W?.deleteAndLeak(ie)});return W?.add(ie),ie}e.$Vg=t;function r(B,N,W){let G=0;const ie=setInterval(()=>{G++,(G>=W||B())&&oe.dispose()},N),oe=(0,A.$Pc)(()=>{clearInterval(ie)});return oe}e.$Wg=r;function o(B){const N=[];let W=0;const G=B.length;function ie(){return W<G?B[W++]():null}function oe(ue){ue!=null&&N.push(ue);const he=ie();return he?he.then(oe):Promise.resolve(N)}return Promise.resolve(null).then(oe)}e.$Xg=o;function v(B,N=G=>!!G,W=null){let G=0;const ie=B.length,oe=()=>{if(G>=ie)return Promise.resolve(W);const ue=B[G++];return Promise.resolve(ue()).then($e=>N($e)?Promise.resolve($e):oe())};return oe()}e.$Yg=v;function y(B,N=G=>!!G,W=null){if(B.length===0)return Promise.resolve(W);let G=B.length;const ie=()=>{G=-1;for(const oe of B)oe.cancel?.()};return new Promise((oe,ue)=>{for(const he of B)he.then($e=>{--G>=0&&N($e)?(ie(),oe($e)):G===0&&oe(W)}).catch($e=>{--G>=0&&(ie(),ue($e))})})}e.$Zg=y;class h{constructor(N){this.a=0,this.d=N,this.f=[],this.b=0,this.g=new j.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(N){return this.a++,new Promise((W,G)=>{this.f.push({factory:N,c:W,e:G}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const N=this.f.shift();this.b++;const W=N.factory();W.then(N.c,N.e),W.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$1g=h;class g extends h{constructor(){super(1)}}e.$2g=g;class O{constructor(){this.a=new J,this.b=0}queue(N){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,N())):this.a.run(this.b++,N())}}e.$3g=O;class T{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const N=new ne;return this.b.add(N),N.p}g(){for(const[,N]of this.a)if(N.size>0)return!1;return!0}queueFor(N,W=I.$lg){const G=W.getComparisonKey(N);let ie=this.a.get(G);if(!ie){ie=new g;const oe=this.f++,ue=j.Event.once(ie.onDrained)(()=>{ie?.dispose(),this.a.delete(G),this.h(),this.d?.deleteAndDispose(oe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$Zc),this.d.set(oe,ue),this.a.set(G,ie)}return ie}h(){this.g()&&this.j()}j(){for(const N of this.b)N.complete();this.b.clear()}dispose(){for(const[,N]of this.a)N.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$4g=T;class M{constructor(N,W){this.a=-1,typeof N=="function"&&typeof W=="number"&&this.setIfNotSet(N,W)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(N,W){this.cancel(),this.a=setTimeout(()=>{this.a=-1,N()},W)}setIfNotSet(N,W){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,N()},W))}}e.$5g=M;class U{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(N,W){this.cancel(),this.a=setInterval(()=>{N()},W)}}e.$6g=U;class z{constructor(N,W){this.b=-1,this.a=N,this.d=W,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(N=this.d){this.cancel(),this.b=setTimeout(this.f,N)}get delay(){return this.d}set delay(N){this.d=N}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$7g=z;class Z{constructor(N,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.a=N,this.b=W,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(N=this.b){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(N/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$8g=Z;class X extends z{constructor(N,W){super(N,W),this.j=[]}work(N){this.j.push(N),this.isScheduled()||this.schedule()}h(){const N=this.j;this.j=[],this.a?.(N)}dispose(){this.j=[],super.dispose()}}e.$9g=X;class x extends A.$Rc{constructor(N,W){super(),this.g=N,this.h=W,this.a=[],this.b=this.B(new A.$Sc),this.f=!1}get pending(){return this.a.length}work(N){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+N.length>this.g.maxBufferedWork)return!1}else if(this.pending+N.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const W of N)this.a.push(W);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$0g=x,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$$g=B=>{(0,R.$B)(()=>{if(N)return;const W=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.$$g=(B,N)=>{const W=requestIdleCallback(B,typeof N=="number"?{timeout:N}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(W))}}}}();class H{constructor(N){this.d=!1,this.a=()=>{try{this.f=N()}catch(W){this.g=W}finally{this.d=!0}},this.b=(0,e.$$g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$_g=H;async function K(B,N,W){let G;for(let ie=0;ie<W;ie++)try{return await B()}catch(oe){G=oe,await i(N)}throw G}e.$ah=K;class J{isRunning(N){return typeof N=="number"?this.a?.taskId===N:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(N,W,G){return this.a={taskId:N,cancel:()=>G?.(),promise:W},W.then(()=>this.d(N),()=>this.d(N)),W}d(N){this.a&&N===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const N=this.b;this.b=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}queue(N){if(this.b)this.b.run=N;else{let W,G;const ie=new Promise((oe,ue)=>{W=oe,G=ue});this.b={run:N,promise:ie,promiseResolve:W,promiseReject:G}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$bh=J;class V{constructor(N,W=()=>Date.now()){this.d=N,this.f=W,this.a=0,this.b=0}increment(){const N=this.f();return N-this.a>this.d&&(this.a=N,this.b=0),this.b++,this.b}}e.$ch=V;var ee;(function(B){B[B.Resolved=0]="Resolved",B[B.Rejected=1]="Rejected"})(ee||(ee={}));class ne{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((N,W)=>{this.a=N,this.b=W})}complete(N){return new Promise(W=>{this.a(N),this.d={outcome:0,value:N},W()})}error(N){return new Promise(W=>{this.b(N),this.d={outcome:1,value:N},W()})}cancel(){return this.error(new F.$4)}}e.$dh=ne;var _;(function(B){async function N(G){let ie;const oe=await Promise.all(G.map(ue=>ue.then(he=>he,he=>{ie||(ie=he)})));if(typeof ie<"u")throw ie;return oe}B.settled=N;function W(G){return new Promise(async(ie,oe)=>{try{await G(ie,oe)}catch(ue){oe(ue)}})}B.withAsyncBody=W})(_||(e.Promises=_={}));var se;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(se||(se={}));class Q{static fromArray(N){return new Q(W=>{W.emitMany(N)})}static fromPromise(N){return new Q(async W=>{W.emitMany(await N)})}static fromPromises(N){return new Q(async W=>{await Promise.all(N.map(async G=>W.emitOne(await G)))})}static merge(N){return new Q(async W=>{await Promise.all(N.map(async G=>{for await(const ie of G)W.emitOne(ie)}))})}static{this.EMPTY=Q.fromArray([])}constructor(N){this.a=0,this.b=[],this.d=null,this.f=new j.$Nd,queueMicrotask(async()=>{const W={emitOne:G=>this.g(G),emitMany:G=>this.h(G),reject:G=>this.k(G)};try{await Promise.resolve(N(W)),this.j()}catch(G){this.k(G)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(N<this.b.length)return{done:!1,value:this.b[N++]};if(this.a===1)return{done:!0,value:void 0};await j.Event.toPromise(this.f.event)}while(!0)}}}static map(N,W){return new Q(async G=>{for await(const ie of N)G.emitOne(W(ie))})}map(N){return Q.map(this,N)}static filter(N,W){return new Q(async G=>{for await(const ie of N)W(ie)&&G.emitOne(ie)})}filter(N){return Q.filter(this,N)}static coalesce(N){return Q.filter(N,W=>!!W)}coalesce(){return Q.coalesce(this)}static async toPromise(N){const W=[];for await(const G of N)W.push(G);return W}toPromise(){return Q.toPromise(this)}g(N){this.a===0&&(this.b.push(N),this.f.fire())}h(N){this.a===0&&(this.b=this.b.concat(N),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(N){this.a===0&&(this.a=2,this.d=N,this.f.fire())}}e.$eh=Q;class q extends Q{constructor(N,W){super(W),this.l=N}cancel(){this.l.cancel()}}e.$fh=q;function C(B){const N=new D.$Xd,W=B(N.token);return new q(N,async G=>{const ie=N.token.onCancellationRequested(()=>{ie.dispose(),N.dispose(),G.reject(new F.$4)});try{for await(const oe of W){if(N.token.isCancellationRequested)return;G.emitOne(oe)}ie.dispose(),N.dispose()}catch(oe){ie.dispose(),N.dispose(),G.reject(oe)}})}e.$gh=C;class L{constructor(){this.a=new ne,this.b=new Q(G=>{if(N){G.reject(N);return}return W&&G.emitMany(W),this.d=ie=>G.reject(ie),this.f=ie=>G.emitOne(ie),this.a.p});let N,W;this.f=G=>{W||(W=[]),W.push(G)},this.d=G=>{N||(N=G)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(N){this.d(N),this.a.complete()}emitOne(N){this.f(N)}}e.$hh=L}),define(ae[91],ce([0,1,18,6,48,34,16,5,27]),function(te,e,D,F,j,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=void 0;function d(){return Object.create(null)}e.$sj=d,e.$tj="**",e.$uj="/";const P="[/\\\\]",E="[^/\\\\]",b=/\//g;function l(K,J){switch(K){case 0:return"";case 1:return`${E}*?`;default:return`(?:${P}|${E}+${P}${J?`|${P}${E}+`:""})*?`}}function $(K,J){if(!K)return[];const V=[];let ee=!1,ne=!1,_="";for(const se of K){switch(se){case J:if(!ee&&!ne){V.push(_),_="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}_+=se}return _&&V.push(_),V}e.$vj=$;function p(K){if(!K)return"";let J="";const V=$(K,e.$uj);if(V.every(ee=>ee===e.$tj))J=".*";else{let ee=!1;V.forEach((ne,_)=>{if(ne===e.$tj){if(ee)return;J+=l(2,_===V.length-1)}else{let se=!1,Q="",q=!1,C="";for(const L of ne){if(L!=="}"&&se){Q+=L;continue}if(q&&(L!=="]"||!C)){let B;L==="-"?B=L:(L==="^"||L==="!")&&!C?B="^":L===e.$uj?B="":B=(0,S.$Fe)(L),C+=B;continue}switch(L){case"{":se=!0;continue;case"[":q=!0;continue;case"}":{const N=`(?:${$(Q,",").map(W=>p(W)).join("|")})`;J+=N,se=!1,Q="";break}case"]":{J+="["+C+"]",q=!1,C="";break}case"?":J+=E;continue;case"*":J+=l(1);continue;default:J+=(0,S.$Fe)(L)}}_<V.length-1&&(V[_+1]!==e.$tj||_+2<V.length)&&(J+=P)}ee=ne===e.$tj})}return J}const w=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new A.$Cc(1e4),a=function(){return!1},n=function(){return null};function i(K,J){if(!K)return n;let V;typeof K!="string"?V=K.pattern:V=K,V=V.trim();const ee=`${V}_${!!J.trimForExclusions}`;let ne=s.get(ee);if(ne)return t(ne,K);let _;return w.test(V)?ne=o(V.substr(4),V):(_=c.exec(r(V,J)))?ne=v(_[1],V):(J.trimForExclusions?f:u).test(V)?ne=y(V,J):(_=m.exec(r(V,J)))?ne=h(_[1].substr(1),V,!0):(_=k.exec(r(V,J)))?ne=h(_[1],V,!1):ne=g(V),s.set(ee,ne),t(ne,K)}function t(K,J){if(typeof J=="string")return K;const V=function(ee,ne){return(0,j.$Xf)(ee,J.base,!R.$l)?K((0,S.$Je)(ee.substr(J.base.length),I.sep),ne):null};return V.allBasenames=K.allBasenames,V.allPaths=K.allPaths,V.basenames=K.basenames,V.patterns=K.patterns,V}function r(K,J){return J.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function o(K,J){return function(V,ee){return typeof V=="string"&&V.endsWith(K)?J:null}}function v(K,J){const V=`/${K}`,ee=`\\${K}`,ne=function(se,Q){return typeof se!="string"?null:Q?Q===K?J:null:se===K||se.endsWith(V)||se.endsWith(ee)?J:null},_=[K];return ne.basenames=_,ne.patterns=[J],ne.allBasenames=_,ne}function y(K,J){const V=x(K.slice(1,-1).split(",").map(Q=>i(Q,J)).filter(Q=>Q!==n),K),ee=V.length;if(!ee)return n;if(ee===1)return V[0];const ne=function(Q,q){for(let C=0,L=V.length;C<L;C++)if(V[C](Q,q))return K;return null},_=V.find(Q=>!!Q.allBasenames);_&&(ne.allBasenames=_.allBasenames);const se=V.reduce((Q,q)=>q.allPaths?Q.concat(q.allPaths):Q,[]);return se.length&&(ne.allPaths=se),ne}function h(K,J,V){const ee=I.sep===I.$fc.sep,ne=ee?K:K.replace(b,I.sep),_=I.sep+ne,se=I.$fc.sep+K;let Q;return V?Q=function(q,C){return typeof q=="string"&&(q===ne||q.endsWith(_)||!ee&&(q===K||q.endsWith(se)))?J:null}:Q=function(q,C){return typeof q=="string"&&(q===ne||!ee&&q===K)?J:null},Q.allPaths=[(V?"*/":"./")+K],Q}function g(K){try{const J=new RegExp(`^${p(K)}$`);return function(V){return J.lastIndex=0,typeof V=="string"&&J.test(V)?K:null}}catch{return n}}function O(K,J,V){return!K||typeof J!="string"?!1:T(K)(J,void 0,V)}e.$wj=O;function T(K,J={}){if(!K)return a;if(typeof K=="string"||M(K)){const V=i(K,J);if(V===n)return a;const ee=function(ne,_){return!!V(ne,_)};return V.allBasenames&&(ee.allBasenames=V.allBasenames),V.allPaths&&(ee.allPaths=V.allPaths),ee}return Z(K,J)}e.$xj=T;function M(K){const J=K;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.$yj=M;function U(K){return K.allBasenames||[]}e.$zj=U;function z(K){return K.allPaths||[]}e.$Aj=z;function Z(K,J){const V=x(Object.getOwnPropertyNames(K).map(Q=>X(Q,K[Q],J)).filter(Q=>Q!==n)),ee=V.length;if(!ee)return n;if(!V.some(Q=>!!Q.requiresSiblings)){if(ee===1)return V[0];const Q=function(L,B){let N;for(let W=0,G=V.length;W<G;W++){const ie=V[W](L,B);if(typeof ie=="string")return ie;(0,F.$Gg)(ie)&&(N||(N=[]),N.push(ie))}return N?(async()=>{for(const W of N){const G=await W;if(typeof G=="string")return G}return null})():null},q=V.find(L=>!!L.allBasenames);q&&(Q.allBasenames=q.allBasenames);const C=V.reduce((L,B)=>B.allPaths?L.concat(B.allPaths):L,[]);return C.length&&(Q.allPaths=C),Q}const ne=function(Q,q,C){let L,B;for(let N=0,W=V.length;N<W;N++){const G=V[N];G.requiresSiblings&&C&&(q||(q=(0,I.$mc)(Q)),L||(L=q.substr(0,q.length-(0,I.$nc)(Q).length)));const ie=G(Q,q,L,C);if(typeof ie=="string")return ie;(0,F.$Gg)(ie)&&(B||(B=[]),B.push(ie))}return B?(async()=>{for(const N of B){const W=await N;if(typeof W=="string")return W}return null})():null},_=V.find(Q=>!!Q.allBasenames);_&&(ne.allBasenames=_.allBasenames);const se=V.reduce((Q,q)=>q.allPaths?Q.concat(q.allPaths):Q,[]);return se.length&&(ne.allPaths=se),ne}function X(K,J,V){if(J===!1)return n;const ee=i(K,V);if(ee===n)return n;if(typeof J=="boolean")return ee;if(J){const ne=J.when;if(typeof ne=="string"){const _=(se,Q,q,C)=>{if(!C||!ee(se,Q))return null;const L=ne.replace("$(basename)",()=>q),B=C(L);return(0,F.$Gg)(B)?B.then(N=>N?K:null):B?K:null};return _.requiresSiblings=!0,_}}return ee}function x(K,J){const V=K.filter(Q=>!!Q.basenames);if(V.length<2)return K;const ee=V.reduce((Q,q)=>{const C=q.basenames;return C?Q.concat(C):Q},[]);let ne;if(J){ne=[];for(let Q=0,q=ee.length;Q<q;Q++)ne.push(J)}else ne=V.reduce((Q,q)=>{const C=q.patterns;return C?Q.concat(C):Q},[]);const _=function(Q,q){if(typeof Q!="string")return null;if(!q){let L;for(L=Q.length;L>0;L--){const B=Q.charCodeAt(L-1);if(B===47||B===92)break}q=Q.substr(L)}const C=ee.indexOf(q);return C!==-1?ne[C]:null};_.basenames=ee,_.patterns=ne,_.allBasenames=ee;const se=K.filter(Q=>!Q.basenames);return se.push(_),se}function H(K,J){return(0,D.$tb)(K,J,(V,ee)=>typeof V=="string"&&typeof ee=="string"?V===ee:typeof V!="string"&&typeof ee!="string"?V.base===ee.base&&V.pattern===ee.pattern:!1)}e.$Bj=H}),define(ae[92],ce([0,1,15,10]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=void 0;function j(E){return E.toJSON()}class A{constructor(b){this.a=b}transformIncoming(b){const l=this.a.transformIncoming(b);return l===b?b:j(F.URI.from(l))}transformOutgoing(b){const l=this.a.transformOutgoing(b);return l===b?b:j(F.URI.from(l))}transformOutgoingURI(b){const l=this.a.transformOutgoing(b);return l===b?b:F.URI.from(l)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$Mm=A,e.$Nm=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function I(E,b,l){if(!E||l>200)return null;if(typeof E=="object"){if(E instanceof F.URI)return b.transformOutgoing(E);for(const $ in E)if(Object.hasOwnProperty.call(E,$)){const p=I(E[$],b,l+1);p!==null&&(E[$]=p)}}return null}function R(E,b){const l=I(E,b,0);return l===null?E:l}e.$Om=R;function S(E,b,l,$){if(!E||$>200)return null;if(typeof E=="object"){if(E.$mid===1)return l?F.URI.revive(b.transformIncoming(E)):b.transformIncoming(E);if(E instanceof D.$be)return null;for(const p in E)if(Object.hasOwnProperty.call(E,p)){const w=S(E[p],b,l,$+1);w!==null&&(E[p]=w)}}return null}function d(E,b){const l=S(E,b,!1,0);return l===null?E:l}e.$Pm=d;function P(E,b){const l=S(E,b,!0,0);return l===null?E:l}e.$Qm=P}),define(ae[142],ce([0,1,36,47,32,130,5]),function(te,e,D,F,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=void 0,e.$Sm=new class{c(b){return this.a||(this.a=F.$Wh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,l=0;const $=(0,D.networkInterfaces)();for(const p in $){const w=$[p];if(w)for(const{mac:c,internal:u}of w)u||(l+=1,this.c(c.toUpperCase())&&(b+=1))}this.b=l>0?b/l:0}return this.b}};let R;async function S(b){return R||(R=(async()=>await d(b)||j.$eg())()),R}e.$Tm=S;async function d(b){try{const l=await new Promise((p,w)=>{te(["crypto"],p,w)}),$=(0,A.$Rm)();return l.createHash("sha256").update($,"utf8").digest("hex")}catch(l){b(l);return}}const P="Software\\Microsoft\\SQMClient";async function E(b){if(I.$j){const l=await new Promise(($,p)=>{te(["@vscode/windows-registry"],$,p)});try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",P,"MachineId")||""}catch($){return b($),""}}return""}e.$Um=E}),define(ae[31],ce([0,1,53,36,268,6,48,88,16,5,19,10]),function(te,e,D,F,j,A,I,R,S,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(X){X[X.UNLINK=0]="UNLINK",X[X.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function l(X,x=b.UNLINK,H){if((0,I.$1f)(X))throw new Error("rimraf - will refuse to recursively delete root");return x===b.UNLINK?p(X):$(X,H)}async function $(X,x=(0,I.$6f)((0,F.tmpdir)())){try{try{await D.promises.rename(X,x)}catch(H){return H.code==="ENOENT"?void 0:p(X)}p(x).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function p(X){return(0,j.promisify)(D.rm)(X,{recursive:!0,force:!0,maxRetries:3})}function w(X){if((0,I.$1f)(X))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(X,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function c(X,x){return m(await(x?u(X):(0,j.promisify)(D.readdir)(X)))}async function u(X){try{return await(0,j.promisify)(D.readdir)(X,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const x=[],H=await c(X);for(const K of H){let J=!1,V=!1,ee=!1;try{const ne=await e.Promises.lstat((0,S.$ic)(X,K));J=ne.isFile(),V=ne.isDirectory(),ee=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}x.push({name:K,isFile:()=>J,isDirectory:()=>V,isSymbolicLink:()=>ee})}return x}function f(X){return m(D.readdirSync(X))}e.readdirSync=f;function m(X){return X.map(x=>typeof x=="string"?d.$k?(0,R.$pl)(x):x:(x.name=d.$k?(0,R.$pl)(x.name):x.name,x))}async function k(X){const x=await c(X),H=[];for(const K of x)await a.existsDirectory((0,S.$ic)(X,K))&&H.push(K);return H}function s(X,x=1e3){return new Promise(H=>{let K=!1;const J=setInterval(()=>{K||(K=!0,D.access(X,V=>{K=!1,V&&(clearInterval(J),H(void 0))}))},x)})}e.whenDeleted=s;var a;(function(X){async function x(J){let V;try{if(V=await e.Promises.lstat(J),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(d.$j&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw ne}throw ee}}X.stat=x;async function H(J){try{const{stat:V,symbolicLink:ee}=await X.stat(J);return V.isFile()&&ee?.dangling!==!0}catch{}return!1}X.existsFile=H;async function K(J){try{const{stat:V,symbolicLink:ee}=await X.stat(J);return V.isDirectory()&&ee?.dangling!==!0}catch{}return!1}X.existsDirectory=K})(a||(e.SymlinkSupport=a={}));const n=new A.$4g;function i(X,x,H){return n.queueFor(E.URI.file(X),P.$mg).queue(()=>{const K=y(H);return new Promise((J,V)=>o(X,x,K,ee=>ee?V(ee):J()))})}let t=!0;function r(X){t=X}e.configureFlushOnWrite=r;function o(X,x,H,K){if(!t)return D.writeFile(X,x,{mode:H.mode,flag:H.flag},K);D.open(X,H.flag,H.mode,(J,V)=>{if(J)return K(J);D.writeFile(V,x,ee=>{if(ee)return D.close(V,()=>K(ee));D.fdatasync(V,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),r(!1)),D.close(V,_=>K(_))))})})}function v(X,x,H){const K=y(H);if(!t)return D.writeFileSync(X,x,{mode:K.mode,flag:K.flag});const J=D.openSync(X,K.flag,K.mode);try{D.writeFileSync(J,x);try{D.fdatasyncSync(J)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),r(!1)}}finally{D.closeSync(J)}}e.writeFileSync=v;function y(X){return X?{mode:typeof X.mode=="number"?X.mode:438,flag:typeof X.flag=="string"?X.flag:"w"}:{mode:438,flag:"w"}}async function h(X,x,H=6e4){if(X!==x)try{d.$j&&typeof H=="number"?await g(X,x,Date.now(),H):await(0,j.promisify)(D.rename)(X,x)}catch(K){if(X.toLowerCase()!==x.toLowerCase()&&K.code==="EXDEV"||X.endsWith("."))await O(X,x,{preserveSymlinks:!1}),await l(X,b.MOVE);else throw K}}async function g(X,x,H,K,J=0){try{return await(0,j.promisify)(D.rename)(X,x)}catch(V){if(V.code!=="EACCES"&&V.code!=="EPERM"&&V.code!=="EBUSY")throw V;if(Date.now()-H>=K)throw console.error(`[node.js fs] rename failed after ${J} retries with error: ${V}`),V;if(J===0){let ee=!1;try{const{stat:ne}=await a.stat(x);ne.isFile()||(ee=!0)}catch{}if(ee)throw V}return await(0,A.$Ug)(Math.min(100,J*10)),g(X,x,H,K,J+1)}}async function O(X,x,H){return M(X,x,{root:{source:X,target:x},options:H,handledSourcePaths:new Set})}const T=511;async function M(X,x,H){if(H.handledSourcePaths.has(X))return;H.handledSourcePaths.add(X);const{stat:K,symbolicLink:J}=await a.stat(X);if(J){if(H.options.preserveSymlinks)try{return await Z(X,x,H)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(J.dangling)return}return K.isDirectory()?U(X,x,K.mode&T,H):z(X,x,K.mode&T)}async function U(X,x,H,K){await e.Promises.mkdir(x,{recursive:!0,mode:H});const J=await c(X);for(const V of J)await M((0,S.$ic)(X,V),(0,S.$ic)(x,V),K)}async function z(X,x,H){await e.Promises.copyFile(X,x),await e.Promises.chmod(x,H)}async function Z(X,x,H){let K=await e.Promises.readlink(X);(0,I.$Xf)(K,H.root.source,!d.$l)&&(K=(0,S.$ic)(H.root.target,K.substr(H.root.source.length+1))),await e.Promises.symlink(K,x)}e.Promises=new class{get access(){return(0,j.promisify)(D.access)}get stat(){return(0,j.promisify)(D.stat)}get lstat(){return(0,j.promisify)(D.lstat)}get utimes(){return(0,j.promisify)(D.utimes)}get read(){return(X,x,H,K,J)=>new Promise((V,ee)=>{D.read(X,x,H,K,J,(ne,_,se)=>ne?ee(ne):V({bytesRead:_,buffer:se}))})}get readFile(){return(0,j.promisify)(D.readFile)}get write(){return(X,x,H,K,J)=>new Promise((V,ee)=>{D.write(X,x,H,K,J,(ne,_,se)=>ne?ee(ne):V({bytesWritten:_,buffer:se}))})}get appendFile(){return(0,j.promisify)(D.appendFile)}get fdatasync(){return(0,j.promisify)(D.fdatasync)}get truncate(){return(0,j.promisify)(D.truncate)}get copyFile(){return(0,j.promisify)(D.copyFile)}get open(){return(0,j.promisify)(D.open)}get close(){return(0,j.promisify)(D.close)}get symlink(){return(0,j.promisify)(D.symlink)}get readlink(){return(0,j.promisify)(D.readlink)}get chmod(){return(0,j.promisify)(D.chmod)}get mkdir(){return(0,j.promisify)(D.mkdir)}get unlink(){return(0,j.promisify)(D.unlink)}get rmdir(){return(0,j.promisify)(D.rmdir)}get realpath(){return(0,j.promisify)(D.realpath)}async exists(X){try{return await e.Promises.access(X),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return k}get writeFile(){return i}get rm(){return l}get rename(){return h}get copy(){return O}}}),define(ae[143],ce([0,1,53,16,5,27,31]),function(te,e,D,F,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=e.$7p=e.$6p=void 0;function R(b){if(j.$l)return b;const l=(0,F.$lc)(b);if(b===l)return b;const $=((0,F.$mc)(b)||b).toLowerCase();try{const w=(0,I.readdirSync)(l).filter(c=>c.toLowerCase()===$);if(w.length===1){const c=R(l);if(c)return(0,F.$ic)(c,w[0])}else if(w.length>1){const c=w.indexOf($);if(c>=0){const u=R(l);if(u)return(0,F.$ic)(u,w[c])}}}catch{}return null}e.$6p=R;async function S(b){if(j.$l)return b;const l=(0,F.$lc)(b);if(b===l)return b;const $=((0,F.$mc)(b)||b).toLowerCase();try{const w=(await I.Promises.readdir(l)).filter(c=>c.toLowerCase()===$);if(w.length===1){const c=await S(l);if(c)return(0,F.$ic)(c,w[0])}else if(w.length>1){const c=w.indexOf($);if(c>=0){const u=await S(l);if(u)return(0,F.$ic)(u,w[c])}}}catch{}return null}e.$7p=S;async function d(b){try{return await I.Promises.realpath(b)}catch{const $=E(b);return await I.Promises.access($,D.constants.R_OK),$}}e.$8p=d;function P(b){try{return D.realpathSync(b)}catch{const $=E(b);return D.accessSync($,D.constants.R_OK),$}}e.$9p=P;function E(b){return(0,A.$Ke)((0,F.$gc)(b),F.sep)}}),define(ae[144],ce([0,1,16,5,37,90,12,31]),function(te,e,D,F,j,A,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Dl=e.$Cl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function S(E=j.env){return E.comspec||"cmd.exe"}e.$Cl=S;function d(E){let b=[],l=!1;const $=function(p){if(l){b.push(p);return}(!E.send(p,c=>{if(c&&console.error(c),l=!1,b.length>0){const u=b.slice(0);b=[],u.forEach(f=>$(f))}})||F.$j)&&(l=!0)};return{send:$}}e.$Dl=d;var P;(function(E){async function b(l,$,p){if(D.$hc(l))return l;if($===void 0&&($=j.cwd()),D.$lc(l)!=="."||(p===void 0&&I.$yf(j.env.PATH)&&(p=j.env.PATH.split(D.$sc)),p===void 0||p.length===0))return D.$ic($,l);async function c(u){if(await R.Promises.exists(u)){let f;try{f=await R.Promises.stat(u)}catch(m){m.message.startsWith("EACCES")&&(f=await R.Promises.lstat(u))}return f?!f.isDirectory():!1}return!1}for(const u of p){let f;if(D.$hc(u)?f=D.$ic(u,l):f=D.$ic($,u,l),await c(f))return f;let m=f+".com";if(await c(m)||(m=f+".exe",await c(m)))return m}return D.$ic($,l)}E.findExecutable=b})(P||(e.win32=P={}))}),define(ae[145],ce([0,1,66,23]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;function j(I){return new Promise((R,S)=>{let d;const P=new Map;function E(l,$,p,w,c){const u=P.get($);if(l===I||u){const f={name:b(p),cmd:p,pid:l,ppid:$,load:w,mem:c};P.set(l,f),l===I&&(d=f),u&&(u.children||(u.children=[]),u.children.push(f),u.children.length>1&&(u.children=u.children.sort((m,k)=>m.pid-k.pid)))}}function b(l){const $=/--utility-sub-type=network/i,p=/--ms-enable-electron-run-as-node/i,w=/--crashes-directory/i,c=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,f=/--type=([a-zA-Z-]+)/;if(w.exec(l))return"electron-crash-reporter";if(c.exec(l))return"winpty-agent";if(u.exec(l))return"conpty-agent";let m=f.exec(l);if(m&&m.length===2)return m[1]==="renderer"?"window":m[1]==="utility"?$.exec(l)?"utility-network-service":"utility-process":m[1]==="extensionHost"?"extension-host":m[1];const k=/[a-zA-Z-]+\.js/g;let s="";do m=k.exec(l),m&&(s+=m+" ");while(m);return s&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${s})`:p.exec(l)?`electron-nodejs (${l})`:l}if(process.platform==="win32"){const l=$=>$.indexOf("\\\\?\\")===0||$.indexOf("\\??\\")===0?$.substring(4):$.indexOf('"\\\\?\\')===0||$.indexOf('"\\??\\')===0?'"'+$.substring(5):$;new Promise(($,p)=>{te(["@vscode/windows-process-tree"],$,p)}).then($=>{$.getProcessList(I,p=>{if(!p){S(new Error(`Root process ${I} not found`));return}$.getProcessCpuUsage(p,w=>{const c=new Map;w.forEach(u=>{const f=l(u.commandLine||"");c.set(u.pid,{name:b(f),cmd:f,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),d=c.get(I),d?(c.forEach(u=>{const f=c.get(u.ppid);f&&(f.children||(f.children=[]),f.children.push(u))}),c.forEach(u=>{u.children&&(u.children=u.children.sort((f,m)=>f.pid-m.pid))}),R(d)):S(new Error(`Root process ${I} not found`))})},$.ProcessDataFlag.CommandLine|$.ProcessDataFlag.Memory)})}else{let l=function(){let $=[d];const p=[];for(;$.length;){const c=$.shift();c&&(p.push(c.pid),c.children&&($=$.concat(c.children)))}let w=JSON.stringify(F.$cg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+p.join(" "),(0,D.exec)(w,{},(c,u,f)=>{if(c||f)S(c||new Error(f.toString()));else{const m=u.toString().split(`
`);for(let k=0;k<p.length;k++){const s=P.get(p[k]);s.load=parseFloat(m[k])}if(!d){S(new Error(`Root process ${I} not found`));return}R(d)}})};(0,D.exec)("which ps",{},($,p,w)=>{if($||w)if(process.platform!=="linux")S($||new Error(w.toString()));else{const c=JSON.stringify(F.$cg.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(c,{},(u,f,m)=>{u||m?S(u||new Error(m.toString())):(A(f,E),l())})}else{const c=p.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${c} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,m,k)=>{f||k&&!k.includes("screen size is bogus")?S(f||new Error(k.toString())):(A(m,E),process.platform==="linux"?l():d?R(d):S(new Error(`Root process ${I} not found`)))})}})}})}e.$Dr=j;function A(I,R){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=I.toString().split(`
`);for(const P of d){const E=S.exec(P.trim());E&&E.length===6&&R(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var ye=this&&this.__decorate||function(te,e,D,F){var j=arguments.length,A=j<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,D):F,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(te,e,D,F);else for(var R=te.length-1;R>=0;R--)(I=te[R])&&(A=(j<3?I(A):j>3?I(e,D,A):I(e,D))||A);return j>3&&A&&Object.defineProperty(e,D,A),A};define(ae[40],ce([0,1,18,6,15,26,84,7,3,2,65,27,12]),function(te,e,D,F,j,A,I,R,S,d,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.ProxyChannel=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.RequestInitiator=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=void 0;var l;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(l||(l={}));function $(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})(p||(p={}));function w(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(c||(c={}));function u(J){let V=0;for(let ee=0;;ee+=7){const ne=J.read(1);if(V|=(ne.buffer[0]&127)<<ee,!(ne.buffer[0]&128))return V}}const f=n(0);function m(J,V){if(V===0){J.write(f);return}let ee=0;for(let _=V;_!==0;_=_>>>7)ee++;const ne=j.$be.alloc(ee);for(let _=0;V!==0;_++)ne.buffer[_]=V&127,V=V>>>7,V>0&&(ne.buffer[_]|=128);J.write(ne)}class k{constructor(V){this.b=V,this.a=0}read(V){const ee=this.b.slice(this.a,this.a+V);return this.a+=ee.byteLength,ee}}e.$oh=k;class s{constructor(){this.a=[]}get buffer(){return j.$be.concat(this.a)}write(V){this.a.push(V)}}e.$ph=s;var a;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object",J[J.Int=6]="Int"})(a||(a={}));function n(J){const V=j.$be.alloc(1);return V.writeUInt8(J,0),V}const i={Undefined:n(a.Undefined),String:n(a.String),Buffer:n(a.Buffer),VSBuffer:n(a.VSBuffer),Array:n(a.Array),Object:n(a.Object),Uint:n(a.Int)},t=typeof Buffer<"u";function r(J,V){if(typeof V>"u")J.write(i.Undefined);else if(typeof V=="string"){const ee=j.$be.fromString(V);J.write(i.String),m(J,ee.byteLength),J.write(ee)}else if(t&&Buffer.isBuffer(V)){const ee=j.$be.wrap(V);J.write(i.Buffer),m(J,ee.byteLength),J.write(ee)}else if(V instanceof j.$be)J.write(i.VSBuffer),m(J,V.byteLength),J.write(V);else if(Array.isArray(V)){J.write(i.Array),m(J,V.length);for(const ee of V)r(J,ee)}else if(typeof V=="number"&&(V|0)===V)J.write(i.Uint),m(J,V);else{const ee=j.$be.fromString(JSON.stringify(V));J.write(i.Object),m(J,ee.byteLength),J.write(ee)}}e.$qh=r;function o(J){switch(J.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return J.read(u(J)).toString();case a.Buffer:return J.read(u(J)).buffer;case a.VSBuffer:return J.read(u(J));case a.Array:{const ee=u(J),ne=[];for(let _=0;_<ee;_++)ne.push(o(J));return ne}case a.Object:return JSON.parse(J.read(u(J)).toString());case a.Int:return u(J)}}e.$rh=o;class v{constructor(V,ee,ne=null,_=1e3){this.h=V,this.j=ee,this.k=ne,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:200})}registerChannel(V,ee){this.b.set(V,ee),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const ee=this.o([V.type]);this.k?.logOutgoing(ee,0,1,w(V.type));return}case 201:case 202:case 204:case 203:{const ee=this.o([V.type,V.id],V.data);this.k?.logOutgoing(ee,V.id,1,w(V.type),V.data);return}}}o(V,ee=void 0){const ne=new s;return r(ne,V),r(ne,ee),this.p(ne.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const ee=new k(V),ne=o(ee),_=o(ee),se=ne[0];switch(se){case 100:return this.k?.logIncoming(V.byteLength,ne[1],1,`${$(se)}: ${ne[2]}.${ne[3]}`,_),this.s({type:se,id:ne[1],channelName:ne[2],name:ne[3],arg:_});case 102:return this.k?.logIncoming(V.byteLength,ne[1],1,`${$(se)}: ${ne[2]}.${ne[3]}`,_),this.t({type:se,id:ne[1],channelName:ne[2],name:ne[3],arg:_});case 101:return this.k?.logIncoming(V.byteLength,ne[1],1,`${$(se)}`),this.u({type:se,id:ne[1]});case 103:return this.k?.logIncoming(V.byteLength,ne[1],1,`${$(se)}`),this.u({type:se,id:ne[1]})}}s(V){const ee=this.b.get(V.channelName);if(!ee){this.v(V);return}const ne=new A.$Xd;let _;try{_=ee.call(this.j,V.name,V.arg,ne.token)}catch(q){_=Promise.reject(q)}const se=V.id;_.then(q=>{this.m({id:se,data:q,type:201})},q=>{q instanceof Error?this.m({id:se,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:se,data:q,type:203})}).finally(()=>{Q.dispose(),this.d.delete(V.id)});const Q=(0,d.$Pc)(()=>ne.cancel());this.d.set(V.id,Q)}t(V){const ee=this.b.get(V.channelName);if(!ee){this.v(V);return}const ne=V.id,se=ee.listen(this.j,V.name,V.arg)(Q=>this.m({id:ne,data:Q,type:204}));this.d.set(V.id,se)}u(V){const ee=this.d.get(V.id);ee&&(ee.dispose(),this.d.delete(V.id))}v(V){let ee=this.g.get(V.channelName);ee||(ee=[],this.g.set(V.channelName,ee));const ne=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ee.push({request:V,timeoutTimer:ne})}w(V){const ee=this.g.get(V);if(ee){for(const ne of ee)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.$Mc)(this.d.values()),this.d.clear()}}e.$sh=v;var y;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class h{constructor(V,ee=null){this.l=V,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=ee}getChannel(V){const ee=this;return{call(ne,_,se){return ee.a?Promise.reject(new R.$4):ee.m(V,ne,_,se)},listen(ne,_){return ee.a?S.Event.None:ee.o(V,ne,_)}}}m(V,ee,ne,_=A.CancellationToken.None){const se=this.g++,q={id:se,type:100,channelName:V,name:ee,arg:ne};if(_.isCancellationRequested)return Promise.reject(new R.$4);let C;return new Promise((B,N)=>{if(_.isCancellationRequested)return N(new R.$4);const W=()=>{const ue=he=>{switch(he.type){case 201:this.f.delete(se),B(he.data);break;case 202:{this.f.delete(se);const $e=new Error(he.data.message);$e.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,$e.name=he.data.name,N($e);break}case 203:this.f.delete(se),N(he.data);break}};this.f.set(se,ue),this.p(q)};let G=null;this.b===c.Idle?W():(G=(0,F.$Hg)(ue=>this.u()),G.then(()=>{G=null,W()}));const ie=()=>{G?(G.cancel(),G=null):this.p({id:se,type:101}),N(new R.$4)},oe=_.onCancellationRequested(ie);C=(0,d.$Oc)((0,d.$Pc)(ie),oe),this.d.add(C)}).finally(()=>{C.dispose(),this.d.delete(C)})}o(V,ee,ne){const _=this.g++,Q={id:_,type:102,channelName:V,name:ee,arg:ne};let q=null;const C=new S.$Nd({onWillAddFirstListener:()=>{q=(0,F.$Hg)(B=>this.u()),q.then(()=>{q=null,this.d.add(C),this.p(Q)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(C),this.p({id:_,type:103}))}}),L=B=>C.fire(B.data);return this.f.set(_,L),C.event}p(V){switch(V.type){case 100:case 102:{const ee=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(ee,V.id,0,`${$(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const ee=this.q([V.type,V.id]);this.j?.logOutgoing(ee,V.id,0,$(V.type));return}}}q(V,ee=void 0){const ne=new s;return r(ne,V),r(ne,ee),this.r(ne.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const ee=new k(V),ne=o(ee),_=o(ee),se=ne[0];switch(se){case 200:return this.j?.logIncoming(V.byteLength,0,0,w(se)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,ne[1],0,w(se),_),this.t({type:ne[0],id:ne[1],data:_})}}t(V){if(V.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.$Mc)(this.d.values()),this.d.clear()}}e.$th=h,ye([I.$ih],h.prototype,"onDidInitializePromise",null);class g{get connections(){const V=[];return this.f.forEach(ee=>V.push(ee)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new S.$Nd,this.onDidAddConnection=this.g.event,this.h=new S.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new d.$Qc,this.j.add(V(({protocol:ee,onDidClientDisconnect:ne})=>{const _=S.Event.once(ee.onMessage);this.j.add(_(se=>{const Q=new k(se),q=o(Q),C=new v(ee,q),L=new h(ee);this.a.forEach((N,W)=>C.registerChannel(W,N));const B={channelServer:C,channelClient:L,ctx:q};this.f.add(B),this.g.fire(B),this.j.add(ne(()=>{C.dispose(),L.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel(V,ee){const ne=this;return{call(_,se,Q){let q;if((0,b.$Mf)(ee)){const L=(0,D.$3b)(ne.connections.filter(ee));q=L?Promise.resolve(L):S.Event.toPromise(S.Event.filter(ne.onDidAddConnection,ee))}else q=ee.routeCall(ne,_,se);const C=q.then(L=>L.channelClient.getChannel(V));return T(C).call(_,se,Q)},listen(_,se){if((0,b.$Mf)(ee))return ne.k(V,ee,_,se);const Q=ee.routeEvent(ne,_,se).then(q=>q.channelClient.getChannel(V));return T(Q).listen(_,se)}}}k(V,ee,ne,_){const se=this;let Q;const q=new S.$Nd({onWillAddFirstListener:()=>{Q=new d.$Qc;const C=new S.$Td,L=new Map,B=W=>{const ie=W.channelClient.getChannel(V).listen(ne,_),oe=C.add(ie);L.set(W,oe)},N=W=>{const G=L.get(W);G&&(G.dispose(),L.delete(W))};se.connections.filter(ee).forEach(B),S.Event.filter(se.onDidAddConnection,ee)(B,void 0,Q),se.onDidRemoveConnection(N,void 0,Q),C.event(q.fire,q,Q),Q.add(C)},onDidRemoveLastListener:()=>{Q?.dispose(),Q=void 0}});return q.event}registerChannel(V,ee){this.a.set(V,ee);for(const ne of this.f)ne.channelServer.registerChannel(V,ee)}dispose(){this.j.dispose();for(const V of this.f)V.channelClient.dispose(),V.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$uh=g;class O{constructor(V,ee,ne=null){const _=new s;r(_,ee),V.send(_.buffer),this.a=new h(V,ne),this.d=new v(V,ee,ne)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,ee){this.d.registerChannel(V,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.$vh=O;function T(J){return{call(V,ee,ne){return J.then(_=>_.call(V,ee,ne))},listen(V,ee){const ne=new S.$Wd;return J.then(_=>ne.input=_.listen(V,ee)),ne.event}}}e.$wh=T;function M(J){let V=!1;return{call(ee,ne,_){return V?J.call(ee,ne,_):(0,F.$Ug)(0).then(()=>V=!0).then(()=>J.call(ee,ne,_))},listen(ee,ne){if(V)return J.listen(ee,ne);const _=new S.$Wd;return(0,F.$Ug)(0).then(()=>V=!0).then(()=>_.input=J.listen(ee,ne)),_.event}}}e.$xh=M;class U{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const ee of V.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await S.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.$yh=U;var z;(function(J){function V(se,Q,q){const C=se,L=q&&q.disableMarshalling,B=new Map;for(const N in C)ne(N)&&B.set(N,S.Event.buffer(C[N],!0,void 0,Q));return new class{listen(N,W,G){const ie=B.get(W);if(ie)return ie;if(_(W)){const oe=C[W];if(typeof oe=="function")return oe.call(C,G)}throw new R.$ab(`Event not found: ${W}`)}call(N,W,G){const ie=C[W];if(typeof ie=="function"){if(!L&&Array.isArray(G))for(let ue=0;ue<G.length;ue++)G[ue]=(0,P.$nh)(G[ue]);let oe=ie.apply(C,G);return oe instanceof Promise||(oe=Promise.resolve(oe)),oe}throw new R.$ab(`Method not found: ${W}`)}}}J.fromService=V;function ee(se,Q){const q=Q&&Q.disableMarshalling;return new Proxy({},{get(C,L){if(typeof L=="string")return Q?.properties?.has(L)?Q.properties.get(L):_(L)?function(B){return se.listen(L,B)}:ne(L)?se.listen(L):async function(...B){let N;Q&&!(0,b.$Hf)(Q.context)?N=[Q.context,...B]:N=B;const W=await se.call(L,N);return q?W:(0,P.$nh)(W)};throw new R.$ab(`Property not found: ${String(L)}`)}})}J.toService=ee;function ne(se){return se[0]==="o"&&se[1]==="n"&&E.$1e(se.charCodeAt(2))}function _(se){return/^onDynamic/.test(se)&&E.$1e(se.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){const V=J.toString();if(V!=="[object Object]")return V}return J}function x(J){return Array.isArray(J)?J.map(X):X(J)}function H(J,V,ee,ne,_,se,Q){Q=x(Q);const q=Z[_],C=q[ne%q.length];let L=[`%c[${J}]%c[${String(V).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${C}`];/\($/.test(se)?(L=L.concat(Q),L.push(")")):L.push(Q),console.log.apply(console,L)}class K{constructor(V,ee){this.d=V,this.f=ee,this.a=0,this.b=0}logOutgoing(V,ee,ne,_,se){this.b+=V,H(this.d,this.b,V,ee,ne,_,se)}logIncoming(V,ee,ne,_,se){this.a+=V,H(this.f,this.a,V,ee,ne,_,se)}}e.$zh=K}),define(ae[67],ce([0,1,15,3,2,40]),function(te,e,D,F,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.ProtocolConstants=e.$Ah=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(I||(e.SocketDiagnosticsEventType=I={}));var R;(function(i){i.enableDiagnostics=!1,i.records=[];const t=new WeakMap;let r=0;function o(y,h){if(!t.has(y)){const g=String(++r);t.set(y,g)}return t.get(y)}function v(y,h,g,O){if(!i.enableDiagnostics)return;const T=o(y,h);if(O instanceof D.$be||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const M=D.$be.alloc(O.byteLength);M.set(O),i.records.push({timestamp:Date.now(),id:T,label:h,type:g,buff:M})}else i.records.push({timestamp:Date.now(),id:T,label:h,type:g,data:O})}i.traceSocketEvent=v})(R||(e.SocketDiagnostics=R={}));var S;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S||(e.SocketCloseEventType=S={}));let d=null;function P(){return d||(d=D.$be.alloc(0)),d}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return P();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const h=this.a[0];return r&&(this.a.shift(),this.b-=t),h}if(this.a[0].byteLength>t){const h=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),h}const o=D.$be.alloc(t);let v=0,y=0;for(;t>0;){const h=this.a[y];if(h.byteLength>t){const g=h.slice(0,t);o.set(g,v),v+=t,r&&(this.a[y]=h.slice(t),this.b-=t),t-=t}else o.set(h,v),v+=h.byteLength,r?(this.a.shift(),this.b-=h.byteLength):y++,t-=h.byteLength}return o}}e.$Ah=E;var b;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(b||(b={}));function l(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var $;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})($||(e.ProtocolConstants=$={}));class p{constructor(t,r,o,v){this.type=t,this.id=r,this.ack=o,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends j.$Rc{constructor(t){super(),this.f=this.B(new F.$Nd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new E,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:l(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,v=this.g.id,y=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new p(o,v,y,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=D.$be.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:l(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const o=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,o}h(){const t=D.$be.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class u extends j.$Rc{constructor(t){super(),this.f=new F.$Nd,this.onMessage=this.f.event,this.g=new F.$Nd,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new c(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new p(1,0,0,t))}}e.$Bh=u;class f extends A.$vh{static fromSocket(t,r){return new f(new u(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,o=null){super(t,r,o),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$Ch=f;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new F.$Nd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Dh=m;class k{constructor(t){this.data=t,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,o=this.a;for(;o;)t[r++]=o.data,o=o.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new k(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class a{static{this.a=10}static{this.b=null}static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<a.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=a.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+a.a)*1e3;let o=0;for(let v=0;v<a.a;v++)t-this.c[v]<=r&&o++;return 1-o/a.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new m,this.onControlMessage=this.u.event,this.v=new m,this.onMessage=this.v.event,this.w=new m,this.onDidDispose=this.w.event,this.x=new m,this.onSocketClose=this.x.event,this.y=new m,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??a.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new j.$Qc,this.o=t.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new p(5,0,0,P());this.p.write(t),this.p.flush()}sendPause(){const t=new p(7,0,0,P());this.p.write(t)}sendResume(){const t=new p(8,0,0,P());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new j.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new p(3,0,this.h,P());this.p.write(t);const r=this.b.toArray();for(let o=0,v=r.length;o<v;o++)this.p.write(r[o]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new p(6,0,0,P())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let o=0,v=r.length;o<v;o++)this.p.write(r[o]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const o=new p(1,r,this.h,t);this.b.push(o),this.a||(this.p.write(o),this.B())}sendControl(t){const r=new p(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,o=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&o>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:o});return}const y=Math.max(2e4-r,2e4-o,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},y)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new p(3,0,this.h,P());this.p.write(t)}D(){this.h=this.g;const t=new p(9,0,this.h,P());this.p.write(t)}}e.$Eh=n}),define(ae[93],ce([0,1,66,6,15,26,140,7,3,2,30,144,90,40]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0;class $ extends l.$sh{constructor(c){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:S.Event.fromNodeEventEmitter(process,"message",u=>j.$be.wrap(Buffer.from(u,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$3p=$;class p{constructor(c,u){this.i=c,this.j=u,this.c=new Set,this.g=new Map,this.h=new S.$Nd,this.onDidProcessExit=this.h.event;const f=u&&u.timeout?u.timeout:6e4;this.b=new F.$Qg(f),this.d=null,this.f=null}getChannel(c){const u=this;return{call(f,m,k){return u.k(c,f,m,k)},listen(f,m){return u.l(c,f,m)}}}k(c,u,f,m=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(R.$5());this.b.cancel();const k=this.n(c),s=(0,F.$Hg)(i=>k.call(u,f,i)),a=m.onCancellationRequested(()=>s.cancel()),n=(0,d.$Pc)(()=>s.cancel());return this.c.add(n),s.finally(()=>{a.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(c,u,f){if(!this.b)return S.Event.None;this.b.cancel();let m;const k=new S.$Nd({onWillAddFirstListener:()=>{m=this.n(c).listen(u,f)(k.fire,k),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return k.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,P.$8m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,b.$Bl)(u.env),this.d=(0,D.fork)(this.i,c,u);const f=new S.$Nd;S.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,I.$Yp)(t)){(0,I.log)(t,`IPC Library: ${this.j.serverName}`);return}f.fire(j.$be.wrap(Buffer.from(t,"base64")))});const k=this.j.useQueue?(0,E.$Dl)(this.d):this.d,s=t=>this.d&&this.d.connected&&k.send(t.buffer.toString("base64")),a=f.event,n={send:s,onMessage:a};this.f=new l.$th(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",i),this.c.forEach(o=>(0,d.$Mc)(o)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(c){let u=this.g.get(c);return u||(u=this.m.getChannel(c),this.g.set(c,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$4p=p}),define(ae[146],ce([0,1,133,15,40,3,12,18]),function(te,e,D,F,j,A,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XT=e.$WT=void 0;class S{constructor(b){this.a=b,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",l=>F.$be.wrap(l.data)),b.start()}send(b){this.a.postMessage(b.buffer)}disconnect(){this.a.close()}}class d extends j.$uh{static b(b){(0,I.$If)((0,D.$VT)(process),"Electron Utility Process");const l=new A.$Nd;return process.parentPort.on("message",$=>{if(b?.handledClientConnection($))return;const p=(0,R.$Nb)($.ports);p&&l.fire(p)}),A.Event.map(l.event,$=>({protocol:new S($),onDidClientDisconnect:A.Event.fromNodeEventEmitter($,"close")}))}constructor(b){super(d.b(b))}}e.$WT=d;function P(E,b,l){const $=p=>{p.data===b&&(E.removeListener("message",$),l())};E.on("message",$)}e.$XT=P}),define(ae[68],ce([0,1,6,3,2,65,12]),function(te,e,D,F,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.StorageState=e.$2o=e.StorageHint=void 0;var R;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function S(b){const l=b;return l?.changed instanceof Map||l?.deleted instanceof Set}e.$2o=S;var d;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(d||(e.StorageState=d={}));class P extends j.$Rc{static{this.a=100}constructor(l,$=Object.create(null)){super(),this.r=l,this.s=$,this.b=this.B(new F.$Qd),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=this.B(new D.$Rg(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(l=>this.u(l)))}u(l){this.b.pause();try{l.changed?.forEach(($,p)=>this.w(p,$)),l.deleted?.forEach($=>this.w($,void 0))}finally{this.b.resume()}}w(l,$){if(this.c===d.Closed)return;let p=!1;(0,I.$Hf)($)?p=this.f.delete(l):this.f.get(l)!==$&&(this.f.set(l,$),p=!0),p&&this.b.fire({key:l,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(l,$){const p=this.f.get(l);return(0,I.$Hf)(p)?$:p}getBoolean(l,$){const p=this.get(l);return(0,I.$Hf)(p)?$:p==="true"}getNumber(l,$){const p=this.get(l);return(0,I.$Hf)(p)?$:parseInt(p,10)}getObject(l,$){const p=this.get(l);return(0,I.$Hf)(p)?$:(0,A.$mh)(p)}async set(l,$,p=!1){if(this.c===d.Closed)return;if((0,I.$Hf)($))return this.delete(l,p);const w=(0,I.$Af)($)||Array.isArray($)?(0,A.$lh)($):String($);if(this.f.get(l)!==w)return this.f.set(l,w),this.j.set(l,w),this.h.delete(l),this.b.fire({key:l,external:p}),this.D()}async delete(l,$=!1){if(!(this.c===d.Closed||!this.f.delete(l)))return this.h.has(l)||this.h.add(l),this.j.delete(l),this.b.fire({key:l,external:$}),this.D()}async optimize(){if(this.c!==d.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=d.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const l={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(l).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(l){if(this.z)return this.D(l)}async D(l){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),l)}async whenFlushed(){if(this.z)return new Promise(l=>this.n.push(l))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$3o=P;class E{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(l){l.insert?.forEach(($,p)=>this.a.set(p,$)),l.delete?.forEach($=>this.a.delete($))}async optimize(){}async close(){}}e.$4o=E}),define(ae[147],ce([13,9]),function(te,e){return te.create("vs/base/node/zip",e)}),define(ae[148],ce([13,9]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[149],ce([13,9]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[150],ce([13,9]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(ae[151],ce([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ae[152],ce([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[153],ce([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[154],ce([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[155],ce([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ae[156],ce([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ae[157],ce([13,9]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[158],ce([13,9]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(ae[159],ce([13,9]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(ae[160],ce([13,9]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(ae[161],ce([13,9]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[162],ce([13,9]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ae[163],ce([13,9]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ae[164],ce([13,9]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ae[165],ce([13,9]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(ae[166],ce([13,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ae[167],ce([13,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[168],ce([13,9]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[169],ce([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ae[170],ce([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ae[171],ce([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ae[172],ce([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ae[173],ce([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ae[174],ce([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ae[175],ce([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ae[176],ce([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ae[177],ce([13,9]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(ae[178],ce([0,1,7,150]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.TokenType=void 0;var j;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(j||(e.TokenType=j={}));function A(...d){switch(d.length){case 1:return(0,F.localize)(0,null,d[0]);case 2:return(0,F.localize)(1,null,d[0],d[1]);case 3:return(0,F.localize)(2,null,d[0],d[1],d[2]);default:return}}const I=(0,F.localize)(3,null),R=(0,F.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,D.$7)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const E=this.d,b=this.c.substring(this.d,this.e),l={type:19,offset:this.d,lexeme:b};this.g.push({offset:E,lexeme:b,additionalInfo:P}),this.f.push(l)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const E=this.c.substring(this.d,this.e),b=S.b.get(E);b?this.k(b):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,E=!1,b=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(R);return}const $=this.c.charCodeAt(P);if(E)E=!1;else if($===47&&!b){P++;break}else $===91?b=!0:$===92?E=!0:$===93&&(b=!1);P++}for(;P<this.c.length&&S.a.has(this.c.charCodeAt(P));)P++;this.e=P;const l=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Li=S}),define(ae[179],ce([0,1,64,84,23,16,37,19,10]),function(te,e,D,F,j,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.$gm=void 0,e.$gm=/^([^.]+\..+):(.+)$/;class d{get appRoot(){return(0,A.$lc)(j.$cg.asFileUri("").fsPath)}get userHome(){return S.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return S.URI.file((0,A.$ic)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.b.tmpDir)}get cacheHome(){return S.URI.file(this.userDataPath)}get stateResource(){return(0,R.$vg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:j.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$vg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,D.$fm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$ic)(this.userDataPath,"logs",l)}return S.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$vg)(S.URI.file((0,A.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$vg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$vg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$vg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=I.env.VSCODE_PORTABLE;return l?S.URI.file((0,A.$ic)(l,"argv.json")):(0,R.$vg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,A.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,A.$jc)(l):(0,A.$gc)((0,A.$ic)(j.$cg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?S.URI.file((0,A.$jc)(l)):S.URI.file((0,A.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,A.$jc)(l);const $=I.env.VSCODE_EXTENSIONS;if($)return $;const p=I.env.VSCODE_PORTABLE;return p?(0,A.$ic)(p,"extensions"):(0,R.$vg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map($=>/^[^:/?#]+?:\/\//.test($)?S.URI.parse($):S.URI.file((0,A.$gc)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?S.URI.parse(l):S.URI.file((0,A.$gc)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.$gm.test(l))}get extensionLogLevel(){const l=[];for(const $ of this.args.log||[]){const p=e.$gm.exec($);p&&p[1]&&p[2]&&l.push([p[1],p[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,R.$vg)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=I.env.VSCODE_PORTABLE;return l?S.URI.file((0,A.$ic)(l,"policy.json")):(0,R.$vg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this.a}constructor(l,$,p){this.a=l,this.b=$,this.c=p,this.editSessionId=this.args.editSessionId}}e.$hm=d,ye([F.$ih],d.prototype,"appRoot",null),ye([F.$ih],d.prototype,"userHome",null),ye([F.$ih],d.prototype,"userDataPath",null),ye([F.$ih],d.prototype,"appSettingsHome",null),ye([F.$ih],d.prototype,"tmpDir",null),ye([F.$ih],d.prototype,"cacheHome",null),ye([F.$ih],d.prototype,"stateResource",null),ye([F.$ih],d.prototype,"userRoamingDataHome",null),ye([F.$ih],d.prototype,"userDataSyncHome",null),ye([F.$ih],d.prototype,"sync",null),ye([F.$ih],d.prototype,"machineSettingsResource",null),ye([F.$ih],d.prototype,"workspaceStorageHome",null),ye([F.$ih],d.prototype,"localHistoryHome",null),ye([F.$ih],d.prototype,"keyboardLayoutResource",null),ye([F.$ih],d.prototype,"argvResource",null),ye([F.$ih],d.prototype,"isExtensionDevelopment",null),ye([F.$ih],d.prototype,"untitledWorkspacesHome",null),ye([F.$ih],d.prototype,"builtinExtensionsPath",null),ye([F.$ih],d.prototype,"extensionsPath",null),ye([F.$ih],d.prototype,"extensionDevelopmentLocationURI",null),ye([F.$ih],d.prototype,"extensionDevelopmentKind",null),ye([F.$ih],d.prototype,"extensionTestsLocationURI",null),ye([F.$ih],d.prototype,"debugExtensionHost",null),ye([F.$ih],d.prototype,"logLevel",null),ye([F.$ih],d.prototype,"extensionLogLevel",null),ye([F.$ih],d.prototype,"serviceMachineIdResource",null),ye([F.$ih],d.prototype,"disableTelemetry",null),ye([F.$ih],d.prototype,"disableWorkspaceTrust",null),ye([F.$ih],d.prototype,"useInMemorySecretStorage",null),ye([F.$ih],d.prototype,"policyFile",null);function P(b,l){return E(b["inspect-extensions"],b["inspect-brk-extensions"],5870,l,b.debugId,b.extensionEnvironment)}e.$im=P;function E(b,l,$,p,w,c){const f=Number(l||b)||(p?null:$),m=f?!!l:!1;let k;if(c)try{k=JSON.parse(c)}catch{}return{port:f,break:m,debugId:w,env:k}}e.$jm=E}),function(){"use strict";function te(e,D,F){function j(I,R){const S=A(I,R),d=[S];return e.isAbsolute(S)||d.unshift(F),e.resolve(...d)}function A(I,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,R);const P=I["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(E,"AppData","Roaming")}break;case"darwin":d=e.join(D.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,R)}return{getUserDataPath:j}}if(typeof define=="function")define(ae[180],ce([269,36,37]),function(e,D,F){return te(e,D,F.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=te(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[181],ce([0,1,36,179,180]),function(te,e,D,F,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=e.$lm=e.$km=void 0;class A extends F.$hm{constructor(d,P){super(d,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,j.getUserDataPath)(d,P.nameShort)},P)}}e.$km=A;function I(S,d){return(0,F.$jm)(S["inspect-ptyhost"],S["inspect-brk-ptyhost"],5877,d,S.extensionEnvironment)}e.$lm=I;function R(S,d){return(0,F.$jm)(S["inspect-sharedprocess"],S["inspect-brk-sharedprocess"],5879,d,S.extensionEnvironment)}e.$mm=R}),define(ae[182],ce([0,1,12,153]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=void 0;function j(I,R,S,d){try{A(I,R,S,d)}catch(P){I.error(P?.message??P)}return R}e.$yp=j;function A(I,R,S,d){const P=(E,b,l)=>{const $=E[b];if((0,D.$yf)($)){const p=$,w=p.length;if(w>1&&p[0]==="%"&&p[w-1]==="%"){const c=p.substr(1,w-2);let u=S[c];u===void 0&&d&&(u=d[c]);const f=typeof u=="string"?u:u?.message,m=d?.[c],k=typeof m=="string"?m:m?.message;if(!f){k||I.warn(`[${R.name}]: ${(0,F.localize)(0,null,c)}`);return}if(l&&(b==="title"||b==="category")&&k&&k!==f){const s={value:f,original:k};E[b]=s}else E[b]=f}}else if((0,D.$Af)($))for(const p in $)$.hasOwnProperty(p)&&(p==="commands"?P($,p,!0):P($,p,l));else if(Array.isArray($))for(let p=0;p<$.length;p++)P($,p,l)};for(const E in R)R.hasOwnProperty(E)&&P(R,E)}}),define(ae[183],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$39b=e.$29b=void 0;class D{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$29b=D;class F{constructor(A){this.a=A}listen(A,I){throw new Error(`Event not found: ${I}`)}call(A,I,R){switch(I){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${I}`)}}e.$39b=F}),define(ae[69],ce([0,1,19,89,157,54]),function(te,e,D,F,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function S(c){return c=c.trim(),c==="*"||I.test(c)}e.$Mo=S;function d(c){if(!S(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=c.match(I);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$No=d;function P(c){if(!c)return null;const u=c.majorBase,f=c.majorMustEqual,m=c.minorBase;let k=c.minorMustEqual;const s=c.patchBase;let a=c.patchMustEqual;c.hasCaret&&(u===0||(k=!1),a=!1);let n=0;if(c.preRelease){const i=R.exec(c.preRelease);if(i){const[,t,r,o]=i;n=Date.UTC(Number(t),Number(r)-1,Number(o))}}return{majorBase:u,majorMustEqual:f,minorBase:m,minorMustEqual:k,patchBase:s,patchMustEqual:a,isMinimum:c.hasGreaterEquals,notBefore:n}}e.$Oo=P;function E(c,u,f){let m;typeof c=="string"?m=P(d(c)):m=c;let k;u instanceof Date?k=u.getTime():typeof u=="string"&&(k=new Date(u).getTime());let s;if(typeof f=="string"?s=P(d(f)):s=f,!m||!s)return!1;const a=m.majorBase,n=m.minorBase,i=m.patchBase;let t=s.majorBase,r=s.minorBase,o=s.patchBase;const v=s.notBefore;let y=s.majorMustEqual,h=s.minorMustEqual,g=s.patchMustEqual;return s.isMinimum?a>t?!0:a<t?!1:n>r?!0:n<r||k&&k<v?!1:i>=o:(a===1&&t===0&&(!y||!h||!g)&&(t=1,r=0,o=0,y=!0,h=!1,g=!1),a<t?!1:a>t?!y:n<r?!1:n>r?!h:i<o?!1:i>o?!g:!(k&&k<v))}e.$Po=E;function b(c,u,f,m,k){const s=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return s.push([F.default.Error,j.localize(0,null)]),s;if(typeof m.name!="string")return s.push([F.default.Error,j.localize(1,null,"name")]),s;if(typeof m.version!="string")return s.push([F.default.Error,j.localize(2,null,"version")]),s;if(!m.engines)return s.push([F.default.Error,j.localize(3,null,"engines")]),s;if(typeof m.engines.vscode!="string")return s.push([F.default.Error,j.localize(4,null,"engines.vscode")]),s;if(typeof m.extensionDependencies<"u"&&!w(m.extensionDependencies))return s.push([F.default.Error,j.localize(5,null,"extensionDependencies")]),s;if(typeof m.activationEvents<"u"){if(!w(m.activationEvents))return s.push([F.default.Error,j.localize(6,null,"activationEvents")]),s;if(typeof m.main>"u"&&typeof m.browser>"u")return s.push([F.default.Error,j.localize(7,null,"activationEvents","main","browser")]),s}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&s.push([F.default.Warning,j.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return s.push([F.default.Error,j.localize(9,null,"main")]),s;{const i=(0,D.$vg)(f,m.main);(0,D.$pg)(i,f)||s.push([F.default.Warning,j.localize(10,null,i.path,f.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return s.push([F.default.Error,j.localize(11,null,"browser")]),s;{const i=(0,D.$vg)(f,m.browser);(0,D.$pg)(i,f)||s.push([F.default.Warning,j.localize(12,null,i.path,f.path)])}}if(!A.valid(m.version))return s.push([F.default.Error,j.localize(13,null)]),s;const a=[];if(!l(c,u,m,k,a))for(const i of a)s.push([F.default.Error,i]);return s}e.$Qo=b;function l(c,u,f,m,k){return m||typeof f.main>"u"&&typeof f.browser>"u"?!0:p(c,u,f.engines.vscode,k)}e.$Ro=l;function $(c,u,f){return c==="*"||p(u,f,c)}e.$So=$;function p(c,u,f,m=[]){const k=P(d(f));if(!k)return m.push(j.localize(14,null,f)),!1;if(k.majorBase===0){if(!k.majorMustEqual||!k.minorMustEqual)return m.push(j.localize(15,null,f)),!1}else if(!k.majorMustEqual)return m.push(j.localize(16,null,f)),!1;return E(c,u,k)?!0:(m.push(j.localize(17,null,c,f)),!1)}function w(c){if(!Array.isArray(c))return!1;for(let u=0,f=c.length;u<f;u++)if(typeof c[u]!="string")return!1;return!0}}),define(ae[43],ce([0,1,15,32]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=void 0;async function j(A,I,R){let S=R&&R.get("storage.serviceMachineId",-1)||null;if(S)return S;try{const P=(await I.readFile(A.serviceMachineIdResource)).value.toString();S=(0,F.$dg)(P)?P:null}catch{S=null}if(!S){S=(0,F.$eg)();try{await I.writeFile(A.serviceMachineIdResource,D.$be.fromString(S))}catch{}}return R?.store("storage.serviceMachineId",S,-1,1),S}e.$ap=j}),define(ae[70],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class D{constructor(j,A=[],I=!1){this.ctor=j,this.staticArguments=A,this.supportsDelayedInstantiation=I}}e.$Nh=D}),define(ae[184],ce([0,1,70]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=e.InstantiationType=void 0;const F=[];var j;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(j||(e.InstantiationType=j={}));function A(R,S,d){S instanceof D.$Nh||(S=new D.$Nh(S,[],!!d)),F.push([R,S])}e.$xr=A;function I(){return F}e.$yr=I}),define(ae[185],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=void 0;class D{constructor(A,I){this.key=A,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.$cq=D;class F{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const I of this.a.values())I.outgoing.size===0&&A.push(I);return A}insertEdge(A,I){const R=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(I);R.outgoing.set(S.key,S),S.incoming.set(R.key,R)}removeNode(A){const I=this.b(A);this.a.delete(I);for(const R of this.a.values())R.outgoing.delete(I),R.incoming.delete(I)}lookupOrInsertNode(A){const I=this.b(A);let R=this.a.get(I);return R||(R=new D(I,A),this.a.set(I,R)),R}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[I,R]of this.a)A.push(`${I}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,I]of this.a){const R=new Set([A]),S=this.c(I,R);if(S)return S}}c(A,I){for(const[R,S]of A.outgoing){if(I.has(R))return[...I,R].join(" -> ");I.add(R);const d=this.c(S,I);if(d)return d;I.delete(R)}}}e.$dq=F}),define(ae[4],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e._util=void 0;var D;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function R(S){return S[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=R})(D||(e._util=D={})),e.$Ph=j("instantiationService");function F(I,R,S){R[D.DI_TARGET]===R?R[D.DI_DEPENDENCIES].push({id:I,index:S}):(R[D.DI_DEPENDENCIES]=[{id:I,index:S}],R[D.DI_TARGET]=R)}function j(I){if(D.serviceIds.has(I))return D.serviceIds.get(I);const R=function(S,d,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(R,S,P)};return R.toString=()=>I,D.serviceIds.set(I,R),R}e.$Qh=j;function A(I){return I}e.$Rh=A}),define(ae[186],ce([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y9b=void 0,e.$y9b=(0,D.$Qh)("checksumService")}),define(ae[20],ce([0,1,12,10,4]),function(te,e,D,F,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.ConfigurationTarget=e.$mi=e.$li=e.$ki=void 0,e.$ki=(0,j.$Qh)("configurationService");function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof F.URI)}e.$li=A;function I(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof F.URI)}e.$mi=I;var R;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function S(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ni=S;function d(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$oi=d;function P(c,u){const f=Object.create(null);for(const m in c)E(f,m,c[m],u);return f}e.$pi=P;function E(c,u,f,m){const k=u.split("."),s=k.pop();let a=c;for(let n=0;n<k.length;n++){const i=k[n];let t=a[i];switch(typeof t){case"undefined":t=a[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${u} as ${k.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}a=t}if(typeof a=="object"&&a!==null)try{a[s]=f}catch{m(`Ignoring ${u} as ${k.join(".")} is ${JSON.stringify(a)}`)}else m(`Ignoring ${u} as ${k.join(".")} is ${JSON.stringify(a)}`)}e.$qi=E;function b(c,u){const f=u.split(".");l(c,f)}e.$ri=b;function l(c,u){const f=u.shift();if(u.length===0){delete c[f];return}if(Object.keys(c).indexOf(f)!==-1){const m=c[f];typeof m=="object"&&!Array.isArray(m)&&(l(m,u),Object.keys(m).length===0&&delete c[f])}}function $(c,u,f){function m(a,n){let i=a;for(const t of n){if(typeof i!="object"||i===null)return;i=i[t]}return i}const k=u.split("."),s=m(c,k);return typeof s>"u"?f:s}e.$si=$;function p(c,u,f){Object.keys(u).forEach(m=>{m!=="__proto__"&&(m in c?D.$Af(c[m])&&D.$Af(u[m])?p(c[m],u[m],f):f&&(c[m]=u[m]):c[m]=u[m])})}e.$ti=p;function w(c){return c.replace(/[\[\]]/g,"")}e.$ui=w}),define(ae[94],ce([0,1,5,27,178,4,149,7]),function(te,e,D,F,j,A,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.ContextKeyExprType=e.$Mi=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",D.$k),S.set("isLinux",D.$l),S.set("isWindows",D.$j),S.set("isWeb",D.$p),S.set("isMacNative",D.$k&&!D.$p),S.set("isEdge",D.$H),S.set("isFirefox",D.$F),S.set("isChrome",D.$E),S.set("isSafari",D.$G);function d(q,C){if(S.get(q)!==void 0)throw(0,R.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(q,C)}e.$Mi=d;const P=Object.prototype.hasOwnProperty;var E;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const b={regexParsingWithErrorRecovery:!0},l=(0,I.localize)(0,null),$=(0,I.localize)(1,null),p=(0,I.localize)(2,null),w=(0,I.localize)(3,null),c=(0,I.localize)(4,null),u=(0,I.localize)(5,null),f=(0,I.localize)(6,null),m=(0,I.localize)(7,null);class k{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(C=b){this.k=C,this.d=new j.$Li,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(C){if(C===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(C).scan(),this.g=0,this.h=[];try{const L=this.l();if(!this.E()){const B=this.D(),N=B.type===17?u:void 0;throw this.h.push({message:c,offset:B.offset,lexeme:j.$Li.getLexeme(B),additionalInfo:N}),k.c}return L}catch(L){if(L!==k.c)throw L;return}}l(){return this.m()}m(){const C=[this.o()];for(;this.y(16);){const L=this.o();C.push(L)}return C.length===1?C[0]:s.or(...C)}o(){const C=[this.s()];for(;this.y(15);){const L=this.s();C.push(L)}return C.length===1?C[0]:s.and(...C)}s(){if(this.y(2)){const C=this.D();switch(C.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const L=this.l();return this.A(1,w),L?.negate()}case 17:return this.z(),O.create(C.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",C)}}return this.t()}t(){const C=this.D();switch(C.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const L=this.l();return this.A(1,w),L}case 17:{const L=C.lexeme;if(this.z(),this.y(9)){const N=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),N.type!==10)throw this.B("REGEX",N);const W=N.lexeme,G=W.lastIndexOf("/"),ie=G===W.length-1?void 0:this.w(W.substring(G+1));let oe;try{oe=new RegExp(W.substring(1,G),ie)}catch{throw this.B("REGEX",N)}return X.create(L,oe)}switch(N.type){case 10:case 19:{const W=[N.lexeme];this.z();let G=this.D(),ie=0;for(let de=0;de<N.lexeme.length;de++)N.lexeme.charCodeAt(de)===40?ie++:N.lexeme.charCodeAt(de)===41&&ie--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let de=0;de<G.lexeme.length;de++)G.lexeme.charCodeAt(de)===40?ie++:N.lexeme.charCodeAt(de)===41&&ie--}if(ie<0)break;W.push(j.$Li.getLexeme(G)),this.z(),G=this.D()}const oe=W.join(""),ue=oe.lastIndexOf("/"),he=ue===oe.length-1?void 0:this.w(oe.substring(ue+1));let $e;try{$e=new RegExp(oe.substring(1,ue),he)}catch{throw this.B("REGEX",N)}return s.regex(L,$e)}case 18:{const W=N.lexeme;this.z();let G=null;if(!(0,F.$Be)(W)){const ie=W.indexOf("/"),oe=W.lastIndexOf("/");if(ie!==oe&&ie>=0){const ue=W.slice(ie+1,oe),he=W[oe+1]==="i"?"i":"";try{G=new RegExp(ue,he)}catch{throw this.B("REGEX",N)}}}if(G===null)throw this.B("REGEX",N);return X.create(L,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const N=this.u();return s.notIn(L,N)}switch(this.D().type){case 3:{this.z();const N=this.u();if(this.x().type===18)return s.equals(L,N);switch(N){case"true":return s.has(L);case"false":return s.not(L);default:return s.equals(L,N)}}case 4:{this.z();const N=this.u();if(this.x().type===18)return s.notEquals(L,N);switch(N){case"true":return s.not(L);case"false":return s.has(L);default:return s.notEquals(L,N)}}case 5:return this.z(),z.create(L,this.u());case 6:return this.z(),Z.create(L,this.u());case 7:return this.z(),M.create(L,this.u());case 8:return this.z(),U.create(L,this.u());case 13:return this.z(),s.in(L,this.u());default:return s.has(L)}}case 20:throw this.h.push({message:f,offset:C.offset,lexeme:"",additionalInfo:m}),k.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const C=this.D();switch(C.type){case 17:case 18:return this.z(),C.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(C){return C.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(C){return this.C(C)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(C,L){if(this.C(C))return this.z();throw this.B(L,this.D())}B(C,L,B){const N=(0,I.localize)(8,null,C,j.$Li.getLexeme(L)),W=L.offset,G=j.$Li.getLexeme(L);return this.h.push({message:N,offset:W,lexeme:G,additionalInfo:B}),k.c}C(C){return this.D().type===C}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ni=k;class s{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(C){return o.create(C)}static equals(C,L){return v.create(C,L)}static notEquals(C,L){return g.create(C,L)}static regex(C,L){return X.create(C,L)}static in(C,L){return y.create(C,L)}static notIn(C,L){return h.create(C,L)}static not(C){return O.create(C)}static and(...C){return K.create(C,null,!0)}static or(...C){return J.create(C,null,!0)}static greater(C,L){return M.create(C,L)}static greaterEquals(C,L){return U.create(C,L)}static smaller(C,L){return z.create(C,L)}static smallerEquals(C,L){return Z.create(C,L)}static{this.c=new k({regexParsingWithErrorRecovery:!1})}static deserialize(C){return C==null?void 0:this.c.parse(C)}}e.$Oi=s;function a(q){const C=new k({regexParsingWithErrorRecovery:!1});return q.map(L=>(C.parse(L),C.lexingErrors.length>0?C.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,I.localize)(9,null,B.additionalInfo):(0,I.localize)(10,null),offset:B.offset,length:B.lexeme.length})):C.parsingErrors.length>0?C.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}e.$Pi=a;function n(q,C){const L=q?q.substituteConstants():void 0,B=C?C.substituteConstants():void 0;return!L&&!B?!0:!L||!B?!1:L.equals(B)}e.$Qi=n;function i(q,C){return q.cmp(C)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return r.INSTANCE}}e.$Ri=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return t.INSTANCE}}e.$Si=r;class o{static create(C,L=null){const B=S.get(C);return typeof B=="boolean"?B?r.INSTANCE:t.INSTANCE:new o(C,L)}constructor(C,L){this.key=C,this.c=L,this.type=2}cmp(C){return C.type!==this.type?this.type-C.type:ee(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=S.get(this.key);return typeof C=="boolean"?C?r.INSTANCE:t.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.c||(this.c=O.create(this.key,this)),this.c}}e.$Ti=o;class v{static create(C,L,B=null){if(typeof L=="boolean")return L?o.create(C,B):O.create(C,B);const N=S.get(C);return typeof N=="boolean"?L===(N?"true":"false")?r.INSTANCE:t.INSTANCE:new v(C,L,B)}constructor(C,L,B){this.c=C,this.d=L,this.f=B,this.type=4}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=S.get(this.c);if(typeof C=="boolean"){const L=C?"true":"false";return this.d===L?r.INSTANCE:t.INSTANCE}return this}evaluate(C){return C.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(C){return C.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.$Ui=v;class y{static create(C,L){return new y(C,L)}constructor(C,L){this.d=C,this.f=L,this.type=10,this.c=null}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.d,this.f,C.d,C.f)}equals(C){return C.type===this.type?this.d===C.d&&this.f===C.f:!1}substituteConstants(){return this}evaluate(C){const L=C.getValue(this.f),B=C.getValue(this.d);return Array.isArray(L)?L.includes(B):typeof B=="string"&&typeof L=="object"&&L!==null?P.call(L,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(C){return C.mapIn(this.d,this.f)}negate(){return this.c||(this.c=h.create(this.d,this.f)),this.c}}e.$Vi=y;class h{static create(C,L){return new h(C,L)}constructor(C,L){this.d=C,this.f=L,this.type=11,this.c=y.create(C,L)}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(C){return C.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Wi=h;class g{static create(C,L,B=null){if(typeof L=="boolean")return L?O.create(C,B):o.create(C,B);const N=S.get(C);return typeof N=="boolean"?L===(N?"true":"false")?t.INSTANCE:r.INSTANCE:new g(C,L,B)}constructor(C,L,B){this.c=C,this.d=L,this.f=B,this.type=5}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=S.get(this.c);if(typeof C=="boolean"){const L=C?"true":"false";return this.d===L?t.INSTANCE:r.INSTANCE}return this}evaluate(C){return C.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(C){return C.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Xi=g;class O{static create(C,L=null){const B=S.get(C);return typeof B=="boolean"?B?t.INSTANCE:r.INSTANCE:new O(C,L)}constructor(C,L){this.c=C,this.d=L,this.type=3}cmp(C){return C.type!==this.type?this.type-C.type:ee(this.c,C.c)}equals(C){return C.type===this.type?this.c===C.c:!1}substituteConstants(){const C=S.get(this.c);return typeof C=="boolean"?C?t.INSTANCE:r.INSTANCE:this}evaluate(C){return!C.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(C){return C.mapNot(this.c)}negate(){return this.d||(this.d=o.create(this.c,this)),this.d}}e.$Yi=O;function T(q,C){if(typeof q=="string"){const L=parseFloat(q);isNaN(L)||(q=L)}return typeof q=="string"||typeof q=="number"?C(q):t.INSTANCE}class M{static create(C,L,B=null){return T(L,N=>new M(C,N,B))}constructor(C,L,B){this.c=C,this.d=L,this.f=B,this.type=12}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$Zi=M;class U{static create(C,L,B=null){return T(L,N=>new U(C,N,B))}constructor(C,L,B){this.c=C,this.d=L,this.f=B,this.type=13}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$1i=U;class z{static create(C,L,B=null){return T(L,N=>new z(C,N,B))}constructor(C,L,B){this.c=C,this.d=L,this.f=B,this.type=14}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$2i=z;class Z{static create(C,L,B=null){return T(L,N=>new Z(C,N,B))}constructor(C,L,B){this.c=C,this.d=L,this.f=B,this.type=15}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$3i=Z;class X{static create(C,L){return new X(C,L)}constructor(C,L){this.d=C,this.f=L,this.type=7,this.c=null}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.d<C.d)return-1;if(this.d>C.d)return 1;const L=this.f?this.f.source:"",B=C.f?C.f.source:"";return L<B?-1:L>B?1:0}equals(C){if(C.type===this.type){const L=this.f?this.f.source:"",B=C.f?C.f.source:"";return this.d===C.d&&L===B}return!1}substituteConstants(){return this}evaluate(C){const L=C.getValue(this.d);return this.f?this.f.test(L):!1}serialize(){const C=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${C}`}keys(){return[this.d]}map(C){return C.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$4i=X;class x{static create(C){return new x(C)}constructor(C){this.c=C,this.type=8}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(C){return new x(this.c.map(C))}negate(){return this.c}}e.$5i=x;function H(q){let C=null;for(let L=0,B=q.length;L<B;L++){const N=q[L].substituteConstants();if(q[L]!==N&&C===null){C=[];for(let W=0;W<L;W++)C[W]=q[W]}C!==null&&(C[L]=N)}return C===null?q:C}class K{static create(C,L,B){return K.d(C,L,B)}constructor(C,L){this.expr=C,this.c=L,this.type=6}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let L=0,B=this.expr.length;L<B;L++){const N=i(this.expr[L],C.expr[L]);if(N!==0)return N}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let L=0,B=this.expr.length;L<B;L++)if(!this.expr[L].equals(C.expr[L]))return!1;return!0}return!1}substituteConstants(){const C=H(this.expr);return C===this.expr?this:K.create(C,this.c,!1)}evaluate(C){for(let L=0,B=this.expr.length;L<B;L++)if(!this.expr[L].evaluate(C))return!1;return!0}static d(C,L,B){const N=[];let W=!1;for(const G of C)if(G){if(G.type===1){W=!0;continue}if(G.type===0)return t.INSTANCE;if(G.type===6){N.push(...G.expr);continue}N.push(G)}if(N.length===0&&W)return r.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(i);for(let G=1;G<N.length;G++)N[G-1].equals(N[G])&&(N.splice(G,1),G--);if(N.length===1)return N[0];for(;N.length>1;){const G=N[N.length-1];if(G.type!==9)break;N.pop();const ie=N.pop(),oe=N.length===0,ue=J.create(G.expr.map(he=>K.create([he,ie],null,B)),null,oe);ue&&(N.push(ue),N.sort(i))}if(N.length===1)return N[0];if(B){for(let G=0;G<N.length;G++)for(let ie=G+1;ie<N.length;ie++)if(N[G].negate().equals(N[ie]))return t.INSTANCE;if(N.length===1)return N[0]}return new K(N,L)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(const L of this.expr)C.push(...L.keys());return C}map(C){return new K(this.expr.map(L=>L.map(C)),null)}negate(){if(!this.c){const C=[];for(const L of this.expr)C.push(L.negate());this.c=J.create(C,this,!0)}return this.c}}e.$6i=K;class J{static create(C,L,B){return J.d(C,L,B)}constructor(C,L){this.expr=C,this.c=L,this.type=9}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let L=0,B=this.expr.length;L<B;L++){const N=i(this.expr[L],C.expr[L]);if(N!==0)return N}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let L=0,B=this.expr.length;L<B;L++)if(!this.expr[L].equals(C.expr[L]))return!1;return!0}return!1}substituteConstants(){const C=H(this.expr);return C===this.expr?this:J.create(C,this.c,!1)}evaluate(C){for(let L=0,B=this.expr.length;L<B;L++)if(this.expr[L].evaluate(C))return!0;return!1}static d(C,L,B){let N=[],W=!1;if(C){for(let G=0,ie=C.length;G<ie;G++){const oe=C[G];if(oe){if(oe.type===0){W=!0;continue}if(oe.type===1)return r.INSTANCE;if(oe.type===9){N=N.concat(oe.expr);continue}N.push(oe)}}if(N.length===0&&W)return t.INSTANCE;N.sort(i)}if(N.length!==0){if(N.length===1)return N[0];for(let G=1;G<N.length;G++)N[G-1].equals(N[G])&&(N.splice(G,1),G--);if(N.length===1)return N[0];if(B){for(let G=0;G<N.length;G++)for(let ie=G+1;ie<N.length;ie++)if(N[G].negate().equals(N[ie]))return r.INSTANCE;if(N.length===1)return N[0]}return new J(N,L)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(const L of this.expr)C.push(...L.keys());return C}map(C){return new J(this.expr.map(L=>L.map(C)),null)}negate(){if(!this.c){const C=[];for(const L of this.expr)C.push(L.negate());for(;C.length>1;){const L=C.shift(),B=C.shift(),N=[];for(const W of Q(L))for(const G of Q(B))N.push(K.create([W,G],null,!1));C.unshift(J.create(N,null,!1))}this.c=J.create(C,this,!0)}return this.c}}e.$7i=J;class V extends o{static{this.d=[]}static all(){return V.d.values()}constructor(C,L,B){super(C,null),this.f=L,typeof B=="object"?V.d.push({...B,key:C}):B!==!0&&V.d.push({key:C,description:B,type:L!=null?typeof L:void 0})}bindTo(C){return C.createKey(this.key,this.f)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return v.create(this.key,C)}notEqualsTo(C){return g.create(this.key,C)}}e.$8i=V,e.$9i=(0,A.$Qh)("contextKeyService");function ee(q,C){return q<C?-1:q>C?1:0}function ne(q,C,L,B){return q<L?-1:q>L?1:C<B?-1:C>B?1:0}function _(q,C){if(q.type===0||C.type===1)return!0;if(q.type===9)return C.type===9?se(q.expr,C.expr):!1;if(C.type===9){for(const L of C.expr)if(_(q,L))return!0;return!1}if(q.type===6){if(C.type===6)return se(C.expr,q.expr);for(const L of q.expr)if(_(L,C))return!0;return!1}return q.equals(C)}e.$0i=_;function se(q,C){let L=0,B=0;for(;L<q.length&&B<C.length;){const N=q[L].cmp(C[B]);if(N<0)return!1;N===0&&L++,B++}return L===q.length}function Q(q){return q.type===9?q.expr:[q]}}),define(ae[95],ce([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=e.$rm=e.ID=void 0,e.ID="diagnosticsService",e.$rm=(0,D.$Qh)(e.ID);function F(A){return!!A.hostName&&!!A.errorMessage}e.$sm=F;class j{async getPerformanceInfo(I,R){return{}}async getSystemInfo(I,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(I,R){return""}async getWorkspaceFileExtensions(I){return{extensions:[]}}async reportWorkspaceStats(I){}}e.$tm=j}),define(ae[96],ce([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=void 0,e.$Pn=(0,D.$Qh)("downloadService")}),define(ae[14],ce([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=void 0,e.$Xh=(0,D.$Qh)("environmentService"),e.$Yh=(0,D.$Rh)(e.$Xh)}),define(ae[29],ce([0,1,152,4]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$$n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=void 0,e.$Yn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Zn=new RegExp(e.$Yn),e.$1n="__web_extension",e.$2n="skipWalkthrough",e.$3n="extensionsSync",e.$4n="dependecyOrPackExtensionInstall";function j(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$5n=j;function A(c){switch(c){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$6n=A;function I(c,u){switch(c){case 3:return u==="x64"?"win32-x64":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$7n=I;function R(c,u){return u==="web"&&!c.includes("web")}e.$8n=R;function S(c,u,f){return R(u,f)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===f}e.$9n=S;function d(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$0n=d;var P;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var E;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var b;(function(c){c.Install="install",c.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var l;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(l||(e.InstallOperation=l={})),e.$$n=(0,F.$Qh)("extensionGalleryService");var $;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));var p;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(p||(e.ExtensionSignaturetErrorCode=p={}));class w extends Error{constructor(u,f){super(u),this.code=f,this.name=f}}e.$_n=w,e.$ao=(0,F.$Qh)("extensionManagementService"),e.$bo="extensionsIdentifiers/disabled",e.$co="extensionsIdentifiers/enabled",e.$do=(0,F.$Qh)("IGlobalExtensionEnablementService"),e.$eo=(0,F.$Qh)("IExtensionTipsService"),e.$fo=(0,D.localize)(0,null),e.$go={value:e.$fo,original:"Extensions"},e.$ho={value:(0,D.localize)(1,null),original:"Preferences"}}),define(ae[187],ce([0,1,3,2,30,10,92,29]),function(te,e,D,F,j,A,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=void 0;function S(w,c){return w?A.URI.revive(c?c.transformIncoming(w):w):void 0}function d(w,c){return c?c.transformOutgoingURI(w):w}function P(w,c){c=c||I.$Nm;const u=w.manifest;return{...(0,I.$Qm)({...w,manifest:void 0},c),manifest:u}}function E(w,c){return w?.profileLocation?(0,I.$Qm)(w,c??I.$Nm):w}function b(w,c){return c?(0,j.$0m)(w,u=>u instanceof A.URI?c.transformOutgoingURI(u):void 0):w}class l{constructor(c,u){this.a=c,this.b=u,this.onInstallExtension=D.Event.buffer(c.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(c.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(c.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(c.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=D.Event.buffer(c.onDidUpdateExtensionMetadata,!0)}listen(c,u){const f=this.b(c);switch(u){case"onInstallExtension":return D.Event.map(this.onInstallExtension,m=>({...m,profileLocation:m.profileLocation?d(m.profileLocation,f):m.profileLocation}));case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,m=>m.map(k=>({...k,local:k.local?b(k.local,f):k.local,profileLocation:k.profileLocation?d(k.profileLocation,f):k.profileLocation})));case"onUninstallExtension":return D.Event.map(this.onUninstallExtension,m=>({...m,profileLocation:m.profileLocation?d(m.profileLocation,f):m.profileLocation}));case"onDidUninstallExtension":return D.Event.map(this.onDidUninstallExtension,m=>({...m,profileLocation:m.profileLocation?d(m.profileLocation,f):m.profileLocation}));case"onDidUpdateExtensionMetadata":return D.Event.map(this.onDidUpdateExtensionMetadata,m=>b(m,f))}throw new Error("Invalid listen")}async call(c,u,f){const m=this.b(c);switch(u){case"zip":{const k=P(f[0],m),s=await this.a.zip(k);return d(s,m)}case"unzip":return this.a.unzip(S(f[0],m));case"install":return this.a.install(S(f[0],m),E(f[1],m));case"installFromLocation":return this.a.installFromLocation(S(f[0],m),S(f[1],m));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(f[0],S(f[1],m),S(f[2],m));case"getManifest":return this.a.getManifest(S(f[0],m));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(f[0]);case"installFromGallery":return this.a.installFromGallery(f[0],E(f[1],m));case"installGalleryExtensions":{const k=f[0];return this.a.installGalleryExtensions(k.map(({extension:s,options:a})=>({extension:s,options:E(a,m)??{}})))}case"uninstall":return this.a.uninstall(P(f[0],m),E(f[1],m));case"reinstallFromGallery":return this.a.reinstallFromGallery(P(f[0],m));case"getInstalled":return(await this.a.getInstalled(f[0],S(f[1],m))).map(s=>b(s,m));case"toggleAppliationScope":{const k=await this.a.toggleAppliationScope(P(f[0],m),S(f[1],m));return b(k,m)}case"copyExtensions":return this.a.copyExtensions(S(f[0],m),S(f[1],m));case"updateMetadata":{const k=await this.a.updateMetadata(P(f[0],m),f[1],S(f[2],m));return b(k,m)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(f[0],f[1],f[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$ip=l;class $ extends F.$Rc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(c){super(),this.m=c,this.c=this.B(new D.$Nd),this.f=this.B(new D.$Nd),this.g=this.B(new D.$Nd),this.h=this.B(new D.$Nd),this.j=this.B(new D.$Nd),this.B(this.m.listen("onInstallExtension")(u=>this.n(this.c,{...u,source:this.r(u.source)?A.URI.revive(u.source):u.source,profileLocation:A.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(u=>this.n(this.f,u.map(f=>({...f,local:f.local?P(f.local,null):f.local,source:this.r(f.source)?A.URI.revive(f.source):f.source,profileLocation:A.URI.revive(f.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(u=>this.n(this.g,{...u,profileLocation:A.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(u=>this.n(this.h,{...u,profileLocation:A.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(P(u,null))))}n(c,u){c.fire(u)}r(c){return c?typeof c.path=="string"&&typeof c.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(c){const u=await this.getTargetPlatform();return c.allTargetPlatforms.some(f=>(0,R.$9n)(f,c.allTargetPlatforms,u))}zip(c){return Promise.resolve(this.m.call("zip",[c]).then(u=>A.URI.revive(u)))}unzip(c){return Promise.resolve(this.m.call("unzip",[c]))}install(c,u){return Promise.resolve(this.m.call("install",[c,u])).then(f=>P(f,null))}installFromLocation(c,u){return Promise.resolve(this.m.call("installFromLocation",[c,u])).then(f=>P(f,null))}async installExtensionsFromProfile(c,u,f){return(await this.m.call("installExtensionsFromProfile",[c,u,f])).map(k=>P(k,null))}getManifest(c){return Promise.resolve(this.m.call("getManifest",[c]))}installFromGallery(c,u){return Promise.resolve(this.m.call("installFromGallery",[c,u])).then(f=>P(f,null))}async installGalleryExtensions(c){return(await this.m.call("installGalleryExtensions",[c])).map(f=>({...f,local:f.local?P(f.local,null):f.local,source:this.r(f.source)?A.URI.revive(f.source):f.source,profileLocation:A.URI.revive(f.profileLocation)}))}uninstall(c,u){return Promise.resolve(this.m.call("uninstall",[c,u]))}reinstallFromGallery(c){return Promise.resolve(this.m.call("reinstallFromGallery",[c])).then(u=>P(u,null))}getInstalled(c=null,u){return Promise.resolve(this.m.call("getInstalled",[c,u])).then(f=>f.map(m=>P(m,null)))}updateMetadata(c,u,f){return Promise.resolve(this.m.call("updateMetadata",[c,u,f])).then(m=>P(m,null))}toggleAppliationScope(c,u){return this.m.call("toggleAppliationScope",[c,u]).then(f=>P(f,null))}copyExtensions(c,u){return this.m.call("copyExtensions",[c,u])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(c,u,f){const m=await this.m.call("download",[c,u,f]);return A.URI.revive(m)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$jp=$;class p{constructor(c){this.a=c}listen(c,u){throw new Error("Invalid listen")}call(c,u,f){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(f[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$kp=p}),define(ae[97],ce([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=void 0,e.$fp=(0,D.$Qh)("IExtensionSignatureVerificationService");class F{b(){return this.a||(this.a=new Promise((A,I)=>te(["node-vsce-sign"],async R=>A(R),I))),this.a}async verify(A,I,R){let S;try{S=await this.b()}catch{return!1}return S.verify(A,I,R)}}e.$gp=F}),define(ae[98],ce([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rWb=e.RecommendationsNotificationResult=e.$qWb=e.RecommendationSource=void 0;var F;(function(I){I[I.FILE=1]="FILE",I[I.WORKSPACE=2]="WORKSPACE",I[I.EXE=3]="EXE"})(F||(e.RecommendationSource=F={}));function j(I){switch(I){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$qWb=j;var A;(function(I){I.Ignored="ignored",I.Cancelled="cancelled",I.TooMany="toomany",I.IncompatibleWindow="incompatibleWindow",I.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$rWb=(0,D.$Qh)("IExtensionRecommendationNotificationService")}),define(ae[11],ce([0,1,47,16,27,12,10,159,4,5,23,61]),function(te,e,D,F,j,A,I,R,S,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileKind=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileOperationResult=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileChangeType=e.$rk=e.FileOperation=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileSystemProviderErrorCode=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.FileSystemProviderCapabilities=e.$bk=e.FilePermission=e.FileType=e.$ak=e.$_j=void 0,e.$_j=(0,S.$Qh)("fileService");function b(_){return _.create===!0}e.$ak=b;var l;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(l||(e.FileType=l={}));var $;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})($||(e.FilePermission=$={}));function p(_){const se=_;return!!se&&typeof se.onDidChange=="function"}e.$bk=p;var w;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function c(_){return!!(_.capabilities&2)}e.$ck=c;function u(_){return!!(_.capabilities&8)}e.$dk=u;function f(_){return!!(_.capabilities&131072)}e.$ek=f;function m(_){return!!(_.capabilities&4)}e.$fk=m;function k(_){return!!(_.capabilities&16)}e.$gk=k;function s(_){return c(_)?!!(_.capabilities&16384):!1}e.$hk=s;function a(_){return c(_)?!!(_.capabilities&32768):!1}e.$ik=a;function n(_){return!!(_.capabilities&65536)}e.$jk=n;function i(_){return!!(_.capabilities&2048)}e.$kk=i;var t;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(se,Q){const q=new r(se.toString(),Q);return y(q,Q),q}constructor(se,Q){super(se),this.code=Q}}e.$lk=r;function o(_,se){return r.create(_,se)}e.$mk=o;function v(_){return _||o((0,R.localize)(0,null),t.Unknown)}e.$nk=v;function y(_,se){return _.name=se?`${se} (FileSystemError)`:"FileSystemError",_}e.$ok=y;function h(_){if(!_)return t.Unknown;if(_ instanceof r)return _.code;const se=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!se)return t.Unknown;switch(se[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$pk=h;function g(_){if(_ instanceof Z)return _.fileOperationResult;switch(h(_)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$qk=g;var O;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(O||(e.FileOperation=O={}));class T{constructor(se,Q,q){this.resource=se,this.operation=Q,this.target=q}isOperation(se){return this.operation===se}}e.$rk=T;var M;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class U{static{this.a=null}constructor(se,Q){this.c=Q,this.b=void 0,this.d=new E.$U(()=>{const q=D.$Wh.forUris(()=>this.c);return q.fill(this.rawAdded.map(C=>[C,!0])),q}),this.f=new E.$U(()=>{const q=D.$Wh.forUris(()=>this.c);return q.fill(this.rawUpdated.map(C=>[C,!0])),q}),this.g=new E.$U(()=>{const q=D.$Wh.forUris(()=>this.c);return q.fill(this.rawDeleted.map(C=>[C,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of se){switch(q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}this.b!==U.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(se,...Q){return this.h(se,{includeChildren:!1},...Q)}affects(se,...Q){return this.h(se,{includeChildren:!0},...Q)}h(se,Q,...q){if(!se)return!1;const C=q.length>0;return!!((!C||q.includes(1))&&(this.d.value.get(se)||Q.includeChildren&&this.d.value.findSuperstr(se))||(!C||q.includes(0))&&(this.f.value.get(se)||Q.includeChildren&&this.f.value.findSuperstr(se))||(!C||q.includes(2))&&(this.g.value.findSubstr(se)||Q.includeChildren&&this.g.value.findSuperstr(se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(se){return this.b===se}hasCorrelation(){return typeof this.b=="number"}}e.$sk=U;function z(_,se,Q){return!_||!se||_===se||se.length>_.length?!1:(se.charAt(se.length-1)!==F.sep&&(se+=F.sep),Q?(0,j.$3e)(_,se):_.indexOf(se)===0)}e.$tk=z;class Z extends Error{constructor(se,Q,q){super(se),this.fileOperationResult=Q,this.options=q}}e.$uk=Z;class X extends Z{constructor(se,Q,q,C){super(se,Q,C),this.fileOperationResult=Q,this.size=q}}e.$vk=X;class x extends Z{constructor(se,Q,q){super(se,2,q),this.stat=Q}}e.$wk=x;var H;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(H||(e.FileOperationResult=H={})),e.$xk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zk="files.associations",e.$Ak="files.exclude",e.$Bk="files.readonlyInclude",e.$Ck="files.readonlyExclude",e.$Dk="files.readonlyFromPermissions";var K;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.$Ek="";function J(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Fk=J;async function V(_,se){if(!se.hasProvider(I.URI.from({scheme:_.scheme})))return new Promise(Q=>{const q=se.onDidChangeFileSystemProviderRegistrations(C=>{C.scheme===_.scheme&&C.added&&(q.dispose(),Q())})})}e.$Gk=V;class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(se){return(0,A.$Cf)(se)||(se=0),se<ee.KB?(0,R.localize)(1,null,se.toFixed(0)):se<ee.MB?(0,R.localize)(2,null,(se/ee.KB).toFixed(2)):se<ee.GB?(0,R.localize)(3,null,(se/ee.MB).toFixed(2)):se<ee.TB?(0,R.localize)(4,null,(se/ee.GB).toFixed(2)):(0,R.localize)(5,null,(se/ee.TB).toFixed(2))}}e.$Hk=ee;function ne(_){const se=typeof _=="string"||_?.scheme===P.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===P.Schemas.file?1024*ee.MB:se?10*ee.MB:d.$p?50*ee.MB:1024*ee.MB}e.$Ik=ne});var Y=this&&this.__param||function(te,e){return function(D,F){e(D,F,te)}};define(ae[188],ce([0,1,71,46,11]),function(te,e,D,F,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z9b=void 0;let A=class{constructor(R){this.a=R}async checksum(R){const S=(await this.a.readFileStream(R)).value;return new Promise((d,P)=>{const E=(0,D.createHash)("md5");(0,F.$6d)(S,{onData:b=>E.update(b.buffer),onError:b=>P(b),onEnd:()=>d(E.digest("base64").replace(/=+$/,""))})})}};e.$z9b=A,e.$z9b=A=ye([Y(0,j.$_j)],A)}),define(ae[99],ce([0,1,15,7,160,11]),function(te,e,D,F,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;async function I(P,E,b,l,$,p){let w;try{await R(P,E,b,l,$,p)}catch(c){w=c}finally{w&&$.errorTransformer&&(w=$.errorTransformer(w)),typeof w<"u"&&b.error(w),b.end()}}e.$Np=I;async function R(P,E,b,l,$,p){S(p);const w=await P.open(E,{create:!1});try{S(p);let c=0,u=0,f=$&&typeof $.length=="number"?$.length:void 0,m=D.$be.alloc(Math.min($.bufferSize,typeof f=="number"?f:$.bufferSize)),k=$&&typeof $.position=="number"?$.position:0,s=0;do u=await P.read(w,k,m.buffer,s,m.byteLength-s),k+=u,s+=u,c+=u,typeof f=="number"&&(f-=u),s===m.byteLength&&(await b.write(l(m)),m=D.$be.alloc(Math.min($.bufferSize,typeof f=="number"?f:$.bufferSize)),s=0);while(u>0&&(typeof f!="number"||f>0)&&S(p)&&d(c,$));if(s>0){let a=s;typeof f=="number"&&(a=Math.min(s,f)),b.write(l(m.slice(0,a)))}}catch(c){throw(0,A.$nk)(c)}finally{await P.close(w)}}function S(P){if(P.isCancellationRequested)throw(0,F.$5)();return!0}function d(P,E){if(typeof E?.limits?.size=="number"&&P>E.limits.size)throw(0,A.$mk)((0,j.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[49],ce([0,1,91,2,16,5,10,11]),function(te,e,D,F,j,A,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=e.$Up=e.$Tp=e.$Sp=e.$Rp=e.$Qp=e.$Pp=void 0;function S(c){return c.recursive===!0}e.$Pp=S;class d extends F.$Rc{static{this.a=5}constructor(u,f,m,k){super(),this.h=u,this.j=f,this.m=m,this.n=k,this.c=this.B(new F.$Sc),this.f=void 0,this.g=0}s(){const u=new F.$Qc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(f=>this.h(f))),u.add(this.b.onDidLogMessage(f=>this.j(f))),u.add(this.b.onDidError(f=>this.t(f)))}t(u){this.n.restartOnError?this.g<d.a&&this.f?(this.w(`restarting watcher after error: ${u}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${u}`):this.w(u)}u(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}w(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}y(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Qp=d;class P extends d{constructor(u,f,m){super(u,f,m,{type:"node.js",restartOnError:!1})}}e.$Rp=P;class E extends d{constructor(u,f,m){super(u,f,m,{type:"universal",restartOnError:!0})}}e.$Sp=E;function b(c){return c.map(u=>({type:u.type,resource:I.URI.revive(u.resource),cId:u.cId}))}e.$Tp=b;function l(c){const u=new w;for(const f of c)u.processEvent(f);return u.coalesce()}e.$Up=l;function $(c,u){return typeof u=="string"&&!u.startsWith(D.$tj)&&!(0,j.$hc)(u)?{base:c,pattern:u}:u}e.$Vp=$;function p(c,u){const f=[];for(const m of u)f.push((0,D.$xj)($(c,m)));return f}e.$Wp=p;class w{constructor(){this.a=new Set,this.b=new Map}c(u){return A.$l?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const f=this.b.get(this.c(u));let m=!1;if(f){const k=f.type,s=u.type;f.resource.fsPath!==u.resource.fsPath&&(u.type===2||u.type===1)?m=!0:k===1&&s===2?(this.b.delete(this.c(u)),this.a.delete(f)):k===2&&s===1?f.type=0:k===1&&s===0||(f.type=s)}else m=!0;m&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],f=[];return Array.from(this.a).filter(m=>m.type!==2?(u.push(m),!1):!0).sort((m,k)=>m.resource.fsPath.length-k.resource.fsPath.length).filter(m=>f.some(k=>(0,R.$tk)(m.resource.fsPath,k,!A.$l))?!1:(f.push(m.resource.fsPath),!0)).concat(u)}}}),define(ae[189],ce([0,1,15,38,7,3,2,46,32,11,49]),function(te,e,D,F,j,A,I,R,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=e.$zN=void 0,e.$zN="localFilesystem";class E extends I.$Rc{constructor(l,$){super(),this.a=l,this.b=$,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$Nd),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$Nd),this.onDidWatchError=this.g.event,this.h=(0,S.$eg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(l){return this.a.call("stat",[l])}readdir(l){return this.a.call("readdir",[l])}async readFile(l,$){const{buffer:p}=await this.a.call("readFile",[l,$]);return p}readFileStream(l,$,p){const w=(0,R.$2d)(u=>D.$be.concat(u.map(f=>D.$be.wrap(f))).buffer),c=new I.$Qc;return c.add(this.a.listen("readFileStream",[l,$])(u=>{if(u instanceof D.$be)w.write(u.buffer);else{if(u==="end")w.end();else{let f;if(u instanceof Error)f=u;else{const m=u;f=(0,d.$mk)(m.message??(0,F.$Bi)(m),m.code??d.FileSystemProviderErrorCode.Unknown)}w.error(f),w.end()}c.dispose()}})),c.add(p.onCancellationRequested(()=>{w.error((0,j.$5)()),w.end(),c.dispose()})),w}writeFile(l,$,p){return this.a.call("writeFile",[l,D.$be.wrap($),p])}open(l,$){return this.a.call("open",[l,$])}close(l){return this.a.call("close",[l])}async read(l,$,p,w,c){const[u,f]=await this.a.call("read",[l,$,c]);return p.set(u.buffer.slice(0,f),w),f}write(l,$,p,w,c){return this.a.call("write",[l,$,D.$be.wrap(p),w,c])}mkdir(l){return this.a.call("mkdir",[l])}delete(l,$){return this.a.call("delete",[l,$])}rename(l,$,p){return this.a.call("rename",[l,$,p])}copy(l,$,p){return this.a.call("copy",[l,$,p])}cloneFile(l,$){return this.a.call("cloneFile",[l,$])}j(){this.B(this.a.listen("fileChange",[this.h])(l=>{if(Array.isArray(l)){const $=l;this.f.fire((0,P.$Tp)($))}else{const $=l;this.g.fire($)}}))}watch(l,$){const p=(0,S.$eg)();return this.a.call("watch",[this.h,p,l,$]),(0,I.$Pc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$AN=E}),define(ae[190],ce([0,1,53,6,26,48,2,88,16,5,19,10,143,31,49]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=void 0;class p extends I.$Rc{static{this.a=100}static{this.b=75}constructor(u,f,m,k){super(),this.m=u,this.n=f,this.r=m,this.s=k,this.c=this.B(new F.$0g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.n(s))),this.f=this.B(new F.$9g(s=>this.z(s),p.b)),this.g=(0,$.$Wp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,$.$Wp)(this.m.path,this.m.includes):void 0,this.j=new j.$Xd,this.ready=this.t()}async t(){try{const u=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const f=await l.Promises.stat(u);this.B(await this.w(u,f.isDirectory()))}catch(u){u.code!=="ENOENT"?this.D(u):this.G(u)}}async u(u){let f=u.path;try{f=await l.Promises.realpath(u.path),u.path===f&&(f=await(0,b.$7p)(u.path)??u.path),u.path!==f&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${f})`)}catch{}return f}async w(u,f){if(d.$k&&(0,A.$Xf)(u,"/Volumes/",!0))return this.D(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),I.$Rc.None;const m=new j.$Xd(this.j.token),k=new I.$Qc;try{const s=E.URI.file(this.m.path),a=(0,S.$mc)(u),n=(0,D.watch)(u);k.add((0,I.$Pc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${u}'`);const i=new Set;if(f)try{for(const r of await l.Promises.readdir(u))i.add(r)}catch(r){this.D(r)}const t=new Map;k.add((0,I.$Pc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,o)=>{this.D(`Failed to watch ${u} for changes using fs.watch() (${r}, ${o})`),this.dispose()}),n.on("change",(r,o)=>{if(m.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${o}`);let v="";if(o&&(v=o.toString(),d.$k&&(v=(0,R.$pl)(v))),!(!v||r!=="change"&&r!=="rename"))if(f)if(r==="rename"){t.get(v)?.dispose();const y=setTimeout(async()=>{if(t.delete(v),v===a&&!await l.Promises.exists(u)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const h=await this.C((0,S.$ic)(u,v));if(m.token.isCancellationRequested)return;let g;h?i.has(v)?g=0:(g=1,i.add(v)):(i.delete(v),g=2),this.y({resource:(0,P.$vg)(s,v),type:g,cId:this.m.correlationId})},p.a);t.set(v,(0,I.$Pc)(()=>clearTimeout(y)))}else{let y;i.has(v)?y=0:(y=1,i.add(v)),this.y({resource:(0,P.$vg)(s,v),type:y,cId:this.m.correlationId})}else if(r==="rename"||v!==a){const y=setTimeout(async()=>{const h=await l.Promises.exists(u);m.token.isCancellationRequested||(h?(this.y({resource:s,type:0,cId:this.m.correlationId},!0),k.add(await this.w(u,!1))):(this.y({resource:s,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},p.a);k.clear(),k.add((0,I.$Pc)(()=>clearTimeout(y)))}else this.y({resource:s,type:0,cId:this.m.correlationId},!0)})}catch(s){await l.Promises.exists(u)&&!m.token.isCancellationRequested&&this.D(`Failed to watch ${u} for changes using fs.watch() (${s.toString()})`)}return(0,I.$Pc)(()=>{m.dispose(!0),k.dispose()})}y(u,f=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!f&&this.g.some(m=>m(u.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${u.resource.fsPath}`):!f&&this.h&&this.h.length>0&&!this.h.some(m=>m(u.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${u.resource.fsPath}`):this.f.work(u))}z(u){const f=(0,$.$Up)(u);if(f.length>0){if(this.s)for(const k of f)this.G(` >> normalized ${k.type===1?"[ADDED]":k.type===2?"[DELETED]":"[CHANGED]"} ${k.resource.fsPath}`);this.c.work(f)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${f[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(u){if(d.$l)return l.Promises.exists(u);try{const f=(0,S.$mc)(u);return(await l.Promises.readdir((0,S.$lc)(u))).some(k=>k===f)}catch(f){return this.G(f),!1}}setVerboseLogging(u){this.s=u}D(u){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}F(u){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}G(u){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$0p=p;async function w(c,u,f,m,k=512){const s=await l.Promises.open(c,"r"),a=Buffer.allocUnsafe(k),n=new j.$Xd(m);let i,t=!1;const r={path:c,excludes:[],recursive:!1},o=new p(r,v=>{(async()=>{for(const{type:y}of v)if(y===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:h}=await l.Promises.read(s,a,0,k,null);if(!h||n.token.isCancellationRequested)break;u(a.slice(0,h))}}catch(h){i=new Error(h),n.dispose(!0)}finally{t=!1}}})()});return await o.ready,f(),new Promise((v,y)=>{n.token.onCancellationRequested(async()=>{o.dispose();try{await l.Promises.close(s)}catch(h){i=new Error(h)}i?y(i):v()})})}e.$$p=w}),define(ae[191],ce([0,1,3,91,2,5,190]),function(te,e,D,F,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=void 0;class R extends j.$Rc{constructor(){super(...arguments),this.a=this.B(new D.$Nd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Nd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(d){const P=this.j(d),E=P.filter(l=>{const $=this.c.get(l.path);return $?!(0,F.$Bj)($.request.excludes,l.excludes)||!(0,F.$Bj)($.request.includes,l.includes):!0}),b=Array.from(this.c.values()).filter(({request:l})=>!P.find($=>$.path===l.path&&(0,F.$Bj)($.excludes,l.excludes)&&(0,F.$Bj)($.includes,l.includes))).map(({request:l})=>l.path);E.length&&this.m(`Request to start watching: ${E.map(l=>`${l.path} (excludes: ${l.excludes.length>0?l.excludes:"<none>"}, includes: ${l.includes&&l.includes.length>0?JSON.stringify(l.includes):"<all>"}, correlationId: ${typeof l.correlationId=="number"?l.correlationId:"<none>"})`).join(",")}`),b.length&&this.m(`Request to stop watching: ${b.join(",")}`);for(const l of b)this.h(l);for(const l of E)this.g(l)}g(d){const P=new I.$0p(d,b=>this.a.fire(b),b=>this.b.fire(b),this.f),E={request:d,instance:P};this.c.set(d.path,E)}async stop(){for(const[d]of this.c)this.h(d);this.c.clear()}h(d){const P=this.c.get(d);P&&(this.c.delete(d),P.instance.dispose())}j(d){const P=new Map;for(const E of d){const b=A.$l?E.path:E.path.toLowerCase();let l=P.get(E.correlationId);l||(l=new Map,P.set(E.correlationId,l)),l.set(b,E)}return Array.from(P.values()).map(E=>Array.from(E.values())).flat()}async setVerboseLogging(d){this.f=d;for(const[,P]of this.c)P.instance.setVerboseLogging(d)}m(d){this.f&&this.b.fire({type:"trace",message:this.n(d)})}n(d,P){return P?`[File Watcher (node.js)] ${d} (path: ${P.request.path})`:`[File Watcher (node.js)] ${d}`}}e.$_p=R}),define(ae[192],ce([0,1,49,191]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0;class j extends D.$Rp{constructor(I,R,S){super(I,R,S),this.s()}r(I){return I.add(new F.$_p)}}e.$aq=j}),define(ae[193],ce([0,1,23,40,93,49]),function(te,e,D,F,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0;class I extends A.$Sp{constructor(S,d,P){super(S,d,P),this.s()}r(S){const d=S.add(new j.$4p(D.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(d.onDidProcessExit(({code:P,signal:E})=>this.t(`terminated by itself with code ${P}, signal: ${E}`))),F.ProxyChannel.toService((0,F.$xh)(d.getChannel("watcher")))}}e.$5p=I}),define(ae[72],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=void 0;class D{constructor(...j){this.a=new Map;for(const[A,I]of j)this.set(A,I)}set(j,A){const I=this.a.get(j);return this.a.set(j,A),I}has(j){return this.a.has(j)}get(j){return this.a.get(j)}}e.$Oh=D}),define(ae[194],ce([0,1,6,7,2,70,185,4,72,87]),function(te,e,D,F,j,A,I,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;const P=!1;class E extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class b{constructor(w=new S.$Oh,c=!1,u,f=P){this.f=w,this.g=c,this.h=u,this.i=f,this.o=new Set,this.f.set(R.$Ph,this),this._globalGraph=f?u?._globalGraph??new I.$dq(m=>m):void 0}createChild(w){return new b(w,this.g,this,this.i)}invokeFunction(w,...c){const u=$.traceInvocation(this.i,w);let f=!1;try{return w({get:k=>{if(f)throw(0,F.$7)("service accessor is only valid during the invocation of its target method");const s=this.m(k,u);if(!s)throw new Error(`[invokeFunction] unknown service '${k}'`);return s}},...c)}finally{f=!0,u.stop()}}createInstance(w,...c){let u,f;return w instanceof A.$Nh?(u=$.traceCreation(this.i,w.ctor),f=this.j(w.ctor,w.staticArguments.concat(c),u)):(u=$.traceCreation(this.i,w),f=this.j(w,c,u)),u.stop(),f}j(w,c=[],u){const f=R._util.getServiceDependencies(w).sort((s,a)=>s.index-a.index),m=[];for(const s of f){const a=this.m(s.id,u);a||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${s.id}.`,!1),m.push(a)}const k=f.length>0?f[0].index:c.length;if(c.length!==k){console.trace(`[createInstance] First service dependency of ${w.name} at position ${k+1} conflicts with ${c.length} static arguments`);const s=k-c.length;s>0?c=c.concat(new Array(s)):c=c.slice(0,k)}return Reflect.construct(w,c.concat(m))}k(w,c){if(this.f.get(w)instanceof A.$Nh)this.f.set(w,c);else if(this.h)this.h.k(w,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const c=this.f.get(w);return!c&&this.h?this.h.l(w):c}m(w,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const u=this.l(w);return u instanceof A.$Nh?this.q(w,u,c.branch(w,!0)):(c.branch(w,!1),u)}q(w,c,u){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,c,u)}finally{this.o.delete(w)}}r(w,c,u){const f=new I.$dq(s=>s.id.toString());let m=0;const k=[{id:w,desc:c,_trace:u}];for(;k.length;){const s=k.pop();if(f.lookupOrInsertNode(s),m++>1e3)throw new E(f);for(const a of R._util.getServiceDependencies(s.desc.ctor)){const n=this.l(a.id);if(n||this.u(`[createInstance] ${w} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(a.id)),n instanceof A.$Nh){const i={id:a.id,desc:n,_trace:s._trace.branch(a.id,!0)};f.insertEdge(s,i),k.push(i)}}}for(;;){const s=f.roots();if(s.length===0){if(!f.isEmpty())throw new E(f);break}for(const{data:a}of s){if(this.l(a.id)instanceof A.$Nh){const i=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,i)}f.removeNode(a)}}return this.l(w)}s(w,c,u=[],f,m){if(this.f.get(w)instanceof A.$Nh)return this.t(w,c,u,f,m);if(this.h)return this.h.s(w,c,u,f,m);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(w,c,u=[],f,m){if(f){const k=new b(void 0,this.g,this,this.i);k.c=String(w);const s=new Map,a=new D.$_g(()=>{const n=k.j(c,u,m);for(const[i,t]of s){const r=n[i];if(typeof r=="function")for(const o of t)r.apply(n,o)}return s.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!a.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let o=s.get(i);return o||(o=new d.$1c,s.set(i,o)),(y,h,g)=>{const O=o.push([y,h,g]);return(0,j.$Pc)(O)}}if(i in n)return n[i];const t=a.value;let r=t[i];return typeof r!="function"||(r=r.bind(t),n[i]=r),r},set(n,i,t){return a.value[i]=t,!0},getPrototypeOf(n){return c.prototype}})}else return this.j(c,u,m)}u(w,c){if(c&&console.warn(w),this.g)throw new Error(w)}}e.$eq=b;var l;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(l||(l={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,c){return w?new $(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(w,c){return w?new $(1,c.name):$.c}static{this.f=0}constructor(w,c){this.type=w,this.name=c,this.g=Date.now(),this.h=[]}branch(w,c){const u=new $(3,w.toString());return this.h.push([w,c,u]),u}stop(){const w=Date.now()-this.g;$.f+=w;let c=!1;function u(m,k){const s=[],a=new Array(m+1).join("	");for(const[n,i,t]of k.h)if(i&&t){c=!0,s.push(`${a}CREATES -> ${n}`);const r=u(m+1,t);r&&s.push(r)}else s.push(`${a}uses -> ${n}`);return s.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(w>2||c)&&$.all.add(f.join(`
`))}}e.$fq=$}),define(ae[55],ce([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$08b=e.$98b=void 0,e.$98b=(0,D.$Qh)("mainProcessService");class F{constructor(A,I){this.a=A,this.b=I}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,I){this.a.registerChannel(A,I)}}e.$08b=F}),define(ae[73],ce([0,1,26,2,5,162,29,4]),function(te,e,D,F,j,A,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=e.$Sq=void 0;function S(P){return P.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$Sq=S,e.$Tq=(0,R.$Qh)("languagePackService");let d=class extends F.$Rc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new D.$Xd;setTimeout(()=>E.cancel(),1e3);let b;try{b=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const $=b.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(w=>w.startsWith("lp-"))).map(p=>{const w=p.properties.localizedLanguages?.[0],c=S(p);return{...this.f(c,w,p),extensionId:p.identifier.id,galleryExtension:p}});return $.push(this.f("en","English")),$}f(E,b,l){const $=b??E;let p;if($!==E&&(p=`(${E})`),E.toLowerCase()===j.$w.toLowerCase()&&(p??="",p+=(0,A.localize)(0,null)),l?.installCount){p??="";const w=l.installCount;let c;w>1e6?c=`${Math.floor(w/1e5)/10}M`:w>1e3?c=`${Math.floor(w/1e3)}K`:c=String(w),p+=` $(cloud-download) ${c}`}return{id:E,label:$,description:p}}};e.$Uq=d,e.$Uq=d=ye([Y(0,I.$$n)],d)}),define(ae[195],ce([0,1,2,73]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v9b=void 0;let j=class extends D.$Rc{constructor(I){super(),this.a=I,this.b()}b(){this.a.update()}};e.$v9b=j,e.$v9b=j=ye([Y(0,F.$Tq)],j)}),define(ae[8],ce([0,1,38,3,52,2,34,5,19,12,10,94,4]),function(te,e,D,F,j,A,I,R,S,d,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.log=e.$bj=e.LogLevel=e.$aj=e.$_i=e.$$i=void 0,e.$$i=(0,b.$Qh)("logService"),e.$_i=(0,b.$Qh)("loggerService");function l(){return new Date().toISOString()}function $(y){return(0,d.$Cf)(y)}e.$aj=$;var p;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$bj=p.Info;function w(y,h,g){switch(h){case p.Trace:y.trace(g);break;case p.Debug:y.debug(g);break;case p.Info:y.info(g);break;case p.Warning:y.warn(g);break;case p.Error:y.error(g);break;case p.Off:break;default:throw new Error(`Invalid log level ${h}`)}}e.log=w;function c(y,h=!1){let g="";for(let O=0;O<y.length;O++){let T=y[O];if(T instanceof Error&&(T=(0,D.$Bi)(T,h)),typeof T=="object")try{T=JSON.stringify(T)}catch{}g+=(O>0?" ":"")+T}return g}class u extends A.$Rc{constructor(){super(...arguments),this.b=e.$bj,this.c=this.B(new F.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(h){this.b!==h&&(this.b=h,this.c.fire(this.b))}getLevel(){return this.b}f(h){return this.b!==p.Off&&this.b<=h}}e.$dj=u;class f extends u{constructor(h){super(),this.h=h}f(h){return this.h||super.f(h)}trace(h,...g){this.f(p.Trace)&&this.g(p.Trace,c([h,...g],!0))}debug(h,...g){this.f(p.Debug)&&this.g(p.Debug,c([h,...g]))}info(h,...g){this.f(p.Info)&&this.g(p.Info,c([h,...g]))}warn(h,...g){this.f(p.Warning)&&this.g(p.Warning,c([h,...g]))}error(h,...g){if(this.f(p.Error))if(h instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=h.stack,this.g(p.Error,c(O))}else this.g(p.Error,c([h,...g]))}flush(){}}e.$ej=f;class m extends u{constructor(h=e.$bj){super(),this.setLevel(h),this.g=!R.$j}trace(h,...g){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,h,...g):console.log(`[main ${l()}]`,h,...g))}debug(h,...g){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,h,...g):console.log(`[main ${l()}]`,h,...g))}info(h,...g){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,h,...g):console.log(`[main ${l()}]`,h,...g))}warn(h,...g){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,h,...g):console.warn(`[main ${l()}]`,h,...g))}error(h,...g){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,h,...g):console.error(`[main ${l()}]`,h,...g))}dispose(){}flush(){}}e.$fj=m;class k extends u{constructor(h=e.$bj,g=!0){super(),this.g=g,this.setLevel(h)}trace(h,...g){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",h,...g):console.log(h,...g))}debug(h,...g){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",h,...g):console.log(h,...g))}info(h,...g){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",h,...g):console.log(h,...g))}warn(h,...g){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",h,...g):console.log(h,...g))}error(h,...g){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",h,...g):console.error(h,...g))}dispose(){}flush(){}}e.$gj=k;class s extends u{constructor(h,g=e.$bj){super(),this.g=h,this.setLevel(g)}trace(h,...g){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(h),...g])}debug(h,...g){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(h),...g])}info(h,...g){this.f(p.Info)&&this.g.log(p.Info,[this.h(h),...g])}warn(h,...g){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(h),...g])}error(h,...g){this.f(p.Error)&&this.g.log(p.Error,[this.h(h),...g])}h(h){return typeof h=="string"?h:(0,D.$Bi)(h,this.f(p.Trace))}dispose(){}flush(){}}e.$hj=s;class a extends u{constructor(h){super(),this.g=h,h.length&&this.setLevel(h[0].getLevel())}setLevel(h){for(const g of this.g)g.setLevel(h);super.setLevel(h)}trace(h,...g){for(const O of this.g)O.trace(h,...g)}debug(h,...g){for(const O of this.g)O.debug(h,...g)}info(h,...g){for(const O of this.g)O.info(h,...g)}warn(h,...g){for(const O of this.g)O.warn(h,...g)}error(h,...g){for(const O of this.g)O.error(h,...g)}flush(){for(const h of this.g)h.flush()}dispose(){for(const h of this.g)h.dispose()}}e.$ij=a;class n extends A.$Rc{constructor(h,g,O){if(super(),this.h=h,this.j=g,this.b=new I.$zc,this.c=this.B(new F.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$Nd),this.onDidChangeVisibility=this.g.event,O)for(const T of O)this.b.set(T.resource,{logger:void 0,info:T})}m(h){return(0,d.$yf)(h)?[...this.b.values()].find(g=>g.info.id===h):this.b.get(h)}getLogger(h){return this.m(h)?.logger}createLogger(h,g){const O=this.n(h),T=(0,d.$yf)(h)?h:g?.id??(0,j.$Ei)(O.toString()).toString(16);let M=this.b.get(O)?.logger;const U=g?.logLevel==="always"?p.Trace:g?.logLevel;M||(M=this.s(O,U??this.getLogLevel(O)??this.h,{...g,id:T}));const z={logger:M,info:{resource:O,id:T,logLevel:U,name:g?.name,hidden:g?.hidden,extensionId:g?.extensionId,when:g?.when}};return this.registerLogger(z.info),this.b.set(O,z),M}n(h){return(0,d.$yf)(h)?(0,S.$vg)(this.j,`${h}.log`):h}setLogLevel(h,g){if(P.URI.isUri(h)){const O=h,T=g,M=this.b.get(O);M&&T!==M.info.logLevel&&(M.info.logLevel=T===this.h?void 0:T,M.logger?.setLevel(T),this.b.set(M.info.resource,M),this.f.fire([O,T]))}else{this.h=h;for(const[O,T]of this.b.entries())this.b.get(O)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(h,g){const O=this.m(h);O&&g!==!O.info.hidden&&(O.info.hidden=!g,this.b.set(O.info.resource,O),this.g.fire([O.info.resource,g]))}getLogLevel(h){let g;return h&&(g=this.b.get(h)?.info.logLevel),g??this.h}registerLogger(h){const g=this.b.get(h.resource);g?g.info.hidden!==h.hidden&&this.setVisibility(h.resource,!h.hidden):(this.b.set(h.resource,{info:h,logger:void 0}),this.c.fire({added:[h],removed:[]}))}deregisterLogger(h){const g=this.b.get(h);g&&(g.logger&&g.logger.dispose(),this.b.delete(h),this.c.fire({added:[],removed:[g.info]}))}*getRegisteredLoggers(){for(const h of this.b.values())yield h.info}getRegisteredLogger(h){return this.b.get(h)?.info}dispose(){this.b.forEach(h=>h.logger?.dispose()),this.b.clear(),super.dispose()}}e.$jj=n;class i{constructor(){this.onDidChangeLogLevel=new F.$Nd().event}setLevel(h){}getLevel(){return p.Info}trace(h,...g){}debug(h,...g){}info(h,...g){}warn(h,...g){}error(h,...g){}critical(h,...g){}dispose(){}flush(){}}e.$kj=i;class t extends i{}e.$lj=t;function r(y){if(y.verbose)return p.Trace;if(typeof y.logLevel=="string"){const h=v(y.logLevel.toLowerCase());if(h!==void 0)return h}return e.$bj}e.$mj=r;function o(y){switch(y){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$nj=o;function v(y){switch(y){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$oj=v,e.$pj=new E.$8i("logLevel",o(p.Info))}),define(ae[196],ce([0,1,6,7,2,23,16,19,31,14,8]),function(te,e,D,F,j,A,I,R,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w9b=void 0;let E=class extends j.$Rc{constructor(l,$){super(),this.a=l,this.b=$,this.B(new D.$7g(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const l=(0,R.$sg)(this.a.logsHome),$=(0,R.$ug)(this.a.logsHome.with({scheme:A.Schemas.file})).fsPath,c=(await S.Promises.readdir($)).filter(f=>/^\d{8}T\d{6}$/.test(f)).sort().filter(f=>f!==l),u=c.slice(0,Math.max(0,c.length-9));u.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${u.join(", ")}'`),await Promise.all(u.map(f=>S.Promises.rm((0,I.$ic)($,f)))))}catch(l){(0,F.$Z)(l)}}};e.$w9b=E,e.$w9b=E=ye([Y(0,d.$Xh),Y(1,P.$$i)],E)}),define(ae[197],ce([0,1,18,6,7,3,2,16,49,8]),function(te,e,D,F,j,A,I,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;class P extends I.$Rc{constructor(b,l){super(),this.a=b,this.b=l,this.c=this.B(new A.$Nd),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$Nd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new F.$Rg(0)),this.w=[],this.y=this.B(new F.$Rg(0))}watch(b,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(b,l):this.z(b,l)}n(b,l){const $={path:this.H(b),excludes:l.excludes,includes:l.includes,recursive:l.recursive,correlationId:l.correlationId},p=(0,D.$Tb)(this.j,$);return this.r(),(0,I.$Pc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,j.$Z)(b))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,S.$Tp)(l)),l=>this.G(l),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const l of this.j)(0,S.$Pp)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const l of this.j)(0,S.$Pp)(l)&&b.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,l){const $={path:this.H(b),excludes:l.excludes,includes:l.includes,recursive:!1,correlationId:l.correlationId},p=(0,D.$Tb)(this.w,$);return this.C(),(0,I.$Pc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,j.$Z)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,S.$Tp)(b)),b=>this.G(b),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}H(b){return(0,R.$gc)(b.fsPath)}}e.$Xp=P}),define(ae[198],ce([0,1,18,6,15,26,3,52,60,2,47,23,100,19,46,158,11,99,8,7]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w,c,u,f){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0;let k=class extends d.$Rc{static{m=this}constructor(a){super(),this.b=a,this.a=256*1024,this.c=this.B(new I.$Nd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new I.$Nd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new I.$Nd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new I.$Nd),this.onDidRunOperation=this.r.event,this.X=this.B(new I.$Nd),this.Y=this.B(new I.$Nd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new I.$Nd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new F.$4g)}registerProvider(a,n){if(this.h.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${a}`);const i=new d.$Qc;return this.h.set(a,n),this.c.fire({added:!0,scheme:a,provider:n}),i.add(n.onDidChangeFile(t=>{const r=new w.$sk(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&i.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),i.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:a}))),(0,d.$Pc)(()=>{this.c.fire({added:!1,scheme:a,provider:n}),this.h.delete(a),(0,d.$Mc)(i)})}getProvider(a){return this.h.get(a)}async activateProvider(a){const n=[];this.f.fire({scheme:a,join(i){n.push(i)}}),!this.h.has(a)&&await F.Promises.settled(n)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.h.has(a.scheme)}hasCapability(a,n){const i=this.h.get(a.scheme);return!!(i&&i.capabilities&n)}listCapabilities(){return S.Iterable.map(this.h,([a,n])=>({scheme:a,capabilities:n.capabilities}))}async j(a){if(!(0,l.$zg)(a))throw new w.$uk((0,p.localize)(0,null,this.sb(a)),8);await this.activateProvider(a.scheme);const n=this.h.get(a.scheme);if(!n){const i=new f.$ab;throw i.message=(0,p.localize)(1,null,a.toString()),i}return n}async m(a){const n=await this.j(a);if((0,w.$fk)(n)||(0,w.$ck)(n)||(0,w.$gk)(n))return n;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(a){const n=await this.j(a);if((0,w.$fk)(n)||(0,w.$ck)(n))return n;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,n){try{return await this.s(a,n)}catch(i){throw(0,w.$pk)(i)===w.FileSystemProviderErrorCode.FileNotFound?new w.$uk((0,p.localize)(2,null,this.sb(a)),1):(0,w.$nk)(i)}}async s(a,n){const i=await this.j(a),t=this.S(i),r=n?.resolveTo,o=n?.resolveSingleChildDescendants,v=n?.resolveMetadata,y=await i.stat(a);let h;return this.t(i,a,y,void 0,!!v,(g,O)=>(h||(h=P.$Wh.forUris(()=>!t),h.set(a,!0),r&&h.fill(!0,r)),h.get(g.resource)||h.findSuperstr(g.resource.with({query:null,fragment:null}))?!0:g.isDirectory&&o?O===1:!1))}async t(a,n,i,t,r,o){const{providerExtUri:v}=this.R(a),y={resource:n,name:v.basename(n),isFile:(i.type&w.FileType.File)!==0,isDirectory:(i.type&w.FileType.Directory)!==0,isSymbolicLink:(i.type&w.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&w.FilePermission.Readonly)||!!(a.capabilities&2048),locked:!!((i.permissions??0)&w.FilePermission.Locked),etag:(0,w.$Fk)({mtime:i.mtime,size:i.size}),children:void 0};if(y.isDirectory&&o(y,t)){try{const h=await a.readdir(n),g=await F.Promises.settled(h.map(async([O,T])=>{try{const M=v.joinPath(n,O),U=r?await a.stat(M):{type:T};return await this.t(a,M,U,h.length,r,o)}catch(M){return this.b.trace(M),null}}));y.children=(0,D.$Gb)(g)}catch(h){this.b.trace(h),y.children=[]}return y}return y}async resolveAll(a){return F.Promises.settled(a.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(a){const n=await this.j(a),i=await n.stat(a);return this.t(n,a,i,void 0,!0,()=>!1)}async exists(a){const n=await this.j(a);try{return!!await n.stat(a)}catch{return!1}}async canCreateFile(a,n){try{await this.u(a,n)}catch(i){return i}return!0}async u(a,n){if(!n?.overwrite&&await this.exists(a))throw new w.$uk((0,p.localize)(3,null,this.sb(a)),3,n)}async createFile(a,n=j.$be.fromString(""),i){await this.u(a,i);const t=await this.writeFile(a,n);return this.r.fire(new w.$rk(a,0,t)),t}async writeFile(a,n,i){const t=this.qb(await this.n(a),a),{providerExtUri:r}=this.R(t);let o=i;if((0,w.$ik)(t)&&!o?.atomic){const v=t.enforceAtomicWriteFile?.(a);v&&(o={...i,atomic:v})}try{await this.w(t,a,o)||await this.U(t,r.dirname(a));let y;if((0,w.$ck)(t)&&!(n instanceof j.$be))if((0,$.$Zd)(n)){const h=await(0,$.$7d)(n,3);h.ended?y=j.$be.concat(h.buffer):y=h}else y=(0,$.$4d)(n,h=>j.$be.concat(h),3);else y=n;!(0,w.$fk)(t)||(0,w.$ck)(t)&&y instanceof j.$be||(0,w.$ck)(t)&&(0,w.$ik)(t)&&o?.atomic?await this.hb(t,a,o,y):await this.db(t,a,o,y instanceof j.$be?(0,j.$me)(y):y),this.r.fire(new w.$rk(a,4))}catch(v){throw new w.$uk((0,p.localize)(4,null,this.sb(a),(0,w.$nk)(v).toString()),(0,w.$qk)(v),o)}return this.resolve(a,{resolveMetadata:!0})}async w(a,n,i){const t=!!i?.unlock;if(t&&!(a.capabilities&8192))throw new Error((0,p.localize)(5,null,this.sb(n)));if(!!i?.atomic){if(!(a.capabilities&32768))throw new Error((0,p.localize)(6,null,this.sb(n)));if(!(a.capabilities&2))throw new Error((0,p.localize)(7,null,this.sb(n)));if(t)throw new Error((0,p.localize)(8,null,this.sb(n)))}let o;try{o=await a.stat(n)}catch{return}if(o.type&w.FileType.Directory)throw new w.$uk((0,p.localize)(9,null,this.sb(n)),0,i);if(this.rb(n,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==w.$Ek&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,w.$Fk)({mtime:i.mtime,size:o.size}))throw new w.$uk((0,p.localize)(10,null),3,i);return o}async readFile(a,n,i){const t=await this.m(a);return n?.atomic?this.z(t,a,n,i):this.C(t,a,n,i)}async z(a,n,i,t){return new Promise((r,o)=>{this.cb.queueFor(n,this.R(a).providerExtUri).queue(async()=>{try{const v=await this.C(a,n,i,t);r(v)}catch(v){o(v)}})})}async C(a,n,i,t){const r=await this.D(a,n,{...i,preferUnbuffered:!0},t);return{...r,value:await(0,j.$ne)(r.value)}}async readFileStream(a,n,i){const t=await this.m(a);return this.D(t,a,n,i)}async D(a,n,i,t){const r=new A.$Xd(t);let o=i;(0,w.$hk)(a)&&a.enforceAtomicReadFile?.(n)&&(o={...i,atomic:!0});const v=this.J(n,o).then(h=>h,h=>{throw r.dispose(!0),h});let y;try{return typeof o?.etag=="string"&&o.etag!==w.$Ek&&await v,o?.atomic&&(0,w.$hk)(a)||!((0,w.$fk)(a)||(0,w.$gk)(a))||(0,w.$ck)(a)&&o?.preferUnbuffered?y=this.I(a,n,o):(0,w.$gk)(a)?y=this.G(a,n,r.token,o):y=this.H(a,n,r.token,o),y.on("end",()=>r.dispose()),y.on("error",()=>r.dispose()),{...await v,value:y}}catch(h){throw y&&await(0,$.$5d)(y),this.F(h,n,o)}}F(a,n,i){const t=(0,p.localize)(11,null,this.sb(n),(0,w.$nk)(a).toString());return a instanceof w.$wk?new w.$wk(t,a.stat,i):a instanceof w.$vk?new w.$vk(t,a.fileOperationResult,a.size,a.options):new w.$uk(t,(0,w.$qk)(a),i)}G(a,n,i,t=Object.create(null)){const r=a.readFileStream(n,t,i);return(0,$.$$d)(r,{data:o=>o instanceof j.$be?o:j.$be.wrap(o),error:o=>this.F(o,n,t)},o=>j.$be.concat(o))}H(a,n,i,t=Object.create(null)){const r=(0,j.$re)();return(0,c.$Np)(a,n,r,o=>o,{...t,bufferSize:this.a,errorTransformer:o=>this.F(o,n,t)},i),r}I(a,n,i){const t=(0,$.$2d)(r=>j.$be.concat(r));return(async()=>{try{let r;i?.atomic&&(0,w.$hk)(a)?r=await a.readFile(n,{atomic:!0}):r=await a.readFile(n),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(n,r.byteLength,i),t.end(j.$be.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(a,n){const i=await this.resolve(a,{resolveMetadata:!0});if(i.isDirectory)throw new w.$uk((0,p.localize)(12,null,this.sb(a)),0,n);if(typeof n?.etag=="string"&&n.etag!==w.$Ek&&n.etag===i.etag)throw new w.$wk((0,p.localize)(13,null),i,n);return this.L(a,i.size,n),i}L(a,n,i){if(typeof i?.limits?.size=="number"&&n>i.limits.size)throw new w.$vk((0,p.localize)(14,null,this.sb(a)),7,n,i)}async canMove(a,n,i){return this.M(a,n,"move",i)}async canCopy(a,n,i){return this.M(a,n,"copy",i)}async M(a,n,i,t){if(a.toString()!==n.toString())try{const r=i==="move"?this.qb(await this.n(a),a):await this.m(a),o=this.qb(await this.n(n),n);await this.Q(r,a,o,n,i,t)}catch(r){return r}return!0}async move(a,n,i){const t=this.qb(await this.n(a),a),r=this.qb(await this.n(n),n),o=await this.N(t,a,r,n,"move",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new w.$rk(a,o==="move"?2:3,v)),v}async copy(a,n,i){const t=await this.m(a),r=this.qb(await this.n(n),n),o=await this.N(t,a,r,n,"copy",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new w.$rk(a,o==="copy"?3:2,v)),v}async N(a,n,i,t,r,o){if(n.toString()===t.toString())return r;const{exists:v,isSameResourceWithDifferentPathCase:y}=await this.Q(a,n,i,t,r,o);if(v&&!y&&o&&await this.del(t,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(t)),r==="copy"){if(a===i&&(0,w.$dk)(a))await a.copy(n,t,{overwrite:o});else{const h=await this.resolve(n);h.isDirectory?await this.P(a,h,i,t):await this.O(a,n,i,t)}return r}else return a===i?(await a.rename(n,t,{overwrite:o}),r):(await this.N(a,n,i,t,"copy",o),await this.del(n,{recursive:!0}),"copy")}async O(a,n,i,t){if((0,w.$fk)(a)&&(0,w.$fk)(i))return this.jb(a,n,i,t);if((0,w.$fk)(a)&&(0,w.$ck)(i))return this.pb(a,n,i,t);if((0,w.$ck)(a)&&(0,w.$fk)(i))return this.nb(a,n,i,t);if((0,w.$ck)(a)&&(0,w.$ck)(i))return this.lb(a,n,i,t)}async P(a,n,i,t){await i.mkdir(t),Array.isArray(n.children)&&await F.Promises.settled(n.children.map(async r=>{const o=this.R(i).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(a,await this.resolve(r.resource),i,o):this.O(a,r.resource,i,o)}))}async Q(a,n,i,t,r,o){let v=!1;if(a===i){const{providerExtUri:h,isPathCaseSensitive:g}=this.R(a);if(g||(v=h.isEqual(n,t)),v&&r==="copy")throw new Error((0,p.localize)(15,null,this.sb(n),this.sb(t)));if(!v&&h.isEqualOrParent(t,n))throw new Error((0,p.localize)(16,null,this.sb(n),this.sb(t)))}const y=await this.exists(t);if(y&&!v){if(!o)throw new w.$uk((0,p.localize)(17,null,this.sb(n),this.sb(t)),4);if(a===i){const{providerExtUri:h}=this.R(a);if(h.isEqualOrParent(n,t))throw new Error((0,p.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:y,isSameResourceWithDifferentPathCase:v}}R(a){const n=this.S(a);return{providerExtUri:n?l.$lg:l.$ng,isPathCaseSensitive:n}}S(a){return!!(a.capabilities&1024)}async createFolder(a){const n=this.qb(await this.j(a),a);await this.U(n,a);const i=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new w.$rk(a,0,i)),i}async U(a,n){const i=[],{providerExtUri:t}=this.R(a);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await a.stat(n)).type&w.FileType.Directory))throw new Error((0,p.localize)(19,null,this.sb(n)));break}catch(r){if((0,w.$pk)(r)!==w.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(t.basename(n)),n=t.dirname(n)}for(let r=i.length-1;r>=0;r--){n=t.joinPath(n,i[r]);try{await a.mkdir(n)}catch(o){if((0,w.$pk)(o)!==w.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(a,n){try{await this.W(a,n)}catch(i){return i}return!0}async W(a,n){const i=this.qb(await this.j(a),a),t=!!n?.useTrash;if(t&&!(i.capabilities&4096))throw new Error((0,p.localize)(20,null,this.sb(a)));const r=n?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,p.localize)(21,null,this.sb(a)));if(t&&r)throw new Error((0,p.localize)(22,null,this.sb(a)));let o;try{o=await i.stat(a)}catch{}if(o)this.rb(a,o);else throw new w.$uk((0,p.localize)(23,null,this.sb(a)),1);if(!!!n?.recursive){const y=await this.resolve(a);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,p.localize)(24,null,this.sb(a)))}return i}async del(a,n){const i=await this.W(a,n);let t=n;if((0,w.$jk)(i)&&!t?.atomic){const y=i.enforceAtomicDelete?.(a);y&&(t={...n,atomic:y})}const r=!!t?.useTrash,o=!!t?.recursive,v=t?.atomic??!1;await i.delete(a,{recursive:o,useTrash:r,atomic:v}),this.r.fire(new w.$rk(a,1))}async cloneFile(a,n){const i=await this.j(a),t=this.qb(await this.n(n),n);if(i===t&&this.R(i).providerExtUri.isEqual(a,n))return;if(i===t&&(0,w.$ek)(i))return i.cloneFile(a,n);await this.U(t,this.R(t).providerExtUri.dirname(n));const r=this.cb.queueFor(a,this.R(i).providerExtUri);return i===t&&(0,w.$dk)(i)?r.queue(()=>i.copy(a,n,{overwrite:!0})):r.queue(()=>this.O(i,a,t,n))}static{this.ab=0}createWatcher(a,n){return this.watch(a,{...n,correlationId:m.ab++})}watch(a,n={recursive:!1,excludes:[]}){const i=new d.$Qc;let t=!1,r=()=>{t=!0};i.add((0,d.$Pc)(()=>r())),(async()=>{try{const v=await this.bb(a,n);t?(0,d.$Mc)(v):r=()=>(0,d.$Mc)(v)}catch(v){this.b.error(v)}})();const o=n.correlationId;if(typeof o=="number"){const v=i.add(new I.$Nd);return i.add(this.X.event(h=>{h.correlates(o)&&v.fire(h)})),{onDidChange:v.event,dispose:()=>i.dispose()}}return i}async bb(a,n){const i=await this.j(a),t=(0,R.$Ei)([this.R(i).providerExtUri.getComparisonKey(a),n]);let r=this.$.get(t);return r||(r={count:0,disposable:i.watch(a,n)},this.$.set(t,r)),r.count+=1,(0,d.$Pc)(()=>{r&&(r.count--,r.count===0&&((0,d.$Mc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,a]of this.$)(0,d.$Mc)(a.disposable);this.$.clear()}async db(a,n,i,t){return this.cb.queueFor(n,this.R(a).providerExtUri).queue(async()=>{const r=await a.open(n,{create:!0,unlock:i?.unlock??!1});try{(0,$.$Zd)(t)||(0,$.$1d)(t)?await this.eb(a,r,t):await this.fb(a,r,t)}catch(o){throw(0,w.$nk)(o)}finally{await a.close(r)}})}async eb(a,n,i){let t=0,r;if((0,$.$1d)(i)){if(i.buffer.length>0){const o=j.$be.concat(i.buffer);await this.gb(a,n,o,o.byteLength,t,0),t+=o.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((o,v)=>{(0,$.$6d)(r,{onData:async y=>{r.pause();try{await this.gb(a,n,y,y.byteLength,t,0)}catch(h){return v(h)}t+=y.byteLength,setTimeout(()=>r.resume())},onError:y=>v(y),onEnd:()=>o()})})}async fb(a,n,i){let t=0,r;for(;(r=i.read())!==null;)await this.gb(a,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(a,n,i,t,r,o){let v=0;for(;v<t;){const y=await a.write(n,r+v,i.buffer,o+v,t-v);v+=y}}async hb(a,n,i,t){return this.cb.queueFor(n,this.R(a).providerExtUri).queue(()=>this.ib(a,n,i,t))}async ib(a,n,i,t){let r;t instanceof j.$be?r=t:(0,$.$Zd)(t)?r=await(0,j.$ne)(t):(0,$.$1d)(t)?r=await(0,j.$oe)(t):r=(0,j.$le)(t),await a.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.kb(a,n,i,t))}async kb(a,n,i,t){let r,o;try{r=await a.open(n,{create:!1}),o=await i.open(t,{create:!0,unlock:!1});const v=j.$be.alloc(this.a);let y=0,h=0,g=0;do g=await a.read(r,y,v.buffer,h,v.byteLength-h),await this.gb(i,o,v,g,y,h),y+=g,h+=g,h===v.byteLength&&(h=0);while(g>0)}catch(v){throw(0,w.$nk)(v)}finally{await F.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async lb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.mb(a,n,i,t))}async mb(a,n,i,t){return i.writeFile(t,await a.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.ob(a,n,i,t))}async ob(a,n,i,t){const r=await i.open(t,{create:!0,unlock:!1});try{const o=await a.readFile(n);await this.gb(i,r,j.$be.wrap(o),o.byteLength,0,0)}catch(o){throw(0,w.$nk)(o)}finally{await i.close(r)}}async pb(a,n,i,t){const r=await(0,j.$ne)(this.H(a,n,A.CancellationToken.None));await this.hb(i,t,void 0,r)}qb(a,n){if(a.capabilities&2048)throw new w.$uk((0,p.localize)(25,null,this.sb(n)),6);return a}rb(a,n){if((n.permissions??0)&w.FilePermission.Readonly)throw new w.$uk((0,p.localize)(26,null,this.sb(a)),6)}sb(a){return a.scheme===E.Schemas.file?a.fsPath:a.toString(!0)}};e.$Op=k,e.$Op=k=m=ye([Y(0,u.$$i)],k)}),define(ae[199],ce([0,1,53,270,6,34,15,3,48,2,16,5,19,46,31,161,11,99,197,38,193,192]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w,c,u,f,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0,(()=>{try{(0,F.gracefulify)(D)}catch(a){console.error(`Error enabling graceful-fs: ${(0,f.$Bi)(a)}`)}})();class s extends u.$Xp{static{this.I=!1}constructor(n,i){super(n,i),this.onDidChangeCapabilities=R.Event.None,this.N=new A.$zc(t=>b.$mg.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,E.$l&&(this.J|=1024)),this.J}async stat(n){try{const{stat:i,symbolicLink:t}=await $.SymlinkSupport.stat(this.H(n));return{type:this.M(i,t),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:w.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const i=await $.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(i.map(async r=>{try{let o;r.isSymbolicLink()?o=(await this.stat((0,b.$vg)(n,r.name))).type:o=this.M(r),t.push([r.name,o])}catch(o){this.a.trace(o)}})),t}catch(i){throw this.fb(i)}}M(n,i){let t;return i?.dangling?t=w.FileType.Unknown:n.isFile()?t=w.FileType.File:n.isDirectory()?t=w.FileType.Directory:t=w.FileType.Unknown,i&&(t|=w.FileType.SymbolicLink),t}async O(n){const i=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await t.wait();const r=new j.$Sg;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,d.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(n,i){let t;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await $.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){s.I&&this.a.trace(n)}readFileStream(n,i,t){const r=(0,l.$2d)(o=>I.$be.concat(o.map(v=>I.$be.wrap(v))).buffer);return(0,c.$Np)(this,n,r,o=>o.buffer,{...i,bufferSize:256*1024},t),r}async writeFile(n,i,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,b.$vg)((0,b.$ug)(n),`${(0,b.$sg)(n)}${t.atomic.postfix}`),i,t):this.S(n,i,t)}async Q(n){try{const i=this.H(n),{symbolicLink:t}=await $.SymlinkSupport.stat(i);if(t)return!1}catch{}return!0}async R(n,i,t,r){const o=new d.$Qc;try{o.add(await this.O(n)),o.add(await this.O(i)),await this.S(i,t,r,!0);try{await this.rename(i,n,{overwrite:!0})}catch(v){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{o.dispose()}}async S(n,i,t,r){let o;try{const v=this.H(n);if(!t.create||!t.overwrite){if(await $.Promises.exists(v)){if(!t.overwrite)throw(0,w.$mk)((0,p.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,w.$mk)((0,p.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(o,0,i,0,i.byteLength)}catch(v){throw await this.gb(n,v)}finally{typeof o=="number"&&await this.close(o)}}static{this.Y=!0}static configureFlushOnWrite(n){s.Y=n}async open(n,i,t){const r=this.H(n);let o;(0,w.$ak)(i)&&!t&&(o=await this.O(n));let v;try{if((0,w.$ak)(i)&&i.unlock)try{const{stat:h}=await $.SymlinkSupport.stat(r);h.mode&128||await $.Promises.chmod(r,h.mode|128)}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}let y;if((0,w.$ak)(i)){if(E.$j)try{await $.Promises.truncate(r,0),y="r+"}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}y||(y="w")}else y="r";v=await $.Promises.open(r,y)}catch(y){throw o?.dispose(),(0,w.$ak)(i)?await this.gb(n,y):this.fb(y)}if(this.U.set(v,0),(0,w.$ak)(i)&&this.X.set(v,n),o){const y=this.W.get(v);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${r})`),this.W.set(v,o),y&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${r})`),y.dispose())}return v}async close(n){const i=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&s.Y)try{await $.Promises.fdatasync(n)}catch(t){s.configureFlushOnWrite(!1),this.a.error(t)}return await $.Promises.close(n)}catch(t){throw this.fb(t)}finally{i&&(this.W.get(n)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,t,r,o){const v=this.Z(n,i);let y=null;try{y=(await $.Promises.read(n,t,r,o,v)).bytesRead}catch(h){throw this.fb(h)}finally{this.$(n,v,y)}return y}Z(n,i){return i===this.U.get(n)?null:i}$(n,i,t){const r=this.U.get(n);typeof r=="number"&&(typeof i=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,i,t,r,o){return(0,j.$ah)(()=>this.ab(n,i,t,r,o),100,3)}async ab(n,i,t,r,o){const v=this.Z(n,i);let y=null;try{y=(await $.Promises.write(n,t,r,o,v)).bytesWritten}catch(h){throw await this.gb(this.X.get(n),h)}finally{this.$(n,v,y)}return y}async mkdir(n){try{await $.Promises.mkdir(this.H(n))}catch(i){throw this.fb(i)}}async delete(n,i){try{const t=this.H(n);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,P.$ic)((0,P.$lc)(t),`${(0,P.$mc)(t)}${i.atomic.postfix}`)),await $.Promises.rm(t,$.RimRafMode.MOVE,r)}else try{await $.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let o=!1;try{const{stat:v,symbolicLink:y}=await $.SymlinkSupport.stat(t);o=v.isDirectory()&&!y}catch{}if(o)await $.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,i,t){const r=this.H(n),o=this.H(i);if(r!==o)try{await this.bb(n,i,"move",t.overwrite),await $.Promises.rename(r,o)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(2,null,(0,P.$mc)(r),(0,P.$mc)((0,P.$lc)(o)),v.toString()))),this.fb(v)}}async copy(n,i,t){const r=this.H(n),o=this.H(i);if(r!==o)try{await this.bb(n,i,"copy",t.overwrite),await $.Promises.copy(r,o,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(3,null,(0,P.$mc)(r),(0,P.$mc)((0,P.$lc)(o)),v.toString()))),this.fb(v)}}async bb(n,i,t,r){const o=this.H(n),v=this.H(i);let y=!1;if(!!(this.capabilities&1024)||(y=(0,S.$Wf)(o,v,!0)),y){if(t==="copy")throw(0,w.$mk)((0,p.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const g=await this.L(n);if(!g)throw(0,w.$mk)((0,p.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const O=await this.L(i);if(O){if(!r)throw(0,w.$mk)((0,p.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);g.type&w.FileType.File&&O.type&w.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,i){return this.cb(n,i,!1)}async cb(n,i,t){const r=this.H(n),o=this.H(i),v=!!(this.capabilities&1024);if((0,S.$Wf)(r,o,!v))return;const y=new d.$Qc;try{y.add(await this.O(n)),y.add(await this.O(i)),t&&await $.Promises.mkdir((0,P.$lc)(o),{recursive:!0}),await $.Promises.copyFile(r,o)}catch(h){if(h.code==="ENOENT"&&!t)return this.cb(n,i,!0);throw this.fb(h)}finally{y.dispose()}}t(n,i,t){return new m.$5p(r=>n(r),r=>i(r),t)}F(n,i,t){return new k.$aq(r=>n(r),r=>i(r),t)}fb(n){if(n instanceof w.$lk)return n;let i=n,t;switch(n.code){case"ENOENT":t=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=w.FileSystemProviderErrorCode.Unknown;break;default:t=w.FileSystemProviderErrorCode.Unknown}return(0,w.$mk)(i,t)}async gb(n,i){let t=this.fb(i);if(n&&t.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await $.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,w.$mk)(i,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$bq=s}),define(ae[101],ce([0,1,3,2,4,8]),function(te,e,D,F,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z9b=e.$Y9b=void 0,e.$Y9b=(0,j.$Qh)("sharedProcessLifecycleService");let I=class extends F.$Rc{constructor(S){super(),this.b=S,this.a=this.B(new D.$Nd),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Z9b=I,e.$Z9b=I=ye([Y(0,A.$$i)],I)}),define(ae[200],ce([0,1,10,3,8,2]),function(te,e,D,F,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=e.$_q=void 0;class I extends j.$jj{constructor(E,b,l,$,p){super(b,l,$),this.r=E,this.t=p,this.B(p.listen("onDidChangeLogLevel",E)(w=>{(0,j.$aj)(w)?super.setLogLevel(w):super.setLogLevel(D.URI.revive(w[0]),w[1])})),this.B(p.listen("onDidChangeVisibility",E)(([w,c])=>super.setVisibility(D.URI.revive(w),c))),this.B(p.listen("onDidChangeLoggers",E)(({added:w,removed:c})=>{for(const u of w)super.registerLogger({...u,resource:D.URI.revive(u.resource)});for(const u of c)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new j.$hj({log:(E,b)=>{this.t.call("consoleLog",[E,b])}})}registerLogger(E){super.registerLogger(E),this.t.call("registerLogger",[E,this.r])}deregisterLogger(E){super.deregisterLogger(E),this.t.call("deregisterLogger",[E,this.r])}setLogLevel(E,b){super.setLogLevel(E,b),this.t.call("setLogLevel",[E,b])}setVisibility(E,b){super.setVisibility(E,b),this.t.call("setVisibility",[this.n(E),b])}s(E,b,l){return new R(this.t,E,b,l,this.r)}static setLogLevel(E,b,l){return E.call("setLogLevel",[b,l])}}e.$_q=I;class R extends j.$ej{constructor(E,b,l,$,p){super($?.logLevel==="always"),this.r=E,this.s=b,this.m=!1,this.n=[],this.setLevel(l),this.r.call("createLogger",[b,$,p]).then(()=>{this.u(this.n),this.m=!0})}g(E,b){const l=[[E,b]];this.m?this.u(l):this.n.push(...l)}u(E){this.r.call("log",[this.s,E])}}class S{constructor(E,b){this.a=E,this.b=b}listen(E,b){const l=this.b(E);switch(b){case"onDidChangeLoggers":return F.Event.map(this.a.onDidChangeLoggers,$=>({added:[...$.added].map(p=>this.c(p,l)),removed:[...$.removed].map(p=>this.c(p,l))}));case"onDidChangeVisibility":return F.Event.map(this.a.onDidChangeVisibility,$=>[l.transformOutgoingURI($[0]),$[1]]);case"onDidChangeLogLevel":return F.Event.map(this.a.onDidChangeLogLevel,$=>(0,j.$aj)($)?$:[l.transformOutgoingURI($[0]),$[1]])}throw new Error(`Event not found: ${b}`)}async call(E,b,l){const $=this.b(E);switch(b){case"setLogLevel":return(0,j.$aj)(l[0])?this.a.setLogLevel(l[0]):this.a.setLogLevel(D.URI.revive($.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,$)))}throw new Error(`Call not found: ${b}`)}c(E,b){return{...E,resource:b.transformOutgoingURI(E.resource)}}}e.$ar=S;class d extends A.$Rc{constructor(E,b){super(),b.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(l=>b.call("setLogLevel",[l]))),b.call("getRegisteredLoggers").then(l=>{for(const $ of l)E.registerLogger({...$,resource:D.URI.revive($.resource)})}),this.B(b.listen("onDidChangeVisibility")(([l,$])=>E.setVisibility(D.URI.revive(l),$))),this.B(b.listen("onDidChangeLoggers")(({added:l,removed:$})=>{for(const p of l)E.registerLogger({...p,resource:D.URI.revive(p.resource)});for(const p of $)E.deregisterLogger(p.resource)}))}}e.$br=d}),define(ae[201],ce([0,1,2,8]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RN=void 0;class j extends D.$Rc{constructor(I,R=[]){super(),this.a=new F.$ij([I,...R]),this.B(I.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(I){this.a.setLevel(I)}getLevel(){return this.a.getLevel()}trace(I,...R){this.a.trace(I,...R)}debug(I,...R){this.a.debug(I,...R)}info(I,...R){this.a.info(I,...R)}warn(I,...R){this.a.warn(I,...R)}error(I,...R){this.a.error(I,...R)}flush(){this.a.flush()}}e.$RN=j}),define(ae[56],ce([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U7b=void 0,e.$U7b=(0,D.$Qh)("nativeHostService")}),define(ae[202],ce([0,1,40,55]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c9b=void 0;let j=class{constructor(I,R){return this.windowId=I,D.ProxyChannel.toService(R.getChannel("nativeHost"),{context:I,properties:(()=>{const S=new Map;return S.set("windowId",I),S})()})}};e.$c9b=j,e.$c9b=j=ye([Y(1,F.$98b)],j)}),define(ae[57],ce([0,1,3,60,2,4]),function(te,e,D,F,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=void 0,e.$jn=(0,A.$Qh)("policy");class I extends j.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$Nd),this.onDidChange=this.h.event}async updatePolicyDefinitions(d){const P=Object.keys(this.f).length;return this.f={...d,...this.f},P!==Object.keys(this.f).length&&await this.j(d),F.Iterable.reduce(this.g.entries(),(E,[b,l])=>({...E,[b]:l}),{})}getPolicyValue(d){return this.g.get(d)}serialize(){return F.Iterable.reduce(Object.entries(this.f),(d,[P,E])=>({...d,[P]:{definition:E,value:this.g.get(P)}}),{})}}e.$kn=I;class R{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$ln=R}),define(ae[203],ce([0,1,3,2,57]),function(te,e,D,F,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F8b=e.$E8b=void 0;class A{constructor(S){this.b=S,this.a=new F.$Qc}listen(S,d){switch(d){case"onDidChange":return D.Event.map(this.b.onDidChange,P=>P.reduce((E,b)=>({...E,[b]:this.b.getPolicyValue(b)??null}),{}),this.a)}throw new Error(`Event not found: ${d}`)}call(S,d,P){switch(d){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${d}`)}dispose(){this.a.dispose()}}e.$E8b=A;class I extends j.$kn{constructor(S,d){super(),this.a=d;for(const P in S){const{definition:E,value:b}=S[P];this.f[P]=E,b!==void 0&&this.g.set(P,b)}this.a.listen("onDidChange")(P=>{for(const E in P){const b=P[E];b===null?this.g.delete(E):this.g.set(E,b)}this.h.fire(Object.keys(P))})}async j(S){const d=await this.a.call("updatePolicyDefinitions",S);for(const P in d)this.g.set(P,d[P])}}e.$F8b=I}),define(ae[102],ce([0,1,5,37]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let j;if(typeof D.$h.vscode<"u"&&typeof D.$h.vscode.context<"u"){const A=D.$h.vscode.context.configuration();if(A)j=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(j=globalThis._VSCODE_PRODUCT_JSON,F.env.VSCODE_DEV&&Object.assign(j,{nameShort:`${j.nameShort} Dev`,nameLong:`${j.nameLong} Dev`,dataFolderName:`${j.dataFolderName}-dev`,serverDataFolderName:j.serverDataFolderName?`${j.serverDataFolderName}-dev`:void 0}),!j.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(j,{version:A.version})}}else j={},Object.keys(j).length===0&&Object.assign(j,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=j}),define(ae[25],ce([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=void 0,e.$qj=(0,D.$Qh)("productService"),e.$rj="vscode://schemas/vscode-product"}),define(ae[204],ce([0,1,6,7,2,16,31,8,25]),function(te,e,D,F,j,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t9b=void 0;let d=class extends j.$Rc{constructor(E,b,l){super(),this.b=b,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this.B(new D.$7g(()=>{this.f(E)},3e4)).schedule()}async f(E){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const b=Date.now(),l=(0,A.$lc)(E),$=(0,A.$mc)(E),p=await I.Promises.readdir(l);await Promise.all(p.map(async w=>{if(w===$)return;const c=(0,A.$ic)(l,w),u=await I.Promises.stat(c);if(u.isDirectory()&&b-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),I.Promises.rm(c)}))}catch(b){(0,F.$Z)(b)}}};e.$t9b=d,e.$t9b=d=ye([Y(1,S.$qj),Y(2,R.$$i)],d)}),define(ae[205],ce([0,1,6,7,2,16,31,14,8,25]),function(te,e,D,F,j,A,I,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u9b=void 0;let P=class extends j.$Rc{constructor(b,l,$){super(),this.b=b,this.c=l,this.f=$,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new D.$7g(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const b=Object.create(null),l=JSON.parse(await I.Promises.readFile((0,A.$ic)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(l)){const f=l[u];b[`${f.hash}.${u}`]=!0}const $=(0,A.$ic)(this.b.userDataPath,"clp");if(!await I.Promises.exists($))return;const w=await I.Promises.readdir($);for(const u of w){if(b[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await I.Promises.rm((0,A.$ic)($,u))}const c=Date.now();for(const u of Object.keys(b)){const f=(0,A.$ic)($,u),m=await I.Promises.readdir(f);for(const k of m){if(k==="tcf.json")continue;const s=(0,A.$ic)(f,k),a=await I.Promises.stat(s);a.isDirectory()&&c-a.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.$ic)(u,k)}`),await I.Promises.rm(s))}}}catch(b){(0,F.$Z)(b)}}};e.$u9b=P,e.$u9b=P=ye([Y(0,R.$Yh),Y(1,S.$$i),Y(2,d.$qj)],P)}),define(ae[206],ce([0,1,16,4]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$$E=void 0,e.$$E=(0,F.$Qh)("IV8InspectProfilingService");var j;(function(A){function I(S){return!!(S.samples&&S.timeDeltas)}A.isValidProfile=I;function R(S,d="noAbsolutePaths"){for(const P of S.nodes)P.callFrame&&P.callFrame.url&&((0,D.$hc)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,D.$ic)(d,(0,D.$mc)(P.callFrame.url)));return S}A.rewriteAbsolutePaths=R})(j||(e.Utils=j={}))}),define(ae[207],ce([0,1,32]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O9b=void 0;class F{constructor(){this.a=new Map}async startProfiling(A){const R=await(await new Promise((d,P)=>{te(["v8-inspect-profiler"],d,P)})).startProfiling({port:A.port,checkForPaused:!0}),S=(0,D.$eg)();return this.a.set(S,R),S}async stopProfiling(A){const I=this.a.get(A);if(!I)throw new Error(`UNKNOWN session '${A}'`);const R=await I.stop();return this.a.delete(A),R.profile}}e.$O9b=F}),define(ae[41],ce([0,1,126,12]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=void 0;class j{constructor(){this.a=new Map}add(I,R){D.ok(F.$yf(I)),D.ok(F.$Af(R)),D.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,R)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.$hn=new j}),define(ae[103],ce([0,1,3,41]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=void 0,e.$in={JSONContribution:"base.contributions.json"};function j(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this.b=new D.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,d){this.a[j(S)]=d,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const I=new A;F.$hn.add(e.$in.JSONContribution,I)}),define(ae[50],ce([0,1,18,3,12,148,20,103,41]),function(te,e,D,F,j,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.ConfigurationScope=e.$mn=e.EditPresentationTypes=void 0;var d;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(d||(e.EditPresentationTypes=d={})),e.$mn={Configuration:"base.contributions.configuration"};var P;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn="vscode://schemas/settings/resourceLanguage",e.$un="vscode://schemas/settings/configurationDefaults";const E=S.$hn.as(R.$in.JSONContribution);class b{constructor(){this.h=new Set,this.i=new F.$Nd,this.onDidSchemaChange=this.i.event,this.j=new F.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$tn,this.g),this.v()}registerConfiguration(s,a=!0){this.registerConfigurations([s],a)}registerConfigurations(s,a=!0){const n=new Set;this.n(s,a,n),E.registerSchema(e.$tn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(s){const a=new Set;this.o(s,a),E.registerSchema(e.$tn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:s,remove:a}){const n=new Set;this.o(a,n),this.n(s,!1,n),E.registerSchema(e.$tn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(s){const a=new Set;this.k(s,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(s,a){const n=[];for(const{overrides:i,source:t}of s)for(const r in i)if(a.add(r),e.$wn.test(r)){const o=this.a.get(r),v=o?.valuesSources??new Map;if(t)for(const O of Object.keys(i[r]))v.set(O,t);const y={...o?.value||{},...i[r]};this.a.set(r,{source:t,value:y,valuesSources:v});const h=(0,I.$ui)(r),g={type:"object",default:y,description:A.localize(1,null,h),$ref:e.$tn,defaultDefaultValue:y,source:j.$yf(t)?void 0:t,defaultValueSource:t};n.push(...p(r)),this.d[r]=g,this.b.properties[r]=g}else{this.a.set(r,{value:i[r],source:t});const o=this.d[r];o&&(this.w(r,o),this.r(r,o))}this.m(n)}deregisterDefaultConfigurations(s){const a=new Set;this.l(s,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(s,a){for(const{overrides:n,source:i}of s)for(const t in n){const r=this.a.get(t),o=j.$yf(i)?i:i?.id,v=j.$yf(r?.source)?r?.source:r?.source?.id;if(o===v)if(a.add(t),this.a.delete(t),e.$wn.test(t))delete this.d[t],delete this.b.properties[t];else{const y=this.d[t];y&&(this.w(t,y),this.r(t,y))}}this.u()}deltaConfiguration(s){let a=!1;const n=new Set;s.removedDefaults&&(this.l(s.removedDefaults,n),a=!0),s.addedDefaults&&(this.k(s.addedDefaults,n),a=!0),s.removedConfigurations&&this.o(s.removedConfigurations,n),s.addedConfigurations&&this.n(s.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const a of s)this.h.add(a);this.u()}n(s,a,n){s.forEach(i=>{this.p(i,a,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(s,a){const n=i=>{if(i.properties)for(const t in i.properties){a.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,i.properties[t])}i.allOf?.forEach(t=>n(t))};for(const i of s){n(i);const t=this.c.indexOf(i);t!==-1&&this.c.splice(t,1)}}p(s,a=!0,n,i,t=3,r){t=j.$Hf(s.scope)?t:s.scope;const o=s.properties;if(o)for(const y in o){const h=o[y];if(a&&f(y,h)){delete o[y];continue}if(h.source=n,h.defaultDefaultValue=o[y].default,this.w(y,h),e.$wn.test(y)?h.scope=void 0:(h.scope=j.$Hf(h.scope)?t:h.scope,h.restricted=j.$Hf(h.restricted)?!!i?.includes(y):h.restricted),o[y].hasOwnProperty("included")&&!o[y].included){this.f[y]=o[y],delete o[y];continue}else this.d[y]=o[y],o[y].policy?.name&&this.e.set(o[y].policy.name,y);!o[y].deprecationMessage&&o[y].markdownDeprecationMessage&&(o[y].deprecationMessage=o[y].markdownDeprecationMessage),r.add(y)}const v=s.allOf;if(v)for(const y of v)this.p(y,a,n,i,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const a=n=>{const i=n.properties;if(i)for(const r in i)this.r(r,i[r]);n.allOf?.forEach(a)};a(s)}r(s,a){switch(e.$nn.properties[s]=a,a.scope){case 1:e.$on.properties[s]=a;break;case 2:e.$pn.properties[s]=a;break;case 6:e.$qn.properties[s]=a;break;case 3:e.$rn.properties[s]=a;break;case 4:e.$sn.properties[s]=a;break;case 5:e.$sn.properties[s]=a,this.g.properties[s]=a;break}}s(s,a){switch(delete e.$nn.properties[s],a.scope){case 1:delete e.$on.properties[s];break;case 2:delete e.$pn.properties[s];break;case 6:delete e.$qn.properties[s];break;case 3:delete e.$rn.properties[s];break;case 4:case 5:delete e.$sn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const a=`[${s}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$tn};this.w(a,n),e.$nn.properties[a]=n,e.$on.properties[a]=n,e.$pn.properties[a]=n,e.$qn.properties[a]=n,e.$rn.properties[a]=n,e.$sn.properties[a]=n}}v(){const s={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$tn};e.$nn.patternProperties[e.$vn]=s,e.$on.patternProperties[e.$vn]=s,e.$pn.patternProperties[e.$vn]=s,e.$qn.patternProperties[e.$vn]=s,e.$rn.patternProperties[e.$vn]=s,e.$sn.patternProperties[e.$vn]=s,this.i.fire()}w(s,a){const n=this.a.get(s);let i=n?.value,t=n?.source;j.$Ff(i)&&(i=a.defaultDefaultValue,t=void 0),j.$Ff(i)&&(i=c(a.type)),a.default=i,a.defaultValueSource=t}}const l="\\[([^\\]]+)\\]",$=new RegExp(l,"g");e.$vn=`^(${l})+$`,e.$wn=new RegExp(e.$vn);function p(k){const s=[];if(e.$wn.test(k)){let a=$.exec(k);for(;a?.length;){const n=a[1].trim();n&&s.push(n),a=$.exec(k)}}return(0,D.$Lb)(s)}e.$xn=p;function w(k){return k.reduce((s,a)=>`${s}[${a}]`,"")}e.$yn=w;function c(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$zn=c;const u=new b;S.$hn.add(e.$mn.Configuration,u);function f(k,s){return k.trim()?e.$wn.test(k)?A.localize(7,null,k):u.getConfigurationProperties()[k]!==void 0?A.localize(8,null,k):s.policy?.name&&u.getPolicyConfigurations().get(s.policy?.name)!==void 0?A.localize(9,null,k,s.policy?.name,u.getPolicyConfigurations().get(s.policy?.name)):null:A.localize(6,null)}e.$An=f;function m(){const k=[],s=u.getConfigurationProperties();for(const a of Object.keys(s))k.push([a,s[a].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.$Bn=m}),define(ae[74],ce([0,1,18,3,35,2,34,30,12,10,20,50,41]),function(te,e,D,F,j,A,I,R,S,d,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=void 0;function l(a){return Object.isFrozen(a)?a:R.$9m(a)}class ${constructor(n={},i=[],t=[],r){this.b=n,this.c=i,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof $)return i;const t=new p("");return t.parseRaw(i),t.configurationModel});this.f=n.reduce((i,t)=>t===i?t:i.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,P.$si)(this.contents,n):this.contents}inspect(n,i){const t=this.rawConfiguration.getValue(n),r=i?this.rawConfiguration.getOverrideValue(n,i):void 0,o=i?this.rawConfiguration.override(i).getValue(n):t;return{value:t,override:r,merged:o}}getOverrideValue(n,i){const t=this.i(i);return t?n?(0,P.$si)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const t of this.overrides)t.identifiers.includes(n)&&i.push(...t.keys);return D.$Lb(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return D.$Lb(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=R.$8m(this.contents),t=R.$8m(this.overrides),r=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const v of n)if(o.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(i,v.contents);for(const y of v.overrides){const[h]=t.filter(g=>D.$tb(g.identifiers,y.identifiers));h?(this.h(h.contents,y.contents),h.keys.push(...y.keys),h.keys=D.$Lb(h.keys)):t.push(R.$8m(y))}for(const y of v.keys)r.indexOf(y)===-1&&r.push(y)}return new $(i,r,t,o.every(v=>v instanceof $)?void 0:o)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const t={};for(const r of D.$Lb([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[r];const v=i[r];v&&(typeof o=="object"&&typeof v=="object"?(o=R.$8m(o),this.h(o,v)):o=v),t[r]=o}return new $(t,this.keys,this.overrides)}h(n,i){for(const t of Object.keys(i)){if(t in n&&S.$Af(n[t])&&S.$Af(i[t])){this.h(n[t],i[t]);continue}n[t]=R.$8m(i[t])}}i(n){let i=null,t=null;const r=o=>{o&&(t?this.h(t,o):t=R.$8m(o))};for(const o of this.overrides)o.identifiers.length===1&&o.identifiers[0]===n?i=o.contents:o.identifiers.includes(n)&&r(o.contents);return r(i),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,P.$ri)(this.contents,n),E.$wn.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>D.$tb(t.identifiers,(0,E.$xn)(n))),1))}j(n,i,t){(0,P.$qi)(this.contents,n,i,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),E.$wn.test(n)&&this.overrides.push({identifiers:(0,E.$xn)(n),keys:Object.keys(this.contents[n]),contents:(0,P.$pi)(this.contents[n],r=>console.error(r))})}}e.$Cn=$;class p{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!S.$Hf(n)){const t=this.g(n);this.parseRaw(t,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:t,keys:r,overrides:o,restricted:v,hasExcludedProperties:y}=this.h(n,i);this.b=new $(t,r,o,y?[n]:void 0),this.c=v||[]}g(n){let i={},t=null,r=[];const o=[],v=[];function y(g){Array.isArray(r)?r.push(g):t!==null&&(r[t]=g)}const h={onObjectBegin:()=>{const g={};y(g),o.push(r),r=g,t=null},onObjectProperty:g=>{t=g},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const g=[];y(g),o.push(r),r=g,t=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:y,onError:(g,O,T)=>{v.push({error:g,offset:O,length:T})}};if(n)try{j.$5m(n,h),i=r[0]||{}}catch(g){console.error(`Error while parsing settings file ${this.f}: ${g}`),this.d=[g]}return i}h(n,i){const t=b.$hn.as(E.$mn.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,i);n=r.raw;const o=(0,P.$pi)(n,h=>console.error(`Conflict in settings file ${this.f}: ${h}`)),v=Object.keys(n),y=this.j(n,h=>console.error(`Conflict in settings file ${this.f}: ${h}`));return{contents:o,keys:v,overrides:y,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,i,t,r){let o=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:o};const v={},y=[];for(const h in n)if(E.$wn.test(h)&&t){const g=this.i(n[h],i,!1,r);v[h]=g.raw,o=o||g.hasExcludedProperties,y.push(...g.restricted)}else{const g=i[h],O=g?typeof g.scope<"u"?g.scope:3:void 0;g?.restricted&&y.push(h),!r.exclude?.includes(h)&&(r.include?.includes(h)||(O===void 0||r.scopes===void 0||r.scopes.includes(O))&&!(r.skipRestricted&&g?.restricted))?v[h]=n[h]:o=!0}return{raw:v,restricted:y,hasExcludedProperties:o}}j(n,i){const t=[];for(const r of Object.keys(n))if(E.$wn.test(r)){const o={};for(const v in n[r])o[v]=n[r][v];t.push({identifiers:(0,E.$xn)(r),keys:Object.keys(o),contents:(0,P.$pi)(o,i)})}return t}}e.$Dn=p;class w extends A.$Rc{constructor(n,i,t,r){super(),this.c=n,this.f=i,this.g=r,this.b=this.B(new F.$Nd),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,o=>o.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&t.isEqual(o.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$En=w;class c{constructor(n,i,t,r,o,v,y,h,g,O,T,M,U){this.a=n,this.b=i,this.c=t,this.overrideIdentifiers=r,this.d=o,this.f=v,this.g=y,this.h=h,this.i=g,this.j=O,this.k=T,this.l=M,this.m=U}get value(){return l(this.c)}n(n,i,t){const r=n.inspect(i,t);return{get value(){return l(r.value)},get override(){return l(r.override)},get merged(){return l(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(n,i,t,r,o=new $,v=new $,y=new I.$zc,h=new $,g=new I.$zc){this.c=n,this.d=i,this.f=t,this.g=r,this.h=o,this.i=v,this.j=y,this.l=h,this.m=g,this.a=null,this.b=new I.$zc,this.n=null}getValue(n,i,t){return this.q(n,i,t).getValue(n)}updateValue(n,i,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new $,this.m.set(t.resource,r))):r=this.l,i===void 0?r.removeValue(n):r.setValue(n,i),t.resource||(this.a=null)}inspect(n,i,t){const r=this.q(n,i,t),o=this.u(i.resource,t),v=i.resource?this.m.get(i.resource)||this.l:this.l,y=new Set;for(const h of r.overrides)for(const g of h.identifiers)r.getOverrideValue(n,g)!==void 0&&y.add(g);return new c(n,i,r.getValue(n),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,o||void 0,v)}keys(n){const i=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const t=[];if(!i){const{added:r,updated:o,removed:v}=k(this.c,n);i=[...r,...o,...v]}for(const r of i)for(const o of(0,E.$xn)(r)){const v=this.c.getKeysForOverrideIdentifier(o),y=n.getKeysForOverrideIdentifier(o),h=[...y.filter(g=>v.indexOf(g)===-1),...v.filter(g=>y.indexOf(g)===-1),...v.filter(g=>!R.$_m(this.c.override(o).getValue(g),n.override(o).getValue(g)))];t.push([o,h])}return this.updateDefaultConfiguration(n),{keys:i,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:t,removed:r}=k(this.d,n),o=[...i,...t,...r];return o.length&&this.updatePolicyConfiguration(n),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=k(this.applicationConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateApplicationConfiguration(n),{keys:v,overrides:o}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=k(this.localUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateLocalUserConfiguration(n),{keys:v,overrides:o}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=k(this.remoteUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateRemoteUserConfiguration(n),{keys:v,overrides:o}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=k(this.workspaceConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateWorkspaceConfiguration(n),{keys:v,overrides:o}}compareAndUpdateFolderConfiguration(n,i){const t=this.p.get(n),{added:r,updated:o,removed:v,overrides:y}=k(t,i),h=[...r,...o,...v];return(h.length||!t)&&this.updateFolderConfiguration(n,i),{keys:h,overrides:y}}compareAndDeleteFolderConfiguration(n){const i=this.p.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:o,overrides:v}=k(i,void 0);return{keys:[...t,...r,...o],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,i,t){let r=this.r(i,t);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}r({resource:n},i){let t=this.s();if(i&&n){const r=i.getFolder(n);r&&(t=this.t(r.uri)||t);const o=this.m.get(n);o&&(t=t.merge(o))}return t}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let i=this.b.get(n);if(!i){const t=this.s(),r=this.j.get(n);r?(i=t.merge(r),this.b.set(n,i)):i=t}return i}u(n,i){if(i&&n){const t=i.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:t,overrides:r,keys:o}=this.j.get(i);return n.push([i,{contents:t,overrides:r,keys:o}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(t=>n.add(t))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}w(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r))),[...i.values()]}static parse(n){const i=this.x(n.defaults),t=this.x(n.policy),r=this.x(n.application),o=this.x(n.user),v=this.x(n.workspace),y=n.folders.reduce((h,g)=>(h.set(d.URI.revive(g[0]),this.x(g[1])),h),new I.$zc);return new u(i,t,r,o,new $,v,y,new $,new I.$zc)}static x(n){return new $(n.contents,n.keys,n.overrides)}}e.$Fn=u;function f(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,i=new Map;for(const r of a)r.keys.forEach(o=>n.add(o)),r.overrides.forEach(([o,v])=>{const y=(0,I.$wc)(i,o,new Set);v.forEach(h=>y.add(h))});const t=[];return i.forEach((r,o)=>t.push([o,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.$Gn=f;class m{constructor(n,i,t,r){this.change=n,this.f=i,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const o of n.keys)this.affectedKeys.add(o);for(const[,o]of n.overrides)for(const v of o)this.affectedKeys.add(v);this.d=this.a;for(const o of this.affectedKeys)this.d+=o+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(n,i){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const o=r+t.length;if(o>=this.d.length)return!1;const v=this.d.charCodeAt(o);if(v!==this.b&&v!==this.c)return!1;if(i){const y=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,h=this.g.getValue(n,i,this.h);return!R.$_m(y,h)}return!0}}e.$Hn=m;function k(a,n){const{added:i,removed:t,updated:r}=s(n?.rawConfiguration,a?.rawConfiguration),o=[],v=a?.getAllOverrideIdentifiers()||[],y=n?.getAllOverrideIdentifiers()||[];if(n){const h=y.filter(g=>!v.includes(g));for(const g of h)o.push([g,n.getKeysForOverrideIdentifier(g)])}if(a){const h=v.filter(g=>!y.includes(g));for(const g of h)o.push([g,a.getKeysForOverrideIdentifier(g)])}if(n&&a){for(const h of v)if(y.includes(h)){const g=s({contents:a.getOverrideValue(void 0,h)||{},keys:a.getKeysForOverrideIdentifier(h)},{contents:n.getOverrideValue(void 0,h)||{},keys:n.getKeysForOverrideIdentifier(h)});o.push([h,[...g.added,...g.removed,...g.updated]])}}return{added:i,removed:t,updated:r,overrides:o}}function s(a,n){const i=a?n?a.keys.filter(o=>n.keys.indexOf(o)===-1):[...a.keys]:[],t=n?a?n.keys.filter(o=>a.keys.indexOf(o)===-1):[...n.keys]:[],r=[];if(a&&n){for(const o of n.keys)if(a.keys.indexOf(o)!==-1){const v=(0,P.$si)(n.contents,o),y=(0,P.$si)(a.contents,o);R.$_m(v,y)||r.push(o)}}return{added:i,removed:t,updated:r}}}),define(ae[208],ce([0,1,18,3,2,30,12,74,50,8,57,41]),function(te,e,D,F,j,A,I,R,S,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=void 0;class b extends j.$Rc{constructor(){super(...arguments),this.a=this.B(new F.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new R.$Cn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$hn.as(S.$mn.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:c})=>this.c(Array.from(w),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(w,c){this.h(w,E.$hn.as(S.$mn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}g(){this.b=new R.$Cn;const w=E.$hn.as(S.$mn.Configuration).getConfigurationProperties();this.h(Object.keys(w),w)}h(w,c){const u=this.f();for(const f of w){const m=u[f],k=c[f];m!==void 0?this.b.addValue(f,m):k?this.b.addValue(f,k.default):this.b.removeValue(f)}}}e.$In=b;class l{constructor(){this.onDidChangeConfiguration=F.Event.None,this.configurationModel=new R.$Cn}async initialize(){return this.configurationModel}}e.$Jn=l;let $=class extends j.$Rc{get configurationModel(){return this.b}constructor(w,c,u){super(),this.c=w,this.f=c,this.g=u,this.a=this.B(new F.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new R.$Cn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const c={},u=[],f=E.$hn.as(S.$mn.Configuration).getConfigurationProperties();for(const m of w){const k=f[m];if(!k){u.push(m);continue}if(k.policy){if(k.type!=="string"&&k.type!=="number"){this.g.warn(`Policy ${k.policy.name} has unsupported type ${k.type}`);continue}u.push(m),c[k.policy.name]={type:k.type}}}return(0,I.$Lf)(c)||await this.f.updatePolicyDefinitions(c),u}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const c=E.$hn.as(S.$mn.Configuration).getPolicyConfigurations(),u=(0,D.$Gb)(w.map(f=>c.get(f)));this.m(u,!0)}m(w,c){this.g.trace("PolicyConfiguration#update",w);const u=E.$hn.as(S.$mn.Configuration).getConfigurationProperties(),f=[],m=this.b.isEmpty();for(const k of w){const s=u[k]?.policy?.name;if(s){const a=this.f.getPolicyValue(s);(m?a!==void 0:!(0,A.$_m)(this.b.getValue(k),a))&&f.push([k,a])}else this.b.getValue(k)!==void 0&&f.push([k,void 0])}if(f.length){this.g.trace("PolicyConfiguration#changed",f);const k=this.b;this.b=new R.$Cn;for(const s of k.keys)this.b.setValue(s,k.getValue(s));for(const[s,a]of f)a===void 0?this.b.removeValue(s):this.b.setValue(s,a);c&&this.a.fire(this.b)}}};e.$Kn=$,e.$Kn=$=ye([Y(1,P.$jn),Y(2,d.$$i)],$)}),define(ae[209],ce([0,1,6,3,2,19,20,74,208,57]),function(te,e,D,F,j,A,I,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=void 0;class P extends j.$Rc{constructor(b,l,$,p){super(),this.j=b,this.h=this.B(new F.$Nd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new S.$In),this.c=$ instanceof d.$ln?new S.$Jn:this.B(new S.$Kn(this.b,$,p)),this.f=this.B(new R.$En(this.j,{},A.$mg,l)),this.a=new R.$Fn(this.b.configurationModel,this.c.configurationModel,new R.$Cn,new R.$Cn),this.g=this.B(new D.$7g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:w,properties:c})=>this.n(w,c))),this.B(this.c.onDidChangeConfiguration(w=>this.r(w))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,l,$]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.$Fn(b,l,new R.$Cn,$)}getConfigurationData(){return this.a.toData()}getValue(b,l){const $=typeof b=="string"?b:void 0,p=(0,I.$li)(b)?b:(0,I.$li)(l)?l:{};return this.a.getValue($,p,void 0)}updateValue(b,l,$,p){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.m(b)}m(b){const l=this.a.toData(),$=this.a.compareAndUpdateLocalUserConfiguration(b);this.s($,l,2)}n(b,l){const $=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration(b,l);this.s(p,$,7)}r(b){const l=this.a.toData(),$=this.a.compareAndUpdatePolicyConfiguration(b);this.s($,l,7)}s(b,l,$){const p=new R.$Hn(b,{data:l},this.a);p.source=$,p.sourceConfig=this.t($),this.h.fire(p)}t(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Ln=P}),define(ae[210],ce([0,1,15,3,2,67]),function(te,e,D,F,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wpb=e.$Vpb=e.$Upb=e.$Tpb=void 0;const I=(d,P,E)=>{const b=new Uint8Array(16);for(let p=0;p<16;p++)b[p]=Math.round(Math.random()*256);const l=(0,D.$ve)(D.$be.wrap(b));return[`GET ws://localhost${d}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${l}`].join(`\r
`)+`\r
\r
`};e.$Tpb=I,e.$Upb=D.$be.fromString(`\r
\r
`);async function R(d,P,E,b,l){d.write(D.$be.fromString((0,e.$Tpb)(P,E,b)));const $=new j.$Qc;try{return await new Promise((p,w)=>{let c;$.add(d.onData(u=>{c?c=D.$be.concat([c,u],c.byteLength+u.byteLength):c=u;const f=c.indexOf(e.$Upb);if(f===-1)return;p(d),d.pauseData();const m=c.slice(f+e.$Upb.byteLength);m.byteLength&&l.onData.fire(m)})),$.add(d.onClose(u=>w(u??new Error("socket closed")))),$.add(d.onEnd(()=>w(new Error("socket ended"))))})}catch(p){throw d.dispose(),p}finally{$.dispose()}}e.$Vpb=R;class S extends j.$Rc{constructor(P,E){super(),this.g=P,this.a=this.B(new F.$Qd),this.onData=(...b)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...b)),this.b=this.B(new F.$Nd),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event(b=>this.a.fire(b))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(P,E){A.SocketDiagnostics.traceSocketEvent(this,this.g,P,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Wpb=S}),define(ae[211],ce([0,1,7,4]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.RemoteAuthorityResolverErrorCode=e.$Sk=e.$Rk=e.RemoteConnectionType=e.$Qk=void 0,e.$Qk=(0,F.$Qh)("remoteAuthorityResolverService");var j;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(j||(e.RemoteConnectionType=j={}));class A{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$Rk=A;class I{constructor(E,b){this.host=E,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sk=I;var R;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class S extends D.$ab{static isNotAvailable(E){return E instanceof S&&E._code===R.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof S&&E._code===R.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof S&&E._code===R.NoResolverFound}static isInvalidAuthority(E){return E instanceof S&&E._code===R.InvalidAuthority}static isHandled(E){return E instanceof S&&E.isHandled}constructor(E,b=R.Unknown,l){super(E),this._message=E,this._code=b,this._detail=l,this.isHandled=b===R.NotAvailable&&l===!0,Object.setPrototypeOf(this,S.prototype)}}e.$Tk=S;function d(P){const E=P.indexOf("+");return E===-1?P:P.substring(0,E)}e.$Uk=d}),define(ae[75],ce([0,1,23]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0;function F(d){return d.scheme===D.Schemas.vscodeRemote?d.authority:void 0}e.$Vk=F;function j(d){if(!d)return;const P=d.indexOf("+");return P<0?d:d.substr(0,P)}e.$Wk=j;function A(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}e.$Xk=A;function I(d){const{host:P,port:E}=S(d);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:E}}e.$Yk=I;function R(d,P){let{host:E,port:b}=S(d);return typeof b>"u"&&(b=P),{host:E,port:b}}e.$Zk=R;function S(d){const P=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const E=d.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const b=d.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:d,port:void 0}}}),define(ae[44],ce([0,1,27,4,75]),function(te,e,D,F,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.TargetPlatform=e.ExtensionType=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=void 0,e.$1l="extensions.user.cache",e.$2l="extensions.builtin.cache",e.$3l="undefined_publisher",e.$4l=["ui","workspace","web"];function A(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$5l=A,e.$6l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(I||(e.ExtensionType=I={}));var R;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class S{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,c){if(typeof w>"u"||w===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof w=="string"||typeof c=="string"){const u=typeof w=="string"?w:w.value,f=typeof c=="string"?c:c.value;return D.$2e(u,f)}return w._lower===c._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$7l=S;class d{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const c of w)this.add(c)}add(w){this.c.add(S.toKey(w))}delete(w){return this.c.delete(S.toKey(w))}has(w){return this.c.has(S.toKey(w))}}e.$8l=d;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(S.toKey(w))}get(w){return this.c.get(S.toKey(w))}has(w){return this.c.has(S.toKey(w))}set(w,c){this.c.set(S.toKey(w),c)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$9l=P;function E(p){return b(p)}e.$0l=E;function b(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$$l=b;function l(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$_l=l;function $(p,w){if(w){const c=`onResolveRemoteAuthority:${(0,j.$Wk)(w)}`;return!!p.activationEvents?.includes(c)}return!1}e.$am=$,e.$bm=(0,F.$Qh)("IBuiltinExtensionsScannerService")}),define(ae[212],ce([0,1,2,44,11]),function(te,e,D,F,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=void 0;class A extends D.$Rc{constructor(R,S,d,P,E){super(),this.a=R,this.b=S,this.c=d,this.f=E,this.B(P.onDidInstallExtensions(b=>this.g(b))),this.B(P.onDidUninstallExtension(b=>this.h(b)))}g(R){for(const S of R)S.local&&this.invalidate(S.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const S of this.a.profiles)this.c.extUri.isEqual(S.extensionsResource,R)&&await this.j(S);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,F.$1l))}catch(S){(0,j.$qk)(S)!==1&&this.f.error(S)}}}e.$Hp=A}),define(ae[213],ce([0,1,6,15,26,7,3,2,100,62,32,67,211,75]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.PersistentConnectionEventType=e.$7k=e.$6k=e.$5k=e.ConnectionType=void 0;const $=30*1e3;var p;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function w(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(q){const C=new j.$Xd;return setTimeout(()=>C.cancel(),q),C.token}function u(q,C){if(q.isCancellationRequested||C.isCancellationRequested)return j.CancellationToken.Cancelled;const L=new j.$Xd;return q.onCancellationRequested(()=>L.cancel()),C.onCancellationRequested(()=>L.cancel()),L.token}class f{get didTimeout(){return this.c==="timedout"}constructor(C){this.c="pending",this.d=new R.$Qc,this.promise=new Promise((L,B)=>{this.f=L,this.g=B}),C.isCancellationRequested?this.h():this.d.add(C.onCancellationRequested(()=>this.h()))}registerDisposable(C){this.c==="pending"?this.d.add(C):C.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const C=new Error("Time limit reached");return C.code="ETIMEDOUT",C.syscall="connect",C}resolve(C){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(C))}reject(C){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(C))}}function m(q,C){const L=new f(C);return L.registerDisposable(q.onControlMessage(B=>{const N=JSON.parse(B.toString()),W=V(N);W?L.reject(W):L.resolve(N)})),L.promise}function k(q,C,L,B,N,W,G,ie){const oe=new f(ie),ue=d.$Jd.create(!1);return q.info(`Creating a socket (${G})...`),S.mark(`code/willCreateSocket/${W}`),C.connect(L,B,N,G).then(he=>{oe.didTimeout?(S.mark(`code/didCreateSocketError/${W}`),q.info(`Creating a socket (${G}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(S.mark(`code/didCreateSocketOK/${W}`),q.info(`Creating a socket (${G}) was successful after ${ue.elapsed()} ms.`),oe.resolve(he))},he=>{S.mark(`code/didCreateSocketError/${W}`),q.info(`Creating a socket (${G}) returned an error after ${ue.elapsed()} ms.`),q.error(he),oe.reject(he)}),oe.promise}function s(q,C){const L=new f(C);return q.then(B=>{L.didTimeout||L.resolve(B)},B=>{L.didTimeout||L.reject(B)}),L.promise}async function a(q,C,L,B){const N=se(q,C);q.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let W;try{W=await k(q.logService,q.remoteSocketFactoryService,q.connectTo,(0,l.$Xk)(q),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,w(C),`renderer-${w(C)}-${q.reconnectionToken}`,B)}catch(he){throw q.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),q.logService.error(he),he}q.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let G,ie;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(W,null),G=q.reconnectionProtocol,ie=!1):(G=new E.$Eh({socket:W}),ie=!0),q.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const oe=await s(q.signService.createNewMessage((0,P.$eg)()),B),ue={type:"auth",auth:q.connectionToken||"00000000000000000000",data:oe.data};G.sendControl(F.$be.fromString(JSON.stringify(ue)));try{const he=await m(G,u(B,c(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const ve=new Error("Unexpected handshake message");throw ve.code="VSCODE_CONNECTION_ERROR",ve}if(q.logService.trace(`${N} 4/6. received SignRequest control message.`),!await s(q.signService.validate(oe,he.signedData),B)){const ve=new Error("Refused to connect to unsupported server");throw ve.code="VSCODE_CONNECTION_ERROR",ve}const de=await s(q.signService.sign(he.data),B),we={type:"connectionType",commit:q.commit,signedData:de,desiredConnectionType:C};return L&&(we.args=L),q.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),G.sendControl(F.$be.fromString(JSON.stringify(we))),{protocol:G,ownsProtocol:ie}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(q.logService.error(`${N} the handshake timed out. Error:`),q.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${N} received error control message when negotiating connection. Error:`),q.logService.error(he)),ie&&J(G),he}}async function n(q,C,L,B){const N=Date.now(),W=se(q,C),{protocol:G,ownsProtocol:ie}=await a(q,C,L,B),oe=new f(B);return oe.registerDisposable(G.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),$e=V(he);$e?(q.logService.error(`${W} received error control message when negotiating connection. Error:`),q.logService.error($e),ie&&J(G),oe.reject($e)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${Q(N)}!`),oe.resolve({protocol:G,firstMessage:he}))})),oe.promise}async function i(q,C){const{protocol:L}=await n(q,1,void 0,C);return{protocol:L}}async function t(q,C,L){const{protocol:B,firstMessage:N}=await n(q,2,C,L),W=N&&N.debugPort;return{protocol:B,debugPort:W}}async function r(q,C,L){const B=Date.now(),N=se(q,3),{protocol:W}=await a(q,3,C,L);return q.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${Q(B)}!`),W}async function o(q,C,L){const{connectTo:B,connectionToken:N}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,connectTo:B,connectionToken:N,reconnectionToken:C,reconnectionProtocol:L,remoteSocketFactoryService:q.remoteSocketFactoryService,signService:q.signService,logService:q.logService}}async function v(q,C,L){return h(q,async B=>{const{protocol:N}=await i(B,j.CancellationToken.None);return new H(q,C,L,B.reconnectionToken,N)})}e.$5k=v;async function y(q,C){return h(q,async L=>{const{protocol:B,debugPort:N}=await t(L,C,j.CancellationToken.None);return new K(q,C,L.reconnectionToken,B,N)})}e.$6k=y;async function h(q,C){for(let B=1;;B++)try{const N=(0,P.$eg)(),W=await o(q,N,null);return await C(W)}catch(N){if(B<5)q.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(N);else throw q.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(N),x.triggerPermanentFailure(0,0,b.$Tk.isHandled(N)),N}}async function g(q,C,L){const B=await o(q,(0,P.$eg)(),null);return await r(B,{host:C,port:L},j.CancellationToken.None)}e.$7k=g;function O(q){return(0,D.$Hg)(C=>new Promise((L,B)=>{const N=setTimeout(L,q*1e3);C.onCancellationRequested(()=>{clearTimeout(N),L()})}))}var T;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class M{constructor(C,L){this.reconnectionToken=C,this.millisSinceLastIncomingData=L,this.type=0}}e.$8k=M;class U{constructor(C,L,B,N){this.reconnectionToken=C,this.millisSinceLastIncomingData=L,this.durationSeconds=B,this.c=N,this.type=1}skipWait(){this.c.cancel()}}e.$9k=U;class z{constructor(C,L,B){this.reconnectionToken=C,this.millisSinceLastIncomingData=L,this.attempt=B,this.type=2}}e.$0k=z;class Z{constructor(C,L,B){this.reconnectionToken=C,this.millisSinceLastIncomingData=L,this.attempt=B,this.type=4}}e.$$k=Z;class X{constructor(C,L,B,N){this.reconnectionToken=C,this.millisSinceLastIncomingData=L,this.attempt=B,this.handled=N,this.type=3}}e.$_k=X;class x extends R.$Rc{static triggerPermanentFailure(C,L,B){this._permanentFailure=!0,this.f=C,this.g=L,this.h=B,this.j.forEach(N=>N.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(C=>C.y())}static debugPauseSocketWriting(){this.j.forEach(C=>C.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(C,L,B,N,W){super(),this.t=C,this.u=L,this.reconnectionToken=B,this.protocol=N,this.w=W,this.m=this.B(new I.$Nd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Z(this.reconnectionToken,0,0)),this.B(N.onSocketClose(G=>{const ie=_(this.t,this.reconnectionToken,!0);G?G.type===0?(this.u.logService.info(`${ie} received socket close event (hadError: ${G.hadError}).`),G.error&&this.u.logService.error(G.error)):(this.u.logService.info(`${ie} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this.u.logService.error(G.event)):this.u.logService.info(`${ie} received socket close event.`),this.y()})),this.B(N.onSocketTimeout(G=>{const ie=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ie} received socket timeout event (unacknowledgedMsgCount: ${G.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${G.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${G.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,R.$Pc)(()=>{const G=x.j.indexOf(this);G>=0&&x.j.splice(G,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const C=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${C} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const N=B<L.length?L[B]:L[L.length-1];try{if(N>0){const G=O(N);this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,G)),this.u.logService.info(`${C} waiting for ${N} seconds before reconnecting...`);try{await G}catch{}}if(this.n){this.u.logService.error(`${C} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${C} resolving connection...`);const W=await o(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${C} connecting to ${W.connectTo}...`),await this.G(W,c($)),this.u.logService.info(`${C} reconnected!`),this.m.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(W){if(W.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${C} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${C} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(b.$Tk.isTemporarilyNotAvailable(W)){this.u.logService.info(`${C} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(W);continue}if((W.code==="ETIMEDOUT"||W.code==="ENETUNREACH"||W.code==="ECONNREFUSED"||W.code==="ECONNRESET")&&W.syscall==="connect"){this.u.logService.info(`${C} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(W);continue}if((0,A.$3)(W)){this.u.logService.info(`${C} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(W);continue}if(W instanceof b.$Tk){this.u.logService.error(`${C} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,b.$Tk.isHandled(W));break}this.u.logService.error(`${C} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(C,L,B){this.w?x.triggerPermanentFailure(C,L,B):this.D(C,L,B)}D(C,L,B){this.m.fire(new X(this.reconnectionToken,C,L,B)),J(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$al=x;class H extends x{constructor(C,L,B,N,W){super(1,C,N,W,!0),this.client=this.B(new E.$Ch(W,{remoteAuthority:L,clientId:B},C.ipcLogger))}async G(C,L){await i(C,L)}}e.$bl=H;class K extends x{constructor(C,L,B,N,W){super(2,C,B,N,!1),this.H=L,this.debugPort=W}async G(C,L){await t(C,this.H,L)}}e.$cl=K;function J(q){try{q.acceptDisconnect();const C=q.getSocket();q.dispose(),C.dispose()}catch(C){(0,A.$Z)(C)}}function V(q){if(q&&q.type==="error"){const C=new Error(`Connection error: ${q.reason}`);return C.code="VSCODE_CONNECTION_ERROR",C}return null}function ee(q,C){for(;q.length<C;)q+=" ";return q}function ne(q,C){return`[remote-connection][${ee(w(q),13)}][${C.substr(0,5)}\u2026]`}function _(q,C,L){return`${ne(q,C)}[${L?"reconnect":"initial"}]`}function se(q,C){return`${_(C,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.connectTo}]`}function Q(q){return`${Date.now()-q} ms`}}),define(ae[104],ce([0,1,2,4]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=void 0,e.$1k=(0,F.$Qh)("remoteSocketFactoryService");class j{constructor(){this.a={}}register(I,R){return this.a[I]??=[],this.a[I].push(R),(0,D.$Pc)(()=>{const S=this.a[I]?.indexOf(R);typeof S=="number"&&S>=0&&this.a[I]?.splice(S,1)})}b(I){return(this.a[I.type]||[]).find(S=>S.supports(I))}connect(I,R,S,d){const P=this.b(I);if(!P)throw new Error(`No socket factory found for ${I}`);return P.connect(I,R,S,d)}}e.$2k=j}),define(ae[214],ce([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M9b=e.$L9b=void 0,e.$L9b=(0,D.$Qh)("sharedProcessTunnelService"),e.$M9b="sharedProcessTunnel"}),define(ae[105],ce([0,1,4,163]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W9b=e.$V9b=e.$U9b=e.$T9b=e.$S9b=e.TunnelStates=e.$R9b=e.$Q9b=void 0,e.$Q9b=(0,D.$Qh)("IRemoteTunnelService"),e.$R9b={active:!1};var j;(function(A){A.disconnected=I=>({type:"disconnected",onTokenFailed:I}),A.connected=(I,R)=>({type:"connected",info:I,serviceInstallFailed:R}),A.connecting=I=>({type:"connecting",progress:I}),A.uninitialized={type:"uninitialized"}})(j||(e.TunnelStates=j={})),e.$S9b="remote.tunnels.access",e.$T9b=e.$S9b+".hostNameOverride",e.$U9b=e.$S9b+".preventSleep",e.$V9b="remoteTunnelService",e.$W9b=(0,F.localize)(0,null)}),define(ae[58],ce([0,1,15,7,2,165,50,4,8,41]),function(te,e,D,F,j,A,I,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0,e.$To=(0,R.$Qh)("requestService");class P{constructor(k){this.b=k}toJSON(){if(!this.a){const k=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?k[s]="*****":k[s]=this.b[s];this.a=k}return this.a}}class E extends j.$Rc{constructor(k){super(),this.b=0,this.a=k.createLogger("network",{name:(0,A.localize)(0,null),when:S.$pj.isEqualTo((0,S.$nj)(S.LogLevel.Trace)).serialize()})}async c(k,s,a){const n=`${k} #${++this.b}: ${s.url}`;this.a.trace(`${n} - begin`,s.type,new P(s.headers??{}));try{const i=await a();return this.a.trace(`${n} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${n} - error`,s.type,(0,F.$9)(i)),i}}}e.$Uo=E;function b(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}e.$Vo=b;function l(m){return m.res.statusCode===204}e.$Wo=l;async function $(m){return l(m)?null:(await(0,D.$ne)(m.stream)).toString()}e.$Xo=$;async function p(m){if(!b(m))throw new Error("Server returned "+m.res.statusCode);return $(m)}e.$Yo=p;async function w(m){if(!b(m))throw new Error("Server returned "+m.res.statusCode);if(l(m))return null;const s=(await(0,D.$ne)(m.stream)).toString();try{return JSON.parse(s)}catch(a){throw a.message+=`:
`+s,a}}e.$Zo=w;function c(m){f(m)}e.$1o=c;let u;function f(m){const k=d.$hn.as(I.$mn.Configuration),s=u;u={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},k.updateConfigurations({add:[u],remove:s?[s]:[]})}f(1)}),define(ae[215],ce([0,1,26,23,11,58]),function(te,e,D,F,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7N=void 0;let I=class{constructor(S,d){this.a=S,this.b=d}async download(S,d,P=D.CancellationToken.None){if(S.scheme===F.Schemas.file||S.scheme===F.Schemas.vscodeRemote){await this.b.copy(S,d);return}const E={type:"GET",url:S.toString(!0)},b=await this.a.request(E,P);if(b.res.statusCode===200)await this.b.writeFile(d,b.stream);else{const l=await(0,A.$Yo)(b);throw new Error(`Expected 200, got back ${b.res.statusCode} instead.

${l}`)}}};e.$7N=I,e.$7N=I=ye([Y(0,A.$To),Y(1,j.$_j)],I)}),define(ae[216],ce([0,1,15,26]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;class j{constructor(R){this.a=R}listen(R,S){throw new Error("Invalid listen")}call(R,S,d,P=F.CancellationToken.None){switch(S){case"request":return this.a.request(d[0],P).then(async({res:E,stream:b})=>{const l=await(0,D.$ne)(b);return[{statusCode:E.statusCode,headers:E.headers},l]});case"resolveProxy":return this.a.resolveProxy(d[0])}throw new Error("Invalid call")}}e.$Wq=j;class A{constructor(R){this.a=R}async request(R,S){const[d,P]=await this.a.call("request",[R],S);return{res:d,stream:(0,D.$pe)(P)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.$Xq=A}),define(ae[217],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e8b=e.$d8b=e.$c8b=void 0,e.$c8b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$d8b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$e8b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[218],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$93b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(j){try{const A=await this.c();if(A){const I=String(D.a++);return this.b.set(I,A),{id:I,data:A.createNewMessage(j)}}}catch{}return{id:"",data:j}}async validate(j,A){if(!j.id)return!0;const I=this.b.get(j.id);if(!I)return!1;this.b.delete(j.id);try{return I.validate(A)==="ok"}catch{return!1}finally{I.dispose?.()}}async sign(j){try{return await this.d(j)}catch{}return j}}e.$93b=D}),define(ae[106],ce([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.$3k=void 0,e.$3k="signService",e.$4k=(0,D.$Qh)(e.$3k)}),define(ae[219],ce([0,1,218]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$58b=void 0;class F extends D.$93b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(I=>new I.signer().sign(A))}h(){return new Promise((A,I)=>te(["vsda"],A,I))}}e.$58b=F}),define(ae[76],ce([0,1,3,2]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QDb=e.$PDb=e.$ODb=e.$NDb=void 0;class j extends F.$Rc{constructor(E,b,l){super(),this.a=E,this.b=b,this.c=l}async getItems(){const E={profile:this.b,workspace:this.c},b=await this.a.call("getItems",E);return new Map(b)}updateItems(E){const b={profile:this.b,workspace:this.c};return E.insert&&(b.insert=Array.from(E.insert.entries())),E.delete&&(b.delete=Array.from(E.delete.values())),this.a.call("updateItems",b)}optimize(){const E={profile:this.b,workspace:this.c};return this.a.call("optimize",E)}}class A extends j{constructor(E,b){super(E,b,void 0),this.f=this.B(new D.$Nd),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(E=>this.h(E)))}h(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this.f.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class I extends A{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.$NDb=I;class R extends A{constructor(E,b){super(E,b)}async close(){this.dispose()}}e.$ODb=R;class S extends j{constructor(E,b){super(E,void 0,b),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.$PDb=S;class d{constructor(E){this.a=E}isUsed(E){const b={payload:E,profile:void 0,workspace:void 0};return this.a.call("isUsed",b)}}e.$QDb=d}),define(ae[107],ce([0,1,5,37,32]),function(te,e,D,F,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=void 0;function A(S){if(D.$u===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function I(S,d,P,E,b,l,$,p,w){const c=Object.create(null);c["common.machineId"]=l,c["common.sqmId"]=$,c.sessionID=(0,j.$eg)()+Date.now(),c.commitHash=E,c.version=b,c["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,D.$i)(D.$u),c["common.nodePlatform"]=F.$cc,c["common.nodeArch"]=P,c["common.product"]=w||"desktop",p&&(c["common.msftInternal"]=p);let u=0;const f=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),D.$m&&(c["common.snap"]="true");const m=A(d);return m&&(c["common.platformDetail"]=m),c}e.$io=I;function R(S){const d=F.env.USERDNSDOMAIN;if(!d)return!1;const P=d.toLowerCase();return S.some(E=>P===E)}e.$jo=R}),define(ae[22],ce([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=void 0,e.$dl=(0,D.$Qh)("telemetryService"),e.$el=(0,D.$Qh)("customEndpointTelemetryService"),e.$fl="telemetry.currentSessionDate",e.$gl="telemetry.firstSessionDate",e.$hl="telemetry.lastSessionDate",e.$il="telemetry.machineId",e.$jl="telemetry.sqmId",e.$kl="telemetry",e.$ll="telemetry.telemetryLevel",e.$ml="telemetry.enableCrashReporter",e.$nl="telemetry.enableTelemetry";var F;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var j;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(j||(e.TelemetryConfiguration=j={}))}),define(ae[220],ce([0,1,36,6,35,23,16,5,10,142,31,145,95,11,25,22]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=e.$Gr=e.$Fr=e.$Er=void 0;const w=new Map;async function c(s,a){const n=`${s}::${a.join(":")}`,i=w.get(n);if(i)return i;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,o=new Map,v=2e4;function y(g,O,T,M){const U=O.substring(g.length+1);return F.Promises.withAsyncBody(async z=>{let Z;try{Z=await P.Promises.readdir(O,{withFileTypes:!0})}catch{z();return}if(M.count>=v){M.count+=Z.length,M.maxReached=!0,z();return}let X=Z.length;if(X===0){z();return}let x=Z;M.count+Z.length>v&&(M.maxReached=!0,X=v-M.count,x=Z.slice(0,X)),M.count+=Z.length;for(const H of x)if(H.isDirectory()){if(T.includes(H.name)||await y(g,(0,I.$ic)(O,H.name),T,M),--X===0){z();return}}else{const K=H.name.lastIndexOf(".");if(K>=0){const J=H.name.substring(K+1);J&&r.set(J,(r.get(J)??0)+1)}for(const J of t)J.relativePathPattern?.test(U)!==!1&&J.filePattern.test(H.name)&&o.set(J.tag,(o.get(J.tag)??0)+1);if(--X===0){z();return}}})}const h=F.Promises.withAsyncBody(async g=>{const O={count:0,maxReached:!1};await y(s,s,a,O);const T=await m(s);g({configFiles:u(o),fileTypes:u(r),fileCount:O.count,maxFilesReached:O.maxReached,launchConfigFiles:T})});return w.set(n,h),h}e.$Er=c;function u(s){return Array.from(s.entries(),([a,n])=>({name:a,count:n})).sort((a,n)=>n.count-a.count)}function f(){const s={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/l.$Hk.GB).toFixed(2)}GB (${(D.freemem()/l.$Hk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.$Sm.value()*100)}%`},a=D.cpus();return a&&a.length>0&&(s.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),s}e.$Fr=f;async function m(s){try{const a=new Map,n=(0,I.$ic)(s,".vscode","launch.json"),i=await P.Promises.readFile(n),t=[],r=(0,j.$Xm)(i.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,j.$7m)(r)==="object"&&r.configurations)for(const o of r.configurations){const v=o.type;v&&(a.has(v)?a.set(v,a.get(v)+1):a.set(v,1))}return u(a)}catch{return[]}}e.$Gr=m;let k=class{constructor(a,n){this.c=a,this.d=n}f(a){const n=[];return n.push(`OS Version:       ${a.os}`),n.push(`CPUs:             ${a.cpus}`),n.push(`Memory (System):  ${a.memory}`),n.push(`VM:               ${a.vmHint}`),n.join(`
`)}g(a){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const i=D.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(D.totalmem()/l.$Hk.GB).toFixed(2)}GB (${(D.freemem()/l.$Hk.GB).toFixed(2)}GB free)`),R.$j||n.push(`Load (avg):       ${D.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(d.$Sm.value()*100)}%`),n.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${a.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(a,n){return Promise.all([(0,E.$Dr)(a.mainPID),this.k(a)]).then(async i=>{let[t,r]=i,o=this.m(a,t);return n.forEach(v=>{if((0,b.$sm)(v))o+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(o+=`

Remote: ${v.hostName}`,v.processes&&(o+=`
${this.m(a,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const y of Object.keys(v.workspaceMetadata)){const h=v.workspaceMetadata[y];let g=`${h.fileCount} files`;h.maxFilesReached&&(g=`more than ${g}`),r+=`|    Folder (${y}): ${g}`,r+=this.h(h)}}}),{processInfo:o,workspaceInfo:r}})}async getSystemInfo(a,n){const{memory:i,vmHint:t,os:r,cpus:o}=f(),v={os:r,memory:i,cpus:o,vmHint:t,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:n};return R.$j||(v.load=`${D.loadavg().map(y=>Math.round(y)).join(", ")}`),R.$l&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(a,n){const i=[];return(0,E.$Dr)(a.mainPID).then(async t=>(i.push(""),i.push(this.g(a)),i.push(""),i.push(this.m(a,t)),a.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(a))),n.forEach(r=>{if((0,b.$sm)(r))i.push(`
${r.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${r.hostName}`),i.push(this.f(r.machineInfo)),r.processes&&i.push(this.m(a,r.processes)),r.workspaceMetadata)for(const o of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[o];let y=`${v.fileCount} files`;v.maxFilesReached&&(y=`more than ${y}`),i.push(`Folder (${o}): ${y}`),i.push(this.h(v))}}),i.push(""),i.push(""),i.join(`
`)))}h(a){const n=[];let t=0;const r=(h,g)=>{const O=` ${h}(${g})`;t+O.length>60?(n.push(o),o="|                 ",t=o.length):t+=O.length,o+=O};let o="|      File types:";const v=10,y=a.fileTypes.length>v?v:a.fileTypes.length;for(let h=0;h<y;h++){const g=a.fileTypes[h];r(g.name,g.count)}if(n.push(o),a.configFiles.length>=0&&(o="|      Conf files:",t=0,a.configFiles.forEach(h=>{r(h.name,h.count)}),n.push(o)),a.launchConfigFiles.length>0){let h="|      Launch Configs:";a.launchConfigFiles.forEach(g=>{const O=g.count>1?` ${g.name}(${g.count})`:` ${g.name}`;h+=O}),n.push(h)}return n.join(`
`)}j(a){const n=Math.max(...Object.keys(a).map(i=>i.length));return Object.keys(a).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${a[i]}`).join(`
                  `)}k(a){const n=[],i=[];return a.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const o=S.URI.revive(r);if(o.scheme===A.Schemas.file){const v=o.fsPath;i.push(c(v,["node_modules",".git"]).then(y=>{let h=`${y.fileCount} files`;y.maxFilesReached&&(h=`more than ${h}`),n.push(`|    Folder (${(0,I.$mc)(v)}): ${h}`),n.push(this.h(y))}).catch(y=>{n.push(`|      Error: Unable to collect workspace stats for folder ${v} (${y.toString()})`)}))}else n.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(a,n){const i=new Map;a.windows.forEach(r=>i.set(r.pid,`window [${r.id}] (${r.title})`)),a.pidToNames.forEach(({pid:r,name:o})=>i.set(r,o));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(a.mainPID,i,t,n,0),t.join(`
`)}n(a,n,i,t,r){const o=r===0;let v;o?v=t.pid===a?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?v=n.get(t.pid):v=`${"  ".repeat(r)} ${t.name}`;const y=process.platform==="win32"?t.mem:D.totalmem()*(t.mem/100);i.push(`${t.load.toFixed(0).padStart(5," ")}	${(y/l.$Hk.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(t.children)&&t.children.forEach(h=>this.n(a,n,i,h,r+1))}async getWorkspaceFileExtensions(a){const n=new Set;for(const{uri:i}of a.folders){const t=S.URI.revive(i);if(t.scheme!==A.Schemas.file)continue;const r=t.fsPath;try{(await c(r,["node_modules",".git"])).fileTypes.forEach(v=>n.add(v.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(a){for(const{uri:n}of a.folders){const i=S.URI.revive(n);if(i.scheme!==A.Schemas.file)continue;const t=i.fsPath;try{const r=await c(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),r.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};e.$Hr=k,e.$Hr=k=ye([Y(0,p.$dl),Y(1,$.$qj)],k)}),define(ae[108],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i8b=e.$h8b=void 0;class D{constructor(A){this.b=A}listen(A,I){throw new Error(`Event not found: ${I}`)}call(A,I,{eventName:R,data:S}){return this.b.forEach(d=>d.log(R,S)),Promise.resolve(null)}}e.$h8b=D;class F{constructor(A){this.b=A}log(A,I){return this.b.call("log",{eventName:A,data:I}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$i8b=F}),define(ae[45],ce([0,1,30,12,3,20,75,107,22]),function(te,e,D,F,j,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=void 0;class d{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$ko=d;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$lo=P,e.$mo=new P;class E{async publicLog(t,r,o){}async publicLogError(t,r,o){}}e.$no=E,e.$oo="telemetry",e.$po="extensionTelemetryLog",e.$qo={log:()=>null,flush:()=>Promise.resolve(null)};function b(i,t){return j.Event.debounce(t.onDidChangeConfiguration,(o,v)=>{const y=o?new Set([...o.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:y}},1e3,!0)(o=>{o.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.$ni)(o.source),configurationKeys:Array.from(o.affectedKeys)})})}e.$ro=b;function l(i,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!i.enableTelemetry)}e.$so=l;function $(i,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$to=$;function p(i){const t=i.getValue(S.$ll),r=i.getValue(S.$ml);if(i.getValue(S.$nl)===!1||r===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$uo=p;function w(i){const t={},r={},o={};f(i,o);for(let v in o){v=v.length>150?v.substr(v.length-149):v;const y=o[v];typeof y=="number"?r[v]=y:typeof y=="boolean"?r[v]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${y.length}`),t[v]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(t[v]=y)}return{properties:t,measurements:r}}e.$vo=w;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(i){if(!i)return"none";const t=(0,I.$Wk)(i);return c.has(t)?t:"other"}e.$wo=u;function f(i,t,r=0,o){if(i)for(const v of Object.getOwnPropertyNames(i)){const y=i[v],h=o?o+v:v;Array.isArray(y)?t[h]=(0,D.$an)(y):y instanceof Date?t[h]=y.toISOString():(0,F.$Af)(y)?r<2?f(y,t,r+1,h+"."):t[h]=(0,D.$an)(y):t[h]=y}}function m(i,t){const r=i.msftInternalDomains||[],o=t.getValue("telemetry.internalTesting");return(0,R.$jo)(r)||o}e.$xo=m;function k(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$yo=k;function s(i,t){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const o=[];for(const g of t)for(;;){const O=g.exec(i);if(!O)break;o.push([O.index,g.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(r="";;){const g=y.exec(i);if(!g)break;const O=o.some(([T,M])=>g.index<M&&T<y.lastIndex);!v.test(g[0])&&!O&&(r+=i.substring(h,g.index)+"<REDACTED: user-file-path>",h=y.lastIndex)}return h<i.length&&(r+=i.substr(h)),r}function a(i){if(!i)return i;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of t)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function n(i,t){return(0,D.$0m)(i,r=>{if(r instanceof d||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let o=r.replaceAll("%20"," ");o=s(o,t);for(const v of t)o=o.replace(v,"");return o=a(o),o}})}e.$zo=n}),define(ae[33],ce([0,1,27,29,44,5,10,7,37,45]),function(te,e,D,F,j,A,I,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0;function P(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,D.$We)(n.id,i.id)===0}e.$Ao=P;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(i){const t=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,t,r)}static parse(i){const t=E.exec(i);return t&&t[1]&&t[2]?new b({id:t[1]},t[2],t[4]||void 0):null}constructor(i,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Bo=b;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(n){const i=l.exec(n);return i&&i[1]?[w(i[1]),i[2]]:[w(n),void 0]}e.$Co=$;function p(n,i){return`${n}.${i}`}e.$Do=p;function w(n){return n.toLowerCase()}e.$Eo=w;function c(n,i){return w(p(n??j.$3l,i))}e.$Fo=c;function u(n,i){const t=[],r=o=>{for(const v of t)if(v.some(y=>P(i(y),i(o))))return v;return null};for(const o of n){const v=r(o);v?v.push(o):t.push([o])}return t}e.$Go=u;function f(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$Ho=f;function m(n){return{id:new d.$ko(n.identifier.id),name:new d.$ko(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Io=m,e.$Jo=new j.$7l("pprice.better-merge");function k(n,i){const t=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const o=r.shift();if(o&&t.every(v=>!P(v.identifier,{id:o}))){const v=n.filter(y=>P(y.identifier,{id:o}));v.length===1&&(t.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$Ko=k;async function s(n,i){if(!A.$l)return!1;let t;try{t=(await n.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){i.debug("Error while getting the os-release file.",(0,R.$9)(o))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(n,i){const t=await s(n,i),r=(0,F.$7n)(t?"alpine":A.$u,S.$dc);return i.debug("ComputeTargetPlatform:",r),r}e.$Lo=a}),define(ae[221],ce([0,1,18,2,19,10,11,25,6,3,16,5,37,33]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d6b=e.$c6b=void 0;let $=class extends F.$Rc{constructor(f,m){super(),this.b=f,this.c=m,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,k])=>this.a.set(k.configPath,k))}getConfigBasedTips(f){return this.f(f)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(f){const m=[];for(const[k,s]of this.a)if(!(s.configScheme&&s.configScheme!==f.scheme))try{const a=(await this.b.readFile((0,j.$vg)(f,k))).value.toString();for(const[n,i]of Object.entries(s.recommendations))(!i.contentPattern||new RegExp(i.contentPattern,"mig").test(a))&&m.push({extensionId:n,extensionName:i.name,configName:s.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})}catch{}return m}};e.$c6b=$,e.$c6b=$=ye([Y(0,I.$_j),Y(1,R.$qj)],$);const p="extensionTips/promptedExecutableTips",w="extensionTips/lastPromptedMediumImpExeTime";class c extends ${constructor(f,m,k,s,a,n,i,t){super(i,t),this.r=f,this.s=m,this.t=k,this.u=s,this.w=a,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,o])=>{const v=[],y=[],h=[];Object.entries(o.recommendations).forEach(([g,O])=>{O.important?o.important?v.push({extensionId:g,extensionName:O.name,isExtensionPack:!!O.isExtensionPack}):y.push({extensionId:g,extensionName:O.name,isExtensionPack:!!O.isExtensionPack}):h.push({extensionId:g,extensionName:O.name,isExtensionPack:!!O.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:v}),y.length&&this.h.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:y}),h.length&&this.j.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:h})}),(0,S.$Vg)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const f=await this.O(this.g),m=await this.O(this.h);return[...f,...m]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const f=await this.O(this.g),m=await this.O(this.h),k=await this.u.getInstalled();this.m=this.D(f,k),this.n=this.D(m,k)}D(f,m){const k=new Map;f.forEach(t=>k.set(t.extensionId.toLowerCase(),t));const{installed:s,uninstalled:a}=this.N([...k.keys()],m);for(const t of s){const r=k.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of a){const r=k.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),i=new Map;for(const t of a){const r=k.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let o=i.get(r.exeName);o||(o=[],i.set(r.exeName,o)),o.push(r)}}return i}F(){if(this.m.size===0)return;const[f,m]=[...this.m.entries()][0];this.H(m).then(k=>{switch(k){case"reacted":this.M(m[0].exeName,m);break;case"ignored":this.m.delete(f);break;case"incompatibleWindow":{const s=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.F()));break}case"toomany":{const s=this.B(new F.$Sc);s.value=(0,S.$Vg)(()=>{s.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const f=this.I(),m=Date.now()-f,k=7*24*60*60*1e3;if(m<k){const n=this.B(new F.$Sc);n.value=(0,S.$Vg)(()=>{n.dispose(),this.G()},k-m);return}const[s,a]=[...this.n.entries()][0];this.H(a).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(s),this.M(a[0].exeName,a);const i=this.B(new F.$Sc);i.value=(0,S.$Vg)(()=>{i.dispose(),this.G()},k);break}case"ignored":this.n.delete(s),this.G();break;case"incompatibleWindow":{const i=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.G()));break}case"toomany":{const i=this.B(new F.$Sc);i.value=(0,S.$Vg)(()=>{i.dispose(),this.G()},60*60*1e3);break}}})}async H(f){const m=await this.u.getInstalled(1),k=f.filter(s=>!s.whenNotInstalled||s.whenNotInstalled.every(a=>m.every(n=>!(0,l.$Ao)(n.identifier,{id:a})))).map(({extensionId:s})=>s.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:k,source:3,name:f[0].exeFriendlyName,searchValue:`@exe:"${f[0].exeName}"`})}I(){let f=this.w.getNumber(w,-1);return f||(f=Date.now(),this.J(f)),f}J(f){this.w.store(w,f,-1,1)}L(){return JSON.parse(this.w.get(p,-1,"{}"))}M(f,m){const k=this.L();k[f]=m.map(({extensionId:s})=>s.toLowerCase()),this.w.store(p,JSON.stringify(k),-1,0)}N(f,m){const k=[],s=[],a=m.reduce((n,i)=>(n.add(i.identifier.id.toLowerCase()),n),new Set);return f.forEach(n=>{a.has(n.toLowerCase())?k.push(n):s.push(n)}),{installed:k,uninstalled:s}}async O(f){const m=[],k=new Map;for(const s of f.keys()){const a=f.get(s);if(!a||!(0,D.$Kb)(a.recommendations))continue;const n=[];E.$j?a.windowsPath&&n.push(a.windowsPath.replace("%USERPROFILE%",()=>b.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>b.env.ProgramFiles).replace("%APPDATA%",()=>b.env.APPDATA).replace("%WINDIR%",()=>b.env.WINDIR)):(n.push((0,P.$ic)("/usr/local/bin",s)),n.push((0,P.$ic)("/usr/bin",s)),n.push((0,P.$ic)(this.r.fsPath,s)));for(const i of n){let t=k.get(i);if(t===void 0&&(t=await this.b.exists(A.URI.file(i)),k.set(i,t)),t)for(const{extensionId:r,extensionName:o,isExtensionPack:v,whenNotInstalled:y}of a.recommendations)m.push({extensionId:r,extensionName:o,isExtensionPack:v,exeName:s,exeFriendlyName:a.exeFriendlyName,windowsPath:a.windowsPath,whenNotInstalled:y})}}return m}}e.$d6b=c}),define(ae[222],ce([0,1,26,33]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HWb=void 0;async function j(A,I,R,S,d){try{const P=await A.getExtensionsControlManifest();if(!P.deprecated)return;const E=await A.getInstalled(1);for(const[b,l]of Object.entries(P.deprecated)){if(!l?.extension)continue;const{id:$,autoMigrate:p,preRelease:w}=l.extension;if(!p)continue;const c=E.find(f=>(0,F.$Ao)(f.identifier,{id:b}));if(!c)continue;const u=(await I.getExtensions([{id:$,preRelease:w}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!u){d.info(`Skipping migrating '${c.identifier.id}' extension because, the comaptible target '${$}' extension is not found`);continue}try{d.info(`Migrating '${c.identifier.id}' extension to '${$}' extension...`);const f=!S.getDisabledExtensions().some(k=>(0,F.$Ao)(k,c.identifier));await A.uninstall(c),d.info(`Uninstalled the unsupported extension '${c.identifier.id}'`);let m=E.find(k=>(0,F.$Ao)(k.identifier,{id:$}));(!m||!m.isPreReleaseVersion&&f)&&(m=await A.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:c.isMachineScoped,operation:4}),d.info(`Installed the pre-release extension '${m.identifier.id}'`),f||(await S.disableExtension(m.identifier),d.info(`Disabled the pre-release extension '${m.identifier.id}' because the unsupported extension '${c.identifier.id}' is disabled`)),p.storage&&(R.addToMigrationList((0,F.$Do)(c.manifest.publisher,c.manifest.name),(0,F.$Do)(m.manifest.publisher,m.manifest.name)),d.info("Added pre-release extension to the storage migration list"))),d.info(`Migrated '${c.identifier.id}' extension to '${$}' extension.`)}catch(f){d.error(f)}}}catch(P){d.error(P)}}e.$HWb=j}),define(ae[223],ce([0,1,3,2,34,33,44]),function(te,e,D,F,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;class R extends F.$Rc{constructor(d,P,E,b,l,$,p){super(),this.f=d,this.g=P,this.h=E,this.j=b,this.m=l,this.n=$,this.r=p,this.a=this.B(new D.$Nd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new F.$Zc),this.s().then(null,w=>p.error(w))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(d=>this.u(d.added))),this.B(this.j.onAddExtensions(d=>this.w(d))),this.B(this.j.onDidAddExtensions(d=>this.y(d))),this.B(this.j.onRemoveExtensions(d=>this.z(d))),this.B(this.j.onDidRemoveExtensions(d=>this.C(d))),this.B(this.n.onDidFilesChange(d=>this.D(d)))}async u(d){try{d.length&&await Promise.all(d.map(P=>(this.c.set(P.id,(0,F.$Oc)(this.n.watch(this.m.extUri.dirname(P.extensionsResource)),this.n.watch(P.extensionsResource))),this.G(P.extensionsResource))))}catch(P){throw this.r.error(P),P}}async w(d){for(const P of d.extensions)this.I(this.L(P.identifier,P.version),d.profileLocation)}async y(d){for(const P of d.extensions){const E=this.L(P.identifier,P.version);d.error?this.J(E,d.profileLocation):this.I(E,d.profileLocation)}}async z(d){for(const P of d.extensions)this.J(this.L(P.identifier,P.version),d.profileLocation)}async C(d){const P=[],E=[];for(const b of d.extensions){const l=this.L(b.identifier,b.version);d.error?this.I(l,d.profileLocation):(this.J(l,d.profileLocation),this.b.has(l)||(this.r.debug("Extension is removed from all profiles",b.identifier.id,b.version),E.push(this.f.scanInstalledExtensionAtLocation(b.location).then($=>{$?P.push($):this.r.info("Extension not found at the location",b.location.toString())},$=>this.r.error($)))))}try{await Promise.all(E),P.length&&await this.H(P)}catch(b){this.r.error(b)}}D(d){for(const P of this.h.profiles)d.contains(P.extensionsResource,0,1)&&this.F(P.extensionsResource)}async F(d){const P=[],E=[],b=await this.j.scanProfileExtensions(d),l=new Set,$=new Set;for(const[p,w]of this.b)w.has(d)&&$.add(p);for(const p of b){const w=this.L(p.identifier,p.version);l.add(w),$.has(w)||(P.push(p.identifier),this.I(w,d))}for(const p of $)if(!l.has(p)){const w=this.M(p);w&&(E.push(w.identifier),this.J(p,d))}(P.length||E.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:d}:void 0,removed:E.length?{extensions:E,profileLocation:d}:void 0})}async G(d){const P=await this.j.scanProfileExtensions(d);for(const E of P)this.I(this.L(E.identifier,E.version),d)}async H(d){d||(d=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),d.length&&await this.f.markAsUninstalled(...d)}I(d,P){let E=this.b.get(d);E||this.b.set(d,E=new j.$Ac(b=>this.m.extUri.getComparisonKey(b))),E.add(P)}J(d,P){const E=this.b.get(d);E&&E.delete(P),E?.size||this.b.delete(d)}L(d,P){return`${I.$7l.toKey(d.id)}@${P}`}M(d){const[P,E]=(0,A.$Co)(d);return E?{identifier:{id:P},version:E}:void 0}}e.$Ip=R}),define(ae[224],ce([0,1,43,45]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=void 0;async function j(A,I,R,S,d,P,E){const b={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${I.nameShort})`};if((0,F.$so)(I,R)&&(0,F.$uo)(S)===3){const l=await(0,D.$ap)(R,d,P);b["X-Market-User-Id"]=l,b["VSCode-SessionId"]=E.machineId||l}return b}e.$bp=j}),define(ae[225],ce([0,1,71,18,6,2,23,16,31,14,29,33,8,73,10]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;let p=class extends l.$Uq{constructor(f,m,k,s){super(k),this.h=f,this.j=s,this.g=this.B(new w(m,s)),this.h.registerParticipant({postInstall:async a=>this.m(a),postUninstall:async a=>this.n(a)})}async getBuiltInExtensionTranslationsUri(f,m){const s=(await this.g.getLanguagePacks())[m];if(!s){this.j.warn(`No language pack found for ${m}`);return}const a=s.translations[f];return a?$.URI.file(a):void 0}async getInstalledLanguages(){const f=await this.g.getLanguagePacks(),m=Object.keys(f).map(k=>{const s=f[k];return{...this.f(k,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return m.push(this.f("en","English")),m.sort((k,s)=>k.label.localeCompare(s.label)),m}async m(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",f.identifier.id),await this.update())}async n(f){const m=await this.g.getLanguagePacks();Object.keys(m).some(k=>m[k]&&m[k].extensions.some(s=>(0,E.$Ao)(s.extensionIdentifier,f.identifier)))&&(this.j.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,m]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),k=await this.g.update(m);return!(0,F.$tb)(Object.keys(f),Object.keys(k))}};e.$Vq=p,e.$Vq=p=ye([Y(0,P.$ao),Y(1,d.$Yh),Y(2,P.$$n),Y(3,b.$$i)],p);let w=class extends A.$Rc{constructor(f,m){super(),this.j=m,this.c={},this.f=(0,R.$ic)(f.userDataPath,"languagepacks.json"),this.g=new j.$2g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(f){return this.s(m=>{Object.keys(m).forEach(k=>delete m[k]),this.m(m,...f)}).then(()=>this.c)}m(f,...m){for(const k of m)k&&k.manifest&&k.manifest.contributes&&k.manifest.contributes.localizations&&k.manifest.contributes.localizations.length&&this.n(f,k);Object.keys(f).forEach(k=>this.r(f[k]))}n(f,m){const k=m.identifier,s=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const a of s)if(m.location.scheme===I.Schemas.file&&c(a)){let n=f[a.languageId];n||(n={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},f[a.languageId]=n);const i=n.extensions.filter(t=>(0,E.$Ao)(t.extensionIdentifier,k))[0];i?i.version=m.manifest.version:n.extensions.push({extensionIdentifier:k,version:m.manifest.version});for(const t of a.translations)n.translations[t.id]=(0,R.$ic)(m.location.fsPath,t.path)}}r(f){if(f){const m=(0,D.createHash)("md5");for(const k of f.extensions)m.update(k.extensionIdentifier.uuid||k.extensionIdentifier.id).update(k.version);f.hash=m.digest("hex")}}s(f=()=>null){return this.g.queue(()=>{let m=null;return S.Promises.readFile(this.f,"utf8").then(void 0,k=>k.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(k)).then(k=>{try{return JSON.parse(k)}catch{return{}}}).then(k=>(m=f(k),k)).then(k=>{for(const a of Object.keys(k))k[a]||delete k[a];this.c=k,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),S.Promises.writeFile(this.f,s)}).then(()=>m,k=>this.j.error(k))})}};w=ye([Y(0,d.$Yh),Y(1,b.$$i)],w);function c(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const f of u.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(ae[226],ce([0,1,141,7,30,45]),function(te,e,D,F,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=void 0;const I="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function S(P,E,b){const l=await(0,D.$IC)("@microsoft/1ds-core-js","dist/ms.core.js"),$=await(0,D.$IC)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new l.AppInsightsCore,w=new $.PostChannel,c={instrumentationKey:P,endpointUrl:I,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(b){c.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:b};c.extensionConfig[w.identifier]=u}return p.initialize(c,[]),p.addTelemetryInitializer(u=>{E&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),p}class d{constructor(E,b,l,$,p){this.e=E,this.f=b,this.g=l,this.h=p,this.c=I,this.d=R,this.g||(this.g={}),typeof $=="function"?this.a=$():this.a=$,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then(b=>{E(b)},b=>{(0,F.$Z)(b),console.error(b)})}}log(E,b){if(!this.a)return;b=(0,j.$$m)(b,this.g),b=(0,A.$vo)(b);const l=this.f+"/"+E;try{this.i($=>{$.pluginVersionString=b?.properties.version??"Unknown",$.track({name:l,baseData:{name:l,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(b=>{b.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$EN=d}),define(ae[109],ce([0,1,2,166,14,8,25,45]),function(te,e,D,F,j,A,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D5b=void 0;let S=class extends D.$Rc{constructor(P,E,b,l,$=""){super(),this.b=$;const p=E.getLogger(R.$oo);if(p)this.a=this.B(p);else{const c=(0,R.$to)(l,b)?" (Not Sent)":"",u=()=>(0,R.$so)(l,b)&&P.getLevel()===A.LogLevel.Trace;this.a=this.B(E.createLogger(R.$oo,{name:(0,F.localize)(0,null,c),hidden:!u()})),this.B(P.onDidChangeLogLevel(()=>E.setVisibility(R.$oo,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,E){this.a.trace(`${this.b}telemetry/${P}`,(0,R.$vo)(E))}};e.$D5b=S,e.$D5b=S=ye([Y(0,A.$$i),Y(1,A.$_i),Y(2,j.$Xh),Y(3,I.$qj)],S)}),define(ae[110],ce([0,1,2,30,5,27,167,20,50,102,25,41,22,45]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;let $=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,u,f){this.k=u,this.l=f,this.d={},this.i=new D.$Qc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,A.$Fe)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Fe)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration(b.$ll)||m.affectsConfiguration(b.$nl)||m.affectsConfiguration(b.$ml))&&this.m()}))}setExperimentProperty(c,u){this.d[c]=u}m(){let c=(0,l.$uo)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const f=u.usage?3:u.error?2:0;c=Math.min(c,f)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,u,f){this.g<u||(f=(0,F.$$m)(f,this.d),f=(0,l.$zo)(f,this.j),f=(0,F.$$m)(f,this.c),this.b.forEach(m=>m.log(c,f)))}publicLog(c,u){this.n(c,3,u)}publicLog2(c,u){this.publicLog(c,u)}publicLogError(c,u){this.h&&this.n(c,2,u)}publicLogError2(c,u){this.publicLogError(c,u)}};e.$2q=$,e.$2q=$=ye([Y(1,R.$ki),Y(2,P.$qj)],$);function p(){const w=(0,I.localize)(0,null,d.default.nameLong),c=d.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=j.$p?"":(0,I.localize)(3,null),f=(0,I.localize)(4,null),m=(0,I.localize)(5,null),k=(0,I.localize)(6,null),s=(0,I.localize)(7,null),a=`
|       | ${f} | ${m} | ${k} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,I.localize)(8,null);return`
${w} ${c} ${u}

&nbsp;

${s}
${a}

&nbsp;

${n}
`}E.$hn.as(S.$mn.Configuration).registerConfiguration({id:b.$kl,order:1,type:"object",title:(0,I.localize)(9,null),properties:{[b.$ll]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$hn.as(S.$mn.Configuration).registerConfiguration({id:b.$kl,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[b.$nl]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,I.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,I.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${b.$ll}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[227],ce([0,1,15,26,271,226]),function(te,e,D,F,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=void 0;async function I(P,E){const b=await E.request(P,F.CancellationToken.None),l=(await(0,D.$ne)(b.stream)).toString(),$=b.res.statusCode??200;return{headers:b.res.headers,statusCode:$,responseData:l}}async function R(P){const E={method:P.type,headers:P.headers};return new Promise((l,$)=>{const p=j.request(P.url??"",E,w=>{w.on("data",function(c){l({headers:w.headers,statusCode:w.statusCode??200,responseData:c.toString()})}),w.on("error",function(c){$(c)})});p.write(P.data,w=>{w&&$(w)}),p.end()})}async function S(P,E,b){const l=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),$={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:l};try{const p=P?await I($,P):await R($);b(p.statusCode,p.headers,p.responseData)}catch{b(0,{})}}class d extends A.$EN{constructor(E,b,l,$,p){const w={sendPOST:(c,u)=>{S(E,c,u)}};super(b,l,$,p,w)}}e.$FN=d}),define(ae[228],ce([0,1,23,93,20,14,8,25,22,108,109,110]),function(te,e,D,F,j,A,I,R,S,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A9b=void 0;let b=class{constructor($,p,w,c,u,f){this.b=$,this.c=p,this.d=w,this.e=c,this.f=u,this.g=f,this.a=new Map}h($){if(!this.a.has($.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.c.machineId,p["common.vscodesessionid"]=this.c.sessionId;const w=[$.id,JSON.stringify(p),$.aiKey],u=new F.$4p(D.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:w,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),f=[new d.$i8b(u),new P.$D5b(this.d,this.e,this.f,this.g,`[${$.id}] `)];this.a.set($.id,new E.$2q({appenders:f,sendErrorTelemetry:$.sendErrorTelemetry},this.b,this.g))}return this.a.get($.id)}publicLog($,p,w){this.h($).publicLog(p,w)}publicLogError($,p,w){this.h($).publicLogError(p,w)}};e.$A9b=b,e.$A9b=b=ye([Y(0,j.$ki),Y(1,S.$dl),Y(2,I.$$i),Y(3,I.$_i),Y(4,A.$Xh),Y(5,R.$qj)],b)}),define(ae[77],ce([0,1,3,20,4,8]),function(te,e,D,F,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.$cv=e.$bv=e.ProvidedOnAutoForward=e.$av=e.TunnelPrivacyId=e.TunnelProtocol=e.$_u=e.$$u=void 0,e.$$u=(0,j.$Qh)("tunnelService"),e.$_u=(0,j.$Qh)("sharedTunnelsService");var I;(function(w){w.Http="http",w.Https="https"})(I||(e.TunnelProtocol=I={}));var R;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(R||(e.TunnelPrivacyId=R={}));function S(w){return!!w.forwardPort}e.$av=S;var d;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function P(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(c)return{address:c[1],port:+c[2]}}e.$bv=P,e.$cv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(w){return e.$cv.indexOf(w)>=0}e.$dv=E,e.$ev=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(w){return e.$ev.indexOf(w)>=0}e.$fv=b;function l(w,c,u,f){if(u===1)return!1;if(u===2&&b(c)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(m?.length===4&&parseInt(m[1])>=18)return!1}return w<1024}e.$gv=l;class ${constructor(c,u,f){this.remoteAddress=c,this.localAddress=u,this.b=f,this.a=new D.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$hv=$;let p=class{constructor(c,u){this.j=c,this.k=u,this.a=new D.$Nd,this.onTunnelOpened=this.a.event,this.b=new D.$Nd,this.onTunnelClosed=this.b.event,this.c=new D.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const c=this.k.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.f=c,c?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.g=c.elevation,this.h=c.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const c=[],u=Array.from(this.e.values());for(const f of u){const m=Array.from(f.values());for(const k of m){const s=await k.value;s&&typeof s!="string"&&c.push(s)}}return c}async dispose(){for(const c of this.e.values()){for(const{value:u}of c.values())await u.then(f=>typeof f!="string"?f?.dispose():void 0);c.clear()}this.e.clear()}setEnvironmentTunnel(c,u,f,m,k){this.p(c,u,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:u,localAddress:f,privacy:m,protocol:k,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,u){(b(c)||E(c))&&(c=e.$cv[0]);const f=this.r(c,u);if(f)return++f.refcount,f.value}openTunnel(c,u,f,m,k,s=!1,a,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${f} on local port ${k}.`);const i=this.f??c;if(!i)return;if(u||(u="localhost"),m||(m=this.l),this.f&&this.i.has(f)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.s(i,u,f,m,k,s,a,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(u,f),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(u,f);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.n(r);return(r.tunnelRemoteHost!==u||r.tunnelRemotePort!==f)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&r.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(o),o}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}n(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const u=this.e.get(c.tunnelRemoteHost);if(u){const f=u.get(c.tunnelRemotePort);f&&(f.refcount--,await this.o(c.tunnelRemoteHost,c.tunnelRemotePort,f))}}}}async o(c,u,f){if(f.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${u}.`);const m=f.value.then(async k=>{k&&typeof k!="string"&&(await k.dispose(!0),this.b.fire({host:k.tunnelRemoteHost,port:k.tunnelRemotePort}))});return this.e.has(c)&&this.e.get(c).delete(u),m}}async closeTunnel(c,u){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${u} `);const f=this.e.get(c);if(f&&f.has(u)){const m=f.get(u);m.refcount=0,await this.o(c,u,m)}}p(c,u,f){this.e.has(c)||this.e.set(c,new Map),this.e.get(c).set(u,{refcount:1,value:f})}async q(c,u){const f=this.e.get(c);if(f){const m=f.get(u),k=m?await m.value:void 0;(!k||typeof k=="string")&&f.delete(u),f.size===0&&this.e.delete(c)}}r(c,u){const f=[c];E(c)?(f.push(...e.$cv),f.push(...e.$ev)):b(c)&&f.push(...e.$ev);const m=f.map(k=>this.e.get(k));for(const k of m){const s=k?.get(u);if(s)return s}}canTunnel(c){return!!P(c)}t(c,u,f,m,k,s,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${f} on local port ${m}.`);const n=f;this.i.add(n);const i=m===void 0?f:m,t={elevationRequired:k?this.isPortPrivileged(i):!1},r={remoteAddress:{host:u,port:f},localAddressPort:m,privacy:s,public:s?s!==R.Private:void 0,protocol:a},o=c.forwardPort(r,t);return o?(this.p(u,f,o),o.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),o}};e.$iv=p,e.$iv=p=ye([Y(0,A.$$i),Y(1,F.$ki)],p)}),define(ae[229],ce([0,1,8,77,2,7,6]),function(te,e,D,F,j,A,I){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$N9b=void 0;class S extends j.$Rc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new I.$dh),this.b.p)}setAddress(E){this.a=E,this.b&&(this.b.complete(E),this.b=null)}setTunnel(E){this.B(E)}}let d=class extends j.$Rc{static{R=this}static{this.a=0}constructor(E,b){super(),this.f=E,this.g=b,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(E,b,l,$,p,w,c){const u=new S,f=await Promise.resolve(this.f.openTunnel(E,u,l,$,p,w,c));if(!f||typeof f=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${l}:${$} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(b))throw this.c.delete(b),u.dispose(),await f.dispose(),(0,A.$5)();return u.setTunnel(f),this.b.set(b,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${f.localAddress} (local) to ${l}:${$} (remote).`),{tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress}}async setAddress(E,b){const l=this.b.get(E);l&&l.setAddress(b)}async destroyTunnel(E){const b=this.b.get(E);if(b){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this.b.delete(E),await b.dispose();return}this.c.add(E)}};e.$N9b=d,e.$N9b=d=R=ye([Y(0,F.$_u),Y(1,D.$$i)],d)}),define(ae[28],ce([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=void 0,e.$Jk=(0,D.$Qh)("IUriIdentityService")}),define(ae[230],ce([0,1,28,184,11,19,127,3,2]),function(te,e,D,F,j,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;class d{static{this._clock=0}constructor(b){this.uri=b,this.time=d._clock++}touch(){return this.time=d._clock++,this}}let P=class{constructor(b){this.g=b,this.c=new S.$Qc,this.f=2**16;const l=new Map,$=p=>{let w=l.get(p.scheme);return w===void 0&&(w=b.hasProvider(p)&&!this.g.hasCapability(p,1024),l.set(p.scheme,w)),w};this.c.add(R.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(p=>{l.delete(p.scheme)})),this.extUri=new A.$kg($),this.d=new I.$zr((p,w)=>this.extUri.compare(p,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,A.$wg)(b));const l=this.d.get(b);return l?l.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new d(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort(($,p)=>$[1].time<p[1].time?1:$[1].time>p[1].time?-1:0);d._clock=0,this.d.clear();const l=this.f*.5;for(let $=0;$<l;$++)this.d.set(b[$][0],b[$][1].touch())}};e.$Ar=P,e.$Ar=P=ye([Y(0,j.$_j)],P),(0,F.$xr)(D.$Jk,P,1)}),define(ae[231],ce([0,1,3,2,11,47,34]),function(te,e,D,F,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$88b=void 0;class R extends F.$Rc{constructor(d,P,E,b,l,$){super(),this.f=d,this.g=P,this.h=E,this.j=b,this.m=l,this.n=$,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new D.$Nd),this.onDidChangeFile=this.a.event,this.b=A.$Wh.forUris(()=>!(this.capabilities&1024)),this.c=new I.$Ac(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(b.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const d of this.j.profiles)this.c.add(d.settingsResource),this.c.add(d.keybindingsResource),this.c.add(d.tasksResource),this.c.add(d.extensionsResource)}open(d,P){return this.g.open(this.t(d),P)}close(d){return this.g.close(d)}read(d,P,E,b,l){return this.g.read(d,P,E,b,l)}write(d,P,E,b,l){return this.g.write(d,P,E,b,l)}watch(d,P){this.b.set(d,d);const E=this.g.watch(this.t(d),P);return(0,F.$Pc)(()=>{this.b.delete(d),E.dispose()})}stat(d){return this.g.stat(this.t(d))}mkdir(d){return this.g.mkdir(this.t(d))}rename(d,P,E){return this.g.rename(this.t(d),this.t(P),E)}readFile(d,P){return this.g.readFile(this.t(d),P)}readFileStream(d,P,E){return this.g.readFileStream(this.t(d),P,E)}readdir(d){return this.g.readdir(this.t(d))}enforceAtomicReadFile(d){return this.c.has(d)}writeFile(d,P,E){return this.g.writeFile(this.t(d),P,E)}enforceAtomicWriteFile(d){return this.c.has(d)?{postfix:".vsctmp"}:!1}delete(d,P){return this.g.delete(this.t(d),P)}copy(d,P,E){if((0,j.$dk)(this.g))return this.g.copy(this.t(d),this.t(P),E);throw new Error("copy not supported")}cloneFile(d,P){if((0,j.$ek)(this.g))return this.g.cloneFile(this.t(d),this.t(P));throw new Error("clone not supported")}s(d){const P=[];for(const E of d){if(E.resource.scheme!==this.f)continue;const b=this.u(E.resource);this.b.findSubstr(b)&&P.push({resource:b,type:E.type,cId:E.cId})}P.length&&(this.n.debug("User data changed"),this.a.fire(P))}t(d){return d.with({scheme:this.f})}u(d){return d.with({scheme:this.h})}}e.$88b=R}),define(ae[78],ce([0,1,86]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uDb=e.$tDb=e.edit=void 0;function F(I,R,S,d){const P=(0,D.$mT)(I,R,S,d)[0];return P&&(I=I.substring(0,P.offset)+P.content+I.substring(P.offset+P.length)),I}e.edit=F;function j(I,R,S){let d=S;for(;d>=0;){if(I.charAt(d)===R.charAt(R.length-1)&&R.length===1)return d+1;if(d--,R.length===2&&d>=0&&I.charAt(d)===R.charAt(0))return d+2}return 0}e.$tDb=j;function A(I,R,S){let d=S;for(;d>=0;)if(I.charAt(d)===R.charAt(R.length-1)&&R.length===1||(d++,R.length===2&&d>=0&&I.charAt(d)===R.charAt(1)))return d;return I.length-1}e.$uDb=A}),define(ae[232],ce([0,1,30,54,12]),function(te,e,D,F,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k4b=void 0;function A(l,$,p,w,c,u){const f=[],m=[],k=[];if(!$){const z=l.filter(({identifier:Z})=>c.every(X=>X.toLowerCase()!==Z.id.toLowerCase()));return{local:{added:f,removed:m,updated:k},remote:z.length>0?{added:z,updated:[],removed:[],all:z}:null}}l=l.map(E),$=$.map(E),p=p?p.map(E):null;const s=new Map,a=z=>{z.uuid&&s.set(z.id.toLowerCase(),z.uuid)};l.forEach(({identifier:z})=>a(z)),$.forEach(({identifier:z})=>a(z)),p?.forEach(({identifier:z})=>a(z)),w?.forEach(({identifier:z})=>a(z)),u?.forEach(z=>a(z));const n=z=>{const Z=z.identifier.uuid||s.get(z.identifier.id.toLowerCase());return Z?`uuid:${Z}`:`id:${z.identifier.id.toLowerCase()}`},i=(z,Z)=>(z.set(n(Z),Z),z),t=l.reduce(i,new Map),r=$.reduce(i,new Map),o=$.reduce((z,Z)=>i(z,(0,D.$8m)(Z)),new Map),v=p?p.reduce(i,new Map):null,y=w.reduce(i,new Map),h=c.reduce((z,Z)=>{const X=s.get(Z.toLowerCase());return z.add(X?`uuid:${X}`:`id:${Z.toLowerCase()}`)},new Set),g=u?u.reduce((z,{id:Z,uuid:X})=>(X=X??s.get(Z.toLowerCase()),z.add(X?`uuid:${X}`:`id:${Z.toLowerCase()}`)),new Set):null,O=I(t,r,h,!1);if(O.added.size>0||O.removed.size>0||O.updated.size>0){const z=I(v,t,h,!1),Z=I(v,r,h,!0),X=(x,H,K,J)=>{let V,ee,ne;return H.installed?(V=J.pinned,ne=J.preRelease,V&&(ee=J.version)):(V=K.pinned,ne=K.preRelease,V&&(ee=K.version)),V===void 0&&(V=H.pinned,V&&(ee=H.version)),ne===void 0&&(ne=H.preRelease),{...J,installed:H.installed||K.installed,pinned:V,preRelease:ne,version:ee??(K.version&&(!H.installed||F.gt(K.version,H.version))?K.version:H.version),state:S(H,K,v?.get(x))}};for(const x of Z.removed.values()){const H=t.get(x);if(!H)continue;const K=(0,j.$Jf)(v?.get(x)),J=g&&!g.has(x)&&K.installed;H.installed&&J?m.push(H.identifier):o.set(x,H)}for(const x of Z.added.values()){const H=(0,j.$Jf)(r.get(x)),K=t.get(x);if(K){if(O.updated.has(x)){const J=X(x,K,H,H);R(K,H,!1,!1)||k.push(b(J,x)),o.set(x,J)}}else H.installed&&f.push(b(H,x))}for(const x of Z.updated.values()){const H=(0,j.$Jf)(r.get(x)),K=(0,j.$Jf)(v?.get(x)),J=t.get(x);if(J)if(g&&!g.has(x)&&K.installed&&J.installed&&!H.installed)m.push(J.identifier);else{const ee=X(x,J,H,H);k.push(b(ee,x)),o.set(x,ee)}else H.installed&&f.push(b(H,x))}for(const x of z.added.values())Z.added.has(x)||o.set(x,(0,j.$Jf)(t.get(x)));for(const x of z.updated.values()){if(Z.removed.has(x)||Z.updated.has(x))continue;const H=(0,j.$Jf)(t.get(x)),K=(0,j.$Jf)(r.get(x));o.set(x,X(x,H,K,H))}for(const x of z.removed.values())Z.updated.has(x)||Z.removed.has(x)||y.has(x)||(0,j.$Jf)(r.get(x)).installed&&g&&(g.has(x)||!(0,j.$Jf)(v?.get(x)).installed||o.delete(x))}const T=[],M=I(r,o,new Set,!0),U=M.added.size>0||M.updated.size>0||M.removed.size>0;return U&&o.forEach((z,Z)=>T.push(b(z,Z))),{local:{added:f,removed:m,updated:k},remote:U?{added:[...M.added].map(z=>o.get(z)),updated:[...M.updated].map(z=>o.get(z)),removed:[...M.removed].map(z=>r.get(z)),all:T}:null}}e.$k4b=A;function I(l,$,p,w){const c=l?[...l.keys()].filter(s=>!p.has(s)):[],u=[...$.keys()].filter(s=>!p.has(s)),f=u.filter(s=>!c.includes(s)).reduce((s,a)=>(s.add(a),s),new Set),m=c.filter(s=>!u.includes(s)).reduce((s,a)=>(s.add(a),s),new Set),k=new Set;for(const s of c){if(m.has(s))continue;const a=l.get(s),n=$.get(s);(!n||!R(a,n,w,!0))&&k.add(s)}return{added:f,removed:m,updated:k}}function R(l,$,p,w){return!(l.disabled!==$.disabled||!!l.isApplicationScoped!=!!$.isApplicationScoped||w&&l.installed!==$.installed||l.installed&&$.installed&&(l.preRelease!==$.preRelease||l.pinned!==$.pinned||$.pinned&&l.version!==$.version)||!P(l.state,$.state)||p&&l.version!==$.version)}function S(l,$,p){const w=l.state,c=$.state,u=p?.state;if(!$.version||w&&F.gt(l.version,$.version))return w;if(c&&F.gt($.version,l.version)||!w)return c;if(!c)return w;const f=(0,D.$8m)(w),m=u?d(u,c):{added:Object.keys(c).reduce((s,a)=>(s.add(a),s),new Set),removed:new Set,updated:new Set},k=u?d(u,w):{added:Object.keys(w).reduce((s,a)=>(s.add(a),s),new Set),removed:new Set,updated:new Set};for(const s of[...m.added.values(),...m.updated.values()])f[s]=c[s];for(const s of m.removed.values())k.updated.has(s)||delete f[s];return f}function d(l,$){const p=Object.keys(l),w=Object.keys($),c=w.filter(m=>!p.includes(m)).reduce((m,k)=>(m.add(k),m),new Set),u=p.filter(m=>!w.includes(m)).reduce((m,k)=>(m.add(k),m),new Set),f=new Set;for(const m of p){if(u.has(m))continue;const k=l[m],s=$[m];(0,D.$_m)(k,s)||f.add(m)}return{added:c,removed:u,updated:f}}function P(l={},$={}){const{added:p,removed:w,updated:c}=d(l,$);return p.size===0&&w.size===0&&c.size===0}function E(l){return{...l,disabled:!!l.disabled,installed:!!l.installed}}function b(l,$){const p={...l,identifier:{id:l.identifier.id,uuid:$.startsWith("uuid:")?$.substring(5):void 0},preRelease:!!l.preRelease,pinned:!!l.pinned};return l.disabled||delete p.disabled,l.installed||delete p.installed,l.state||delete p.state,l.isApplicationScoped||delete p.isApplicationScoped,p}}),define(ae[111],ce([0,1,18,20,4]),function(te,e,D,F,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rFb=e.$qFb=void 0,e.$qFb=(0,j.$Qh)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,S){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return d=d.filter(P=>P!==R&&P!==`-${R}`),S&&d.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}updateSynchronizedExtensions(R,S){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return d=d.filter(P=>P!==R&&P!==`-${R}`),S&&d.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}getIgnoredExtensions(R){const S=R.filter(b=>b.isMachineScoped).map(b=>b.identifier.id.toLowerCase()),d=this.b().map(b=>b.toLowerCase()),P=[],E=[];if(Array.isArray(d))for(const b of d)b.startsWith("-")?E.push(b.substring(1)):P.push(b);return(0,D.$Lb)([...S,...P].filter(b=>!E.includes(b)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};e.$rFb=A,e.$rFb=A=ye([Y(0,F.$ki)],A)}),define(ae[233],ce([0,1,18,35,30,94,78]),function(te,e,D,F,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q4b=void 0;function R(m){return(0,F.$Xm)(m)||[]}async function S(m,k,s,a,n){const i=R(m),t=R(k),r=s?R(s):null,o=[...i,...t,...r||[]].map(X=>X.key),v=await n.resolveUserBindings(o),y=P(i,t,r,v);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:m,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:k,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:m,hasChanges:!0,hasConflicts:!1};const h=b(i),g=b(t),O=r?b(r):null,T=$(h,g,v),M=O?$(O,h,v):{added:[...h.keys()].reduce((X,x)=>(X.add(x),X),new Set),removed:new Set,updated:new Set},U=O?$(O,g,v):{added:[...g.keys()].reduce((X,x)=>(X.add(x),X),new Set),removed:new Set,updated:new Set},z=d(T,M,U);let Z=m;for(const X of z.removed.values())z.conflicts.has(X)||(Z=u(Z,X,a));for(const X of z.added.values()){if(z.conflicts.has(X))continue;const x=g.get(X);if(x.some(H=>H.command!==`-${X}`&&y.conflicts.has(v[H.key]))){z.conflicts.add(X);continue}Z=c(Z,x,a)}for(const X of z.updated.values()){if(z.conflicts.has(X))continue;const x=g.get(X);if(x.some(H=>H.command!==`-${X}`&&y.conflicts.has(v[H.key]))){z.conflicts.add(X);continue}Z=f(Z,X,x,a)}return{mergeContent:Z,hasChanges:!0,hasConflicts:z.conflicts.size>0}}e.$q4b=S;function d(m,k,s){const a=new Set,n=new Set,i=new Set,t=new Set;for(const r of k.removed.values())s.updated.has(r)&&t.add(r);for(const r of s.removed.values())t.has(r)||(k.updated.has(r)?t.add(r):n.add(r));for(const r of k.added.values())t.has(r)||s.added.has(r)&&m.updated.has(r)&&t.add(r);for(const r of s.added.values())t.has(r)||(k.added.has(r)?m.updated.has(r)&&t.add(r):a.add(r));for(const r of k.updated.values())t.has(r)||s.updated.has(r)&&m.updated.has(r)&&t.add(r);for(const r of s.updated.values())t.has(r)||(k.updated.has(r)?m.updated.has(r)&&t.add(r):i.add(r));return{added:a,removed:n,updated:i,conflicts:t}}function P(m,k,s,a){const n=new Set,i=E(m,a),t=E(k,a),r=s?E(s,a):null,o=l(i,t);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const v=r?l(r,i):{added:[...i.keys()].reduce((M,U)=>(M.add(U),M),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const y=r?l(r,t):{added:[...t.keys()].reduce((M,U)=>(M.add(U),M),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:h,removed:g,updated:O,conflicts:T}=d(o,v,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:h,removed:g,updated:O,conflicts:T}}function E(m,k){const s=new Map;for(const a of m){const n=k[a.key];let i=s.get(n);i||(i=[],s.set(n,i)),i.push(a)}return s}function b(m){const k=new Map;for(const s of m){const a=s.command[0]==="-"?s.command.substring(1):s.command;let n=k.get(a);n||(n=[],k.set(a,n)),n.push(s)}return k}function l(m,k){const s=[...m.keys()],a=[...k.keys()],n=a.filter(r=>!s.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),i=s.filter(r=>!a.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),t=new Set;for(const r of s){if(i.has(r))continue;const o=m.get(r).map(y=>({...y,key:r})),v=k.get(r).map(y=>({...y,key:r}));(0,D.$tb)(o,v,(y,h)=>w(y,h))||t.add(r)}return{added:n,removed:i,updated:t}}function $(m,k,s){const a=[...m.keys()],n=[...k.keys()],i=n.filter(o=>!a.includes(o)).reduce((o,v)=>(o.add(v),o),new Set),t=a.filter(o=>!n.includes(o)).reduce((o,v)=>(o.add(v),o),new Set),r=new Set;for(const o of a){if(t.has(o))continue;const v=m.get(o).map(h=>({...h,key:s[h.key]})),y=k.get(o).map(h=>({...h,key:s[h.key]}));p(v,y)||r.add(o)}return{added:i,removed:t,updated:r}}function p(m,k){return!(!(0,D.$tb)(m.filter(({command:s})=>s[0]!=="-"),k.filter(({command:s})=>s[0]!=="-"),(s,a)=>w(s,a))||!(0,D.$tb)(m.filter(({command:s})=>s[0]==="-"),k.filter(({command:s})=>s[0]==="-"),(s,a)=>w(s,a)))}function w(m,k){if(m.command!==k.command||m.key!==k.key)return!1;const s=A.$Oi.deserialize(m.when),a=A.$Oi.deserialize(k.when);return!(s&&!a||!s&&a||s&&a&&!s.equals(a)||!j.$_m(m.args,k.args))}function c(m,k,s){for(const a of k)m=I.edit(m,[-1],a,s);return m}function u(m,k,s){const a=R(m);for(let n=a.length-1;n>=0;n--)(a[n].command===k||a[n].command===`-${k}`)&&(m=I.edit(m,[n],void 0,s));return m}function f(m,k,s,a){const n=R(m),i=n.findIndex(t=>t.command===k||t.command===`-${k}`);for(let t=n.length-1;t>=0;t--)(n[t].command===k||n[t].command===`-${k}`)&&(m=I.edit(m,[t],void 0,a));for(let t=s.length-1;t>=0;t--)m=I.edit(m,[i],s[t],a);return m}}),define(ae[234],ce([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y4b=e.$x4b=void 0;function D(A,I,R){const S={},d={},P=new Set;if(!I)return{local:{added:S,updated:d,removed:[...P.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const E=F(A,I);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:S,updated:d,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const b=F(R,A),l=F(R,I),$={},p={},w=new Set,c=new Set;for(const u of b.removed.values())l.updated.has(u)?S[u]=I[u]:w.add(u);for(const u of l.removed.values())c.has(u)||(b.updated.has(u)?c.add(u):P.add(u));for(const u of b.updated.values())c.has(u)||(l.updated.has(u)?E.updated.has(u)&&c.add(u):p[u]=A[u]);for(const u of l.updated.values())c.has(u)||(b.updated.has(u)?E.updated.has(u)&&c.add(u):A[u]!==void 0&&(d[u]=I[u]));for(const u of b.added.values())c.has(u)||(l.added.has(u)?E.updated.has(u)&&c.add(u):$[u]=A[u]);for(const u of l.added.values())c.has(u)||(b.added.has(u)?E.updated.has(u)&&c.add(u):S[u]=I[u]);return{local:{added:S,removed:[...P.values()],updated:d},remote:{added:$,removed:[...w.values()],updated:p},conflicts:[...c.values()]}}e.$x4b=D;function F(A,I){const R=A?Object.keys(A):[],S=I?Object.keys(I):[],d=S.filter(b=>!R.includes(b)).reduce((b,l)=>(b.add(l),b),new Set),P=R.filter(b=>!S.includes(b)).reduce((b,l)=>(b.add(l),b),new Set),E=new Set;for(const b of R){if(P.has(b))continue;const l=A[b],$=I[b];l!==$&&E.add(b)}return{added:d,removed:P,updated:E}}function j(A,I){const{added:R,removed:S,updated:d}=F(A,I);return R.size===0&&S.size===0&&d.size===0}e.$y4b=j}),define(ae[235],ce([0,1,30]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g6b=void 0;function F(A,I,R,S){const d={added:[],removed:[],updated:[]};let P={added:[],removed:[],updated:[]};if(!I){const b=A.filter(({id:l})=>!S.includes(l));return b.length?P.added=b:P=null,{local:d,remote:P}}const E=j(A,I,S);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const b=j(R,A,S),l=j(R,I,S);for(const $ of l.removed){const p=A.find(w=>w.id===$);p&&d.removed.push(p)}for(const $ of l.added){const p=I.find(w=>w.id===$);b.added.includes($)?E.updated.includes($)&&d.updated.push(p):d.added.push(p)}for(const $ of l.updated)d.updated.push(I.find(p=>p.id===$));for(const $ of b.added)l.added.includes($)||P.added.push(A.find(p=>p.id===$));for(const $ of b.updated)l.removed.includes($)||l.updated.includes($)||P.updated.push(A.find(p=>p.id===$));for(const $ of b.removed){const p=I.find(w=>w.id===$);p&&P.removed.push(p)}}return P.added.length===0&&P.removed.length===0&&P.updated.length===0&&(P=null),{local:d,remote:P}}e.$g6b=F;function j(A,I,R){A=A?A.filter(({id:l})=>!R.includes(l)):[],I=I.filter(({id:l})=>!R.includes(l));const S=A.map(({id:l})=>l),d=I.map(({id:l})=>l),P=d.filter(l=>!S.includes(l)),E=S.filter(l=>!d.includes(l)),b=[];for(const{id:l,name:$,shortName:p,icon:w,useDefaultFlags:c}of A){if(E.includes(l))continue;const u=I.find(f=>f.id===l);(!u||u.name!==$||u.shortName!==p||u.icon!==w||!(0,D.$_m)(u.useDefaultFlags,c))&&b.push(l)}return{added:P,removed:E,updated:b}}}),define(ae[24],ce([0,1,18,12,173,50,29,4,103,41]),function(te,e,D,F,j,A,I,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thb=e.$shb=e.$rhb=e.$qhb=e.$phb=e.$ohb=e.$nhb=e.$mhb=e.$lhb=e.$khb=e.$jhb=e.MergeState=e.Change=e.SyncStatus=e.$ihb=e.$hhb=e.$ghb=e.UserDataSyncErrorCode=e.$fhb=e.$ehb=e.$dhb=e.$chb=e.$bhb=e.$ahb=e.$_gb=e.$$gb=e.$0gb=e.SyncResource=e.$9gb=e.$8gb=e.$7gb=e.$6gb=e.$5gb=e.$4gb=void 0;function P(){const t=d.$hn.as(A.$mn.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$4gb=P;function E(){const t=d.$hn.as(A.$mn.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(y=>!!t[y].ignoreSync),o=Object.keys(t).filter(y=>t[y].scope===2||t[y].scope===6),v=P();return(0,D.$Lb)([...r,...o,...v])}e.$5gb=E,e.$6gb="settingsSync",e.$7gb="settingsSync.keybindingsPerPlatform";function b(){const t="vscode://schemas/ignoredSettings",r=d.$hn.as(A.$mn.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,j.localize)(0,null),type:"object",properties:{[e.$7gb]:{type:"boolean",description:(0,j.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,j.localize)(2,null),items:[{type:"string",pattern:I.$Yn,errorMessage:(0,j.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,j.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const o=d.$hn.as(S.$in.JSONContribution),v=()=>{const y=P(),h=E(),g=Object.keys(A.$nn.properties).filter(M=>!h.includes(M)),O=h.filter(M=>!y.includes(M)),T={items:{type:"string",enum:[...g,...O.map(M=>`-${M}`)]}};o.registerSchema(t,T)};return r.onDidUpdateConfiguration(()=>v())}e.$8gb=b;function l(t){return t&&(0,F.$Af)(t)&&(0,F.$yf)(t.id)&&Array.isArray(t.scopes)}e.$9gb=l;var $;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})($||(e.SyncResource=$={})),e.$0gb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(t,...r){return t?[t,...r]:r}e.$$gb=p;function w(t,r,o,v){return v.joinPath(o.userDataSyncHome,...p(t,r,`lastSync${r}.json`))}e.$_gb=w,e.$ahb=(0,R.$Qh)("IUserDataSyncStoreManagementService"),e.$bhb=(0,R.$Qh)("IUserDataSyncStoreService"),e.$chb=(0,R.$Qh)("IUserDataSyncLocalStoreService"),e.$dhb="x-operation-id",e.$ehb="X-Execution-Id";function c(t){const r={};return r[e.$ehb]=t,r}e.$fhb=c;var u;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class f extends Error{constructor(r,o,v,y){super(r),this.code=o,this.resource=v,this.operationId=y,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$ghb=f;class m extends f{constructor(r,o,v,y,h){super(r,v,void 0,h),this.url=o,this.serverCode=y}}e.$hhb=m;class k extends f{constructor(r,o){super(r,o)}}e.$ihb=k,function(t){function r(o){if(o instanceof t)return o;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(o.name);if(v&&v[1]){const y=v[2]==="unknown"?void 0:v[2],h=v[3]==="unknown"?void 0:v[3];return new t(o.message,v[1],y,h)}return new t(o.message,"Unknown")}t.toUserDataSyncError=r}(f||(e.$ghb=f={}));var s;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(s||(e.SyncStatus=s={}));var a;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(a||(e.Change=a={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$jhb="sync.store.url.type";function i(t){return`sync.enable.${t}`}e.$khb=i,e.$lhb=(0,R.$Qh)("IUserDataSyncEnablementService"),e.$mhb=(0,R.$Qh)("IUserDataSyncService"),e.$nhb=(0,R.$Qh)("IUserDataSyncResourceProviderService"),e.$ohb=(0,R.$Qh)("IUserDataAutoSyncService"),e.$phb=(0,R.$Qh)("IUserDataSyncUtilService"),e.$qhb=(0,R.$Qh)("IUserDataSyncLogService"),e.$rhb="userDataSync",e.$shb="vscode-userdata-sync",e.$thb="preview"}),define(ae[236],ce([0,1,30,24]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MEb=void 0;function j(I,R,S,d,P){if(!R)return{remote:{added:Object.keys(I),removed:[],updated:[],all:Object.keys(I).length>0?I:null},local:{added:{},removed:[],updated:{}}};const E=A(I,R);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const b=S?A(S,R):{added:Object.keys(R).reduce((u,f)=>(u.add(f),u),new Set),removed:new Set,updated:new Set},l=S?A(S,I):{added:Object.keys(I).reduce((u,f)=>(u.add(f),u),new Set),removed:new Set,updated:new Set},$={added:{},removed:[],updated:{}},p=D.$8m(R),w=!S;for(const u of l.added.values())u!==F.$jhb&&w&&b.added.has(u)||(p[u]=I[u]);for(const u of l.updated.values())p[u]=I[u];for(const u of l.removed.values())d.unregistered.includes(u)||delete p[u];for(const u of b.added.values()){const f=R[u];if(d.machine.includes(u)){P.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(S&&l.added.has(u))continue;const m=I[u];m&&m.value===f.value||u===F.$jhb&&w&&l.added.has(u)||(m?$.updated[u]=f:$.added[u]=f)}for(const u of b.updated.values()){const f=R[u];if(d.machine.includes(u)){P.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(l.updated.has(u)||l.removed.has(u))continue;const m=I[u];m&&m.value===f.value||($.updated[u]=f)}for(const u of b.removed.values()){if(d.machine.includes(u)){P.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}l.updated.has(u)||l.removed.has(u)||$.removed.push(u)}const c=A(R,p);return{local:$,remote:{added:[...c.added],updated:[...c.updated],removed:[...c.removed],all:c.added.size===0&&c.removed.size===0&&c.updated.size===0?null:p}}}e.$MEb=j;function A(I,R){const S=Object.keys(I),d=Object.keys(R),P=d.filter(l=>!S.includes(l)).reduce((l,$)=>(l.add($),l),new Set),E=S.filter(l=>!d.includes(l)).reduce((l,$)=>(l.add($),l),new Set),b=new Set;for(const l of S){if(E.has(l))continue;const $=I[l],p=R[l];D.$_m($,p)||b.add(l)}return{added:P,removed:E,updated:b}}}),define(ae[237],ce([0,1,18,35,86,42,30,78,24]),function(te,e,D,F,j,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ADb=e.$zDb=e.$yDb=e.$xDb=e.$wDb=e.$vDb=void 0;function d(o,v,y){let h=[];y?h=E(y):h=P(v);const g=[],O=[...(0,S.$4gb)()];if(Array.isArray(h))for(const T of h)T.startsWith("-")?O.push(T.substring(1)):g.push(T);return(0,D.$Lb)([...o,...g].filter(T=>!O.includes(T)))}e.$vDb=d;function P(o){let v=o.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=o.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:o.getValue("settingsSync.ignoredSettings")||[]}function E(o){const v=(0,F.$Xm)(o);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function b(o,v){const y=(0,F.$Xm)(o)||{};let h="{}";for(const g of Object.keys(y)){const O=(0,j.$mT)(h,[g],y[g],v);h=(0,j.$pT)(h,O)}return h}e.$wDb=b;function l(o,v,y,h){if(y.length){const g=r(v),O=(0,F.$Xm)(v)||{},T=(0,F.$Xm)(o);if(!T)return o;const M=[];for(const U of y){const z=O[U],Z=T[U];z===void 0?o=R.edit(o,[U],void 0,h):Z!==void 0?o=R.edit(o,[U],z,h):M.push(s(U,g))}M.sort((U,z)=>U.startOffset-z.startOffset),M.forEach(U=>o=u(U.setting.key,v,o,h))}return o}e.$xDb=l;function $(o,v,y,h,g,O){const T=l(o,v,h,O),M=y!==T,U=y!==v;if(!M&&!U)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!U)return{conflictsSettings:[],localContent:null,remoteContent:T,hasConflicts:!1};if(U&&!M)return{conflictsSettings:[],localContent:l(v,o,h,O),remoteContent:null,hasConflicts:!1};if(y===null&&w(o)){const L=p(o,v,h)?null:l(v,o,h,O);return{conflictsSettings:[],localContent:L,remoteContent:null,hasConflicts:!1}}let z=o,Z=v;const X=(0,F.$Xm)(o),x=(0,F.$Xm)(v),H=y?(0,F.$Xm)(y):null,K=h.reduce((L,B)=>(L.add(B),L),new Set),J=c(X,x,K),V=c(H,X,K),ee=c(H,x,K),ne=new Map,_=new Set,se=L=>{_.add(L);const B=g.filter(({key:N})=>N===L)[0];B?(z=R.edit(z,[L],B.value,O),Z=R.edit(Z,[L],B.value,O)):ne.set(L,{key:L,localValue:X[L],remoteValue:x[L]})};for(const L of V.removed.values())ee.updated.has(L)?se(L):Z=R.edit(Z,[L],void 0,O);for(const L of ee.removed.values())_.has(L)||(V.updated.has(L)?se(L):z=R.edit(z,[L],void 0,O));for(const L of V.updated.values())_.has(L)||(ee.updated.has(L)?J.updated.has(L)&&se(L):Z=R.edit(Z,[L],X[L],O));for(const L of ee.updated.values())_.has(L)||(V.updated.has(L)?J.updated.has(L)&&se(L):z=R.edit(z,[L],x[L],O));for(const L of V.added.values())_.has(L)||(ee.added.has(L)?J.updated.has(L)&&se(L):Z=u(L,z,Z,O));for(const L of ee.added.values())_.has(L)||(V.added.has(L)?J.updated.has(L)&&se(L):z=u(L,Z,z,O));const Q=ne.size>0||!p(z,Z,h),q=Q||!p(z,o,[]),C=Q||!p(Z,v,[]);return{localContent:q?z:null,remoteContent:C?Z:null,conflictsSettings:[...ne.values()],hasConflicts:Q}}e.$yDb=$;function p(o,v,y){if(o===v)return!0;const h=(0,F.$Xm)(o),g=(0,F.$Xm)(v),O=y.reduce((U,z)=>(U.add(z),U),new Set),T=r(o).filter(U=>!(U.setting&&O.has(U.setting.key))),M=r(v).filter(U=>!(U.setting&&O.has(U.setting.key)));if(T.length!==M.length)return!1;for(let U=0;U<T.length;U++){const z=T[U],Z=M[U];if(z.setting&&Z.setting){if(z.setting.key!==Z.setting.key||!I.$_m(h[z.setting.key],g[z.setting.key]))return!1}else if(!z.setting&&!Z.setting){if(z.value!==Z.value)return!1}else return!1}return!0}function w(o){return o?r(o).length===0:!0}e.$zDb=w;function c(o,v,y){const h=o?Object.keys(o).filter(U=>!y.has(U)):[],g=Object.keys(v).filter(U=>!y.has(U)),O=g.filter(U=>!h.includes(U)).reduce((U,z)=>(U.add(z),U),new Set),T=h.filter(U=>!g.includes(U)).reduce((U,z)=>(U.add(z),U),new Set),M=new Set;if(o)for(const U of h){if(T.has(U))continue;const z=o[U],Z=v[U];I.$_m(z,Z)||M.add(U)}return{added:O,removed:T,updated:M}}function u(o,v,y,h){const g=(0,F.$Xm)(v),O=r(v),T=r(y),M=f(o,O,T);return m(y,o,g[o],M,T,h)}e.$ADb=u;function f(o,v,y){const h=v.findIndex(O=>O.setting?.key===o),g=v[h-1];if(g){if(g.setting){const T=s(g.setting.key,y);if(T)return{index:y.indexOf(T),insertAfter:!0}}else{const T=a(h,v);if(T){const M=s(T.setting.key,y);if(M){const U=n(y.indexOf(M),y),z=i(v,T,v[h]);if(U){const Z=i(y,M,U),X=t(z,Z);return X?{index:y.indexOf(X),insertAfter:!0}:{index:y.indexOf(U),insertAfter:!1}}else{const Z=i(y,M,y[y.length-1]),X=t(z,Z);return X?{index:y.indexOf(X),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const O=v[h+1];if(O)if(O.setting){const T=s(O.setting.key,y);if(T)return{index:y.indexOf(T),insertAfter:!1}}else{const T=n(h,v);if(T){const M=s(T.setting.key,y);if(M){const U=a(y.indexOf(M),y),z=i(v,v[h],T);if(U){const Z=i(y,U,M),X=t(z.reverse(),Z.reverse());return X?{index:y.indexOf(X),insertAfter:!1}:{index:y.indexOf(U),insertAfter:!0}}else{const Z=i(y,y[0],M),X=t(z.reverse(),Z.reverse());return X?{index:y.indexOf(X),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function m(o,v,y,h,g,O){let T;return h.index===-1?T=(0,j.$mT)(o,[v],y,O):T=k(o,v,y,h,g,O).map(M=>(0,j.$nT)(o,M,O)[0]),(0,j.$pT)(o,T)}function k(o,v,y,h,g,O){const T=`${JSON.stringify(v)}: ${JSON.stringify(y)}`,M=(0,A.$jT)(O,o),U=g[h.index];if(h.insertAfter){const z=[];if(U.setting)z.push({offset:U.endOffset,length:0,content:","+T});else{const Z=n(h.index,g),X=a(h.index,g),x=X?.setting?.commaOffset;X&&x===void 0&&z.push({offset:X.endOffset,length:0,content:","});const H=x!==void 0&&x>U.endOffset;z.push({offset:H?x+1:U.endOffset,length:0,content:Z?M+T+",":M+T})}return z}else{if(U.setting)return[{offset:U.startOffset,length:0,content:T+","}];const z=(g[h.index-1]&&!g[h.index-1].setting?M:"")+T+(n(h.index,g)?",":"")+M;return[{offset:U.startOffset,length:0,content:z}]}}function s(o,v){return v.filter(y=>y.setting?.key===o)[0]}function a(o,v){for(let y=o-1;y>=0;y--)if(v[y].setting)return v[y]}function n(o,v){for(let y=o+1;y<v.length;y++)if(v[y].setting)return v[y]}function i(o,v,y){const h=o.indexOf(v),g=o.indexOf(y);return o.filter((O,T)=>h<T&&T<g)}function t(o,v){if(o.length&&v.length){let y=0;for(;y<v.length&&y<o.length;y++)if(o[y].value!==v[y].value)return v[y-1];return v[y-1]}}function r(o){const v=[];let y=-1,h,g;const O={onObjectBegin:T=>{y++},onObjectProperty:(T,M,U)=>{y===0&&(h=M,g=T)},onObjectEnd:(T,M)=>{y--,y===0&&v.push({startOffset:h,endOffset:T+M,value:o.substring(h,T+M),setting:{key:g,commaOffset:void 0}})},onArrayBegin:(T,M)=>{y++},onArrayEnd:(T,M)=>{y--,y===0&&v.push({startOffset:h,endOffset:T+M,value:o.substring(h,T+M),setting:{key:g,commaOffset:void 0}})},onLiteralValue:(T,M,U)=>{y===0&&v.push({startOffset:h,endOffset:M+U,value:o.substring(h,M+U),setting:{key:g,commaOffset:void 0}})},onSeparator:(T,M,U)=>{if(y===0&&T===","){let z=v.length-1;for(;z>=0&&!v[z].setting;z--);const Z=v[z];Z&&v.splice(z,1,{startOffset:Z.startOffset,endOffset:Z.endOffset,value:Z.value,setting:{key:Z.setting.key,commaOffset:M}})}},onComment:(T,M)=>{y===0&&v.push({startOffset:T,endOffset:T+M,value:o.substring(T,T+M)})}};return(0,F.$5m)(o,O),v}}),define(ae[79],ce([0,1,3,2,4,24]),function(te,e,D,F,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gDb=e.$fDb=void 0,e.$fDb=(0,j.$Qh)("IUserDataSyncAccountService");let I=class extends F.$Rc{get account(){return this.a}constructor(S,d){super(),this.g=S,this.h=d,this.b=this.B(new D.$Nd),this.onDidChangeAccount=this.b.event,this.c=this.B(new D.$Nd),this.onTokenFailed=this.c.event,this.f=!1,this.B(S.onTokenFailed(P=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,P),this.updateAccount(void 0),P==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(S.onTokenSucceed(()=>this.f=!1))}async updateAccount(S){(S&&this.a?S.token!==this.a.token||S.authenticationProviderId!==this.a.authenticationProviderId:S!==this.a)&&(this.a=S,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(S))}};e.$gDb=I,e.$gDb=I=ye([Y(0,A.$bhb),Y(1,A.$qhb)],I)}),define(ae[238],ce([0,1,2,10]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H9b=e.$G9b=e.$F9b=e.$E9b=e.$D9b=e.$C9b=e.$B9b=void 0;class j{constructor(b){this.a=b}listen(b,l){switch(l){case"onError":return this.a.onError}throw new Error(`Event not found: ${l}`)}call(b,l,$){switch(l){case"triggerSync":return this.a.triggerSync($[0],$[1],$[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff($[0])}throw new Error("Invalid call")}}e.$B9b=j;class A{constructor(b){this.a=b}listen(b,l){throw new Error(`Event not found: ${l}`)}call(b,l,$){switch(l){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings($[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(F.URI.revive($[0]))}throw new Error("Invalid call")}}e.$C9b=A;class I{constructor(b){this.a=b}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(b){return this.a.call("resolveUserKeybindings",[b])}async resolveFormattingOptions(b){return this.a.call("resolveFormattingOptions",[b])}}e.$D9b=I;class R{constructor(b){this.a=b}listen(b,l){switch(l){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${l}`)}async call(b,l,$){switch(l){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine($[0],$[1]);case"setEnablements":return this.a.setEnablements($)}throw new Error("Invalid call")}}e.$E9b=R;class S{constructor(b){this.a=b}listen(b,l){switch(l){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${l}`)}call(b,l,$){switch(l){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount($)}throw new Error("Invalid call")}}e.$F9b=S;class d{constructor(b){this.a=b}listen(b,l){switch(l){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${l}`)}call(b,l,$){switch(l){case"switch":return this.a.switch($[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$G9b=d;class P extends D.$Rc{constructor(b){super(),this.a=b,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(b){return this.a.call("switch",[b])}async getPreviousUserDataSyncStore(){const b=await this.a.call("getPreviousUserDataSyncStore");return this.b(b)}b(b){return{url:F.URI.revive(b.url),type:b.type,defaultUrl:F.URI.revive(b.defaultUrl),insidersUrl:F.URI.revive(b.insidersUrl),stableUrl:F.URI.revive(b.stableUrl),canSwitch:b.canSwitch,authenticationProviders:b.authenticationProviders}}}e.$H9b=P}),define(ae[239],ce([0,1,19,174,14,8,24]),function(te,e,D,F,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sFb=void 0;let R=class extends A.$dj{constructor(d,P){super(),this.g=this.B(d.createLogger((0,D.$vg)(P.logsHome,`${I.$rhb}.log`),{id:I.$rhb,name:(0,F.localize)(0,null)}))}trace(d,...P){this.g.trace(d,...P)}debug(d,...P){this.g.debug(d,...P)}info(d,...P){this.g.info(d,...P)}warn(d,...P){this.g.warn(d,...P)}error(d,...P){this.g.error(d,...P)}flush(){this.g.flush()}};e.$sFb=R,e.$sFb=R=ye([Y(0,A.$_i),Y(1,j.$Xh)],R)}),define(ae[240],ce([0,1,6,3,2]),function(te,e,D,F,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C8b=void 0;class A extends j.$Rc{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:S,getActiveWindowId:d}){super(),this.a=this.B(new j.$Qc),F.Event.latch(F.Event.any(R,S))(this.f,this,this.a),this.b=(0,D.$Hg)(()=>d()),(async()=>{try{const E=await this.b;this.c=typeof this.c=="number"?this.c:E}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$C8b=A}),define(ae[112],ce([0,1,177,16,47,19,10,4,23]),function(te,e,D,F,j,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.WorkbenchState=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=void 0,e.$Zh=(0,R.$Qh)("contextService");function d(i){const t=i;return typeof t?.id=="string"&&I.URI.isUri(t.uri)}e.$1h=d;function P(i){return typeof i?.id=="string"&&!d(i)&&!b(i)}e.$2h=P,e.$3h={id:"ext-dev"},e.$4h={id:"empty-window"};function E(i,t){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,F.$mc)(i)}:t?e.$3h:e.$4h;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$5h=E;function b(i){const t=i;return typeof t?.id=="string"&&I.URI.isUri(t.configPath)}e.$6h=b;function l(i){const t=i;if(t?.uri)return{id:t.id,uri:I.URI.revive(t.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:I.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$7h=l;var $;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function p(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$8h=p;function w(i){const t=i;return!!(t&&typeof t=="object"&&I.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$9h=w;class c{constructor(t,r,o,v,y){this.h=t,this.j=o,this.k=v,this.l=y,this.c=j.$Wh.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=j.$Wh.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$0h=c;class u{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,A.$vg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$$h=u;function f(i){return new u({uri:i,index:0,name:(0,A.$rg)(i)},{uri:i.toString()})}e.$_h=f,e.$ai="code-workspace",e.$bi=`.${e.$ai}`,e.$ci=[{name:(0,D.localize)(0,null),extensions:[e.$ai]}],e.$di="workspace.json";function m(i,t){return A.$mg.isEqualOrParent(i,t.untitledWorkspacesHome)}e.$ei=m;function k(i){let t;return I.URI.isUri(i)?t=i:t=i.configuration,t?.scheme===S.Schemas.tmp}e.$fi=k,e.$gi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$gi}e.$hi=s;function a(i,t){return!m(i,t)&&!k(i)}e.$ii=a;function n(i){return(typeof i=="string"?(0,F.$nc)(i):(0,A.$tg)(i))===e.$bi}e.$ji=n}),define(ae[17],ce([0,1,52,3,2,19,10,168,14,11,4,8,112,34,28,6,32,27,12]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.ProfileResourceType=void 0;var f;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(f||(e.ProfileResourceType=f={}));function m(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&I.URI.isUri(t.location)&&I.URI.isUri(t.globalStorageHome)&&I.URI.isUri(t.settingsResource)&&I.URI.isUri(t.keybindingsResource)&&I.URI.isUri(t.tasksResource)&&I.URI.isUri(t.snippetsHome)&&I.URI.isUri(t.extensionsResource))}e.$Kk=m,e.$Lk=(0,P.$Qh)("IUserDataProfilesService");function k(i,t){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:I.URI.revive(i.location).with({scheme:t}),globalStorageHome:I.URI.revive(i.globalStorageHome).with({scheme:t}),settingsResource:I.URI.revive(i.settingsResource).with({scheme:t}),keybindingsResource:I.URI.revive(i.keybindingsResource).with({scheme:t}),tasksResource:I.URI.revive(i.tasksResource).with({scheme:t}),snippetsHome:I.URI.revive(i.snippetsHome).with({scheme:t}),extensionsResource:I.URI.revive(i.extensionsResource).with({scheme:t}),cacheHome:I.URI.revive(i.cacheHome).with({scheme:t}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Mk=k;function s(i,t,r,o,v,y){return{id:i,name:t,location:r,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:y&&v?.useDefaultFlags?.globalState?y.globalStorageHome:(0,A.$vg)(r,"globalStorage"),settingsResource:y&&v?.useDefaultFlags?.settings?y.settingsResource:(0,A.$vg)(r,"settings.json"),keybindingsResource:y&&v?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,A.$vg)(r,"keybindings.json"),tasksResource:y&&v?.useDefaultFlags?.tasks?y.tasksResource:(0,A.$vg)(r,"tasks.json"),snippetsHome:y&&v?.useDefaultFlags?.snippets?y.snippetsHome:(0,A.$vg)(r,"snippets"),extensionsResource:y&&v?.useDefaultFlags?.extensions?y.extensionsResource:(0,A.$vg)(r,"extensions.json"),cacheHome:(0,A.$vg)(o,i),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$Nk=s;let a=class extends j.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,o,v){super(),this.t=t,this.u=r,this.w=o,this.y=v,this.f=!0,this.h=this.B(new F.$Nd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new F.$Nd),this.onWillCreateProfile=this.j.event,this.m=this.B(new F.$Nd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new F.$Nd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new l.$zc,emptyWindows:new Map},this.profilesHome=(0,A.$vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,u.$yf)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(s((0,A.$sg)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},t))}}catch(y){this.y.error(y)}const o=new l.$zc,v=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[h,g]of Object.entries(y.workspaces)){const O=I.URI.parse(h),T=r.find(M=>M.id===g);T&&o.set(O,T)}if(y.emptyWindows)for(const[h,g]of Object.entries(y.emptyWindows)){const O=r.find(T=>T.id===g);O&&v.set(h,O)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:o,emptyWindows:v}}return this.z}D(){const t=s("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",o=new RegExp(`${(0,c.$Fe)(r)}\\s(\\d+)`);let v=0;for(const h of this.profiles){const g=o.exec(h.name),O=g?parseInt(g[1]):0;v=O>v?O:v}const y=`${r} ${v+1}`;return this.createProfile((0,D.$Ei)((0,w.$eg)()).toString(16),y,{transient:!0},t)}async createNamedProfile(t,r,o){return this.createProfile((0,D.$Ei)((0,w.$eg)()).toString(16),t,r,o)}async createProfile(t,r,o,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(t,r,o);return v&&await this.setProfileForWorkspace(v,y),y}async F(t,r,o){if(!(0,u.$yf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const y=this.profiles.find(O=>O.name===r||O.id===t);if(y)return y;const h=s(t,r,(0,A.$vg)(this.profilesHome,t),this.g,o,this.defaultProfile);await this.u.createFolder(h.location);const g=[];return this.j.fire({profile:h,join(O){g.push(O)}}),await p.Promises.settled(g),this.I([h],[],[]),h}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(v=>v.id===t.id);if(!o)throw new Error(`Profile '${t.name}' does not exist`);return o=s(o.id,r.name??o.name,o.location,this.g,{shortName:r.shortName??o.shortName,icon:r.icon===null?void 0:r.icon??o.icon,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags},this.defaultProfile),this.I([],[],[o]),o}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this.m.fire({profile:r,join(v){o.push(v)}});try{await Promise.allSettled(o)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,d.$qk)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(v=>v.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,o)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.w.extUri.isEqual(o.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return I.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,b.$1h)(t)?t.uri:(0,b.$6h)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,o){const v=[...this.profiles,...t],y=[];this.s.profiles=[];for(let h of v)h.isDefault||r.some(g=>h.id===g.id)||(h=o.find(g=>h.id===g.id)??h,h.isTransient?this.s.profiles.push(h):y.push({location:h.location,name:h.name,shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags}));this.P(y),this.z=void 0,this.J(t,r,o)}J(t,r,o){this.h.fire({added:t,removed:r,updated:o,all:this.profiles})}L(t,r,o){o=r?.isTransient?!0:o,o||this.L(t,void 0,!0);const v=this.G(t),y=o?this.s:this.C;I.URI.isUri(v)?(y.workspaces.delete(v),r&&y.workspaces.set(v,r)):(y.emptyWindows.delete(v),r&&y.emptyWindows.set(v,r)),o||this.M()}M(){const t={};for(const[o,v]of this.C.workspaces.entries())t[o.toString()]=v.id;const r={};for(const[o,v]of this.C.emptyWindows.entries())r[o.toString()]=v.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},o=this.D();if(t.workspaces)for(const[y,h]of Object.entries(t.workspaces)){const g=I.URI.parse(h);r[y]=this.w.extUri.isEqual(g,o.location)?o.id:this.w.extUri.basename(g)}const v={};if(t.emptyWindows)for(const[y,h]of Object.entries(t.emptyWindows)){const g=I.URI.parse(h);v[y]=this.w.extUri.isEqual(g,o.location)?o.id:this.w.extUri.basename(g)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$Ok=a,e.$Ok=a=ye([Y(0,S.$Xh),Y(1,d.$_j),Y(2,$.$Jk),Y(3,E.$$i)],a);class n extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$Pk=n}),define(ae[241],ce([0,1,6,2,17]),function(te,e,D,F,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P9b=void 0;let A=class extends F.$Rc{constructor(R){super(),this.B(new D.$7g(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$P9b=A,e.$P9b=A=ye([Y(0,j.$Lk)],A)}),define(ae[242],ce([0,1,18,6,26,7,3,2,5,12,10,151,29,33,44,8,25,22,28,17]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w,c,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=void 0;let m=class extends R.$Rc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,o,v,y,h){super(),this.z=t,this.C=r,this.D=o,this.F=v,this.G=y,this.H=h,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new I.$Nd),this.s=this.B(new I.$Nd),this.t=this.B(new I.$Nd),this.u=this.B(new I.$Nd),this.w=this.B(new I.$Nd),this.y=[],this.B((0,R.$Pc)(()=>{this.j.forEach(({task:g})=>g.cancel()),this.m.forEach(g=>g.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,b.$9n)(o,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const v=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:y})=>(0,l.$Ao)(y,t.identifier));if(v?.local)return v?.local;throw v?.error?v.error:s(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(o){throw s(o)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new b.$_n(E.localize(0,null),b.ExtensionManagementErrorCode.Internal);const r=[],o=[];await Promise.allSettled(t.map(async({extension:v,options:y})=>{try{const h=await this.O(v,!!y?.installGivenVersion,!!y?.installPreReleaseVersion);o.push({...h,options:y})}catch(h){r.push({identifier:v.identifier,operation:2,source:v,error:h})}})),o.length&&r.push(...await this.I(o));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!P.URI.isUri(v.source)&&a(this.C,"extensionGallery:install",{extensionData:(0,l.$Io)(v.source),error:v.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,r)}async toggleAppliationScope(t,r){if((0,$.$0l)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let o=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(o=await this.ab(t,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const y=(await this.getInstalled(1,v.extensionsResource)).find(h=>(0,l.$Ao)(h.identifier,t.identifier));y?this.w.fire(y):this.u.fire({identifier:t.identifier,profileLocation:v.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[];return await Promise.allSettled(t.map(async o=>{try{const v=await this.J(o,(y,h)=>t.some(g=>(0,l.$Eo)(h.identifier.id)===(0,l.$Fo)(g.manifest.publisher,g.manifest.name))?!1:this.L(y,h));r.push(...v)}catch(v){r.push({identifier:{id:(0,l.$Fo)(o.manifest.publisher,o.manifest.name)},operation:2,source:o.extension,error:v})}})),this.s.fire(r),r}async J({manifest:t,extension:r,options:o},v){const y=o.isApplicationScoped||o.isBuiltin||(0,$.$0l)(t),h={...o,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:y,profileLocation:y?this.H.defaultProfile.extensionsResource:o.profileLocation??this.Y()},g=Z=>`${l.$Bo.create(Z).toString()}${h.profileLocation?`-${h.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const Z=this.j.get(g(r));if(Z)return this.F.info("Extensions is already requested to install",r.identifier.id),await Z.task.waitUntilTaskIsFinished(),[]}const O=[],T=[],M=[],U=this.Z(t,r,h);P.URI.isUri(r)||this.j.set(g(r),{task:U,waitingTasks:[]}),this.n.fire({identifier:U.identifier,source:r,profileLocation:h.profileLocation}),this.F.info("Installing extension:",U.identifier.id),O.push({task:U,manifest:t});let z=!1;try{if(h.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",U.identifier.id);else try{const X=await this.N(U.identifier,t,!!h.installOnlyNewlyAddedFromExtensionPack,!!h.installPreReleaseVersion,h.profileLocation),x=await this.getInstalled(void 0,h.profileLocation),H={...h,donotIncludePackAndDependencies:!0,context:{...h.context,[b.$4n]:!0}};for(const{gallery:K,manifest:J}of(0,D.$Lb)(X,({gallery:V})=>V.identifier.id)){z=z||!!J.extensionDependencies?.some(ne=>(0,l.$Ao)({id:ne},U.identifier));const V=g(K),ee=this.j.get(V);if(ee){if(v(U,ee.task)){const ne=ee.task.identifier;this.F.info("Waiting for already requested installing extension",ne.id,U.identifier.id),ee.waitingTasks.push(U),T.push(I.Event.toPromise(I.Event.filter(this.onDidInstallExtensions,_=>_.some(se=>(0,l.$Ao)(se.identifier,ne)))).then(_=>{if(this.F.info("Finished waiting for already requested installing extension",ne.id,U.identifier.id),!_.find(Q=>(0,l.$Ao)(Q.identifier,ne))?.local)throw new Error(`Extension ${ne.id} is not installed`)}))}}else if(!x.some(({identifier:ne})=>(0,l.$Ao)(ne,K.identifier))){const ne=this.Z(J,K,H);this.j.set(V,{task:ne,waitingTasks:[U]}),this.n.fire({identifier:ne.identifier,source:K,profileLocation:h.profileLocation}),this.F.info("Installing extension:",ne.identifier.id,U.identifier.id),O.push({task:ne,manifest:J})}}}catch(X){if(P.URI.isUri(U.source))(0,D.$Kb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",U.identifier.id,X.message),(0,D.$Kb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",U.identifier.id,X.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",U.identifier.id),X}const Z=O.reduce((X,{task:x,manifest:H})=>(X.set(x.identifier.id.toLowerCase(),{task:x,manifest:H}),X),new Map);for(;Z.size;){let X;const x=[...Z.values()].filter(({manifest:H})=>!H.extensionDependencies?.some(K=>Z.has(K.toLowerCase())));x.length?X=Z.size===1?x:x.filter(({task:H})=>!(H===U&&!z)):(this.F.info("Found extensions with circular dependencies",x.map(({task:H})=>H.identifier.id)),X=[...Z.values()]),await this.M(X.map(async({task:H})=>{const K=new Date().getTime();try{const J=await H.run();if(await this.M(this.y.map(V=>V.postInstall(J,H.source,h,j.CancellationToken.None))),!P.URI.isUri(H.source)){const V=H.operation===3,ee=V?void 0:(new Date().getTime()-H.source.lastUpdated)/1e3;if(a(this.C,V?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Io)(H.source),verificationStatus:H.verificationStatus,duration:new Date().getTime()-K,durationSinceUpdate:ee}),S.$p&&H.operation!==3)try{await this.z.reportStatistic(J.manifest.publisher,J.manifest.name,J.manifest.version,"install")}catch{}}M.push({local:J,identifier:H.identifier,operation:H.operation,source:H.source,context:H.options.context,profileLocation:H.profileLocation,applicationScoped:J.isApplicationScoped})}catch(J){throw P.URI.isUri(H.source)||a(this.C,H.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Io)(H.source),verificationStatus:H.verificationStatus,duration:new Date().getTime()-K,error:J}),this.F.error("Error while installing the extension:",H.identifier.id),J}finally{Z.delete(H.identifier.id.toLowerCase())}}))}return T.length&&await this.M(T),M.forEach(({identifier:X})=>this.F.info("Extension installed successfully:",X.id)),M}catch(Z){if(O.forEach(({task:X})=>X.cancel()),M.length)try{const X=await Promise.allSettled(M.map(({local:x})=>this.$(x,{versionOnly:!0,profileLocation:h.profileLocation}).run()));for(let x=0;x<X.length;x++){const H=X[x],{identifier:K}=M[x];H.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",K.id):this.F.warn("Rollback: Error while uninstalling extension",K.id,(0,A.$9)(H.reason))}}catch(X){this.F.warn("Error while rolling back extensions",(0,A.$9)(X),M.map(({identifier:x})=>x.id))}return O.map(({task:X})=>({identifier:X.identifier,operation:2,source:X.source,context:h.context,profileLocation:h.profileLocation,error:Z}))}finally{for(const{task:Z}of O)Z.source&&!P.URI.isUri(Z.source)&&this.j.delete(g(Z.source))}}L(t,r){for(const[,{task:o,waitingTasks:v}]of this.j.entries())if(o===t&&(v.includes(r)||v.some(y=>this.L(y,r)))||o===r&&v[0]&&!this.L(t,v[0]))return!1;return!0}async M(t){const r=[],o=[],v=await Promise.allSettled(t);for(const y of v)y.status==="fulfilled"?r.push(y.value):o.push(y.reason);if(o.length)throw k(o);return r}async N(t,r,o,v,y){if(!this.z.isEnabled())return[];const h=await this.getInstalled(void 0,y),g=[],O=[],T=async(M,U)=>{g.push(M);const z=U.extensionDependencies||[],Z=[...z];if(U.extensionPack){const X=o?h.find(x=>(0,l.$Ao)(x.identifier,M)):void 0;for(const x of U.extensionPack)X&&X.manifest.extensionPack&&X.manifest.extensionPack.some(H=>(0,l.$Ao)({id:H},{id:x}))||Z.every(H=>!(0,l.$Ao)({id:H},{id:x}))&&Z.push(x)}if(Z.length){const X=Z.filter(x=>g.every(H=>!(0,l.$Ao)(H,{id:x})));if(X.length){const x=await this.z.getExtensions(X.map(H=>({id:H,preRelease:v})),j.CancellationToken.None);for(const H of x){if(g.find(V=>(0,l.$Ao)(V,H.identifier)))continue;const K=z.some(V=>(0,l.$Ao)({id:V},H.identifier));let J;try{J=await this.O(H,!1,v)}catch(V){if(K)throw V;this.F.info("Skipping the packed extension as it cannot be installed",H.identifier.id,(0,A.$9)(V));continue}O.push({gallery:J.extension,manifest:J.manifest}),await T(J.extension.identifier,J.manifest)}}}};return await T(t,r),O}async O(t,r,o){let v;const y=await this.getExtensionsControlManifest();if(y.malicious.some(O=>(0,l.$Ao)(t.identifier,O)))throw new b.$_n(E.localize(1,null,t.identifier.id),b.ExtensionManagementErrorCode.Malicious);const h=y.deprecated[t.identifier.id.toLowerCase()];if(h?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${h.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:h.extension.id,preRelease:h.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},j.CancellationToken.None))[0],!v)throw new b.$_n(E.localize(2,null,t.identifier.id,h.extension.id),b.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const O=await this.getTargetPlatform();throw new b.$_n(E.localize(3,null,t.identifier.id,this.G.nameLong,(0,b.$5n)(O)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.P(t,r,o),!v)throw!o&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],j.CancellationToken.None))[0]?new b.$_n(E.localize(4,null,t.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.$_n(E.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),b.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const g=await this.z.getManifest(v,j.CancellationToken.None);if(g===null)throw new b.$_n(`Missing manifest for extension ${v.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(g.version!==v.version)throw new b.$_n(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:g}}async P(t,r,o){const v=await this.getTargetPlatform();let y=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(y=(await this.z.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:v,compatible:!0},j.CancellationToken.None))[0]||null),!y&&await this.z.isExtensionCompatible(t,o,v)&&(y=t),y||(r?y=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:v,compatible:!0},j.CancellationToken.None))[0]||null:y=await this.z.getCompatibleExtension(t,o,v)),y}async Q(t,r){const o={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},v=M=>`${M.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,y=this.m.get(v(t.identifier));if(y)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),y.waitUntilTaskIsFinished();const h=M=>{const U=this.$(M,o);return this.m.set(v(U.extension.identifier),U),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.t.fire({identifier:M.identifier,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped}),U},g=(M,U)=>{U?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString(),U.message):this.F.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,U.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),a(this.C,"extensionGallery:uninstall",{extensionData:(0,l.$Ho)(M),error:U}),this.u.fire({identifier:M.identifier,error:U?.code,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped})},O=[],T=[];try{O.push(h(t));const M=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const U=this.U(t,M);for(const z of U)this.m.has(v(z.identifier))?this.F.info("Extensions is already requested to uninstall",z.identifier.id):O.push(h(z))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(O.map(U=>U.extension),M,t),await this.M(O.map(async U=>{try{if(await U.run(),await this.M(this.y.map(z=>z.postUninstall(U.extension,o,j.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,"uninstall")}catch{}g(U.extension)}catch(z){const Z=z instanceof b.$_n?z:new b.$_n((0,A.$9)(z),b.ExtensionManagementErrorCode.Internal);throw g(U.extension,Z),Z}finally{T.push(U)}}))}catch(M){const U=M instanceof b.$_n?M:new b.$_n((0,A.$9)(M),b.ExtensionManagementErrorCode.Internal);for(const z of O){try{z.cancel()}catch{}T.includes(z)||g(z.extension,U)}throw U}finally{for(const M of O)this.m.delete(v(M.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}R(t,r,o){for(const v of t){const y=this.W(v,r);if(y.length){const h=y.filter(g=>!t.some(O=>(0,l.$Ao)(O.identifier,g.identifier)));if(h.length)throw new Error(this.S(v,h,o))}}}S(t,r,o){return o===t?r.length===1?E.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?E.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(t,r,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const v=t.manifest.extensionPack?t.manifest.extensionPack:[];if(v.length){const y=r.filter(g=>!g.isBuiltin&&v.some(O=>(0,l.$Ao)({id:O},g.identifier))),h=[];for(const g of y)h.push(...this.U(g,r,o));return[...y,...h]}return[]}W(t,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(v=>(0,l.$Ao)({id:v},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$qp=m,e.$qp=m=ye([Y(0,b.$$n),Y(1,c.$dl),Y(2,u.$Jk),Y(3,p.$$i),Y(4,w.$qj),Y(5,f.$Lk)],m);function k(i){const t=Array.isArray(i)?i:[i];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.$rp=k;function s(i){if(i instanceof b.$_n)return i;const t=new b.$_n(i.message,b.ExtensionManagementErrorCode.Internal);return t.stack=i.stack,t}e.$sp=s;function a(i,t,{extensionData:r,verificationStatus:o,duration:v,error:y,durationSinceUpdate:h}){let g,O;(0,d.$Gf)(o)&&(o===!0?o="Verified":(o===!1||(g=b.ExtensionManagementErrorCode.Signature,O=o),o="Unverified")),y&&(y instanceof b.$_n?(g=y.code,y.code===b.ExtensionManagementErrorCode.Signature&&(O=y.message)):g=b.ExtensionManagementErrorCode.Internal),i.publicLog(t,{...r,verificationStatus:o,success:!y,duration:v,errorcode:g,errorcodeDetail:O,durationSinceUpdate:h})}class n{constructor(){this.d=new F.$Sg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,F.$Hg)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,F.$Hg)(t=>new Promise((r,o)=>{const v=t.onCancellationRequested(()=>{v.dispose(),o(new A.$4)})})),this.d.open()),this.g.cancel()}}e.$tp=n}),define(ae[51],ce([0,1,6,15,2,3,34,10,29,33,11,4,8,17,28,12,7,22]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.$up=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class f extends Error{constructor(n,i){super(n),this.code=i}}e.$up=f,e.$vp=(0,E.$Qh)("IExtensionsProfileScannerService");let m=class extends j.$Rc{constructor(n,i,t,r,o,v){super(),this.j=n,this.m=i,this.n=t,this.r=r,this.s=o,this.t=v,this.b=this.B(new A.$Nd),this.onAddExtensions=this.b.event,this.c=this.B(new A.$Nd),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$Nd),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$Nd),this.onDidRemoveExtensions=this.g.event,this.h=new I.$zc}scanProfileExtensions(n,i){return this.u(n,void 0,i)}async addExtensionsToProfile(n,i){const t=[],r=[];try{return await this.u(i,o=>{const v=[];for(const y of o)n.some(([h])=>(0,d.$Ao)(h.identifier,y.identifier)&&h.manifest.version!==y.version)?t.push(y):v.push(y);for(const[y,h]of n){const g=v.findIndex(T=>(0,d.$Ao)(T.identifier,y.identifier)&&T.version===y.manifest.version),O={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:h};g===-1?(r.push(O),v.push(O)):v.splice(g,1,O)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),t.length&&this.f.fire({extensions:t,profileLocation:i}),v}),r.length&&this.c.fire({extensions:r,profileLocation:i}),t.length&&this.g.fire({extensions:t,profileLocation:i}),r}catch(o){throw r.length&&this.c.fire({extensions:r,error:o,profileLocation:i}),t.length&&this.g.fire({extensions:t,error:o,profileLocation:i}),o}}async updateMetadata(n,i){const t=[];return await this.u(i,r=>{const o=[];for(const v of r){const y=n.find(([h])=>(0,d.$Ao)(h.identifier,v.identifier)&&h.manifest.version===v.version);y&&(v.metadata={...v.metadata,...y[1]},t.push(v)),o.push(v)}return o}),t}async removeExtensionFromProfile(n,i){const t=[];try{await this.u(i,r=>{const o=[];for(const v of r)(0,d.$Ao)(v.identifier,n.identifier)?t.push(v):o.push(v);return t.length&&this.f.fire({extensions:t,profileLocation:i}),o}),t.length&&this.g.fire({extensions:t,profileLocation:i})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:i}),r}}async u(n,i,t){return this.F(n).queue(async()=>{let r=[],o;try{const v=await this.m.readFile(n);o=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,P.$qk)(v)!==1)throw v;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(o=await this.D()),!o&&t?.bailOutWhenFileNotFound)throw new f((0,w.$9)(v),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.w(n);let v=!1;for(const y of o){k(y)||this.w(n);let h;if((0,p.$yf)(y.relativeLocation)&&y.relativeLocation)h=this.z(y.relativeLocation);else if((0,p.$yf)(y.location))h=this.z(y.location),v=!0,y.relativeLocation=y.location,y.location=h.toJSON();else{h=R.URI.revive(y.location);const g=this.y(h);g&&(v=!0,y.relativeLocation=g)}r.push({identifier:y.identifier,location:h,version:y.version,metadata:y.metadata})}v&&await this.m.writeFile(n,F.$be.fromString(JSON.stringify(o)))}if(i){r=i(r);const v=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(n,F.$be.fromString(JSON.stringify(v)))}return r})}w(n){const i=new f(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(o){if((0,P.$qk)(o)===1)return;throw o}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const o=JSON.parse(t);Array.isArray(o)&&o.every(v=>k(v))?r=o:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.t.error(o)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,F.$be.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(o){if((0,P.$qk)(o)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw o}try{await this.m.del(n)}catch(o){(0,P.$qk)(o)!==1&&this.t.error(o)}try{await this.m.del(i)}catch(o){(0,P.$qk)(o)!==1&&this.t.error(o)}return r})()),this.C}F(n){let i=this.h.get(n);return i||(i=new D.$2g,this.h.set(n,i)),i}};e.$wp=m,e.$wp=m=ye([Y(1,P.$_j),Y(2,l.$Lk),Y(3,$.$Jk),Y(4,c.$dl),Y(5,b.$$i)],m);function k(a){return(0,p.$Af)(a)&&(0,S.$0n)(a.identifier)&&(s(a.location)||(0,p.$yf)(a.location)&&a.location)&&((0,p.$Ff)(a.relativeLocation)||(0,p.$yf)(a.relativeLocation))&&a.version&&(0,p.$yf)(a.version)}function s(a){return a?(0,p.$yf)(a.path)&&(0,p.$yf)(a.scheme):!1}}),define(ae[80],ce([0,1,18,6,30,15,7,35,137,2,23,16,5,19,54,89,12,10,154,14,33,44,69,11,4,8,25,3,65,51,17,28,182]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w,c,u,f,m,k,s,a,n,i,t,r,o,v,y,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.Translations=void 0;var O;(function(x){function H(K,J){if(K===J)return!0;const V=Object.keys(K),ee=new Set;for(const ne of Object.keys(J))ee.add(ne);if(V.length!==ee.size)return!1;for(const ne of V){if(K[ne]!==J[ne])return!1;ee.delete(ne)}return ee.size===0}x.equals=H})(O||(e.Translations=O={})),e.$zp=(0,n.$Qh)("IExtensionsScannerService");let T=class extends d.$Rc{constructor(H,K,J,V,ee,ne,_,se,Q,q,C,L){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=K,this.r=J,this.s=V,this.t=ee,this.u=ne,this.w=_,this.y=se,this.z=Q,this.C=q,this.D=C,this.F=L,this.g=this.B(new r.$Nd),this.onDidChangeCache=this.g.event,this.h=(0,l.$vg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(z,this.s,this.h)),this.m=this.B(this.F.createInstance(z,this.s,this.h)),this.n=this.B(this.F.createInstance(U,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,m.$Lo)(this.w,this.y)),this.G}async scanAllExtensions(H,K,J){const[V,ee]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(K)]),ne=J?await this.scanExtensionsUnderDevelopment(H,[...V,...ee]):[];return this.L(V,ee,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const K=[];K.push(this.M(!!H.useCache,H.language)),K.push(this.N(H.language,!!H.checkControlFile));const[J,V]=await Promise.all(K);return this.J([...J,...V],0,H,!1)}async scanUserExtensions(H){const K=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const J=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.P(K,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,J),ee=H.useCache&&!V.devMode&&V.excludeObsolete?this.m:this.n;let ne;try{ne=await ee.scanExtensions(V)}catch(_){if(_ instanceof v.$up&&_.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ne=await ee.scanExtensions(V);else throw _}return ne=await this.J(ne,1,H,!0),this.y.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(H,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const J=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(V=>V.scheme===P.Schemas.file).map(async V=>{const ee=await this.P(V,!1,1,!0,H.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(ee)).map(_=>(_.type=K.find(se=>(0,m.$Ao)(se.identifier,_.identifier))?.type??_.type,this.n.validate(_,ee)))}))).flat();return this.J(J,"development",H,!0)}return[]}async scanExistingExtension(H,K,J){const V=await this.P(H,!1,K,!0,J.language,!0,void 0),ee=await this.n.scanExtension(V);return!ee||!J.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(H,K,J){const V=await this.P(H,!1,K,!0,J.language,!0,void 0),ee=await this.n.scanOneOrMultipleExtensions(V);return this.J(ee,K,J,!0)}async scanMetadata(H){const K=(0,l.$vg)(H,"package.json"),J=(await this.w.readFile(K)).value.toString();return JSON.parse(J).__metadata}async updateMetadata(H,K){const J=(0,l.$vg)(H,"package.json"),V=(await this.w.readFile(J)).value.toString(),ee=JSON.parse(V);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,ee.__metadata={...ee.__metadata,...K},await this.w.writeFile((0,l.$vg)(H,"package.json"),A.$be.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof v.$up&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$be.fromString(JSON.stringify([])))}catch(K){(0,a.$qk)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,I.$9)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,K,J,V){return J.includeAllVersions||(H=this.L(K===0?H:void 0,K===1?H:void 0,K==="development"?H:void 0,await this.getTargetPlatform(),V)),J.includeInvalid||(H=H.filter(ee=>ee.isValid)),H.sort((ee,ne)=>{const _=E.$mc(ee.location.fsPath),se=E.$mc(ne.location.fsPath);return _<se?-1:_>se?1:0})}L(H,K,J,V,ee){const ne=(se,Q,q)=>{if(se.isValid&&!Q.isValid)return!1;if(se.isValid===Q.isValid){if(ee&&$.gt(se.manifest.version,Q.manifest.version))return this.y.debug(`Skipping extension ${Q.location.path} with lower version ${Q.manifest.version} in favour of ${se.location.path} with version ${se.manifest.version}`),!1;if($.eq(se.manifest.version,Q.manifest.version)){if(se.type===0)return this.y.debug(`Skipping extension ${Q.location.path} in favour of system extension ${se.location.path} with same version`),!1;if(se.targetPlatform===V)return this.y.debug(`Skipping extension ${Q.location.path} from different target platform ${Q.targetPlatform}`),!1}}return q?this.y.warn(`Overwriting user extension ${se.location.path} with ${Q.location.path}.`):this.y.debug(`Overwriting user extension ${se.location.path} with ${Q.location.path}.`),!0},_=new k.$9l;return H?.forEach(se=>{const Q=_.get(se.identifier.id);(!Q||ne(Q,se,!1))&&_.set(se.identifier.id,se)}),K?.forEach(se=>{const Q=_.get(se.identifier.id);if(!Q&&H&&se.type===0){this.y.debug(`Skipping obsolete system extension ${se.location.path}.`);return}(!Q||ne(Q,se,!1))&&_.set(se.identifier.id,se)}),J?.forEach(se=>{const Q=_.get(se.identifier.id);(!Q||ne(Q,se,!0))&&_.set(se.identifier.id,se),_.set(se.identifier.id,se)}),[..._.values()]}async M(H,K){this.y.trace("Started scanning system extensions");const J=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),ee=await(H&&!J.devMode?this.j:this.n).scanExtensions(J);return this.y.trace("Scanned system extensions:",ee.length),ee}async N(H,K){const J=this.z.isBuilt?[]:this.C.builtInExtensions;if(!J?.length)return[];this.y.trace("Started scanning dev system extensions");const V=K?await this.O():{},ee=[],ne=c.URI.file(E.$gc(E.$ic(P.$cg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const se of J){const Q=V[se.name]||"marketplace";switch(Q){case"disabled":break;case"marketplace":ee.push((0,l.$vg)(ne,se.name));break;default:ee.push(c.URI.file(Q));break}}const _=await Promise.all(ee.map(async se=>this.n.scanExtension(await this.P(se,!1,0,!0,H,!0,void 0))));return this.y.trace("Scanned dev system extensions:",_.length),(0,D.$Gb)(_)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,K,J,V,ee,ne,_){const se=await this.f(ee??b.$w),Q=await this.Q(H),q=K&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,C=q?await this.Q(q):void 0;return new M(H,Q,q,C,K,_,J,V,ne,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,ee,se)}async Q(H){try{const K=await this.w.stat(H);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.$Ap=T,e.$Ap=T=ye([Y(4,y.$Lk),Y(5,v.$vp),Y(6,a.$_j),Y(7,i.$$i),Y(8,f.$Xh),Y(9,t.$qj),Y(10,h.$Jk),Y(11,n.$Ph)],T);class M{constructor(H,K,J,V,ee,ne,_,se,Q,q,C,L,B,N,W){this.location=H,this.mtime=K,this.applicationExtensionslocation=J,this.applicationExtensionslocationMtime=V,this.profile=ee,this.profileScanOptions=ne,this.type=_,this.excludeObsolete=se,this.validate=Q,this.productVersion=q,this.productDate=C,this.productCommit=L,this.devMode=B,this.language=N,this.translations=W}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,K){return(0,l.$og)(H.location,K.location)&&H.mtime===K.mtime&&(0,l.$og)(H.applicationExtensionslocation,K.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&H.profile===K.profile&&j.$_m(H.profileScanOptions,K.profileScanOptions)&&H.type===K.type&&H.excludeObsolete===K.excludeObsolete&&H.validate===K.validate&&H.productVersion===K.productVersion&&H.productDate===K.productDate&&H.productCommit===K.productCommit&&H.devMode===K.devMode&&H.language===K.language&&O.equals(H.translations,K.translations)}}e.$Bp=M;let U=class extends d.$Rc{constructor(H,K,J,V,ee){super(),this.f=H,this.g=K,this.h=J,this.j=V,this.m=ee}async scanExtensions(H){const K=H.profile?await this.r(H):await this.n(H);let J={};if(H.excludeObsolete&&H.type===1)try{const V=(await this.j.readFile(this.f)).value.toString();J=JSON.parse(V)}catch{}return(0,w.$Lf)(J)?K:K.filter(V=>!J[m.$Bo.create(V).toString()])}async n(H){const K=await this.j.resolve(H.location);if(!K.children?.length)return[];const J=await Promise.all(K.children.map(async V=>{if(!V.isDirectory||H.type===1&&(0,l.$sg)(V.resource).indexOf(".")===0)return null;const ee=new M(V.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ee)}));return(0,D.$Gb)(J).sort((V,ee)=>V.location.path<ee.location.path?-1:1)}async r(H){let K=await this.s(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){K=K.filter(V=>!V.metadata?.isApplicationScoped);const J=await this.s(H.applicationExtensionslocation,V=>!!V.metadata?.isBuiltin||!!V.metadata?.isApplicationScoped,H);K.push(...J)}return K}async s(H,K,J){const V=await this.g.scanProfileExtensions(H,J.profileScanOptions);if(!V.length)return[];const ee=await Promise.all(V.map(async ne=>{if(K(ne)){const _=new M(ne.location,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(_,ne.metadata)}return null}));return(0,D.$Gb)(ee)}async scanOneOrMultipleExtensions(H){try{if(await this.j.exists((0,l.$vg)(H.location,"package.json"))){const K=await this.scanExtension(H);return K?[K]:[]}else return await this.scanExtensions(H)}catch(K){return this.m.error(`Error scanning extensions at ${H.location.path}:`,(0,I.$9)(K)),[]}}async scanExtension(H,K){try{let J=await this.scanExtensionManifest(H.location);if(J){J.publisher||(J.publisher=k.$3l),K=K??J.__metadata,delete J.__metadata;const V=(0,m.$Fo)(J.publisher,J.name),ee=K?.id?{id:V,uuid:K.id}:{id:V},ne=K?.isSystem?0:H.type,_=ne===0||!!K?.isBuiltin;J=await this.t(H.location,J,M.createNlsConfiguration(H));const se={type:ne,identifier:ee,manifest:J,location:H.location,isBuiltin:_,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return H.validate?this.validate(se,H):se}}catch(J){H.type!==0&&this.m.error(J)}return null}validate(H,K){let J=!0;const V=(0,s.$Qo)(K.productVersion,K.productDate,K.location,H.manifest,H.isBuiltin);for(const[ee,ne]of V)ee===p.default.Error&&(J=!1,this.m.error(this.z(K.location,ne)));return H.isValid=J,H.validations=V,H}async scanExtensionManifest(H){const K=(0,l.$vg)(H,"package.json");let J;try{J=(await this.j.readFile(K)).value.toString()}catch(ee){return(0,a.$qk)(ee)!==1&&this.m.error(this.z(H,(0,u.localize)(0,null,K.path,ee.message))),null}let V;try{V=JSON.parse(J)}catch{const ne=[];(0,R.$Xm)(J,ne);for(const _ of ne)this.m.error(this.z(H,(0,u.localize)(1,null,K.path,_.offset,_.length,(0,S.$xp)(_.error))));return null}return(0,R.$7m)(V)!=="object"?(this.m.error(this.z(H,(0,u.localize)(2,null,K.path))),null):V}async t(H,K,J){const V=await this.u(H,K,J);if(V)try{const ee=[],ne=await this.w(V.default,ee);if(ee.length>0)return ee.forEach(se=>{this.m.error(this.z(H,(0,u.localize)(3,null,V.default?.path,(0,S.$xp)(se.error))))}),K;if((0,R.$7m)(V)!=="object")return this.m.error(this.z(H,(0,u.localize)(4,null,V.default?.path))),K;const _=V.values||Object.create(null);return(0,g.$yp)(this.m,K,_,ne)}catch{}return K}async u(H,K,J){const V=(0,l.$vg)(H,"package.nls.json"),ee=(Q,q)=>{q.forEach(C=>{this.m.error(this.z(H,(0,u.localize)(5,null,Q?.path,(0,S.$xp)(C.error))))})},ne=Q=>{this.m.error(this.z(H,(0,u.localize)(6,null,Q?.path)))},_=`${K.publisher}.${K.name}`,se=J.translations[_];if(se)try{const Q=c.URI.file(se),q=(await this.j.readFile(Q)).value.toString(),C=[],L=(0,R.$Xm)(q,C);return C.length>0?(ee(Q,C),{values:void 0,default:V}):(0,R.$7m)(L)!=="object"?(ne(Q),{values:void 0,default:V}):{values:L.contents?L.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.j.exists(V))return;let q;try{q=await this.y(H,J)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const C=(await this.j.readFile(q.localized)).value.toString(),L=[],B=(0,R.$Xm)(C,L);return L.length>0?(ee(q.localized,L),{values:void 0,default:q.original}):(0,R.$7m)(B)!=="object"?(ne(q.localized),{values:void 0,default:q.original}):{values:B,default:q.original}}catch{return{values:void 0,default:q.original}}}}async w(H,K){if(H)try{const J=(await this.j.readFile(H)).value.toString();return(0,R.$Xm)(J,K)}catch{}}y(H,K){return new Promise((J,V)=>{const ee=ne=>{const _=(0,l.$vg)(H,`package.nls.${ne}.json`);this.j.exists(_).then(se=>{se&&J({localized:_,original:(0,l.$vg)(H,"package.nls.json")});const Q=ne.lastIndexOf("-");Q===-1?J({localized:(0,l.$vg)(H,"package.nls.json"),original:null}):(ne=ne.substring(0,Q),ee(ne))})};if(K.devMode||K.pseudo||!K.language)return J({localized:(0,l.$vg)(H,"package.nls.json"),original:null});ee(K.language)})}z(H,K){return`[${H.path}]: ${K}`}};U=ye([Y(1,v.$vp),Y(2,h.$Jk),Y(3,a.$_j),Y(4,i.$$i)],U);let z=class extends U{constructor(H,K,J,V,ee,ne,_){super(K,V,ee,ne,_),this.G=H,this.H=J,this.D=this.B(new F.$Rg(3e3)),this.F=this.B(new r.$Nd),this.onDidChangeCache=this.F.event}async scanExtensions(H){const K=this.M(H),J=await this.I(K);if(this.C=H,J&&J.input&&M.equals(J.input,this.C))return this.m.debug("Using cached extensions scan result",H.location.toString()),this.D.trigger(()=>this.L()),J.result.map(ee=>(ee.location=c.URI.revive(ee.location),ee));const V=await super.scanExtensions(H);return await this.J(K,{input:H,result:V}),V}async I(H){try{const K=await this.j.readFile(H),J=JSON.parse(K.value.toString());return{result:J.result,input:(0,o.$nh)(J.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",H.path,(0,I.$9)(K))}return null}async J(H,K){try{await this.j.writeFile(H,A.$be.fromString(JSON.stringify(K)))}catch(J){this.m.debug("Error while writing the extension cache file:",H.path,(0,I.$9)(J))}}async L(){if(!this.C)return;const H=this.M(this.C),K=await this.I(H);if(!K)return;const J=K.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!j.$_m(V,J))try{this.m.info("Invalidating Cache",J,V),await this.j.del(H),this.F.fire()}catch(ee){this.m.error(ee)}}M(H){const K=this.N(H);return this.h.extUri.joinPath(K.cacheHome,H.type===0?k.$2l:k.$1l)}N(H){return H.type===0?this.H.defaultProfile:H.profile?this.h.extUri.isEqual(H.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(H.location,K.extensionsResource))??this.G:this.H.defaultProfile}};z=ye([Y(2,y.$Lk),Y(3,v.$vp),Y(4,h.$Jk),Y(5,a.$_j),Y(6,i.$$i)],z);function Z(x,H){const K=(0,m.$Do)(x.manifest.publisher,x.manifest.name);return{id:K,identifier:new k.$7l(K),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:H,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$Cp=Z;class X extends T{constructor(H,K,J,V,ee,ne,_,se,Q,q,C,L){super(H,K,(0,l.$vg)(J,".vscode-oss-dev","extensions","control.json"),V,ee,ne,_,se,Q,q,C,L),this.R=(async()=>{if(b.$z)try{const B=await this.w.readFile(c.URI.file(b.$z));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(H){return this.R}}e.$Dp=X}),define(ae[243],ce([0,1,66,6,38,3,2,23,16,31,8,17]),function(te,e,D,F,j,A,I,R,S,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=void 0;let b=class extends I.$Rc{constructor($,p){super(),this.b=$,this.f=p,this.a=new F.$1g(5)}async postUninstall($){const p=this.g($,"uninstall");p&&(this.f.info($.identifier.id,$.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,$),this.f.info("Finished running post uninstall script",$.identifier.id,$.manifest.version)}catch(w){this.f.error("Failed to run post uninstall script",$.identifier.id,$.manifest.version),this.f.error(w)}}));try{await d.Promises.rm(this.m($))}catch(w){this.f.error("Error while removing extension storage path",$.identifier.id),this.f.error(w)}}g($,p){const w=`vscode:${p}`;if($.location.scheme===R.Schemas.file&&$.manifest&&$.manifest.scripts&&typeof $.manifest.scripts[w]=="string"){const c=$.manifest.scripts[w].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn($.identifier.id,$.manifest.version,`${w} should be a node script`),null):{script:(0,S.$ic)($.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h($,p,w,c,u){return new Promise((f,m)=>{const k=this.j($,p,w,u);let s;const a=n=>{s&&(clearTimeout(s),s=null),n?m(n):f(void 0)};k.on("error",n=>{a((0,j.$Bi)(n)||"Unknown")}),k.on("exit",(n,i)=>{a(n?`post-${p} process exited with code ${n}`:void 0)}),c&&(s=setTimeout(()=>{s=null,k.kill(),m("timed out")},5e3))})}j($,p,w,c){const u={silent:!0,execArgv:void 0},f=(0,D.fork)($,[`--type=extension-post-${p}`,...w],u);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const m=A.Event.fromNodeEventEmitter(f.stdout,"data"),k=A.Event.fromNodeEventEmitter(f.stderr,"data");m(n=>this.f.info(c.identifier.id,c.manifest.version,`post-${p}`,n)),k(n=>this.f.error(c.identifier.id,c.manifest.version,`post-${p}`,n));const s=A.Event.any(A.Event.map(m,n=>({data:`%c${n}`,format:[""]})),A.Event.map(k,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(s,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(c.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}m($){return(0,S.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,$.identifier.id.toLowerCase())}};e.$Fp=b,e.$Fp=b=ye([Y(0,E.$Lk),Y(1,P.$$i)],b)}),define(ae[244],ce([0,1,8,17,28,22,51,11,14,10]),function(te,e,D,F,j,A,I,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QN=void 0;let P=class extends I.$wp{constructor(b,l,$,p,w,c){super(d.URI.file(b.extensionsPath),l,$,p,w,c)}};e.$QN=P,e.$QN=P=ye([Y(0,S.$Yh),Y(1,R.$_j),Y(2,F.$Lk),Y(3,j.$Jk),Y(4,A.$dl),Y(5,D.$$i)],P)}),define(ae[245],ce([0,1,10,14,51,80,11,4,8,25,28,17]),function(te,e,D,F,j,A,I,R,S,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G8b=void 0;let b=class extends A.$Dp{constructor($,p,w,c,u,f,m,k){super(D.URI.file(u.builtinExtensionsPath),D.URI.file(u.extensionsPath),u.userHome,$.defaultProfile,$,p,w,c,u,f,m,k)}};e.$G8b=b,e.$G8b=b=ye([Y(0,E.$Lk),Y(1,j.$vp),Y(2,I.$_j),Y(3,S.$$i),Y(4,F.$Yh),Y(5,d.$qj),Y(6,P.$Jk),Y(7,R.$Ph)],b)}),define(ae[21],ce([0,1,6,3,2,100,12,68,4,17]),function(te,e,D,F,j,A,I,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$7o=e.$6o=e.$5o=void 0,e.$5o="__$__isNewStorageMarker",e.$6o="__$__targetStorageMarker",e.$7o=(0,S.$Qh)("storageService");var P;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var E;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var b;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function l(u){const f=u.get(e.$6o);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}e.$8o=l;class $ extends j.$Rc{static{this.a=60*1e3}constructor(f={flushInterval:$.a}){super(),this.m=f,this.b=this.B(new F.$Qd),this.c=this.B(new F.$Qd),this.onDidChangeTarget=this.c.event,this.f=this.B(new F.$Nd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$7g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new j.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(f,m,k){return F.Event.filter(this.b.event,s=>s.scope===f&&(m===void 0||s.key===m),k)}n(){this.j.value=(0,D.$$g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,j.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(f,m){const{key:k,external:s}=m;if(k===e.$6o){switch(f){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:f})}else this.b.fire({scope:f,key:k,target:this.J(f)[k],external:s})}w(f){this.f.fire({reason:f})}get(f,m,k){return this.P(m)?.get(f,k)}getBoolean(f,m,k){return this.P(m)?.getBoolean(f,k)}getNumber(f,m,k){return this.P(m)?.getNumber(f,k)}getObject(f,m,k){return this.P(m)?.getObject(f,k)}storeAll(f,m){this.y(()=>{for(const k of f)this.store(k.key,k.value,k.scope,k.target,m)})}store(f,m,k,s,a=!1){if((0,I.$Hf)(m)){this.remove(f,k,a);return}this.y(()=>{this.z(f,k,s),this.P(k)?.set(f,m,a)})}remove(f,m,k=!1){this.y(()=>{this.z(f,m,void 0),this.P(m)?.delete(f,k)})}y(f){this.b.pause(),this.c.pause();try{f()}finally{this.b.resume(),this.c.resume()}}keys(f,m){const k=[],s=this.J(f);for(const a of Object.keys(s))s[a]===m&&k.push(a);return k}z(f,m,k,s=!1){const a=this.J(m);typeof k=="number"?a[f]!==k&&(a[f]=k,this.P(m)?.set(e.$6o,JSON.stringify(a),s)):typeof a[f]=="number"&&(delete a[f],this.P(m)?.set(e.$6o,JSON.stringify(a),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(f){switch(f){case-1:return this.I;case 0:return this.G;default:return this.D}}L(f){const m=this.P(f);return m?l(m):Object.create(null)}isNew(f){return this.getBoolean(e.$5o,f)===!0}async flush(f=P.NONE){this.f.fire({reason:f});const m=this.P(-1),k=this.P(0),s=this.P(1);switch(f){case P.NONE:await D.Promises.settled([m?.whenFlushed()??Promise.resolve(),k?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await D.Promises.settled([m?.flush(0)??Promise.resolve(),k?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,k=this.P(1)?.items??new Map;return c(f,m,k,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(f){return await this.flush(),this.P(f)?.optimize()}async switch(f,m){return this.w(P.NONE),(0,d.$Kk)(f)?this.R(f,m):this.S(f,m)}M(f,m){return!(f.id===m.id||p(m)&&p(f))}N(f,m,k){this.y(()=>{const s=new Set;for(const[a,n]of f)s.add(a),m.get(a)!==n&&this.u(k,{key:a,external:!0});for(const[a]of m.items)s.has(a)||this.u(k,{key:a,external:!0})})}}e.$9o=$;function p(u){return u.isDefault||!!u.useDefaultFlags?.globalState}e.$0o=p;class w extends ${constructor(){super(),this.U=this.B(new R.$3o(new R.$4o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$3o(new R.$4o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$3o(new R.$4o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(f=>this.u(1,f))),this.B(this.W.onDidChangeStorage(f=>this.u(0,f))),this.B(this.U.onDidChangeStorage(f=>this.u(-1,f)))}P(f){switch(f){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(f){return!1}}e.$$o=w;async function c(u,f,m,k,s,a){const n=O=>{try{return JSON.parse(O)}catch{return O}},i=new Map,t=new Map;u.forEach((O,T)=>{i.set(T,O),t.set(T,n(O))});const r=new Map,o=new Map;f.forEach((O,T)=>{r.set(T,O),o.set(T,n(O))});const v=new Map,y=new Map;m.forEach((O,T)=>{v.set(T,O),y.set(T,n(O))}),console.group(k!==s?`Storage: Application (path: ${k})`:`Storage: Application & Profile (path: ${k}, default profile)`);const h=[];if(i.forEach((O,T)=>{h.push({key:T,value:O})}),console.table(h),console.groupEnd(),console.log(t),k!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const O=[];r.forEach((T,M)=>{O.push({key:M,value:T})}),console.table(O),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${a})`);const g=[];v.forEach((O,T)=>{g.push({key:T,value:O})}),console.table(g),console.groupEnd(),console.log(y)}e.$_o=c}),define(ae[113],ce([0,1,3,2,12,29,33,21]),function(te,e,D,F,j,A,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eDb=e.$dDb=void 0;let S=class extends F.$Rc{constructor(E,b){super(),this.a=new D.$Nd,this.onDidChangeEnablement=this.a.event,this.b=this.B(new d(E)),this.B(this.b.onDidChange(l=>this.a.fire({extensions:l,source:"storage"}))),this.B(b.onDidInstallExtensions(l=>l.forEach(({local:$,operation:p})=>{$&&p===4&&this.f($.identifier)})))}async enableExtension(E,b){return this.f(E)?(this.a.fire({extensions:[E],source:b}),!0):!1}async disableExtension(E,b){return this.c(E)?(this.a.fire({extensions:[E],source:b}),!0):!1}getDisabledExtensions(){return this.h(A.$bo)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(E){const b=this.getDisabledExtensions();return b.every(l=>!(0,I.$Ao)(l,E))?(b.push(E),this.g(b),!0):!1}f(E){const b=this.getDisabledExtensions();for(let l=0;l<b.length;l++){const $=b[l];if((0,I.$Ao)($,E))return b.splice(l,1),this.g(b),!0}return!1}g(E){this.j(A.$bo,E)}h(E){return this.b.get(E,0)}j(E,b){this.b.set(E,b,0)}};e.$dDb=S,e.$dDb=S=ye([Y(0,R.$7o),Y(1,A.$ao)],S);class d extends F.$Rc{constructor(E){super(),this.c=E,this.a=Object.create(null),this.b=this.B(new D.$Nd),this.onDidChange=this.b.event,this.B(E.onDidChangeValue(0,void 0,this.B(new F.$Qc))(b=>this.f(b)))}get(E,b){let l;return b===0?((0,j.$Hf)(this.a[E])&&(this.a[E]=this.g(E,b)),l=this.a[E]):l=this.g(E,b),JSON.parse(l)}set(E,b,l){const $=JSON.stringify(b.map(({id:w,uuid:c})=>({id:w,uuid:c})));this.g(E,l)!==$&&(l===0&&(b.length?this.a[E]=$:delete this.a[E]),this.h(E,b.length?$:void 0,l))}f(E){if(!(0,j.$Hf)(this.a[E.key])&&this.g(E.key,E.scope)!==this.a[E.key]){const l=this.get(E.key,E.scope);delete this.a[E.key];const $=this.get(E.key,E.scope),p=l.filter(c=>!$.some(u=>(0,I.$Ao)(c,u))),w=$.filter(c=>!l.some(u=>(0,I.$Ao)(u,c)));(p.length||w.length)&&this.b.fire([...p,...w])}}g(E,b){return this.c.get(E,b,"[]")}h(E,b,l){b?this.c.store(E,b,l,1):this.c.remove(E,l)}}e.$eDb=d}),define(ae[246],ce([0,1,18,26,7,5,37,12,10,20,14,29,33,69,11,8,25,58,224,21,22,62]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w,c,u,f,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.$cp=void 0;const s=A.$p?"web":(0,E.$7n)(A.$u,I.$dc),a="X-Market-Search-Activity-Id";var n;(function(C){C[C.None=0]="None",C[C.IncludeVersions=1]="IncludeVersions",C[C.IncludeFiles=2]="IncludeFiles",C[C.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",C[C.IncludeSharedAccounts=8]="IncludeSharedAccounts",C[C.IncludeVersionProperties=16]="IncludeVersionProperties",C[C.ExcludeNonValidated=32]="ExcludeNonValidated",C[C.IncludeInstallationTargets=64]="IncludeInstallationTargets",C[C.IncludeAssetUri=128]="IncludeAssetUri",C[C.IncludeStatistics=256]="IncludeStatistics",C[C.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",C[C.Unpublished=4096]="Unpublished",C[C.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function i(...C){return String(C.reduce((L,B)=>L|B,0))}var t;(function(C){C[C.Tag=1]="Tag",C[C.ExtensionId=4]="ExtensionId",C[C.Category=5]="Category",C[C.ExtensionName=7]="ExtensionName",C[C.Target=8]="Target",C[C.Featured=9]="Featured",C[C.SearchText=10]="SearchText",C[C.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class h{constructor(L=y){this.d=L}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(L,B=this.d.pageSize){return new h({...this.d,pageNumber:L,pageSize:B})}withFilter(L,...B){const N=[...this.d.criteria,...B.length?B.map(W=>({filterType:L,value:W})):[{filterType:L}]];return new h({...this.d,criteria:N})}withSortBy(L){return new h({...this.d,sortBy:L})}withSortOrder(L){return new h({...this.d,sortOrder:L})}withFlags(...L){return new h({...this.d,flags:L.reduce((B,N)=>B|N,0)})}withAssetTypes(...L){return new h({...this.d,assetTypes:L})}withSource(L){return new h({...this.d,source:L})}get raw(){const{criteria:L,pageNumber:B,pageSize:N,sortBy:W,sortOrder:G,flags:ie,assetTypes:oe}=this.d;return{filters:[{criteria:L,pageNumber:B,pageSize:N,sortBy:W,sortOrder:G}],assetTypes:oe,flags:ie}}get searchText(){const L=this.d.criteria.filter(B=>B.filterType===t.SearchText)[0];return L&&L.value?L.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(L=>String(L.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function g(C,L){const B=(C||[]).filter(N=>N.statisticName===L)[0];return B?B.value:0}function O(C){const L="Microsoft.VisualStudio.Code.Translation.";return C.files.filter(N=>N.assetType.indexOf(L)===0).reduce((N,W)=>{const G=U(C,W.assetType);return G&&N.push([W.assetType.substring(L.length),G]),N},[])}function T(C){if(C.properties){const L=C.properties.filter(W=>W.key===r.Repository),B=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),N=L.filter(W=>B.test(W.value))[0];return N?{uri:N.value,fallbackUri:N.value}:null}return U(C,r.Repository)}function M(C){return{uri:`${C.fallbackAssetUri}/${r.VSIX}?redirect=true${C.targetPlatform?`&targetPlatform=${C.targetPlatform}`:""}`,fallbackUri:`${C.fallbackAssetUri}/${r.VSIX}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`}}function U(C,L){return C.files.filter(N=>N.assetType===L)[0]?{uri:`${C.assetUri}/${L}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`,fallbackUri:`${C.fallbackAssetUri}/${L}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`}:null}function z(C,L){const B=C.properties?C.properties.filter(W=>W.key===L):[],N=B.length>0&&B[0].value;return N?N.split(",").map(W=>(0,b.$Eo)(W)):[]}function Z(C){const L=C.properties?C.properties.filter(B=>B.key===o.Engine):[];return L.length>0&&L[0].value||""}function X(C){const L=C.properties?C.properties.filter(B=>B.key===o.PreRelease):[];return L.length>0&&L[0].value==="true"}function x(C){const L=C.properties?C.properties.filter(N=>N.key===o.LocalizedLanguages):[],B=L.length>0&&L[0].value||"";return B?B.split(","):[]}function H(C){return C.properties?.find(L=>L.key===o.SponsorLink)?.value}function K(C){return C.indexOf("preview")!==-1}function J(C){return C.targetPlatform?(0,E.$6n)(C.targetPlatform):"undefined"}function V(C){const L=(0,D.$Lb)(C.versions.map(J)),B=!!C.tags?.includes(E.$1n),N=L.indexOf("web");return B?N===-1&&L.push("web"):N!==-1&&L.splice(N,1),L}function ee(C,L){for(let B=0;B<C.length;B++){const N=C[B];if(N.version===C[B-1]?.version){let W=B;if(J(N)===L)for(;W>0&&C[W-1].version===N.version;)W--;W!==B&&(C.splice(B,1),C.splice(W,0,N))}}return C}e.$cp=ee;function ne(C,L,B){C.telemetryData={index:L,querySource:B,queryActivityId:C.queryContext?.[a]}}function _(C,L,B,N){const W=C.versions[0],G={manifest:U(L,r.Manifest),readme:U(L,r.Details),changelog:U(L,r.Changelog),license:U(L,r.License),repository:T(L),download:M(L),icon:U(L,r.Icon),signature:U(L,r.Signature),coreTranslations:O(L)};return{identifier:{id:(0,b.$Fo)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},name:C.extensionName,version:L.version,displayName:C.displayName,publisherId:C.publisher.publisherId,publisher:C.publisher.publisherName,publisherDisplayName:C.publisher.displayName,publisherDomain:C.publisher.domain?{link:C.publisher.domain,verified:!!C.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(W),description:C.shortDescription||"",installCount:g(C.statistics,"install"),rating:g(C.statistics,"averagerating"),ratingCount:g(C.statistics,"ratingcount"),categories:C.categories||[],tags:C.tags||[],releaseDate:Date.parse(C.releaseDate),lastUpdated:Date.parse(C.lastUpdated),allTargetPlatforms:B,assets:G,properties:{dependencies:z(L,o.Dependency),extensionPack:z(L,o.ExtensionPack),engine:Z(L),localizedLanguages:x(L),targetPlatform:J(L),isPreReleaseVersion:X(L)},hasPreReleaseVersion:X(W),hasReleaseVersion:!0,preview:K(C.flags),isSigned:!!G.signature,queryContext:N}}let se=class{constructor(L,B,N,W,G,ie,oe,ue){this.k=B,this.l=N,this.n=W,this.o=G,this.q=ie,this.u=oe,this.w=ue;const he=oe.extensionsGallery,$e=he?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=$e?he.servicePPEUrl:he?.serviceUrl,this.g=$e?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,u.$bp)(oe.version,oe,this.n,this.w,this.q,L,this.o)}x(L=""){return`${this.d}${L}`}isEnabled(){return!!this.d}async getExtensions(L,B,N){const W=F.CancellationToken.isCancellationToken(B)?{}:B,G=F.CancellationToken.isCancellationToken(B)?B:N,ie=[],oe=[],ue=[],he=[];let $e=!0;for(const ve of L){ve.uuid?oe.push(ve.uuid):ie.push(ve.id);const Ie=!!(ve.version||ve.preRelease);ue.push({id:ve.id,uuid:ve.uuid,includePreRelease:Ie}),ve.version&&he.push({id:ve.id,uuid:ve.uuid,version:ve.version}),$e=$e&&!!ve.hasPreRelease&&!Ie}if(!oe.length&&!ie.length)return[];let de=new h().withPage(1,L.length);oe.length&&(de=de.withFilter(t.ExtensionId,...oe)),ie.length&&(de=de.withFilter(t.ExtensionName,...ie)),(W.queryAllVersions||$e)&&(de=de.withFlags(de.flags,n.IncludeVersions)),W.source&&(de=de.withSource(W.source));const{extensions:we}=await this.z(de,{targetPlatform:W.targetPlatform??s,includePreRelease:ue,versions:he,compatible:!!W.compatible},G);return W.source&&we.forEach((ve,Ie)=>ne(ve,Ie,W.source)),we}async getCompatibleExtension(L,B,N){if((0,E.$8n)(L.allTargetPlatforms,N))return null;if(await this.isExtensionCompatible(L,B,N))return L;const W=new h().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,L.identifier.uuid),{extensions:G}=await this.z(W,{targetPlatform:N,compatible:!0,includePreRelease:B},F.CancellationToken.None);return G[0]||null}async isExtensionCompatible(L,B,N){if(!(0,E.$9n)(L.properties.targetPlatform,L.allTargetPlatforms,N)||!B&&L.properties.isPreReleaseVersion)return!1;let W=L.properties.engine;if(!W){const G=await this.getManifest(L,F.CancellationToken.None);if(!G)throw new Error("Manifest was not found");W=G.engines.vscode}return(0,l.$So)(W,this.u.version,this.u.date)}async y(L,B,N,W,G){if(!(0,E.$9n)(J(L),W,G)||B!=="any"&&X(L)!==(B==="prerelease"))return!1;if(N)try{const ie=await this.E(L);if(!(0,l.$So)(ie,this.u.version,this.u.date))return!1}catch(ie){return this.l.error(`Error while getting the engine for the version ${L.version}.`,(0,j.$9)(ie)),!1}return!0}async query(L,B){let N=L.text||"";const W=L.pageSize??50;let G=new h().withPage(1,W);N?(N=N.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(G=G.withFilter(t.Category,we||de),"")),N=N.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(G=G.withFilter(t.Tag,we||de),"")),N=N.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(t.Featured),"")),N=N.trim(),N&&(N=N.length<200?N:N.substring(0,200),G=G.withFilter(t.SearchText,N)),G=G.withSortBy(0)):L.ids?G=G.withFilter(t.ExtensionId,...L.ids):L.names?G=G.withFilter(t.ExtensionName,...L.names):G=G.withSortBy(4),typeof L.sortBy=="number"&&(G=G.withSortBy(L.sortBy)),typeof L.sortOrder=="number"&&(G=G.withSortOrder(L.sortOrder)),L.source&&(G=G.withSource(L.source));const ie=async($e,de)=>{const{extensions:we,total:ve}=await this.z($e,{targetPlatform:s,compatible:!1,includePreRelease:!!L.includePreRelease},de);return we.forEach((Ie,Le)=>ne(Ie,($e.pageNumber-1)*$e.pageSize+Le,L.source)),{extensions:we,total:ve}},{extensions:oe,total:ue}=await ie(G,B),he=async($e,de)=>{if(de.isCancellationRequested)throw new j.$4;const{extensions:we}=await ie(G.withPage($e+1),de);return we};return{firstPage:oe,total:ue,pageSize:G.pageSize,getPage:he}}async z(L,B,N){const W=L.flags;L.flags&n.IncludeLatestVersionOnly&&L.flags&n.IncludeVersions&&(L=L.withFlags(L.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(L.flags&n.IncludeLatestVersionOnly)&&!(L.flags&n.IncludeVersions)&&(L=L.withFlags(L.flags,n.IncludeLatestVersionOnly)),B.versions?.length&&(L=L.withFlags(L.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),L=L.withFlags(L.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:G,total:ie,context:oe}=await this.B(L,N);if(!(L.flags&n.IncludeLatestVersionOnly)){const de=[];for(const we of G){const ve=await this.A(we,B,oe);ve&&de.push(ve)}return{extensions:de,total:ie}}const he=[],$e=new Map;for(let de=0;de<G.length;de++){const we=G[de],ve={id:(0,b.$Fo)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Ie=(0,R.$Ef)(B.includePreRelease)?B.includePreRelease:!!B.includePreRelease.find(Me=>(0,b.$Ao)(Me,ve))?.includePreRelease;if(B.compatible&&(0,E.$8n)(V(we),B.targetPlatform))continue;const Le=await this.A(we,B,oe);!Le||Le.properties.isPreReleaseVersion&&(!Ie||!Le.hasReleaseVersion)||!Le.properties.isPreReleaseVersion&&Le.properties.targetPlatform!==B.targetPlatform&&Le.hasPreReleaseVersion?$e.set(we.extensionId,de):he.push([de,Le])}if($e.size){const de=new k.$Jd,we=new h().withFlags(W&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,$e.size).withFilter(t.ExtensionId,...$e.keys()),{extensions:ve}=await this.z(we,B,N);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:$e.size});for(const Ie of ve){const Le=$e.get(Ie.identifier.uuid);he.push([Le,Ie])}}return{extensions:he.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:ie}}async A(L,B,N){const W={id:(0,b.$Fo)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},G=B.versions?.find(he=>(0,b.$Ao)(he,W))?.version,ie=(0,R.$Ef)(B.includePreRelease)?B.includePreRelease:!!B.includePreRelease.find(he=>(0,b.$Ao)(he,W))?.includePreRelease,oe=V(L),ue=ee(L.versions,B.targetPlatform);if(B.compatible&&(0,E.$8n)(oe,B.targetPlatform))return null;for(let he=0;he<ue.length;he++){const $e=ue[he];if(!(G&&$e.version!==G)){if(await this.y($e,ie?"any":"release",B.compatible,oe,B.targetPlatform))return _(L,$e,oe,N);if(G&&$e.version===G)return null}}return G||B.compatible?null:_(L,L.versions[0],oe)}async B(L,B){if(!this.isEnabled())throw new Error("No extension gallery service configured.");L=L.withFlags(L.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(n.Unpublished));const N=await this.j,W=JSON.stringify(L.raw),G={...N,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)},ie=new k.$Jd;let oe,ue,he=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&L.criteria.some(de=>de.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:W,headers:G},B),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:he};const $e=await(0,c.$Zo)(oe);if($e){const de=$e.results[0],we=de.extensions,ve=de.resultMetadata&&de.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return he=ve&&ve.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:he,context:{[a]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch($e){throw ue=$e,$e}finally{this.o.publicLog2("galleryService:query",{...L.telemetryData,requestBodySize:String(W.length),duration:ie.elapsed(),success:!!oe&&(0,c.$Vo)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:ue?(0,j.$3)(ue)?"canceled":(0,j.$9)(ue).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(L,B,N,W){if(!this.isEnabled())return;const G=A.$p?this.x(`/itemName/${L}.${B}/version/${N}/statType/${W==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${L}/extensions/${B}/${N}/stats?statType=${W}`),ie=A.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:ie};try{await this.k.request({type:"POST",url:G,headers:ue},F.CancellationToken.None)}catch{}}async download(L,B,N){this.l.trace("ExtensionGalleryService#download",L.identifier.id);const W=(0,b.$Io)(L),G=new Date().getTime(),ie=de=>this.o.publicLog("galleryService:downloadVSIX",{...W,duration:de}),oe=N===2?"install":N===3?"update":"",ue=oe?{uri:`${L.assets.download.uri}${S.URI.parse(L.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${L.assets.download.fallbackUri}${S.URI.parse(L.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:L.assets.download,he=L.queryContext?.[a]?{[a]:L.queryContext[a]}:void 0,$e=await this.D(ue,he?{headers:he}:void 0);await this.q.writeFile(B,$e.stream),ie(new Date().getTime()-G)}async downloadSignatureArchive(L,B){if(!L.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",L.identifier.id);const N=await this.D(L.assets.signature);await this.q.writeFile(B,N.stream)}async getReadme(L,B){if(L.assets.readme){const N=await this.D(L.assets.readme,{},B);return await(0,c.$Yo)(N)||""}return""}async getManifest(L,B){if(L.assets.manifest){const N=await this.D(L.assets.manifest,{},B),W=await(0,c.$Yo)(N);return W?JSON.parse(W):null}return null}async C(L,B){const N=U(L,r.Manifest);if(!N)throw new Error("Manifest was not found");const W={"Accept-Encoding":"gzip"},G=await this.D(N,{headers:W});return await(0,c.$Zo)(G)}async getCoreTranslation(L,B){const N=L.assets.coreTranslations.filter(W=>W[0]===B.toUpperCase())[0];if(N){const W=await this.D(N[1]),G=await(0,c.$Yo)(W);return G?JSON.parse(G):null}return null}async getChangelog(L,B){if(L.assets.changelog){const N=await this.D(L.assets.changelog,{},B);return await(0,c.$Yo)(N)||""}return""}async getAllCompatibleVersions(L,B,N){let W=new h().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);L.identifier.uuid?W=W.withFilter(t.ExtensionId,L.identifier.uuid):W=W.withFilter(t.ExtensionName,L.identifier.id);const{galleryExtensions:G}=await this.B(W,F.CancellationToken.None);if(!G.length)return[];const ie=V(G[0]);if((0,E.$8n)(ie,N))return[];const oe=[];await Promise.all(G[0].versions.map(async $e=>{try{await this.y($e,B?"any":"release",!0,ie,N)&&oe.push($e)}catch{}}));const ue=[],he=new Set;for(const $e of ee(oe,N))he.has($e.version)||(he.add($e.version),ue.push({version:$e.version,date:$e.lastUpdated,isPreReleaseVersion:X($e)}));return ue}async D(L,B={},N=F.CancellationToken.None){const W=await this.j,G={type:"GET"},ie={...W,...B.headers||{}};B={...B,...G,headers:ie};const oe=L.uri,ue=L.fallbackUri,he={...B,url:oe};try{const $e=await this.k.request(he,N);if($e.res.statusCode===200)return $e;const de=await(0,c.$Yo)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${de}`)}catch($e){if((0,j.$3)($e))throw $e;const de=(0,j.$9)($e);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:de});const we={...B,url:ue};return this.k.request(we,N)}}async E(L){let B=Z(L);if(!B){const N=await this.C(L,F.CancellationToken.None);if(!N)throw new Error("Manifest was not found");B=N.engines.vscode}return B}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const L=await this.k.request({type:"GET",url:this.h},F.CancellationToken.None);if(L.res.statusCode!==200)throw new Error("Could not get extensions report.");const B=await(0,c.$Zo)(L),N=[],W={},G=[];if(B){for(const ie of B.malicious)N.push({id:ie});if(B.migrateToPreRelease)for(const[ie,oe]of Object.entries(B.migrateToPreRelease))(!oe.engine||(0,l.$So)(oe.engine,this.u.version,this.u.date))&&(W[ie.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(B.deprecated)for(const[ie,oe]of Object.entries(B.deprecated))oe&&(W[ie.toLowerCase()]=(0,R.$Ef)(oe)?{}:oe);if(B.search)for(const ie of B.search)G.push(ie)}return{malicious:N,deprecated:W,search:G}}};se=ye([Y(1,c.$To),Y(2,p.$$i),Y(3,P.$Xh),Y(4,m.$dl),Y(5,$.$_j),Y(6,w.$qj),Y(7,d.$ki)],se);let Q=class extends se{constructor(L,B,N,W,G,ie,oe,ue){super(L,B,N,W,G,ie,oe,ue)}};e.$dp=Q,e.$dp=Q=ye([Y(0,f.$7o),Y(1,c.$To),Y(2,p.$$i),Y(3,P.$Xh),Y(4,m.$dl),Y(5,$.$_j),Y(6,w.$qj),Y(7,d.$ki)],Q);let q=class extends se{constructor(L,B,N,W,G,ie,oe){super(void 0,L,B,N,W,G,ie,oe)}};e.$ep=q,e.$ep=q=ye([Y(0,c.$To),Y(1,p.$$i),Y(2,P.$Xh),Y(3,m.$dl),Y(4,$.$_j),Y(5,w.$qj),Y(6,d.$ki)],q)}),define(ae[81],ce([0,1,4,3,2,21,33,25,18,8,12]),function(te,e,D,F,j,A,I,R,S,d,P){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yu=e.$Xu=void 0,e.$Xu=(0,D.$Qh)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let l=class extends j.$Rc{static{E=this}static{this.a=512*1024}static b(p){return`extensionKeys/${(0,I.$Eo)(p.id)}@${p.version}`}static c(p){const w=b.exec(p);if(w&&w[1])return{id:w[1],version:w[2]}}static async removeOutdatedExtensionVersions(p,w){const c=await p.getInstalled(),u=[];for(const[f,m]of E.f(w)){const k=c.find(s=>(0,I.$Ao)(s.identifier,{id:f}))?.manifest.version;for(const s of m)k!==s&&u.push(E.b({id:f,version:s}))}for(const f of u)w.remove(f,0)}static f(p){const w=new Map,c=p.keys(0,1);for(const u of c){const f=E.c(u);if(f){let m=w.get(f.id.toLowerCase());m||w.set(f.id.toLowerCase(),m=[]),m.push(f.version)}}return w}constructor(p,w,c){super(),this.j=p,this.m=w,this.n=c,this.g=this.B(new F.$Nd),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=E.f(p),this.B(this.j.onDidChangeValue(0,void 0,this.B(new j.$Qc))(u=>this.r(u)))}r(p){if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const w=E.c(p.key);if(w){if(this.j.get(p.key,0)===void 0)this.h.delete(w.id.toLowerCase());else{let c=this.h.get(w.id.toLowerCase());c||this.h.set(w.id.toLowerCase(),c=[]),c.push(w.version),this.g.fire()}return}}s(p){if((0,P.$yf)(p))return p;const w=p.manifest?p.manifest.publisher:p.publisher,c=p.manifest?p.manifest.name:p.name;return(0,I.$Do)(w,c)}getExtensionState(p,w){const c=this.s(p),u=this.getExtensionStateRaw(p,w);if(u)try{return JSON.parse(u)}catch(f){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${c}, global: ${w}): ${f}`)}}getExtensionStateRaw(p,w){const c=this.s(p),u=this.j.get(c,w?0:1);return u&&u?.length>E.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${c}, global: ${w}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(p,w,c){const u=this.s(p);w===void 0?this.j.remove(u,c?0:1):this.j.store(u,JSON.stringify(w),c?0:1,1)}setKeysForSync(p,w){this.j.store(E.b(p),JSON.stringify(w),0,1)}getKeysForSync(p){const w=this.m.extensionSyncedKeys?.[p.id.toLowerCase()],c=this.j.get(E.b(p),0),u=c?JSON.parse(c):void 0;return u&&w?(0,S.$Lb)([...u,...w]):u||w}addToMigrationList(p,w){if(p!==w){const c=this.t.filter(u=>!u.includes(p)&&!u.includes(w));c.push([p,w]),this.t=c}}getSourceExtensionToMigrate(p){const w=this.t.find(([,c])=>p===c);return w?w[0]:void 0}get t(){const p=this.j.get("extensionStorage.migrationList",-1,"[]");try{const w=JSON.parse(p);if(Array.isArray(w))return w}catch{}return[]}set t(p){p.length?this.j.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$Yu=l,e.$Yu=l=E=ye([Y(0,A.$7o),Y(1,R.$qj),Y(2,d.$$i)],l)}),define(ae[247],ce([0,1,29,11,25,14,98,56,21,22,221]),function(te,e,D,F,j,A,I,R,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$59b=void 0;let E=class extends P.$d6b{constructor(l,$,p,w,c,u,f,m){super(l.userHome,c,$,p,w,u,f,m)}};e.$59b=E,e.$59b=E=ye([Y(0,A.$Yh),Y(1,d.$dl),Y(2,D.$ao),Y(3,S.$7o),Y(4,R.$U7b),Y(5,I.$rWb),Y(6,F.$_j),Y(7,j.$qj)],E)}),define(ae[248],ce([0,1,105,3,22,14,2,8,16,66,25,5,6,101,20,164,36,21,12,131,19]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w,c,u,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$19b=void 0;const k=[D.$T9b,D.$U9b],s="remoteTunnelSession",a="remoteTunnelIsService";let n=class extends I.$Rc{constructor(o,v,y,h,g,O,T){super(),this.y=o,this.z=v,this.C=y,this.D=O,this.F=T,this.f=new F.$Nd,this.onDidTokenFailed=this.f.event,this.g=new F.$Nd,this.onDidChangeTunnelStatus=this.g.event,this.h=new F.$Nd,this.onDidChangeMode=this.h.event,this.n=D.$R9b,this.w=!1,this.I=(M,U)=>{U?this.j.error(M):this.j.info(M)},this.j=this.B(h.createLogger((0,m.$vg)(y.logsHome,`${D.$V9b}.log`),{id:D.$V9b,name:D.$W9b})),this.t=new b.$Qg(100),this.B(this.j.onDidChangeLogLevel(M=>this.j.info("Log level changed to "+(0,R.$nj)(M)))),this.B(g.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(O.onDidChangeConfiguration(M=>{k.some(U=>M.affectsConfiguration(U))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=D.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(o){this.s=o,this.g.fire(o)}H(o){t(this.n,o)||(this.n=o,this.S(o),this.h.fire(this.n),o.active?(this.j.info(`Session updated: ${o.session.accountLabel} (${o.session.providerId}) (service=${o.asService})`),o.session.token&&this.j.info(`Session token updated: ${o.session.accountLabel} (${o.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(o){if(this.w)return this.s;this.w=!0,this.H(o);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let o;E.$k?o=this.C.appRoot:o=(0,S.$lc)((0,S.$lc)(this.C.appRoot)),this.u=(0,S.$ic)(o,"bin",`${this.z.tunnelApplicationName}${E.$j?".exe":""}`)}return this.u}async startTunnel(o){if(t(this.n,o)&&this.s.type!=="disconnected")return this.s;this.H(o);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),!this.n.active)return;const o=this.n.asService;this.H(D.$R9b);try{o&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}try{await this.O("stop",["kill"])}catch(v){this.j.error(v)}this.G(D.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let o="",v=!1;const y=(U,z)=>{z?this.j.error(U):o+=U,!this.C.isBuilt&&U.startsWith("   Compiling")&&this.G(D.TunnelStates.connecting((0,p.localize)(0,null)))},h=this.O("status",["status"],y);this.r=h;try{if(await h,this.r!==h)return;let U;try{U=JSON.parse(o.trim().split(`
`).find(z=>z.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(o.trim())}`),this.G(D.TunnelStates.disconnected());return}if(v=U.service_installed,this.j.info(U.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!U.tunnel&&!this.n.active){this.G(D.TunnelStates.disconnected());return}}catch(U){this.j.error(U),this.G(D.TunnelStates.disconnected());return}finally{this.r===h&&(this.r=void 0)}const g=this.n.active?this.n.session:void 0;if(g&&g.token){const U=g.token;this.G(D.TunnelStates.connecting((0,p.localize)(1,null,g.accountLabel,g.providerId)));const z=(X,x)=>{X=X.replaceAll(U,"*".repeat(4)),y(X,x)},Z=this.O("login",["user","login","--provider",g.providerId,"--access-token",U,"--log",(0,R.$nj)(this.j.getLevel())],z);this.r=Z;try{if(await Z,this.r!==Z)return}catch(X){this.j.error(X),this.r=void 0,this.f.fire(g),this.G(D.TunnelStates.disconnected(g));return}}const O=this.Q();O?this.G(D.TunnelStates.connecting((0,p.localize)(2,null,O))):this.G(D.TunnelStates.connecting((0,p.localize)(3,null)));const T=["--accept-server-license-terms","--log",(0,R.$nj)(this.j.getLevel())];O?T.push("--name",O):T.push("--random-name");let M=!1;return this.n.active&&this.n.asService&&!v&&(M=await this.M(T)===!1),this.N(g,T,M)}async M(o){let v;try{v=await this.O("serviceInstall",["service","install",...o])}catch(y){this.j.error(y),v=1}if(v!==0){const y=(0,p.localize)(4,null);return this.j.warn(y),this.G(D.TunnelStates.connecting(y)),!1}return!0}async N(o,v,y){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let h=!1;const g=this.O("tunnel",v,(O,T)=>{T?this.j.error(O):this.j.info(O),O.includes("Connected to an existing tunnel process")&&(h=!0);const M=O.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(M){const U={link:M[1],domain:M[2],tunnelName:M[4],isAttached:h};this.G(D.TunnelStates.connected(U,y))}else O.match(/error refreshing token/)&&(g.cancel(),this.f.fire(o),this.G(D.TunnelStates.disconnected(o)))});this.r=g,g.finally(()=>{g===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=D.$R9b,this.G(D.TunnelStates.disconnected()))})}O(o,v,y=this.I){return(0,b.$Hg)(h=>new Promise((g,O)=>{h.isCancellationRequested&&g(-1);let T;const M=["ignore","pipe","pipe"];if(h.onCancellationRequested(()=>{T&&(this.j.info(`${o} terminating(${T.pid})`),T.kill())}),!this.C.isBuilt)y(`Building tunnel CLI from sources and run
`,!1),y(`${o} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),T=(0,d.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,S.$ic)(this.C.appRoot,"cli"),stdio:M});else{y(`Running tunnel CLI
`,!1);const U=this.J();y(`${o} Spawning: ${U} tunnel ${v.join(" ")}
`,!1),T=(0,d.spawn)(U,["tunnel",...v],{cwd:(0,w.homedir)(),stdio:M})}T.stdout.pipe(new f.$FT(`
`)).on("data",U=>{if(T){const z=U.toString();y(z,!1)}}),T.stderr.pipe(new f.$FT(`
`)).on("data",U=>{if(T){const z=U.toString();y(z,!0)}}),T.on("exit",U=>{T&&(y(`${o} exit(${T.pid}): + ${U} `,!1),T=void 0,g(U||0))}),T.on("error",U=>{T&&(y(`${o} error(${T.pid}): + ${U} `,!0),T=void 0,O())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(D.$U9b)}Q(){let o=this.D.getValue(D.$T9b)||(0,w.hostname)();return o=o.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),o||void 0}R(){try{const o=this.F.get(s,-1),v=this.F.getBoolean(a,-1,!1);if(o){const y=JSON.parse(o);if(y&&(0,u.$yf)(y.accountLabel)&&(0,u.$yf)(y.sessionId)&&(0,u.$yf)(y.providerId))return{active:!0,session:y,asService:v};this.j.error("Problems restoring session from storage, invalid format",y)}}catch(o){this.j.error("Problems restoring session from storage",o)}return D.$R9b}S(o){if(o.active){const v={providerId:o.session.providerId,sessionId:o.session.sessionId,accountLabel:o.session.accountLabel};this.F.store(s,JSON.stringify(v),-1,1),this.F.store(a,o.asService,-1,1)}else this.F.remove(s,-1),this.F.remove(a,-1)}};e.$19b=n,e.$19b=n=ye([Y(0,j.$dl),Y(1,P.$qj),Y(2,A.$Yh),Y(3,R.$_i),Y(4,l.$Y9b),Y(5,$.$ki),Y(6,c.$7o)],n);function i(r,o){return r&&o?r.sessionId===o.sessionId&&r.providerId===o.providerId&&r.token===o.token:r===o}const t=(r,o)=>r.active!==o.active?!1:r.active&&o.active?r.asService===o.asService&&i(r.session,o.session):!0}),define(ae[249],ce([0,1,6,2,23,19,68,21,76,17]),function(te,e,D,F,j,A,I,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$69b=void 0;class P extends R.$9o{constructor(b,l,$,p){super(),this.bb=b,this.cb=l,this.db=$,this.eb=p,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new F.$Qc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new F.$Qc),this.ab=this.hb(this.bb)}fb(){const b=this.B(new S.$NDb(this.db.getChannel("storage"))),l=this.B(new I.$3o(b));return this.B(l.onDidChangeStorage($=>this.u(-1,$))),l}gb(b){this.X.clear(),this.W=b;let l;if((0,R.$0o)(b))l=this.U;else{const $=this.X.add(new S.$ODb(this.db.getChannel("storage"),b));l=this.X.add(new I.$3o($))}return this.X.add(l.onDidChangeStorage($=>this.u(0,$))),l}hb(b){this.$.clear(),this.Z=b?.id;let l;if(b){const $=this.$.add(new S.$PDb(this.db.getChannel("storage"),b));l=this.$.add(new I.$3o($)),this.$.add(l.onDidChangeStorage(p=>this.u(1,p)))}return l}async O(){await D.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(b){switch(b){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(b){switch(b){case-1:return this.s.globalStorageHome.with({scheme:j.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:j.Schemas.file}).fsPath;default:return this.Z?`${(0,A.$vg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:j.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(b){if(!this.M(this.W,b))return;const l=this.Y,$=l.items;l!==this.U&&await l.close(),this.Y=this.gb(b),await this.Y.init(),this.N($,this.Y,0)}async S(b,l){const $=this.ab,p=$?.items??new Map;await $?.close(),this.ab=this.hb(b),await this.ab.init(),this.N(p,this.ab,1)}hasScope(b){return(0,d.$Kk)(b)?this.W.id===b.id:this.Z===b.id}}e.$69b=P}),define(ae[250],ce([0,1,3,2,17,92]),function(te,e,D,F,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YN=e.$XN=void 0;class I{constructor(d,P){this.a=d,this.b=P}listen(d,P){const E=this.b(d);switch(P){case"onDidChangeProfiles":return D.Event.map(this.a.onDidChangeProfiles,b=>({all:b.all.map(l=>(0,A.$Om)({...l},E)),added:b.added.map(l=>(0,A.$Om)({...l},E)),removed:b.removed.map(l=>(0,A.$Om)({...l},E)),updated:b.updated.map(l=>(0,A.$Om)({...l},E))}))}throw new Error(`Invalid listen ${P}`)}async call(d,P,E){const b=this.b(d);switch(P){case"createProfile":{const l=await this.a.createProfile(E[0],E[1],E[2]);return(0,A.$Om)({...l},b)}case"updateProfile":{let l=(0,j.$Mk)((0,A.$Pm)(E[0],b),this.a.profilesHome.scheme);return l=await this.a.updateProfile(l,E[1]),(0,A.$Om)({...l},b)}case"removeProfile":{const l=(0,j.$Mk)((0,A.$Pm)(E[0],b),this.a.profilesHome.scheme);return this.a.removeProfile(l)}}throw new Error(`Invalid call ${P}`)}}e.$XN=I;class R extends F.$Rc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(d,P,E){super(),this.profilesHome=P,this.f=E,this.a=[],this.b=this.B(new D.$Nd),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=d.map(b=>(0,j.$Mk)(b,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(b=>{const l=b.added.map(w=>(0,j.$Mk)(w,this.profilesHome.scheme)),$=b.removed.map(w=>(0,j.$Mk)(w,this.profilesHome.scheme)),p=b.updated.map(w=>(0,j.$Mk)(w,this.profilesHome.scheme));this.a=b.all.map(w=>(0,j.$Mk)(w,this.profilesHome.scheme)),this.b.fire({added:l,removed:$,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(d){this.c=d}isEnabled(){return this.c}async createNamedProfile(d,P,E){const b=await this.f.call("createNamedProfile",[d,P,E]);return(0,j.$Mk)(b,this.profilesHome.scheme)}async createProfile(d,P,E,b){const l=await this.f.call("createProfile",[d,P,E,b]);return(0,j.$Mk)(l,this.profilesHome.scheme)}async createTransientProfile(d){const P=await this.f.call("createTransientProfile",[d]);return(0,j.$Mk)(P,this.profilesHome.scheme)}async setProfileForWorkspace(d,P){await this.f.call("setProfileForWorkspace",[d,P])}removeProfile(d){return this.f.call("removeProfile",[d])}async updateProfile(d,P){const E=await this.f.call("updateProfile",[d,P]);return(0,j.$Mk)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$YN=R}),define(ae[59],ce([0,1,2,68,4,21,3,76,17]),function(te,e,D,F,j,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TDb=e.$SDb=e.$RDb=void 0,e.$RDb=(0,j.$Qh)("IUserDataProfileStorageService");let d=class extends D.$Rc{constructor(l){super(),this.a=l}async readStorageData(l){return this.withProfileScopedStorageService(l,async $=>this.b($))}async updateStorageData(l,$,p){return this.withProfileScopedStorageService(l,async w=>this.c(w,$,p))}async withProfileScopedStorageService(l,$){if(this.a.hasScope(l))return $(this.a);const p=await this.g(l),w=new E(p);try{await w.initialize();const c=await $(w);return await w.flush(),c}finally{w.dispose(),await this.f(p)}}b(l){const $=new Map,p=w=>{for(const c of l.keys(0,w))$.set(c,{value:l.get(c,0),target:w})};return p(0),p(1),$}c(l,$,p){l.storeAll(Array.from($.entries()).map(([w,c])=>({key:w,value:c,scope:0,target:p})),!0)}async f(l){try{await l.close()}finally{(0,D.$Lc)(l)&&l.dispose()}}};e.$SDb=d,e.$SDb=d=ye([Y(0,A.$7o)],d);class P extends d{constructor(l,$,p,w){super(p),this.j=l;const c=l.getChannel("profileStorageListener"),u=this.B(new D.$Sc);this.h=this.B(new I.$Nd({onWillAddFirstListener:()=>{u.value=c.listen("onDidChange")(f=>{w.trace("profile storage changes",f),this.h.fire({targetChanges:f.targetChanges.map(m=>(0,S.$Mk)(m,$.profilesHome.scheme)),valueChanges:f.valueChanges.map(m=>({...m,profile:(0,S.$Mk)(m.profile,$.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(l){const $=this.j.getChannel("storage");return(0,A.$0o)(l)?new R.$NDb($):new R.$ODb($,l)}}e.$TDb=P;class E extends A.$9o{constructor(l){super({flushInterval:100}),this.s=this.B(new F.$3o(l))}O(){return this.s.init()}P(l){return l===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(ae[251],ce([0,1,21,8,17,55,59]),function(te,e,D,F,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K9b=void 0;let R=class extends I.$TDb{constructor(d,P,E,b){super(d,P,E,b)}};e.$K9b=R,e.$K9b=R=ye([Y(0,A.$98b),Y(1,j.$Lk),Y(2,D.$7o),Y(3,F.$$i)],R)}),define(ae[39],ce([0,1,18,6,15,26,3,35,2,27,12,169,20,14,11,8,43,21,22,28,24,17]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w,c,u,f,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LEb=e.$KEb=e.$JEb=e.$IEb=e.$HEb=e.$GEb=e.$FEb=void 0;function s(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||a(v.syncData)))}e.$FEb=s;function a(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$GEb=a;function n(v,y){return`${(0,d.$qf)(v)}${y.isDefault?"":` (${y.name})`}`}e.$HEb=n;let i=class extends S.$Rc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(y,h,g,O,T,M,U,z,Z,X,x,H){super(),this.syncResource=y,this.collection=h,this.G=g,this.H=O,this.I=T,this.J=M,this.L=U,this.M=z,this.N=Z,this.O=X,this.P=x,this.c=null,this.m="idle",this.n=this.B(new I.$Nd),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new I.$Nd),this.onDidChangeConflicts=this.t.event,this.u=this.B(new F.$Rg(50)),this.w=this.B(new I.$Nd),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(y.syncResource,y.profile),this.h=H.extUri,this.f=this.h.joinPath(O.userDataSyncHome,...(0,m.$$gb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource)),this.g=this.h.joinPath(this.f,m.$thb),this.y=(0,m.$_gb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource,O,this.h),this.j=(0,w.$ap)(O,g,T)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const y=await this.c;this.c=null;const h=await this.Y(y.remoteUserData,y.lastSyncUserData,!0,this.ob());this.S(h)}else{this.O.trace(`${this.D}: Checking for local changes...`);const y=await this.getLastSyncUserData();(y?await this.ub(y):!0)&&this.w.fire()}}S(y){this.m!==y&&(this.m=y,this.n.fire(y))}async sync(y,h={}){await this.U(y,!0,this.ob(),h)}async preview(y,h,g={}){return this.U(y,!1,h,g)}async apply(y,h={}){try{this.F={...h};const g=await this.ab(y);return this.S(g),this.c}finally{this.F={}}}async U(y,h,g,O){try{if(this.F={...O},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let T="idle";try{const M=await this.getLastSyncUserData(),U=await this.X(y,M);return T=await this.Y(U,M,h,g),T==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):T==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(T)}}finally{this.F={}}}async replace(y){const h=this.kb(y);if(!h)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const g=await this.getLastSyncUserData(),O=await this.X(null,g),T=await this.W(O),M=await this.qb({ref:O.ref,syncData:h},g,T,this.ob(),A.CancellationToken.None),U=[];for(const z of M){const Z=await this.sb(z,z.remoteResource,void 0,A.CancellationToken.None),{remoteChange:X}=await this.sb(z,z.previewResource,z.remoteContent,A.CancellationToken.None);U.push([z,{...Z,remoteChange:X!==0?X:2}])}await this.tb(O,g,U,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(y){const h=await this.j;return!!y.syncData?.machineId&&y.syncData.machineId===h}async X(y,h){if(h){const g=y?y[this.resource]:void 0;if(h.ref===g||g===void 0&&h.syncData===null)return h}return this.getRemoteUserData(h)}async Y(y,h,g,O){if(y.syncData&&y.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new m.$ghb((0,E.localize)(0,null,this.resource,this.pb,y.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(y,h,g,O)}catch(T){if(T instanceof m.$ghb)switch(T.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(y,h,g,O);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),y=await this.getRemoteUserData(null),h=await this.getLastSyncUserData(),this.Y(y,h,g,O)}throw T}}async Z(y,h,g,O){try{const T=await this.W(y),M=!T&&h===null&&this.gb()!==void 0,U=g&&!M;this.c||(this.c=(0,F.$Hg)(Z=>this.eb(y,h,T,U,O,Z)));let z=await this.c;if(g&&M){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Z of z.resourcePreviews)z=await this.accept(Z.remoteResource)||z}return this.cb(z.resourcePreviews),z.resourcePreviews.some(({mergeState:Z})=>Z==="conflict")?"hasConflicts":g?await this.ab(!1):"syncing"}catch(T){throw this.c=null,T}}async merge(y){return await this.$(y,async h=>{const g=await this.rb(h,A.CancellationToken.None);await this.G.writeFile(h.previewResource,j.$be.fromString(g?.content||""));const O=g&&!g.hasConflicts?await this.sb(h,h.previewResource,void 0,A.CancellationToken.None):void 0;return h.acceptResult=O,h.mergeState=g.hasConflicts?"conflict":O?"accepted":"preview",h.localChange=O?O.localChange:g.localChange,h.remoteChange=O?O.remoteChange:g.remoteChange,h}),this.c}async accept(y,h){return await this.$(y,async g=>{const O=await this.sb(g,y,h,A.CancellationToken.None);return g.acceptResult=O,g.mergeState="accepted",g.localChange=O.localChange,g.remoteChange=O.remoteChange,g}),this.c}async discard(y){return await this.$(y,async h=>{const g=await this.rb(h,A.CancellationToken.None);return await this.G.writeFile(h.previewResource,j.$be.fromString(g.content||"")),h.acceptResult=void 0,h.mergeState="preview",h.localChange=g.localChange,h.remoteChange=g.remoteChange,h}),this.c}async $(y,h){if(!this.c)return;let g=await this.c;const O=g.resourcePreviews.findIndex(({localResource:T,remoteResource:M,previewResource:U})=>this.h.isEqual(T,y)||this.h.isEqual(M,y)||this.h.isEqual(U,y));O!==-1&&(this.c=(0,F.$Hg)(async T=>{const M=[...g.resourcePreviews];return M[O]=await h(M[O]),{...g,resourcePreviews:M}}),g=await this.c,this.cb(g.resourcePreviews),g.resourcePreviews.some(({mergeState:T})=>T==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(y){if(!this.c)return"idle";const h=await this.c;return h.resourcePreviews.some(({mergeState:g})=>g==="conflict")?"hasConflicts":h.resourcePreviews.some(({mergeState:g})=>g!=="accepted")?"syncing":(await this.tb(h.remoteUserData,h.lastSyncUserData,h.resourcePreviews.map(g=>[g,g.acceptResult]),y),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(y){const h=y.filter(({mergeState:g})=>g==="conflict");(0,D.$tb)(this.s,h,(g,O)=>this.h.isEqual(g.previewResource,O.previewResource))||(this.s=h,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const y=await this.getLastSyncUserData();return!!y&&y.syncData!==null}async db(y){const h=this.c?await this.c:null;if(h)for(const g of h.resourcePreviews){if(this.h.isEqual(g.acceptedResource,y))return g.acceptResult?g.acceptResult.content:null;if(this.h.isEqual(g.remoteResource,y))return g.remoteContent;if(this.h.isEqual(g.localResource,y))return g.localContent;if(this.h.isEqual(g.baseResource,y))return g.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(y){(0,$.$qk)(y)!==1&&this.O.error(y)}}async eb(y,h,g,O,T,M){const U=await this.qb(y,h,g,T,M),z=[];for(const Z of U){const X=Z.previewResource.with({scheme:m.$shb,authority:"accepted"});if(Z.localChange===0&&Z.remoteChange===0)z.push({...Z,acceptedResource:X,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=O?await this.rb(Z,M):void 0;if(M.isCancellationRequested)break;await this.G.writeFile(Z.previewResource,j.$be.fromString(x?.content||""));const H=x&&!x.hasConflicts?await this.sb(Z,Z.previewResource,void 0,M):void 0;z.push({...Z,acceptResult:H,mergeState:x?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:x?x.localChange:Z.localChange,remoteChange:H?H.remoteChange:x?x.remoteChange:Z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:y,lastSyncUserData:h,resourcePreviews:z,isLastSyncFromCurrentMachine:g}}async getLastSyncUserData(){let y=this.gb();if(y||(y=await this.jb()),!y)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const h=JSON.parse(y),g=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!h.version&&!!g&&h.version!==g,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${h.version} is not compatible with current sync state version ${g}.`),await this.resetLocal(),null;let O,T=1;for(;O===void 0&&T++<6;)try{const M=await this.hb();M&&(M.ref===h.ref?O=M.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof $.$uk&&M.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(M instanceof m.$ghb)throw M;this.O.error(M,T)}}if(O===void 0)try{const M=await this.J.resolveResourceContent(this.resource,h.ref,this.collection,this.F);O=M===null?null:this.kb(M),await this.ib({ref:h.ref,syncData:O})}catch(M){if(M instanceof m.$ghb&&M.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw M}return O===void 0?null:{...h,syncData:O}}async fb(y,h={}){if(h.ref||h.version)throw new Error("Cannot have core properties as additional");const g=this.M.getResourceSyncStateVersion(this.resource),O={ref:y.ref,version:g,...h};this.I.store(this.z,JSON.stringify(O),-1,1),await this.ib(y)}gb(){return this.I.get(this.z,-1)}async hb(){const y=(await this.G.readFile(this.y)).value.toString();try{const h=y?JSON.parse(y):void 0;if(s(h))return h}catch(h){this.O.error(h)}}async ib(y){await this.G.writeFile(this.y,j.$be.fromString(JSON.stringify(y)))}async jb(){try{const y=await this.G.readFile(this.y),h=JSON.parse(y.value.toString());await this.G.del(this.y),h.ref&&h.content!==void 0?(this.I.store(this.z,JSON.stringify({...h,content:void 0}),-1,1),await this.ib({ref:h.ref,syncData:h.content===null?null:JSON.parse(h.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,h)}catch(y){y instanceof $.$uk&&y.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(y)}return this.I.get(this.z,-1)}async getRemoteUserData(y){const{ref:h,content:g}=await this.lb(y);let O=null;return g!==null&&(O=this.kb(g)),{ref:h,syncData:O}}kb(y){try{const h=JSON.parse(y);if(a(h))return h}catch(h){this.O.error(h)}throw new m.$ghb((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(y){const h=y?{ref:y.ref,content:y.syncData?JSON.stringify(y.syncData):null}:null;return this.J.readResource(this.resource,h,this.collection,this.F)}async mb(y,h){const g=await this.j,O={version:this.pb,machineId:g,content:y};try{return h=await this.J.writeResource(this.resource,JSON.stringify(O),h,this.collection,this.F),{ref:h,syncData:O}}catch(T){throw T instanceof m.$ghb&&T.code==="TooLarge"&&(T=new m.$ghb(T.message,T.code,this.resource)),T}}async nb(y){const h={version:this.pb,content:y};return this.L.writeResource(this.resource,JSON.stringify(h),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(m.$6gb)}};e.$IEb=i,e.$IEb=i=ye([Y(2,$.$_j),Y(3,l.$Xh),Y(4,c.$7o),Y(5,m.$bhb),Y(6,m.$chb),Y(7,m.$lhb),Y(8,u.$dl),Y(9,m.$qhb),Y(10,b.$ki),Y(11,f.$Jk)],i);let t=class extends i{constructor(y,h,g,O,T,M,U,z,Z,X,x,H,K){super(h,g,O,T,M,U,z,Z,X,x,H,K),this.r=y,this.B(this.G.watch(this.h.dirname(y))),this.B(this.G.onDidFilesChange(J=>this.yb(J)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(y,h,g){try{h?await this.G.writeFile(this.r,j.$be.fromString(y),g?void 0:h):await this.G.createFile(this.r,j.$be.fromString(y),{overwrite:g})}catch(O){throw O instanceof $.$uk&&O.fileOperationResult===1||O instanceof $.$uk&&O.fileOperationResult===3?new m.$ghb(O.message,"LocalPreconditionFailed"):O}}async xb(){try{await this.G.del(this.r)}catch(y){if(!(y instanceof $.$uk&&y.fileOperationResult===1))throw y}}yb(y){y.contains(this.r)&&this.Q()}};e.$JEb=t,e.$JEb=t=ye([Y(3,$.$_j),Y(4,l.$Xh),Y(5,c.$7o),Y(6,m.$bhb),Y(7,m.$chb),Y(8,m.$lhb),Y(9,u.$dl),Y(10,m.$qhb),Y(11,b.$ki),Y(12,f.$Jk)],t);let r=class extends t{constructor(y,h,g,O,T,M,U,z,Z,X,x,H,K,J){super(y,h,g,O,T,M,U,z,Z,X,x,K,J),this.zb=H,this.Bb=void 0}Ab(y,h){const g=[],O=(0,R.$Xm)(y,g,{allowEmptyContent:!0,allowTrailingComma:!0});return g.length>0||!(0,P.$Ff)(O)&&h!==Array.isArray(O)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$KEb=r,e.$KEb=r=ye([Y(3,$.$_j),Y(4,l.$Xh),Y(5,c.$7o),Y(6,m.$bhb),Y(7,m.$chb),Y(8,m.$lhb),Y(9,u.$dl),Y(10,m.$qhb),Y(11,m.$phb),Y(12,b.$ki),Y(13,f.$Jk)],r);let o=class{constructor(y,h,g,O,T,M,U){this.resource=y,this.g=h,this.h=g,this.j=O,this.k=T,this.l=M,this.d=U.extUri,this.f=(0,m.$_gb)(void 0,this.resource,g,this.d)}async initialize({ref:y,content:h}){if(!h){this.j.info("Remote content does not exist.",this.resource);return}const g=this.m(h);if(g)try{await this.o({ref:y,syncData:g})}catch(O){this.j.error(O)}}m(y){try{const h=JSON.parse(y);if(a(h))return h}catch(h){this.j.error(h)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(y,h={}){if(h.ref||h.version)throw new Error("Cannot have core properties as additional");const g={ref:y.ref,version:void 0,...h};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(g),-1,1),await this.k.writeFile(this.f,j.$be.fromString(JSON.stringify(y)))}};e.$LEb=o,e.$LEb=o=ye([Y(1,k.$Lk),Y(2,l.$Xh),Y(3,p.$$i),Y(4,$.$_j),Y(5,c.$7o),Y(6,f.$Jk)],o)}),define(ae[114],ce([0,1,6,26,7,3,42,2,27,20,14,113,29,33,81,44,11,4,72,8,21,22,28,17,39,232,111,24,59]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w,c,u,f,m,k,s,a,n,i,t,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p4b=e.$o4b=e.$n4b=e.$m4b=e.$l4b=void 0;async function v(M,U){const z=JSON.parse(M.content);if(M.version===1||M.version===2){const Z=(await U.getInstalled(0)).filter(X=>X.isBuiltin);for(const X of z)M.version===1&&(X.enabled===!1&&(X.disabled=!0),delete X.enabled),M.version===2&&Z.every(x=>!(0,l.$Ao)(x.identifier,X.identifier))&&(X.installed=!0)}return z}function y(M){return JSON.parse(M.content)}e.$l4b=y;function h(M,U){return M.sort((z,Z)=>!z.identifier.uuid&&Z.identifier.uuid?-1:z.identifier.uuid&&!Z.identifier.uuid?1:(0,S.$Ue)(z.identifier.id,Z.identifier.id)),U?(0,I.$iT)(M,{}):JSON.stringify(M)}e.$m4b=h;let g=class extends n.$IEb{constructor(U,z,Z,X,x,H,K,J,V,ee,ne,_,se,Q,q,C,L){super({syncResource:"extensions",profile:U},z,X,Z,x,H,K,_,se,ee,ne,q),this.Cb=J,this.Db=V,this.Eb=L,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$shb,authority:"base"}),this.yb=this.wb.with({scheme:r.$shb,authority:"local"}),this.zb=this.wb.with({scheme:r.$shb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$shb,authority:"accepted"}),this.Bb=this.Eb.createInstance(O),this.B(A.Event.any(A.Event.filter(this.Cb.onDidInstallExtensions,B=>B.some(({local:N})=>!!N)),A.Event.filter(this.Cb.onDidUninstallExtension,B=>!B.error),A.Event.filter(C.onDidChange,B=>B.valueChanges.some(({profile:N,changes:W})=>this.syncResource.profile.id===N.id&&W.some(G=>G.key===b.$bo))),Q.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(U,z){const Z=U.syncData?await v(U.syncData,this.Cb):null,X=z?.skippedExtensions??[],x=z?.builtinExtensions??null,H=z?.syncData?await v(z.syncData,this.Cb):null,{localExtensions:K,ignoredExtensions:J}=await this.Bb.getLocalExtensions(this.syncResource.profile);Z?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:V,remote:ee}=(0,i.$k4b)(K,Z,H,X,J,x),ne={local:V,remote:ee,content:this.Hb(K,V.added,V.updated,V.removed),localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:ee!==null?2:0},_=this.Ob(K,!1);return[{skippedExtensions:X,builtinExtensions:x,baseResource:this.xb,baseContent:H?this.Ob(H,!1):_,localResource:this.yb,localContent:_,localExtensions:K,remoteResource:this.zb,remoteExtensions:Z,remoteContent:Z?this.Ob(Z,!1):null,previewResource:this.wb,previewResult:ne,localChange:ne.localChange,remoteChange:ne.remoteChange,acceptedResource:this.Ab}]}async ub(U){const z=U.syncData?await v(U.syncData,this.Cb):null,{localExtensions:Z,ignoredExtensions:X}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,i.$k4b)(Z,z,z,U.skippedExtensions||[],X,U.builtinExtensions||[]);return x!==null}Hb(U,z,Z,X){const x=[...z,...Z],H=new Set,K=J=>{H.add(J.id.toLowerCase()),J.uuid&&H.add(J.uuid)};x.forEach(({identifier:J})=>K(J)),X.forEach(K);for(const J of U)H.has(J.identifier.id.toLowerCase())||J.identifier.uuid&&H.has(J.identifier.uuid)||x.push(J);return this.Ob(x,!1)}async rb(U,z){return{...U.previewResult,hasConflicts:!1}}async sb(U,z,Z,X){if(this.h.isEqual(z,this.yb))return this.Kb(U);if(this.h.isEqual(z,this.zb))return this.Lb(U);if(this.h.isEqual(z,this.wb))return U.previewResult;throw new Error(`Invalid Resource: ${z.toString()}`)}async Kb(U){const z=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.Db.getIgnoredExtensions(z),X=(0,i.$k4b)(U.localExtensions,null,null,U.skippedExtensions,Z,U.builtinExtensions),{local:x,remote:H}=X;return{content:U.localContent,local:x,remote:H,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:H!==null?2:0}}async Lb(U){const z=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.Db.getIgnoredExtensions(z),X=U.remoteContent?JSON.parse(U.remoteContent):null;if(X!==null){const x=(0,i.$k4b)(U.localExtensions,X,U.localExtensions,[],Z,U.builtinExtensions),{local:H,remote:K}=x;return{content:U.remoteContent,local:H,remote:K,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:K!==null?2:0}}else return{content:U.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(U,z,Z,X){let{skippedExtensions:x,builtinExtensions:H,localExtensions:K}=Z[0][0];const{local:J,remote:V,localChange:ee,remoteChange:ne}=Z[0][1];if(ee===0&&ne===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ee!==0&&(await this.nb(JSON.stringify(K)),x=await this.Bb.updateLocalExtensions(J.added,J.removed,J.updated,x,this.syncResource.profile)),V){this.O.trace(`${this.D}: Updating remote extensions...`);const _=JSON.stringify(V.all);U=await this.mb(_,X?null:U.ref),this.O.info(`${this.D}: Updated remote extensions.${V.added.length?` Added: ${JSON.stringify(V.added.map(se=>se.identifier.id))}.`:""}${V.updated.length?` Updated: ${JSON.stringify(V.updated.map(se=>se.identifier.id))}.`:""}${V.removed.length?` Removed: ${JSON.stringify(V.removed.map(se=>se.identifier.id))}.`:""}`)}z?.ref!==U.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(K,H),await this.fb(U,{skippedExtensions:x,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(_=>_.identifier.id))}.`:""}`))}Nb(U,z){const Z=new Set,X=[];for(const x of U)Z.add(x.identifier.id.toLowerCase()),x.installed||X.push(x.identifier);if(z)for(const x of z)Z.has(x.id.toLowerCase())||X.push(x);return X}async resolveContent(U){if(this.h.isEqual(this.zb,U)||this.h.isEqual(this.xb,U)||this.h.isEqual(this.yb,U)||this.h.isEqual(this.Ab,U)){const z=await this.db(U);return z&&this.Ob(JSON.parse(z),!0)}return null}Ob(U,z){return h(U,z)}async hasLocalData(){try{const{localExtensions:U}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(U.some(z=>z.installed||z.disabled))return!0}catch{}return!1}};e.$n4b=g,e.$n4b=g=ye([Y(2,P.$Xh),Y(3,w.$_j),Y(4,m.$7o),Y(5,r.$bhb),Y(6,r.$chb),Y(7,b.$ao),Y(8,t.$qFb),Y(9,r.$qhb),Y(10,d.$ki),Y(11,r.$lhb),Y(12,k.$dl),Y(13,$.$Xu),Y(14,s.$Jk),Y(15,o.$RDb),Y(16,c.$Ph)],g);let O=class{constructor(U,z,Z,X,x,H){this.a=U,this.b=z,this.c=Z,this.d=X,this.f=x,this.g=H}async getLocalExtensions(U){const z=await this.a.getInstalled(void 0,U.extensionsResource),Z=this.d.getIgnoredExtensions(z);return{localExtensions:await this.j(U,async(x,H)=>{const K=x.getDisabledExtensions();return z.map(J=>{const{identifier:V,isBuiltin:ee,manifest:ne,preRelease:_,pinned:se,isApplicationScoped:Q}=J,q={identifier:V,preRelease:_,version:ne.version,pinned:!!se};Q&&!(0,p.$0l)(ne)&&(q.isApplicationScoped=Q),K.some(C=>(0,l.$Ao)(C,V))&&(q.disabled=!0),ee||(q.installed=!0);try{const C=H.getKeysForSync({id:V.id,version:ne.version});if(C){const L=H.getExtensionState(J,!0)||{};q.state=Object.keys(L).reduce((B,N)=>(C.includes(N)&&(B[N]=L[N]),B),{})}}catch(C){this.g.info(`${(0,n.$HEb)("extensions",U)}: Error while parsing extension state`,(0,j.$9)(C))}return q})}),ignoredExtensions:Z}}async updateLocalExtensions(U,z,Z,X,x){const H=(0,n.$HEb)("extensions",x),K=[],J=new Map,V=[],ee=[],ne=await this.a.getInstalled(void 0,x.extensionsResource);if((U.length||Z.length)&&await this.j(x,async(Q,q)=>{await D.Promises.settled([...U,...Z].map(async C=>{const L=ne.find(W=>(0,l.$Ao)(W.identifier,C.identifier));if(L&&L.isBuiltin){C.state&&L.manifest.version===C.version&&this.h(C.state,L,L.manifest.version,q),Q.getDisabledExtensions().some(G=>(0,l.$Ao)(G,C.identifier))!==!!C.disabled&&(C.disabled?(this.g.trace(`${H}: Disabling extension...`,C.identifier.id),await Q.disableExtension(C.identifier),this.g.info(`${H}: Disabled extension`,C.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,C.identifier.id),await Q.enableExtension(C.identifier),this.g.info(`${H}: Enabled extension`,C.identifier.id))),V.push(C.identifier);return}const B=C.pinned?C.version:void 0,N=(await this.c.getExtensions([{...C.identifier,version:B,preRelease:B?void 0:C.preRelease}],F.CancellationToken.None))[0];if(C.state&&(L?L.manifest.version===C.version:N)&&this.h(C.state,L||N,L?.manifest.version,q),N)try{Q.getDisabledExtensions().some(G=>(0,l.$Ao)(G,C.identifier))!==!!C.disabled&&(C.disabled?(this.g.trace(`${H}: Disabling extension...`,C.identifier.id,N.version),await Q.disableExtension(N.identifier),this.g.info(`${H}: Disabled extension`,C.identifier.id,N.version)):(this.g.trace(`${H}: Enabling extension...`,C.identifier.id,N.version),await Q.enableExtension(N.identifier),this.g.info(`${H}: Enabled extension`,C.identifier.id,N.version))),(!L||L.preRelease!==C.preRelease||L.pinned!==C.pinned||B&&L.manifest.version!==B)&&(await this.a.canInstall(N)?(K.push({extension:N,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:C.pinned&&!!C.version,installPreReleaseVersion:C.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:C.isApplicationScoped,context:{[b.$2n]:!0,[b.$3n]:!0}}}),J.set(N.identifier.id.toLowerCase(),C)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,N.displayName||N.identifier.id),ee.push(C)))}catch(W){ee.push(C),this.g.error(W),this.g.info(`${H}: Skipped synchronizing extension`,N.displayName||N.identifier.id)}else ee.push(C),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,C.identifier.id)}))}),z.length){const Q=ne.filter(({identifier:q,isBuiltin:C})=>!C&&z.some(L=>(0,l.$Ao)(q,L)));await D.Promises.settled(Q.map(async q=>{this.g.trace(`${H}: Uninstalling local extension...`,q.identifier.id),await this.a.uninstall(q,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,q.identifier.id),V.push(q.identifier)}))}const _=await this.a.installGalleryExtensions(K);for(const{identifier:Q,local:q,error:C,source:L}of _){const B=L;if(q)this.g.info(`${H}: Installed extension.`,Q.id,B.version),V.push(Q);else{const N=J.get(Q.id.toLowerCase());N&&(ee.push(N),this.g.info(`${H}: Skipped synchronizing extension`,B.displayName||B.identifier.id)),C instanceof b.$_n&&[b.ExtensionManagementErrorCode.Incompatible,b.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(C.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):C&&this.g.error(C)}}const se=[];for(const Q of X)V.some(q=>(0,l.$Ao)(q,Q.identifier))||se.push(Q);for(const Q of ee)se.some(q=>(0,l.$Ao)(q.identifier,Q.identifier))||se.push(Q);return se}h(U,z,Z,X){const x=X.getExtensionState(z,!0)||{},H=Z?X.getKeysForSync({id:z.identifier.id,version:Z}):void 0;H?H.forEach(K=>{x[K]=U[K]}):Object.keys(U).forEach(K=>x[K]=U[K]),X.setExtensionState(z,x,!0)}async j(U,z){return this.b.withProfileScopedStorageService(U,async Z=>{const X=new R.$Qc,x=this.f.createChild(new u.$Oh([m.$7o,Z])),H=X.add(x.createInstance(E.$dDb)),K=X.add(x.createInstance($.$Yu));try{return await z(H,K)}finally{X.dispose()}})}};e.$o4b=O,e.$o4b=O=ye([Y(0,b.$ao),Y(1,o.$RDb),Y(2,b.$$n),Y(3,t.$qFb),Y(4,c.$Ph),Y(5,r.$qhb)],O);let T=class extends n.$LEb{constructor(U,z,Z,X,x,H,K,J){super("extensions",X,x,H,Z,K,J),this.p=U,this.q=z}async t(U){return U.syncData?await v(U.syncData,this.p):null}u(U,z){const Z=[],X=[],x=[];for(const H of U){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const K=z.find(J=>(0,l.$Ao)(J.identifier,H.identifier));K?(Z.push(K),H.disabled&&x.push(H.identifier)):H.installed&&(X.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&x.push(H.identifier))}return{installedExtensions:Z,newExtensions:X,disabledExtensions:x,remoteExtensions:U}}};e.$p4b=T,e.$p4b=T=ye([Y(0,b.$ao),Y(1,t.$qFb),Y(2,w.$_j),Y(3,a.$Lk),Y(4,P.$Xh),Y(5,f.$$i),Y(6,m.$7o),Y(7,s.$Jk)],T)}),define(ae[115],ce([0,1,15,7,3,35,42,5,32,20,14,11,8,43,21,22,28,39,78,236,24,17,59,4]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w,c,u,f,m,k,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$REb=e.$QEb=e.$PEb=e.$OEb=e.$NEb=void 0;const n="globalState.argv.",i=["locale"];function t(g,O){const T=g.storage?Object.keys(g.storage).sort():[],M={};return T.forEach(U=>M[U]=g.storage[U]),g.storage=M,O?(0,I.$iT)(g,{}):JSON.stringify(g)}e.$NEb=t;const r=1;let o=class extends c.$IEb{constructor(O,T,M,U,z,Z,X,x,H,K,J,V,ee,ne){super({syncResource:"globalState",profile:O},T,U,x,V,z,Z,H,K,X,J,ee),this.Bb=M,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:m.$shb,authority:"base"}),this.xb=this.vb.with({scheme:m.$shb,authority:"local"}),this.yb=this.vb.with({scheme:m.$shb,authority:"remote"}),this.zb=this.vb.with({scheme:m.$shb,authority:"accepted"}),this.Ab=ne.createInstance(v),this.B(U.watch(this.h.dirname(this.H.argvResource))),this.B(j.Event.any(j.Event.filter(U.onDidFilesChange,_=>_.contains(this.H.argvResource)),j.Event.filter(M.onDidChange,_=>!!(_.targetChanges.some(se=>this.syncResource.profile.id===se.id)||_.valueChanges.some(({profile:se,changes:Q})=>this.syncResource.profile.id===se.id&&Q.some(q=>q.target===0)))))(()=>this.Q()))}async qb(O,T,M){const U=O.syncData?JSON.parse(O.syncData.content):null;T=T===null&&M?O:T;const z=T&&T.syncData?JSON.parse(T.syncData.content):null,Z=await this.Ab.getLocalGlobalState(this.syncResource.profile);U?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const X=await this.Jb(z),{local:x,remote:H}=(0,f.$MEb)(Z.storage,U?U.storage:null,z?z.storage:null,X,this.O),K={content:null,local:x,remote:H,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:H.all!==null?2:0},J=t(Z,!1);return[{baseResource:this.wb,baseContent:z?t(z,!1):J,localResource:this.xb,localContent:J,localUserData:Z,remoteResource:this.yb,remoteContent:U?t(U,!1):null,previewResource:this.vb,previewResult:K,localChange:K.localChange,remoteChange:K.remoteChange,acceptedResource:this.zb,storageKeys:X}]}async ub(O){const T=O.syncData?JSON.parse(O.syncData.content):null;if(T===null)return!0;const M=await this.Ab.getLocalGlobalState(this.syncResource.profile),U=await this.Jb(T),{remote:z}=(0,f.$MEb)(M.storage,T.storage,T.storage,U,this.O);return z.all!==null}async rb(O,T){return{...O.previewResult,hasConflicts:!1}}async sb(O,T,M,U){if(this.h.isEqual(T,this.xb))return this.Gb(O);if(this.h.isEqual(T,this.yb))return this.Hb(O);if(this.h.isEqual(T,this.vb))return O.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async Gb(O){return{content:O.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(O.localUserData.storage),removed:[],updated:[],all:O.localUserData.storage},localChange:0,remoteChange:2}}async Hb(O){if(O.remoteContent!==null){const T=JSON.parse(O.remoteContent),{local:M,remote:U}=(0,f.$MEb)(O.localUserData.storage,T.storage,null,O.storageKeys,this.O);return{content:O.remoteContent,local:M,remote:U,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:O.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(O,T,M,U){const{localUserData:z}=M[0][0],{local:Z,remote:X,localChange:x,remoteChange:H}=M[0][1];if(x===0&&H===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(z)),await this.Ab.writeLocalGlobalState(Z,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const K=JSON.stringify({storage:X.all});O=await this.mb(K,U?null:O.ref),this.O.info(`${this.D}: Updated remote ui state.${X.added.length?` Added: ${X.added}.`:""}${X.updated.length?` Updated: ${X.updated}.`:""}${X.removed.length?` Removed: ${X.removed}.`:""}`)}T?.ref!==O.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(O),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(O){if(this.h.isEqual(this.yb,O)||this.h.isEqual(this.wb,O)||this.h.isEqual(this.xb,O)||this.h.isEqual(this.zb,O)){const T=await this.db(O);return T&&t(JSON.parse(T),!0)}return null}async hasLocalData(){try{const{storage:O}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(O).length>1||O[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(O){const T=await this.Bb.readStorageData(this.syncResource.profile),M=[],U=[];for(const[X,x]of T)x.target===0?M.push(X):x.target===1&&U.push(X);const z=[...M,...U],Z=O?.storage?Object.keys(O.storage).filter(X=>!X.startsWith(n)&&!z.includes(X)&&T.get(X)!==void 0):[];if(!R.$p){const X=[...m.$0gb.map(x=>(0,m.$khb)(x)),m.$jhb];Z.push(...X),U.push(...X)}return{user:M,machine:U,unregistered:Z}}};e.$OEb=o,e.$OEb=o=ye([Y(2,s.$RDb),Y(3,E.$_j),Y(4,m.$bhb),Y(5,m.$chb),Y(6,m.$qhb),Y(7,P.$Xh),Y(8,m.$lhb),Y(9,p.$dl),Y(10,d.$ki),Y(11,$.$7o),Y(12,w.$Jk),Y(13,a.$Ph)],o);let v=class{constructor(O,T,M,U){this.a=O,this.b=T,this.c=M,this.d=U}async getLocalGlobalState(O){const T={};if(O.isDefault){const U=await this.f(),z=(0,A.$Xm)(U);for(const Z of i)z[Z]!==void 0&&(T[`${n}${Z}`]={version:1,value:z[Z]})}const M=await this.c.readStorageData(O);for(const[U,z]of M)z.value&&z.target===0&&(T[U]={version:1,value:z.value});return{storage:T}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const O=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),O.value.toString()}catch(O){this.d.debug((0,F.$9)(O))}return"{}"}async writeLocalGlobalState({added:O,removed:T,updated:M},U){const z=(0,c.$HEb)("globalState",U),Z={},X=new Map,x=await this.c.readStorageData(U),H=(K,J)=>{for(const V of K){if(V.startsWith(n)){Z[V.substring(n.length)]=J?J[V].value:void 0;continue}if(J){const ee=J[V];ee.value!==x.get(V)?.value&&X.set(V,ee.value)}else x.get(V)!==void 0&&X.set(V,void 0)}};if(H(Object.keys(O),O),H(Object.keys(M),M),H(T),Object.keys(Z).length){this.d.trace(`${z}: Updating locale...`);const K=await this.f();let J=K;for(const V of Object.keys(Z))J=(0,u.edit)(J,[V],Z[V],{});K!==J&&(this.d.trace(`${z}: Updating locale...`),await this.a.writeFile(this.b.argvResource,D.$be.fromString(J)),this.d.info(`${z}: Updated locale.`)),this.d.info(`${z}: Updated locale`)}X.size&&(this.d.trace(`${z}: Updating global state...`),await this.c.updateStorageData(U,X,0),this.d.info(`${z}: Updated global state`,[...X.keys()]))}};e.$PEb=v,e.$PEb=v=ye([Y(0,E.$_j),Y(1,P.$Xh),Y(2,s.$RDb),Y(3,m.$qhb)],v);let y=class extends c.$LEb{constructor(O,T,M,U,z,Z){super("globalState",M,U,z,T,O,Z)}async o(O){const T=O.syncData?JSON.parse(O.syncData.content):null;if(!T){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const M={},U={};for(const z of Object.keys(T.storage))z.startsWith(n)?M[z.substring(n.length)]=T.storage[z].value:this.l.get(z,0)===void 0&&(U[z]=T.storage[z].value);if(Object.keys(M).length){let z="{}";try{z=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Z of Object.keys(M))z=(0,u.edit)(z,[Z],M[Z],{});await this.k.writeFile(this.h.argvResource,D.$be.fromString(z))}if(Object.keys(U).length){const z=[];for(const Z of Object.keys(U))z.push({key:Z,value:U[Z],scope:0,target:0});this.l.storeAll(z,!0)}}};e.$QEb=y,e.$QEb=y=ye([Y(0,$.$7o),Y(1,E.$_j),Y(2,k.$Lk),Y(3,P.$Xh),Y(4,m.$qhb),Y(5,w.$Jk)],y);let h=class{constructor(O,T,M,U,z){this.a=O,this.b=T,this.c=M,this.d=U,this.f=z}getSyncStoreType(O){return this.h(O)?.storage[m.$jhb]?.value}async sync(O){const T=(0,m.$fhb)((0,S.$eg)());try{return await this.g(O,T)}catch(M){if(M instanceof m.$ghb)switch(M.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(O,T)}throw M}}async g(O,T){const M=await this.a.readResource("globalState",null,void 0,T),U=this.h(M)||{storage:{}};U.storage[m.$jhb]={value:O,version:r};const z=await(0,l.$ap)(this.c,this.d,this.b),Z={version:r,machineId:z,content:t(U,!1)};await this.a.writeResource("globalState",JSON.stringify(Z),M.ref,void 0,T)}h({content:O}){if(!O)return null;const T=JSON.parse(O);if((0,c.$GEb)(T))return T?JSON.parse(T.content):null;throw new Error("Invalid remote data")}};e.$REb=h,e.$REb=h=ye([Y(1,$.$7o),Y(2,P.$Xh),Y(3,E.$_j),Y(4,b.$$i)],h)}),define(ae[116],ce([0,1,18,15,3,35,5,12,170,20,14,11,21,22,28,17,39,233,24]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t4b=e.$s4b=e.$r4b=void 0;function f(s,a,n){try{const i=JSON.parse(s);if(!a)return(0,R.$Ff)(i.all)?null:i.all;switch(I.OS){case 2:return(0,R.$Ff)(i.mac)?null:i.mac;case 3:return(0,R.$Ff)(i.linux)?null:i.linux;case 1:return(0,R.$Ff)(i.windows)?null:i.windows}}catch(i){return n.error(i),null}}e.$r4b=f;let m=class extends w.$KEb{constructor(a,n,i,t,r,o,v,y,h,g,O,T,M){super(a.keybindingsResource,{syncResource:"keybindings",profile:a},n,y,h,g,i,t,v,T,r,O,o,M),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:u.$shb,authority:"base"}),this.Gb=this.Eb.with({scheme:u.$shb,authority:"local"}),this.Hb=this.Eb.with({scheme:u.$shb,authority:"remote"}),this.Ib=this.Eb.with({scheme:u.$shb,authority:"accepted"}),this.B(j.Event.filter(o.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(a,n,i,t){const r=a.syncData?f(a.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&i?a:n;const o=n?this.Ob(n):null,v=await this.vb(),y=await this.Cb();let h=null,g=!1,O=!1,T=!1;if(r){let z=v?v.value.toString():"[]";if(z=z||"[]",this.Ab(z,!0))throw new u.$ghb((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==z||o!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Z=await(0,c.$q4b)(z,r,o,y,this.zb);Z.hasChanges&&(h=Z.mergeContent,T=Z.hasConflicts,g=T||Z.mergeContent!==z,O=T||Z.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),h=v.value.toString(),O=!0);const M={content:T?o:h,localChange:g?v?2:1:0,remoteChange:O?2:0,hasConflicts:T},U=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:o,localResource:this.Gb,localContent:U,localChange:M.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:M.remoteChange,previewResource:this.Eb,previewResult:M,acceptedResource:this.Ib}]}async ub(a){const n=this.Ob(a);if(n===null)return!0;const i=await this.vb(),t=i?i.value.toString():"",r=await this.Cb(),o=await(0,c.$q4b)(t||"[]",n,n,r,this.zb);return o.hasConflicts||o.mergeContent!==n}async rb(a,n){return a.previewResult}async sb(a,n,i,t){if(this.h.isEqual(n,this.Gb))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return i===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(a,n,i,t){const{fileContent:r}=i[0][0];let{content:o,localChange:v,remoteChange:y}=i[0][1];if(v===0&&y===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.Ab(o,!0)))throw new u.$ghb((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(o||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),y!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const h=this.Pb(o||"[]",a.syncData?.content);a=await this.mb(h,t?null:a.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==a.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(a,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.vb();if(a){const n=(0,A.$Xm)(a.value.toString());if((0,D.$Kb)(n))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async resolveContent(a){return this.h.isEqual(this.Hb,a)||this.h.isEqual(this.Fb,a)||this.h.isEqual(this.Gb,a)||this.h.isEqual(this.Ib,a)?this.db(a):null}Ob(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.Qb()?null:f(a.syncData.content,this.Qb(),this.O)}Pb(a,n){let i={};try{i=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete i.all:i.all=a,I.OS){case 2:i.mac=a;break;case 3:i.linux=a;break;case 1:i.windows=a;break}return JSON.stringify(i)}Qb(){return!!this.P.getValue(u.$7gb)}};e.$s4b=m,e.$s4b=m=ye([Y(2,u.$bhb),Y(3,u.$chb),Y(4,u.$qhb),Y(5,d.$ki),Y(6,u.$lhb),Y(7,E.$_j),Y(8,P.$Xh),Y(9,b.$7o),Y(10,u.$phb),Y(11,l.$dl),Y(12,$.$Jk)],m);let k=class extends w.$LEb{constructor(a,n,i,t,r,o){super("keybindings",n,i,t,a,r,o)}async o(a){const n=a.syncData?this.p(a.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,F.$be.fromString(n)),await this.n(a)}async i(){try{const a=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,A.$Xm)(a.value.toString());return!(0,D.$Kb)(n)}catch(a){return a.fileOperationResult===1}}p(a){try{return f(a,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$t4b=k,e.$t4b=k=ye([Y(0,E.$_j),Y(1,p.$Lk),Y(2,P.$Xh),Y(3,u.$qhb),Y(4,b.$7o),Y(5,$.$Jk)],k)}),define(ae[117],ce([0,1,15,3,171,20,74,14,29,11,21,22,28,17,39,237,24]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w4b=e.$v4b=e.$u4b=void 0;function c(k){return k&&k.settings&&typeof k.settings=="string"&&Object.keys(k).length===1}function u(k){const s=JSON.parse(k);return c(s)?s:{settings:k}}e.$u4b=u;let f=class extends $.$KEb{constructor(s,a,n,i,t,r,o,v,y,h,g,O,T,M){super(s.settingsResource,{syncResource:"settings",profile:s},a,n,i,t,r,o,g,O,v,y,h,M),this.Eb=T,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:w.$shb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$shb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$shb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$shb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(s){const a=await this.getLastSyncUserData(),n=await this.X(s,a),i=this.Lb(n),t=new I.$Dn(w.$6gb);return i?.settings&&t.parse(i.settings),t.configurationModel.getValue(w.$6gb)||{}}async qb(s,a,n){const i=await this.vb(),t=await this.Cb(),r=this.Lb(s);a=a===null&&n?s:a;const o=a?this.Lb(a):null,v=await this.Pb();let y=null,h=!1,g=!1,O=!1;if(r){let z=i?i.value.toString().trim():"{}";z=z||"{}",this.Qb(z),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Z=(0,p.$yDb)(z,r.settings,o?o.settings:null,v,[],t);y=Z.localContent||Z.remoteContent,h=Z.localContent!==null,g=Z.remoteContent!==null,O=Z.hasConflicts}else i&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),y=i.value.toString().trim()||"{}",this.Qb(y),g=!0);const T=i?i.value.toString():null,M=o?.settings??null,U={content:O?M:y,localChange:h?2:0,remoteChange:g?2:0,hasConflicts:O};return[{fileContent:i,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:T,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async ub(s){const a=this.Lb(s);if(a===null)return!0;const n=await this.vb(),i=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,p.$yDb)(i||"{}",a.settings,a.settings,t,[],r).remoteContent!==null}async rb(s,a){const n=await this.Cb(),i=await this.Pb();return{...s.previewResult,content:s.previewResult.content?(0,p.$xDb)(s.previewResult.content,"{}",i,n):null}}async sb(s,a,n,i){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(a,this.localResource))return{content:s.fileContent?(0,p.$xDb)(s.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(a,this.remoteResource))return{content:s.remoteContent!==null?(0,p.$xDb)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(a,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,p.$xDb)(n,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async tb(s,a,n,i){const{fileContent:t}=n[0][0];let{content:r,localChange:o,remoteChange:v}=n[0][1];if(o===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),o!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,i),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const y=await this.Cb(),h=this.Lb(s),g=await this.Pb(r);r=(0,p.$xDb)(r,h?h.settings:"{}",g,y),this.O.trace(`${this.D}: Updating remote settings...`),s=await this.mb(JSON.stringify(this.Nb(r)),i?null:s.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}a?.ref!==s.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(s),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.vb();if(s)return!(0,p.$zDb)(s.value.toString())}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.remoteResource,s)||this.h.isEqual(this.localResource,s)||this.h.isEqual(this.acceptedResource,s)||this.h.isEqual(this.baseResource,s)?this.db(s):null}async db(s){let a=await super.db(s);if(a){const n=await this.Cb(),i=await this.Pb();a=(0,p.$xDb)(a,"{}",i,n)}return a}Lb(s){return s.syncData?this.Mb(s.syncData.content):null}Mb(s){try{return u(s)}catch(a){this.O.error(a)}return null}Nb(s){return{settings:s}}async Pb(s){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(F.Event.any(F.Event.filter(this.Eb.onDidInstallExtensions,i=>i.some(({local:t})=>!!t)),F.Event.filter(this.Eb.onDidUninstallExtension,i=>!i.error))(()=>{n.dispose(),this.Ob=void 0}))}const a=await this.Ob;return(0,p.$vDb)(a,this.P,s)}Qb(s){if(this.Ab(s,!1))throw new w.$ghb((0,j.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$v4b=f,e.$v4b=f=ye([Y(2,d.$_j),Y(3,R.$Xh),Y(4,P.$7o),Y(5,w.$bhb),Y(6,w.$chb),Y(7,w.$qhb),Y(8,w.$phb),Y(9,A.$ki),Y(10,w.$lhb),Y(11,E.$dl),Y(12,S.$ao),Y(13,b.$Jk)],f);let m=class extends $.$LEb{constructor(s,a,n,i,t,r){super("settings",a,n,i,s,t,r)}async o(s){const a=s.syncData?this.p(s.syncData.content):null;if(!a){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,D.$be.fromString(a.settings)),await this.n(s)}async i(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,p.$zDb)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}p(s){try{return u(s)}catch(a){this.j.error(a)}return null}};e.$w4b=m,e.$w4b=m=ye([Y(0,d.$_j),Y(1,l.$Lk),Y(2,R.$Xh),Y(3,w.$qhb),Y(4,P.$7o),Y(5,b.$Jk)],m)}),define(ae[118],ce([0,1,15,3,30,20,14,11,21,22,28,17,39,234,24]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B4b=e.$A4b=e.$z4b=void 0;function p(u){return JSON.parse(u.content)}e.$z4b=p;let w=class extends b.$IEb{constructor(f,m,k,s,a,n,i,t,r,o,v,y){super({syncResource:"snippets",profile:f},m,s,k,a,n,i,o,v,t,r,y),this.pb=1,this.vb=f.snippetsHome,this.B(this.G.watch(k.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(F.Event.filter(this.G.onDidFilesChange,h=>h.affects(this.vb))(()=>this.Q()))}async qb(f,m,k){const s=await this.Hb(),a=this.Gb(s),n=f.syncData?this.Fb(f.syncData):null;m=m===null&&k?f:m;const i=m&&m.syncData?this.Fb(m.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,l.$x4b)(a,n,i);return this.Bb(t,s,n||{},i||{})}async ub(f){const m=f.syncData?this.Fb(f.syncData):null;if(m===null)return!0;const k=await this.Hb(),s=this.Gb(k),a=(0,l.$x4b)(s,m,m);return Object.keys(a.remote.added).length>0||Object.keys(a.remote.updated).length>0||a.remote.removed.length>0||a.conflicts.length>0}async rb(f,m){return f.previewResult}async sb(f,m,k,s){if(this.h.isEqualOrParent(m,this.g.with({scheme:$.$shb,authority:"local"})))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:f.fileContent?f.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(m,this.g.with({scheme:$.$shb,authority:"remote"})))return{content:f.remoteContent,localChange:f.remoteContent!==null?f.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(m,this.g))return k===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:k,localChange:k===null?f.fileContent!==null?3:0:2,remoteChange:k===null?f.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async tb(f,m,k,s){const a=k.map(([n,i])=>({...n,acceptResult:i}));a.every(({localChange:n,remoteChange:i})=>n===0&&i===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),a.some(({localChange:n})=>n!==0)&&(await this.Cb(a),await this.Db(a,s)),a.some(({remoteChange:n})=>n!==0)&&(f=await this.Eb(a,f,s)),m?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of a)try{await this.G.del(n)}catch{}}Bb(f,m,k,s){const a=new Map;for(const n of Object.keys(f.local.added)){const i={content:f.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"accepted"})})}for(const n of Object.keys(f.local.updated)){const i={content:f.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"accepted"})})}for(const n of f.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"accepted"})})}for(const n of Object.keys(f.remote.added)){const i={content:f.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"accepted"})})}for(const n of Object.keys(f.remote.updated)){const i={content:f.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"accepted"})})}for(const n of f.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"accepted"})})}for(const n of f.conflicts){const i={content:s[n]??null,hasConflicts:!0,localChange:m[n]?2:1,remoteChange:k[n]?2:1},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"local"}),fileContent:m[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"remote"}),remoteContent:k[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"accepted"})})}for(const n of Object.keys(m))if(!a.has(n)){const i={content:m[n]?m[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"local"}),fileContent:m[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"remote"}),remoteContent:k[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$shb,authority:"accepted"})})}return[...a.values()]}async resolveContent(f){return this.h.isEqualOrParent(f,this.g.with({scheme:$.$shb,authority:"remote"}))||this.h.isEqualOrParent(f,this.g.with({scheme:$.$shb,authority:"local"}))||this.h.isEqualOrParent(f,this.g.with({scheme:$.$shb,authority:"base"}))||this.h.isEqualOrParent(f,this.g.with({scheme:$.$shb,authority:"accepted"}))?this.db(f):null}async hasLocalData(){try{const f=await this.Hb();if(Object.keys(f).length)return!0}catch{}return!1}async Cb(f){const m={};for(const k of f)k.fileContent&&(m[this.h.basename(k.localResource)]=k.fileContent);await this.nb(JSON.stringify(this.Gb(m)))}async Db(f,m){for(const{fileContent:k,acceptResult:s,localResource:a,remoteResource:n,localChange:i}of f)if(i!==0){const t=n?this.h.basename(n):this.h.basename(a),r=this.h.joinPath(this.vb,t);i===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):i===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,D.$be.fromString(s.content),{overwrite:m}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,D.$be.fromString(s.content),m?void 0:k),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(f,m,k){const s=m.syncData?this.Fb(m.syncData):{},a=(0,j.$8m)(s);for(const{acceptResult:n,localResource:i,remoteResource:t,remoteChange:r}of f)if(r!==0){const o=i?this.h.basename(i):this.h.basename(t);r===3?delete a[o]:a[o]=n.content}return(0,l.$y4b)(s,a)||(this.O.trace(`${this.D}: Updating remote snippets...`),m=await this.mb(JSON.stringify(a),k?null:m.ref),this.O.info(`${this.D}: Updated remote snippets`)),m}Fb(f){return p(f)}Gb(f){const m={};for(const k of Object.keys(f))m[k]=f[k].value.toString();return m}async Hb(){const f={};let m;try{m=await this.G.resolve(this.vb)}catch(k){if(k instanceof R.$uk&&k.fileOperationResult===1)return f;throw k}for(const k of m.children||[]){const s=k.resource,a=this.h.extname(s);if(a===".json"||a===".code-snippets"){const n=this.h.relativePath(this.vb,s),i=await this.G.readFile(s);f[n]=i}}return f}};e.$A4b=w,e.$A4b=w=ye([Y(2,I.$Xh),Y(3,R.$_j),Y(4,S.$7o),Y(5,$.$bhb),Y(6,$.$chb),Y(7,$.$qhb),Y(8,A.$ki),Y(9,$.$lhb),Y(10,d.$dl),Y(11,P.$Jk)],w);let c=class extends b.$LEb{constructor(f,m,k,s,a,n){super("snippets",m,k,s,f,a,n)}async o(f){const m=f.syncData?JSON.parse(f.syncData.content):null;if(!m){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const s of Object.keys(m)){const a=m[s];if(a){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,s);await this.k.createFile(n,D.$be.fromString(a)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(f)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(f){return f.fileOperationResult===1}}};e.$B4b=c,e.$B4b=c=ye([Y(0,R.$_j),Y(1,E.$Lk),Y(2,I.$Xh),Y(3,$.$qhb),Y(4,S.$7o),Y(5,P.$Jk)],c)}),define(ae[119],ce([0,1,15,20,14,11,21,22,28,17,39,24]),function(te,e,D,F,j,A,I,R,S,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E4b=e.$D4b=e.$C4b=void 0;function b(w,c){try{return JSON.parse(w).tasks??null}catch(u){return c.error(u),null}}e.$C4b=b;let l=class extends P.$JEb{constructor(c,u,f,m,k,s,a,n,i,t,r,o){super(c.tasksResource,{syncResource:"tasks",profile:c},u,n,i,t,f,m,a,r,k,s,o),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:E.$shb,authority:"base"}),this.Cb=this.Ab.with({scheme:E.$shb,authority:"local"}),this.Db=this.Ab.with({scheme:E.$shb,authority:"remote"}),this.Eb=this.Ab.with({scheme:E.$shb,authority:"accepted"})}async qb(c,u,f,m){const k=c.syncData?b(c.syncData.content,this.O):null;u=u===null&&f?c:u;const s=u?.syncData?b(u.syncData.content,this.O):null,a=await this.vb();let n=null,i=!1,t=!1,r=!1;if(c.syncData){const y=a?a.value.toString():null;if(!s||s!==y||s!==k){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const h=p(y,k,s);n=h.content,r=h.hasConflicts,i=h.hasLocalChanged,t=h.hasRemoteChanged}}else a&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=a.value.toString(),t=!0);const o={content:r?s:n,localChange:i?a?2:1:0,remoteChange:t?2:0,hasConflicts:r},v=a?a.value.toString():null;return[{fileContent:a,baseResource:this.Bb,baseContent:s,localResource:this.Cb,localContent:v,localChange:o.localChange,remoteResource:this.Db,remoteContent:k,remoteChange:o.remoteChange,previewResource:this.Ab,previewResult:o,acceptedResource:this.Eb}]}async ub(c){const u=c?.syncData?b(c.syncData.content,this.O):null;if(u===null)return!0;const f=await this.vb(),m=f?f.value.toString():null,k=p(m,u,u);return k.hasLocalChanged||k.hasRemoteChanged}async rb(c,u){return c.previewResult}async sb(c,u,f,m){if(this.h.isEqual(u,this.Cb))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.Db))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.Ab))return f===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:f,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async tb(c,u,f,m){const{fileContent:k}=f[0][0],{content:s,localChange:a,remoteChange:n}=f[0][1];if(a===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),a!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),k&&await this.nb(JSON.stringify(this.Kb(k.value.toString()))),s?await this.wb(s,k,m):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const i=JSON.stringify(this.Kb(s));c=await this.mb(i,m?null:c.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}u?.ref!==c.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(c),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(c){return this.h.isEqual(this.Db,c)||this.h.isEqual(this.Bb,c)||this.h.isEqual(this.Cb,c)||this.h.isEqual(this.Eb,c)?this.db(c):null}Kb(c){return c?{tasks:c}:{}}};e.$D4b=l,e.$D4b=l=ye([Y(2,E.$bhb),Y(3,E.$chb),Y(4,E.$qhb),Y(5,F.$ki),Y(6,E.$lhb),Y(7,A.$_j),Y(8,j.$Xh),Y(9,I.$7o),Y(10,R.$dl),Y(11,S.$Jk)],l);let $=class extends P.$LEb{constructor(c,u,f,m,k,s){super("tasks",u,f,m,c,k,s),this.c=this.g.defaultProfile.tasksResource}async o(c){const u=c.syncData?b(c.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,D.$be.fromString(u)),await this.n(c)}async p(){return this.k.exists(this.c)}};e.$E4b=$,e.$E4b=$=ye([Y(0,A.$_j),Y(1,d.$Lk),Y(2,j.$Xh),Y(3,E.$qhb),Y(4,I.$7o),Y(5,S.$Jk)],$);function p(w,c,u){if(w===null&&c===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===c)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const f=u!==w,m=u!==c;return!f&&!m?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:f&&!m?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:m&&!f?{content:c,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ae[120],ce([0,1,42,20,14,11,21,22,28,17,39,235,24]),function(te,e,D,F,j,A,I,R,S,d,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j6b=e.$i6b=e.$h6b=void 0;let l=class extends P.$IEb{constructor(c,u,f,m,k,s,a,n,i,t,r,o,v){super({syncResource:"profiles",profile:c},u,m,k,s,a,n,r,o,i,t,v),this.vb=f,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:b.$shb,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.$shb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.$shb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.$shb,authority:"accepted"}),this.B(f.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const c=await this.getLastSyncUserData();return c?.syncData?p(c.syncData):null}async getRemoteSyncedProfiles(c){const u=await this.getLastSyncUserData(),f=await this.X(c,u);return f?.syncData?p(f.syncData):null}async qb(c,u,f){if(!this.vb.isEnabled())throw new b.$ghb("Cannot sync profiles because they are disabled","LocalError");const m=c.syncData?p(c.syncData):null,k=u?.syncData?p(u.syncData):null,s=this.Db(),{local:a,remote:n}=(0,E.$g6b)(s,m,k,[]),i={local:a,remote:n,content:k?this.Eb(k):null,localChange:a.added.length>0||a.removed.length>0||a.updated.length>0?2:0,remoteChange:n!==null?2:0},t=$(s,!1);return[{baseResource:this.baseResource,baseContent:k?this.Eb(k):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:m?this.Eb(m):null,remoteProfiles:m,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async ub(c){const u=c?.syncData?p(c.syncData):null,f=this.Db(),{remote:m}=(0,E.$g6b)(f,u,u,[]);return!!m?.added.length||!!m?.removed.length||!!m?.updated.length}async rb(c,u){return{...c.previewResult,hasConflicts:!1}}async sb(c,u,f,m){if(this.h.isEqual(u,this.localResource))return this.Ab(c);if(this.h.isEqual(u,this.remoteResource))return this.Bb(c);if(this.h.isEqual(u,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async Ab(c){const u=this.Db(),f=(0,E.$g6b)(u,null,null,[]),{local:m,remote:k}=f;return{content:c.localContent,local:m,remote:k,localChange:m.added.length>0||m.removed.length>0||m.updated.length>0?2:0,remoteChange:k!==null?2:0}}async Bb(c){const u=c.remoteContent?JSON.parse(c.remoteContent):null,f=[],m=[];for(const k of this.Db()){const s=u?.find(a=>a.id===k.id);s&&(f.push({id:k.id,name:k.name,collection:s.collection}),m.push(k))}if(u!==null){const k=(0,E.$g6b)(m,u,f,[]),{local:s,remote:a}=k;return{content:c.remoteContent,local:s,remote:a,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:a!==null?2:0}}else return{content:c.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(c,u,f,m){const{local:k,remote:s,localChange:a,remoteChange:n}=f[0][1];a===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const i=f[0][0].remoteProfiles||[];if(i.length+(s?.added.length??0)-(s?.removed.length??0)>20)throw new b.$ghb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(a!==0){await this.nb($(this.Db(),!1));const t=[];for(const r of k.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of k.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of k.updated){const o=this.vb.profiles.find(v=>v.id===r.id);o?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(o,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=i.length+(s?.added.length??0)<=20;if(r)for(const o of s?.added||[]){const v=await this.J.createCollection(this.F);t.push(v),i.push({id:o.id,name:o.name,collection:v,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const o of s?.removed||[])i.splice(i.findIndex(({id:v})=>o.id===v),1);for(const o of s?.updated||[]){const v=i.find(({id:y})=>o.id===y);v&&i.splice(i.indexOf(v),1,{...v,id:o.id,name:o.name,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}try{c=await this.updateRemoteProfiles(i,m?null:c.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&s?.added.length?` Added: ${JSON.stringify(s.added.map(o=>o.name))}.`:""}${s?.updated.length?` Updated: ${JSON.stringify(s.updated.map(o=>o.name))}.`:""}${s?.removed.length?` Removed: ${JSON.stringify(s.removed.map(o=>o.name))}.`:""}`)}catch(o){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of t)await this.J.deleteCollection(v,this.F)}throw o}for(const o of s?.removed||[])await this.J.deleteCollection(o.collection,this.F)}u?.ref!==c.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(c),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(c,u){return this.mb(this.Eb(c),u)}async hasLocalData(){return this.Db().length>0}async resolveContent(c){if(this.h.isEqual(this.remoteResource,c)||this.h.isEqual(this.baseResource,c)||this.h.isEqual(this.localResource,c)||this.h.isEqual(this.acceptedResource,c)){const u=await this.db(c);return u&&(0,D.$iT)(JSON.parse(u),{})}return null}Db(){return this.vb.profiles.filter(c=>!c.isDefault&&!c.isTransient)}Eb(c){return JSON.stringify([...c].sort((u,f)=>u.name.localeCompare(f.name)))}};e.$h6b=l,e.$h6b=l=ye([Y(2,d.$Lk),Y(3,A.$_j),Y(4,j.$Xh),Y(5,I.$7o),Y(6,b.$bhb),Y(7,b.$chb),Y(8,b.$qhb),Y(9,F.$ki),Y(10,b.$lhb),Y(11,R.$dl),Y(12,S.$Jk)],l);function $(w,c){const u=[...w].sort((f,m)=>f.name.localeCompare(m.name)).map(f=>({id:f.id,name:f.name}));return c?(0,D.$iT)(u,{}):JSON.stringify(u)}e.$i6b=$;function p(w){return JSON.parse(w.content)}e.$j6b=p}),define(ae[252],ce([0,1,3,2,5,14,21,22,24]),function(te,e,D,F,j,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$75b=void 0;const d="sync.enable";let P=class extends F.$Rc{constructor(b,l,$,p){super(),this.c=b,this.f=l,this.g=$,this.h=p,this.a=new D.$Nd,this.onDidChangeEnablement=this.a.event,this.b=new D.$Nd,this.onDidChangeResourceEnablement=this.b.event,this.B(b.onDidChangeValue(-1,void 0,this.B(new F.$Qc))(w=>this.m(w)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(d,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(b){b&&!this.canToggleEnablement()||(this.f.publicLog2(d,{enabled:b}),this.c.store(d,b,-1,1))}isResourceEnabled(b){return this.c.getBoolean((0,S.$khb)(b),-1,!0)}setResourceEnablement(b,l){if(this.isResourceEnabled(b)!==l){const $=(0,S.$khb)(b);this.j($,l)}}getResourceSyncStateVersion(b){}j(b,l){this.c.store(b,l,-1,j.$p?0:1)}m(b){if(d===b.key){this.a.fire(this.isEnabled());return}const l=S.$0gb.filter($=>(0,S.$khb)($)===b.key)[0];if(l){this.b.fire([l,this.isResourceEnabled(l)]);return}}};e.$75b=P,e.$75b=P=ye([Y(0,I.$7o),Y(1,R.$dl),Y(2,A.$Xh),Y(3,S.$ahb)],P)}),define(ae[253],ce([0,1,6,15,64,2,19,20,14,11,17,24]),function(te,e,D,F,j,A,I,R,S,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f6b=void 0;let b=class extends A.$Rc{constructor($,p,w,c,u){super(),this.a=$,this.b=p,this.c=w,this.f=c,this.g=u,this.h()}async h(){for(const p of this.g.profiles)for(const w of E.$0gb)try{await this.m(this.j(w,p.isDefault?void 0:p.id))}catch(c){this.f.error(c)}let $;try{$=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,d.$qk)(p)!==1&&this.f.error(p);return}if($.children){for(const p of $.children)if(p.isDirectory&&!this.g.profiles.some(w=>w.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(w){this.f.error(w)}}}async getAllResourceRefs($,p,w){const c=this.j($,p,w);try{const u=await this.b.resolve(c);if(u.children)return u.children.filter(m=>m.isFile&&!m.name.startsWith("lastSync")).sort().reverse().map(m=>({ref:m.name,created:this.n(m)}))}catch(u){if((0,d.$qk)(u)!==1)throw u}return[]}async resolveResourceContent($,p,w,c){const u=this.j($,w,c),f=(0,I.$vg)(u,p);try{return(await this.b.readFile(f)).value.toString()}catch(m){return this.f.error(m),null}}async writeResource($,p,w,c,u){const f=this.j($,c,u),m=(0,I.$vg)(f,`${(0,j.$fm)(w).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(m,F.$be.fromString(p))}catch(k){this.f.error(k)}}j($,p,w=this.a.userDataSyncHome){return(0,I.$vg)(w,...p?[p,$]:[$])}async m($){try{try{if(!await this.b.exists($))return}catch{return}const p=await this.b.resolve($);if(p.children){const w=p.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort(),c=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=w.filter(m=>Date.now()-this.n(m)>c);const f=w.length-u.length;f<10&&(u=u.slice(10-f)),await D.Promises.settled(u.map(async m=>{this.f.info("Deleting from backup",m.resource.path),await this.b.del(m.resource)}))}}catch(p){this.f.error(p)}}n($){return new Date(parseInt($.name.substring(0,4)),parseInt($.name.substring(4,6))-1,parseInt($.name.substring(6,8)),parseInt($.name.substring(9,11)),parseInt($.name.substring(11,13)),parseInt($.name.substring(13,15))).getTime()}};e.$f6b=b,e.$f6b=b=ye([Y(0,S.$Xh),Y(1,d.$_j),Y(2,R.$ki),Y(3,E.$qhb),Y(4,P.$Lk)],b)}),define(ae[82],ce([0,1,3,2,5,27,175,14,11,4,25,43,21,24]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$3gb=e.$2gb=e.$1gb=void 0,e.$1gb=(0,d.$Qh)("IUserDataSyncMachinesService");const p="sync.currentMachineName",w="Safari",c="Chrome",u="Edge",f="Firefox",m="Android";function k(n){switch(n){case w:case c:case u:case f:case m:case(0,j.$i)(0):return!0}return!1}e.$2gb=k;function s(){return j.$G?w:j.$E?c:j.$H?u:j.$F?f:j.$I?m:(0,j.$i)(j.$p?0:j.$u)}let a=class extends F.$Rc{static{$=this}static{this.a=1}static{this.b="machines"}constructor(i,t,r,o,v,y){super(),this.h=r,this.j=o,this.m=v,this.n=y,this.c=this.B(new D.$Nd),this.onDidChange=this.c.event,this.g=null,this.f=(0,E.$ap)(i,t,r)}async getMachines(i){const t=await this.f;return(await this.s(i)).machines.map(o=>({...o,isCurrent:o.id===t}))}async addCurrentMachine(i){const t=await this.f,r=await this.s(i);r.machines.some(({id:o})=>o===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:s()}),await this.t(r))}async removeCurrentMachine(i){const t=await this.f,r=await this.s(i),o=r.machines.filter(({id:v})=>v!==t);o.length!==r.machines.length&&(r.machines=o,await this.t(r))}async renameMachine(i,t,r){const o=await this.s(r),v=o.machines.find(({id:y})=>y===i);if(v){v.name=t,await this.t(o);const y=await this.f;i===y&&this.h.store(p,t,-1,1)}}async setEnablements(i){const t=await this.s();for(const[r,o]of i){const v=t.machines.find(y=>y.id===r);v&&(v.disabled=o?void 0:!0)}await this.t(t)}r(i){const t=this.h.get(p,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${s()} (${this.n.nameShort})`,o=new RegExp(`${(0,A.$Fe)(r)}\\s#(\\d+)`);let v=0;for(const y of i){const h=o.exec(y.name),g=h?parseInt(h[1]):0;v=g>v?g:v}return`${r} #${v+1}`}async s(i){this.g=await this.u(i);const t=this.w(this.g);if(t.version!==$.a)throw new Error((0,I.localize)(0,null,this.n.nameLong));return t}async t(i){const t=JSON.stringify(i),r=await this.j.writeResource($.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(i){if(this.g){const t=i&&i.latest?i.latest[$.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource($.b,this.g)}w(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.m.error(t)}return{version:$.a,machines:[]}}};e.$3gb=a,e.$3gb=a=$=ye([Y(0,R.$Xh),Y(1,S.$_j),Y(2,b.$7o),Y(3,l.$bhb),Y(4,l.$qhb),Y(5,P.$qj)],a)}),define(ae[254],ce([0,1,6,64,38,7,3,2,5,19,10,172,25,21,22,24,79,82]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l6b=void 0;const u="sync.disableMachineEventually",f="sync.sessionId",m="sync.storeUrl",k="sync.productQuality";let s=class extends R.$Rc{get n(){const i=this.H.get(m,-1);return i?P.URI.parse(i):void 0}set n(i){i?this.H.store(m,i.toString(),-1,1):this.H.remove(m,-1)}get s(){return this.H.get(k,-1)}set s(i){i?this.H.store(k,i,-1,1):this.H.remove(k,-1)}constructor(i,t,r,o,v,y,h,g,O,T){super(),this.u=t,this.w=r,this.y=o,this.z=v,this.C=y,this.D=h,this.F=g,this.G=O,this.H=T,this.a=this.B(new R.$Sc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new I.$Nd),this.onError=this.h.event,this.S=[],this.f=this.B(new D.$Rg(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=i.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,d.$og)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(h.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this.B(I.Event.filter(this.y.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:i,message:t}=this.L();i?this.a.value===void 0&&(this.a.value=new a(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,F.$fm)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(i,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(f,-1),i?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(o){if(this.C.error(o),t)this.M(!1);else throw o}}M(i){this.y.isEnabled()!==i&&(this.y.setEnablement(i),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(i){if(!i){this.b=0;return}const t=p.$ghb.toUserDataSyncError(i);t instanceof p.$ihb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?S.$p&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(u,!0,-1,1),await(0,D.$Ug)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(u,-1,!1)}R(){this.H.remove(u,-1)}async triggerSync(i,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...i),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const o=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:o}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$l6b=s,e.$l6b=s=ye([Y(0,b.$qj),Y(1,p.$ahb),Y(2,p.$bhb),Y(3,p.$lhb),Y(4,p.$mhb),Y(5,p.$qhb),Y(6,w.$fDb),Y(7,$.$dl),Y(8,c.$1gb),Y(9,l.$7o)],s);class a extends R.$Rc{static{this.a="Interval"}constructor(i,t,r,o,v,y,h,g,O){super(),this.m=i,this.n=t,this.r=r,this.s=o,this.u=v,this.w=y,this.y=h,this.z=g,this.C=O,this.b=this.B(new R.$Sc),this.c=this.B(new I.$Nd),this.onDidStartSync=this.c.event,this.f=this.B(new I.$Nd),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$Pc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(a.a,!1)}D(){this.b.value=(0,D.$Vg)(()=>{this.sync(a.a,!1),this.b.value=void 0},this.n)}sync(i,t){const r=(0,D.$Hg)(async o=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,A.$3)(v))return}return this.H(i,t,o)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,d.$og)(this.m,this.r.userDataSyncStore?.url)}async G(){const i=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!i&&(!(0,d.$og)(t.defaultUrl,i.defaultUrl)||!(0,d.$og)(t.insidersUrl,i.insidersUrl)||!(0,d.$og)(t.stableUrl,i.stableUrl))}async H(i,t,r){this.y.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let o;try{await this.I(t,r)}catch(v){if(this.y.error(v),o=v,p.$ghb.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),o=void 0}catch(y){this.y.error(y),o=y}}this.f.fire(o)}async I(i,t){if(this.h=await this.u.createSyncTask(this.g,i),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new p.$ihb((0,E.localize)(0,null),"DefaultServiceChanged"):new p.$ihb((0,E.localize)(1,null),"ServiceChanged"):new p.$ihb((0,E.localize)(2,null),"TurnedOff");const r=this.C.get(f,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new p.$ihb((0,E.localize)(3,null),"DefaultServiceChanged"):new p.$ihb((0,E.localize)(4,null),"ServiceChanged"):new p.$ihb((0,E.localize)(5,null),"SessionExpired");const o=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const v=o.find(h=>h.isCurrent);if(v?.disabled)throw new p.$ihb((0,E.localize)(6,null),"TurnedOff");const y=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-y}),this.g===null)try{this.g=await this.s.manifest(null)}catch(h){throw new p.$ihb((0,j.$Bi)(h),h instanceof p.$ghb?h.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(f,this.g.session,-1,1),!t.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}}),define(ae[255],ce([0,1,10,176,14,11,43,21,28,24,17,39,118,117,116,20,119,114,115,4,120,42,27]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w,c,u,f,m,k,s){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$V6b=void 0;let n=class{static{a=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,o,v,y,h,g,O,T,M){this.e=t,this.f=r,this.g=o,this.h=y,this.i=h,this.j=g,this.k=O,this.l=T,this.n=M,this.d=v.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,m.$j6b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const o=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(o){const v=this.L(o,"profiles");return(0,m.$j6b)(v)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const o=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(o)return JSON.parse(o).machines.map(y=>({...y,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:v,ref:y})=>({created:v,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:y,node:void 0})}))}async getLocalSyncResourceHandles(t,r,o){return(await this.f.getAllResourceRefs(t,r?.collection,o)).map(({created:y,ref:h})=>({created:y,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:h,node:void 0,location:o})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),o=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&o?{profile:o,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const o=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,o);case"keybindings":return this.u(t,o);case"tasks":return this.w(t,o);case"snippets":return this.y(t,o);case"globalState":return this.D(t,o);case"extensions":return this.A(t,o);case"profiles":return this.G(t,o);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:o}=await this.M(r.syncResource,r.ref,r.collection);if(o)return this.L(o,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const o=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(o)return this.L(o,r.syncResource)?.machineId}return}return(0,I.$ap)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===a.a)return null;if(r.ref){const o=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&o?this.q(r.syncResource,o,r.node):o}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,o,v,y){if(t){const{content:h}=await this.M(r,v,o);return h}return this.f.resolveResourceContent(r,v,o,y)}q(t,r,o){const v=this.L(r,t);switch(t){case"settings":return this.t(v,o);case"keybindings":return this.v(v,o);case"tasks":return this.x(v,o);case"snippets":return this.z(v,o);case"globalState":return this.E(v,o);case"extensions":return this.B(v,o);case"profiles":return this.H(v,o);case"workspaceState":return null}}async r(t,r){const o=this.k.profiles.find(v=>v.id===r);if(!o)return null;switch(t){case"globalState":return this.F(o);case"extensions":return this.C(o);case"profiles":return this.I(o);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const o=this.d.joinPath(t,"settings.json"),v=r?r.settingsResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}t(t,r){switch(r){case"settings.json":return(0,l.$u4b)(t.content).settings}return null}u(t,r){const o=this.d.joinPath(t,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}v(t,r){switch(r){case"keybindings.json":return(0,$.$r4b)(t.content,!!this.l.getValue(d.$7gb),this.g)}return null}w(t,r){const o=this.d.joinPath(t,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}x(t,r){switch(r){case"tasks.json":return(0,w.$C4b)(t.content,this.g)}return null}async y(t,r){const o=await this.resolveContent(t);if(o){const v=this.L(o,"snippets");if(v){const y=(0,b.$z4b)(v),h=[];for(const g of Object.keys(y)){const O=this.d.joinPath(t,g),T=r?this.d.joinPath(r.snippetsHome,g):this.d.joinPath(t,a.a);h.push({resource:O,comparableResource:T})}return h}}return[]}z(t,r){return(0,b.$z4b)(t)[r]||null}A(t,r){const o=this.d.joinPath(t,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}B(t,r){switch(r){case"extensions.json":return(0,c.$m4b)((0,c.$l4b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(c.$o4b).getLocalExtensions(t);return(0,c.$m4b)(r,!0)}D(t,r){const o=this.d.joinPath(t,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}E(t,r){switch(r){case"globalState.json":return(0,u.$NEb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(u.$PEb).getLocalGlobalState(t);return(0,u.$NEb)(r,!0)}G(t,r){const o=this.d.joinPath(t,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:v}]}H(t,r){switch(r){case"profiles.json":return(0,k.$iT)(JSON.parse(t.content),{})}return null}async I(t){return(0,m.$i6b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?a.b:a.c,o=[];return t.location&&(o.push(`scheme:${t.location.scheme}`),o.push(`authority:${t.location.authority}`),o.push((0,s.$Ie)(t.location.path,"/"))),o.push(`syncResource:${t.syncResource}`),o.push(`profile:${t.profile}`),t.collection&&o.push(`collection:${t.collection}`),t.ref&&o.push(`ref:${t.ref}`),t.node&&o.push(t.node),this.d.joinPath(D.URI.from({scheme:d.$shb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...o)}K(t){if(t.scheme!==d.$shb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const o=t.authority===a.b;let v,y;const h=[];let g,O,T,M,U;for(;r.length;){const z=r.shift();z.startsWith("scheme:")?v=z.substring(7):z.startsWith("authority:")?y=z.substring(10):z.startsWith("syncResource:")?g=z.substring(13):z.startsWith("profile:")?O=z.substring(8):z.startsWith("collection:")?T=z.substring(11):z.startsWith("ref:")?M=z.substring(4):g?U=z:h.push(z)}return{remote:o,syncResource:g,profile:O,collection:T,ref:M,node:U,location:v&&y!==void 0?this.d.joinPath(D.URI.from({scheme:v,authority:y,query:t.query,fragment:t.fragment,path:"/"}),...h):void 0}}L(t,r){try{const o=JSON.parse(t);if((0,E.$GEb)(o))return o}catch(o){this.g.error(o)}throw new d.$ghb((0,F.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,o){const v=await this.e.resolveResourceContent(t,r,o);return{ref:r,content:v}}};e.$V6b=n,e.$V6b=n=a=ye([Y(0,d.$bhb),Y(1,d.$chb),Y(2,d.$qhb),Y(3,S.$Jk),Y(4,j.$Xh),Y(5,R.$7o),Y(6,A.$_j),Y(7,P.$Lk),Y(8,p.$ki),Y(9,f.$Ph)],n)}),define(ae[256],ce([0,1,18,6,26,38,3,2,19,12,32,20,29,11,4,21,22,17,114,115,116,117,118,119,120,24]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w,c,u,f,m,k,s,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k6b=void 0;const t="sync.lastSyncTime";let r=class extends R.$Rc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(g,O,T,M,U,z,Z,X,x,H,K){super(),this.C=g,this.D=O,this.F=T,this.G=M,this.H=U,this.I=z,this.J=Z,this.L=X,this.M=x,this.N=H,this.O=K,this.f="uninitialized",this.g=this.B(new I.$Nd),this.onDidChangeStatus=this.g.event,this.h=this.B(new I.$Nd),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new I.$Nd),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new I.$Nd),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new I.$Nd),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new I.$Nd),this.onDidResetLocal=this.w.event,this.y=this.B(new I.$Nd),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=T.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,R.$Pc)(()=>this.bb()))}async createSyncTask(g,O){this.cb(),this.H.info("Sync started.");const T=new Date().getTime(),M=(0,P.$eg)();try{const X=(0,i.$fhb)(M);O&&(X["Cache-Control"]="no-cache"),g=await this.D.manifest(g,X)}catch(X){const x=i.$ghb.toUserDataSyncError(X);throw y(x,M,this.F,this.I),x}const U=!1,z=this;let Z;return{manifest:g,async run(){if(U)throw new Error("Can run a task only once");Z=(0,F.$Hg)(X=>z.P(g,!1,M,X)),await Z.finally(()=>Z=void 0),z.H.info(`Sync done. Took ${new Date().getTime()-T}ms`),z.$()},stop(){return Z?.cancel(),z.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new i.$ghb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const g=new Date().getTime(),O=(0,P.$eg)(),T=(0,i.$fhb)(O);let M;try{M=await this.D.manifest(null,T)}catch(Z){const X=i.$ghb.toUserDataSyncError(Z);throw y(X,O,this.F,this.I),X}await this.resetLocal();const U=this,z=new j.$Xd;return{id:O,async merge(){return U.P(M,!0,O,z.token)},async apply(){try{try{await U.R(M,O,z.token)}catch(Z){if(i.$ghb.toUserDataSyncError(Z).code==="MethodNotFound")U.H.info("Client is making invalid requests. Cleaning up data..."),await U.cleanUpRemoteData(),U.H.info("Applying manual sync again..."),await U.R(M,O,z.token);else throw Z}}catch(Z){throw U.H.error(Z),Z}U.H.info(`Sync done. Took ${new Date().getTime()-g}ms`),U.$()},async stop(){z.cancel(),await U.U(),await U.resetLocal()}}}async P(g,O,T,M){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const U=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(U,g,O,T,M));const z=U.enabled.find(Z=>Z.resource==="profiles");if(z){const Z=await z.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.Q(Z,g,O,T,M)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(g,O,T,M,U){for(const z of g){if(U.isCancellationRequested)return;const Z=this.M.profiles.find(x=>x.id===z.id);if(!Z){this.H.error(`Profile with id:${z.id} and name: ${z.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",z.name);const X=this.getOrCreateActiveProfileSynchronizer(Z,z);this.n.push(...await this.S(X,O,T,M,U))}for(const[z,Z]of this.z.entries())this.M.profiles.some(X=>X.id===Z[0].profile.id)||(Z[1].dispose(),this.z.delete(z))}async R(g,O,T){const M=this.ab();for(const x of M){if(T.isCancellationRequested)return;await x.apply(O,T)}const U=M.find(x=>x.profile.isDefault);if(!U)return;const z=U.enabled.find(x=>x.resource==="profiles");if(!z)return;const X=(await z.getRemoteSyncedProfiles(g?.latest??null)||[]).filter(x=>M.every(H=>H.profile.id!==x.id));X.length&&await this.Q(X,g,!1,O,T)}async S(g,O,T,M,U){return(await g.sync(O,T,M,U)).map(([Z,X])=>({profile:g.profile,syncResource:Z,error:X}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(g=>g.stop()))}async resolveContent(g){const O=await this.N.resolveContent(g);if(O)return O;for(const T of this.ab())for(const M of T.enabled){const U=await M.resolveContent(g);if(U)return U}return null}async replace(g){this.cb();const O=this.N.resolveUserDataSyncResource(g);if(!O)return;const T=await this.resolveContent(g.uri);T&&await this.W(O.profile,async M=>{if(O.syncResource===M.resource)return await M.replace(T),!0})}async accept(g,O,T,M){this.cb(),await this.W(g.profile,async U=>{if(g.syncResource===U.resource)return await U.accept(O,T),M&&await U.apply((0,d.$Ef)(M)?!1:M.force,(0,i.$fhb)((0,P.$eg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async O=>{if(O.resource!=="globalState"&&await O.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async O=>{if(await O.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(g){this.H.error(g)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[g]of this.z.values())try{await g.resetLocal()}catch(O){this.H.error(O)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const g=await this.N.getRemoteSyncedProfiles(),O=g.map(z=>z.collection),T=await this.D.getAllCollections(),M=T.filter(z=>!O.includes(z));M.length&&(this.H.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(z=>this.D.deleteCollection(z))),this.H.info("Deleted redundant collections on server"));const U=g.filter(z=>T.includes(z.collection));if(U.length!==g.length){const z=this.G.createInstance(n.$h6b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await z.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await z.updateRemoteProfiles(U,null),this.H.info("Updated remote profiles on server")}finally{z.dispose()}}}async saveRemoteActivityData(g){this.cb();const O=await this.D.getActivityData();await this.C.writeFile(g,O)}async extractActivityData(g,O){const T=(await this.C.readFile(g)).value.toString(),M=JSON.parse(T);if(M.resources)for(const U in M.resources)for(const z of M.resources[U])await this.O.writeResource(U,z.content,new Date(z.created*1e3),void 0,O);if(M.collections)for(const U in M.collections)for(const z in M.collections[U].resources)for(const Z of M.collections[U].resources?.[z]??[])await this.O.writeResource(z,Z.content,new Date(Z.created*1e3),U,O)}async W(g,O){const T=new R.$Qc;try{const M=this.z.get(g.id);if(M){const x=await this.X(M[0],O,T);return(0,d.$Ff)(x)?null:x}if(g.isDefault){const x=T.add(this.G.createInstance(o,g,void 0)),H=await this.X(x,O,T);return(0,d.$Ff)(H)?null:H}if(this.M.isEnabled())return null;const U=T.add(this.G.createInstance(n.$h6b,g,void 0)),z=await this.D.manifest(null),X=(await U.getRemoteSyncedProfiles(z?.latest??null)||[]).find(x=>x.id===g.id);if(X){const x=T.add(this.G.createInstance(o,g,X.collection)),H=await this.X(x,O,T);return(0,d.$Ff)(H)?null:H}return null}finally{T.dispose()}}async X(g,O,T){const M=[...g.enabled,...g.disabled.reduce((U,z)=>(z!=="workspaceState"&&U.push(T.add(g.createSynchronizer(z))),U),[])];for(const U of M){const z=await O(U);if(!(0,d.$Ff)(z))return z}}Y(g){const O=this.f;this.f!==g&&(this.f=g,this.g.fire(g),O==="hasConflicts"&&this.$())}Z(){const g=this.ab().map(O=>O.conflicts).flat();(0,D.$tb)(this.j,g,(O,T)=>O.profile.id===T.profile.id&&O.syncResource===T.syncResource&&(0,D.$tb)(O.conflicts,T.conflicts,(M,U)=>(0,S.$og)(M.previewResource,U.previewResource)))||(this.j=g,this.m.fire(g))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(g,O){let T=this.z.get(g.id);if(T&&T[0].collection!==O?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),T[1].dispose(),T=void 0,this.z.delete(g.id)),!T){const M=new R.$Qc,U=M.add(this.G.createInstance(o,g,O?.collection));M.add(U.onDidChangeStatus(z=>this.Y(z))),M.add(U.onDidChangeConflicts(z=>this.Z())),M.add(U.onDidChangeLocal(z=>this.h.fire(z))),this.z.set(g.id,T=[U,M])}return T[0]}ab(){const g=[];for(const[O]of this.z.values())g.push(O);return g}bb(){this.z.forEach(([,g])=>g.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$k6b=r,e.$k6b=r=ye([Y(0,l.$_j),Y(1,i.$bhb),Y(2,i.$ahb),Y(3,$.$Ph),Y(4,i.$qhb),Y(5,w.$dl),Y(6,p.$7o),Y(7,i.$lhb),Y(8,c.$Lk),Y(9,i.$nhb),Y(10,i.$chb)],r);let o=class extends R.$Rc{get enabled(){return this.f.sort((g,O)=>g[1]-O[1]).map(([g])=>g)}get disabled(){return i.$0gb.filter(g=>!this.r.isResourceEnabled(g))}get status(){return this.g}get conflicts(){return this.m}constructor(g,O,T,M,U,z,Z,X,x,H){super(),this.profile=g,this.collection=O,this.r=T,this.t=M,this.u=U,this.w=z,this.y=Z,this.z=X,this.C=x,this.D=H,this.f=[],this.g="idle",this.h=this.B(new I.$Nd),this.onDidChangeStatus=this.h.event,this.j=this.B(new I.$Nd),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new I.$Nd),this.onDidChangeConflicts=this.n.event,this.B(T.onDidChangeResourceEnablement(([K,J])=>this.F(K,J))),this.B((0,R.$Pc)(()=>this.f.splice(0,this.f.length).forEach(([,,K])=>K.dispose())));for(const K of i.$0gb)T.isResourceEnabled(K)&&this.G(K)}F(g,O){O?this.G(g):this.H(g)}G(g){if(this.f.some(([U])=>U.resource===g))return;if(g==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(g==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||g==="workspaceState")return;if(g!=="profiles"&&this.profile.useDefaultFlags?.[g]){this.z.debug(`Skipping syncing ${g} in ${this.profile.name} because it is already synced by default profile`);return}const O=new R.$Qc,T=O.add(this.createSynchronizer(g));O.add(T.onDidChangeStatus(()=>this.L())),O.add(T.onDidChangeConflicts(()=>this.M())),O.add(T.onDidChangeLocal(()=>this.j.fire(g)));const M=this.N(g);this.f.push([T,M,O])}H(g){const O=this.f.findIndex(([T])=>T.resource===g);if(O!==-1){const[[T,,M]]=this.f.splice(O,1);M.dispose(),this.L(),Promise.allSettled([T.stop(),T.resetLocal()]).then(null,U=>this.z.error(U))}}createSynchronizer(g){switch(g){case"settings":return this.t.createInstance(k.$v4b,this.profile,this.collection);case"keybindings":return this.t.createInstance(m.$s4b,this.profile,this.collection);case"snippets":return this.t.createInstance(s.$A4b,this.profile,this.collection);case"tasks":return this.t.createInstance(a.$D4b,this.profile,this.collection);case"globalState":return this.t.createInstance(f.$OEb,this.profile,this.collection);case"extensions":return this.t.createInstance(u.$n4b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$h6b,this.profile,this.collection)}}async sync(g,O,T,M){if(M.isCancellationRequested)return[];const U=this.enabled;if(!U.length)return[];try{const z=[],Z=(0,i.$fhb)(T),X=(this.collection?g?.collections?.[this.collection]?.latest:g?.latest)??null,x=O?await this.I(X):{};for(const H of U){if(M.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(O){const K=await H.preview(X,x,Z);if(K)for(const J of K.resourcePreviews)(J.localChange!==0||J.remoteChange!==0)&&J.mergeState==="preview"&&await H.merge(J.previewResource)}else await H.sync(X,Z)}catch(K){const J=i.$ghb.toUserDataSyncError(K);if(y(J,T,this.w,this.y),v(K))throw J;this.z.error(K),this.z.error(`${H.resource}: ${(0,A.$Bi)(K)}`),z.push([H.resource,J])}}return z}finally{this.L()}}async apply(g,O){const T=(0,i.$fhb)(g);for(const M of this.enabled){if(O.isCancellationRequested)return;try{await M.apply(!1,T)}catch(U){const z=i.$ghb.toUserDataSyncError(U);if(y(z,g,this.w,this.y),v(U))throw z;this.z.error(U),this.z.error(`${M.resource}: ${(0,A.$Bi)(U)}`)}}}async stop(){for(const g of this.enabled)try{g.status!=="idle"&&await g.stop()}catch(O){this.z.error(O)}}async resetLocal(){for(const g of this.enabled)try{await g.resetLocal()}catch(O){this.z.error(`${g.resource}: ${(0,A.$Bi)(O)}`),this.z.error(O)}}async I(g){if(!this.profile.isDefault)return{};const O=this.D.getValue(i.$6gb),T=this.enabled.find(M=>M instanceof k.$v4b);if(T){const M=await T.getRemoteUserDataSyncConfiguration(g);return{...O,...M}}return O}J(g){this.g!==g&&(this.g=g,this.h.fire(g))}L(){return this.M(),this.enabled.some(g=>g.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(g=>g.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const g=this.enabled.filter(O=>O.status==="hasConflicts").filter(O=>O.conflicts.conflicts.length>0).map(O=>O.conflicts);(0,D.$tb)(this.m,g,(O,T)=>O.syncResource===T.syncResource&&(0,D.$tb)(O.conflicts,T.conflicts,(M,U)=>(0,S.$og)(M.previewResource,U.previewResource)))||(this.m=g,this.n.fire(g))}N(g){switch(g){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};o=ye([Y(2,i.$lhb),Y(3,$.$Ph),Y(4,b.$$n),Y(5,i.$ahb),Y(6,w.$dl),Y(7,i.$qhb),Y(8,c.$Lk),Y(9,E.$ki)],o);function v(h){if(h instanceof i.$ghb)switch(h.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function y(h,g,O,T){T.publicLog2("sync/error",{code:h.code,serverCode:h instanceof i.$hhb?String(h.serverCode):void 0,url:h instanceof i.$hhb?h.url:void 0,resource:h.resource,executionId:g,service:O.userDataSyncStore.url.toString()})}}),define(ae[257],ce([0,1,3,2,10,17,24]),function(te,e,D,F,j,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J9b=e.$I9b=void 0;function R(b,l){return{...b,profile:(0,A.$Mk)(b.profile,l.profilesHome.scheme)}}function S(b){return{created:b.created,uri:j.URI.revive(b.uri)}}class d{constructor(l,$,p){this.c=l,this.d=$,this.f=p,this.a=new Map,this.b=new D.$Nd}listen(l,$){switch($){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${$}`)}async call(l,$,p){try{return await this.g(l,$,p)}catch(w){throw this.f.error(w),w}}async g(l,$,p){switch($){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(j.URI.revive(p[0]));case"accept":return this.c.accept(R(p[0],this.d),j.URI.revive(p[1]),p[2],p[3]);case"replace":return this.c.replace(S(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(j.URI.revive(p[0]));case"extractActivityData":return this.c.extractActivityData(j.URI.revive(p[0]),j.URI.revive(p[1]));case"createManualSyncTask":return this.i()}if($.startsWith("manualSync/")){const w=$.substring(11),c=p[0],u=this.h(c);switch(p=p.slice(1),w){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(l){const $=this.a.get(this.j(l));if(!$)throw new Error(`Manual sync taks not found: ${l}`);return $}async i(){const l=await this.c.createManualSyncTask();return this.a.set(this.j(l.id),l),l.id}j(l){return`manualSyncTask-${l}`}}e.$I9b=d;let P=class extends F.$Rc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(l,$){super(),this.n=$,this.b="uninitialized",this.c=this.B(new D.$Nd),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new D.$Nd),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new D.$Nd),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new D.$Nd),this.onSyncErrors=this.m.event,this.a={call(p,w,c){return l.call(p,w,c).then(null,u=>{throw I.$ghb.toUserDataSyncError(u)})},listen(p,w){return l.listen(p,w)}},this.a.call("_getInitialData").then(([p,w,c])=>{this.s(p),this.t(w),c&&this.u(c),this.B(this.a.listen("onDidChangeStatus")(u=>this.s(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.u(u)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.t(p))),this.B(this.a.listen("onSyncErrors")(p=>this.m.fire(p.map(w=>({...w,error:I.$ghb.toUserDataSyncError(w.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const l=await this.a.call("createManualSyncTask"),$=this;return new E(l,{async call(w,c,u){return $.a.call(`manualSync/${w}`,[l,...Array.isArray(c)?c:[c]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(l,$,p,w){return this.a.call("accept",[l,$,p,w])}resolveContent(l){return this.a.call("resolveContent",[l])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(l){return this.a.call("replace",[l])}saveRemoteActivityData(l){return this.a.call("getRemoteActivityData",[l])}extractActivityData(l,$){return this.a.call("extractActivityData",[l,$])}async s(l){this.b=l,this.c.fire(l)}async t(l){this.f=l.map($=>({syncResource:$.syncResource,profile:(0,A.$Mk)($.profile,this.n.profilesHome.scheme),conflicts:$.conflicts.map(p=>({...p,baseResource:j.URI.revive(p.baseResource),localResource:j.URI.revive(p.localResource),remoteResource:j.URI.revive(p.remoteResource),previewResource:j.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}u(l){this.h!==l&&(this.h=l,this.j.fire(l))}};e.$J9b=P,e.$J9b=P=ye([Y(1,A.$Lk)],P);class E extends F.$Rc{constructor(l,$){super(),this.id=l,this.a=$}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(ae[258],ce([0,1,6,26,7,3,2,139,5,19,12,10,32,20,14,11,25,58,43,21,24]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w,c,u,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EEb=e.$DEb=e.$CEb=e.$BEb=e.$AEb=void 0;const k="configurationSync.store",s="sync.previous.store",a="sync.donot-make-requests-until",n="sync.user-session-id",i="sync.machine-session-id",t=100,r=1e3*60*5;let o=class extends I.$Rc{get userDataSyncStore(){return this.b}get c(){return this.h.get(m.$jhb,-1)}set c(T){this.h.store(m.$jhb,T,-1,S.$p?0:1)}constructor(T,M,U){super(),this.f=T,this.g=M,this.h=U,this.a=this.B(new A.$Nd),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const z=this.B(new I.$Qc);this.B(A.Event.filter(U.onDidChangeValue(-1,m.$jhb,z),()=>this.c!==this.userDataSyncStore?.type,z)(()=>this.j()))}j(){this.b=this.m(this.f[k]),this.a.fire()}m(T){if(T&&(T=S.$p&&T.web?{...T,...T.web}:T,(0,P.$yf)(T.url)&&(0,P.$Af)(T.authenticationProviders)&&Object.keys(T.authenticationProviders).every(M=>Array.isArray(T.authenticationProviders[M].scopes)))){const M=T,U=!!M.canSwitch,z=M.url===M.insidersUrl?"insiders":"stable",Z=(U?this.c:void 0)||z,X=Z==="insiders"?M.insidersUrl:Z==="stable"?M.stableUrl:M.url;return{url:E.URI.parse(X),type:Z,defaultType:z,defaultUrl:E.URI.parse(M.url),stableUrl:E.URI.parse(M.stableUrl),insidersUrl:E.URI.parse(M.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(M.authenticationProviders).reduce((x,H)=>(x.push({id:H,scopes:M.authenticationProviders[H].scopes}),x),[])}}}};e.$AEb=o,e.$AEb=o=ye([Y(0,w.$qj),Y(1,l.$ki),Y(2,f.$7o)],o);let v=class extends o{constructor(T,M,U){super(T,M,U);const z=this.h.get(s,-1);z&&(this.n=JSON.parse(z));const Z=this.f[k];Z?this.h.store(s,JSON.stringify(Z),-1,1):this.h.remove(s,-1)}async switch(T){T!==this.c&&(this.c=T,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$BEb=v,e.$BEb=v=ye([Y(0,w.$qj),Y(1,l.$ki),Y(2,f.$7o)],v);let y=class extends I.$Rc{get donotMakeRequestsUntil(){return this.j}constructor(T,M,U,z,Z,X,x){super(),this.n=U,this.r=z,this.s=x,this.g=this.B(new A.$Nd),this.onTokenFailed=this.g.event,this.h=this.B(new A.$Nd),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new A.$Nd),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(T),this.c=(0,u.$ap)(Z,X,x).then(H=>{const K={"X-Client-Name":`${M.applicationName}${S.$p?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(K["X-Client-Commit"]=M.commit),K}),this.f=new g(t,r,this.n,this.r),this.u(),this.B((0,I.$Pc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(T,M){this.b={token:T,type:M}}t(T){this.a=T?(0,d.$vg)(T,"v1"):void 0}u(){const T=this.s.getNumber(a,-1);T&&Date.now()<T&&this.y(new Date(T))}y(T){this.j?.getTime()!==T?.getTime()&&(this.j=T,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(a,this.j.getTime(),-1,1),this.w=(0,D.$Hg)(M=>(0,D.$Ug)(this.j.getTime()-Date.now(),M).then(()=>this.y(void 0))),this.w.then(null,M=>null)):this.s.remove(a,-1),this.m.fire())}async getAllCollections(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,d.$vg)(this.a,"collection").toString();T={...T},T["Content-Type"]="application/json";const U=await this.D(M,{type:"GET",headers:T},[],F.CancellationToken.None);return(await(0,c.$Zo)(U))?.map(({id:z})=>z)||[]}async createCollection(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,d.$vg)(this.a,"collection").toString();T={...T},T["Content-Type"]=R.$Qr.text;const U=await this.D(M,{type:"POST",headers:T},[],F.CancellationToken.None),z=await(0,c.$Yo)(U);if(!z)throw new m.$hhb("Server did not return the collection id",M,"NoCollection",U.res.statusCode,U.res.headers[m.$dhb]);return z}async deleteCollection(T,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=T?(0,d.$vg)(this.a,"collection",T).toString():(0,d.$vg)(this.a,"collection").toString();M={...M},await this.D(U,{type:"DELETE",headers:M},[],F.CancellationToken.None)}async getAllResourceRefs(T,M){if(!this.a)throw new Error("No settings sync store url configured.");const U=this.z(this.a,M,T),z={},Z=await this.D(U.toString(),{type:"GET",headers:z},[],F.CancellationToken.None);return(await(0,c.$Zo)(Z)||[]).map(({url:x,created:H})=>({ref:(0,d.$xg)(U,U.with({path:x})),created:H*1e3}))}async resolveResourceContent(T,M,U,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,d.$vg)(this.z(this.a,U,T),M).toString();z={...z},z["Cache-Control"]="no-cache";const X=await this.D(Z,{type:"GET",headers:z},[],F.CancellationToken.None);return await(0,c.$Yo)(X)}async deleteResource(T,M,U){if(!this.a)throw new Error("No settings sync store url configured.");const z=M!==null?(0,d.$vg)(this.z(this.a,U,T),M).toString():this.z(this.a,U,T).toString(),Z={};await this.D(z,{type:"DELETE",headers:Z},[],F.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,d.$vg)(this.a,"resource").toString(),M={"Content-Type":R.$Qr.text};await this.D(T,{type:"DELETE",headers:M},[],F.CancellationToken.None)}async readResource(T,M,U,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,d.$vg)(this.z(this.a,U,T),"latest").toString();z={...z},z["Cache-Control"]="no-cache",M&&(z["If-None-Match"]=M.ref);const X=await this.D(Z,{type:"GET",headers:z},[304],F.CancellationToken.None);let x=null;if(X.res.statusCode===304&&(x=M),x===null){const H=X.res.headers.etag;if(!H)throw new m.$hhb("Server did not return the ref",Z,"NoRef",X.res.statusCode,X.res.headers[m.$dhb]);const K=await(0,c.$Yo)(X);if(!K&&X.res.statusCode===304)throw new m.$hhb("Empty response",Z,"EmptyResponse",X.res.statusCode,X.res.headers[m.$dhb]);x={ref:H,content:K}}return x}async writeResource(T,M,U,z,Z={}){if(!this.a)throw new Error("No settings sync store url configured.");const X=this.z(this.a,z,T).toString();Z={...Z},Z["Content-Type"]=R.$Qr.text,U&&(Z["If-Match"]=U);const x=await this.D(X,{type:"POST",data:M,headers:Z},[],F.CancellationToken.None),H=x.res.headers.etag;if(!H)throw new m.$hhb("Server did not return the ref",X,"NoRef",x.res.statusCode,x.res.headers[m.$dhb]);return H}async manifest(T,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,d.$vg)(this.a,"manifest").toString();M={...M},M["Content-Type"]="application/json",T&&(M["If-None-Match"]=T.ref);const z=await this.D(U,{type:"GET",headers:M},[304],F.CancellationToken.None);let Z=null;if(z.res.statusCode===304&&(Z=T),!Z){const x=z.res.headers.etag;if(!x)throw new m.$hhb("Server did not return the ref",U,"NoRef",z.res.statusCode,z.res.headers[m.$dhb]);const H=await(0,c.$Yo)(z);if(!H&&z.res.statusCode===304)throw new m.$hhb("Empty response",U,"EmptyResponse",z.res.statusCode,z.res.headers[m.$dhb]);H&&(Z={...JSON.parse(H),ref:x})}const X=this.s.get(n,-1);return X&&Z&&X!==Z.session&&this.C(),Z===null&&X&&this.C(),Z&&this.s.store(n,Z.session,-1,1),Z}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,d.$vg)(this.a,"download").toString(),M={},U=await this.D(T,{type:"GET",headers:M},[],F.CancellationToken.None);if(!(0,c.$Vo)(U))throw new m.$hhb("Server returned "+U.res.statusCode,T,"EmptyResponse",U.res.statusCode,U.res.headers[m.$dhb]);if((0,c.$Wo)(U))throw new m.$hhb("Empty response",T,"EmptyResponse",U.res.statusCode,U.res.headers[m.$dhb]);return U.stream}z(T,M,U){return M?(0,d.$vg)(T,"collection",M,"resource",U):(0,d.$vg)(T,"resource",U)}C(){this.s.remove(n,-1),this.s.remove(i,-1)}async D(T,M,U,z){if(!this.b)throw new m.$hhb("No Auth Token Available",T,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new m.$hhb(`${M.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Z=await this.c;M.headers={...M.headers||{},...Z,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(M.headers),this.r.trace("Sending request to server",{url:T,type:M.type,headers:{...M.headers,authorization:void 0}});let X;try{X=await this.f.request(T,M,z)}catch(V){if(!(V instanceof m.$hhb)){let ee="RequestFailed";const ne=(0,j.$9)(V).toLowerCase();ne.includes("xhr timeout")?ee="RequestTimeout":ne.includes("protocol")&&ne.includes("not supported")?ee="RequestProtocolNotSupported":ne.includes("request path contains unescaped characters")?ee="RequestPathNotEscaped":ne.includes("headers must be an object")?ee="RequestHeadersNotObject":(0,j.$3)(V)&&(ee="RequestCanceled"),V=new m.$hhb(`Connection refused for the request '${T}'.`,T,ee,void 0,void 0)}throw this.r.info("Request failed",T),V}const x=X.res.headers[m.$dhb],H={url:T,status:X.res.statusCode,"execution-id":M.headers[m.$ehb],"operation-id":x},K=(0,c.$Vo)(X)||X.res.statusCode&&U.includes(X.res.statusCode);let J="";if(K?this.r.trace("Request succeeded",H):(J=await(0,c.$Xo)(X)||"",this.r.info("Request failed",H,J)),X.res.statusCode===401||X.res.statusCode===403){if(this.b=void 0,X.res.statusCode===401)throw this.g.fire("Unauthorized"),new m.$hhb(`${M.type} request '${T}' failed because of Unauthorized (401).`,T,"Unauthorized",X.res.statusCode,x);if(X.res.statusCode===403)throw this.g.fire("Forbidden"),new m.$hhb(`${M.type} request '${T}' failed because the access is forbidden (403).`,T,"Forbidden",X.res.statusCode,x)}if(this.h.fire(),X.res.statusCode===404)throw new m.$hhb(`${M.type} request '${T}' failed because the requested resource is not found (404).`,T,"NotFound",X.res.statusCode,x);if(X.res.statusCode===405)throw new m.$hhb(`${M.type} request '${T}' failed because the requested endpoint is not found (405). ${J}`,T,"MethodNotFound",X.res.statusCode,x);if(X.res.statusCode===409)throw new m.$hhb(`${M.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,"Conflict",X.res.statusCode,x);if(X.res.statusCode===410)throw new m.$hhb(`${M.type} request '${T}' failed because the requested resource is not longer available (410).`,T,"Gone",X.res.statusCode,x);if(X.res.statusCode===412)throw new m.$hhb(`${M.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,"PreconditionFailed",X.res.statusCode,x);if(X.res.statusCode===413)throw new m.$hhb(`${M.type} request '${T}' failed because of too large payload (413).`,T,"TooLarge",X.res.statusCode,x);if(X.res.statusCode===426)throw new m.$hhb(`${M.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,"UpgradeRequired",X.res.statusCode,x);if(X.res.statusCode===429){const V=X.res.headers["retry-after"];throw V?(this.y(new Date(Date.now()+parseInt(V)*1e3)),new m.$hhb(`${M.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",X.res.statusCode,x)):new m.$hhb(`${M.type} request '${T}' failed because of too many requests (429).`,T,"RemoteTooManyRequests",X.res.statusCode,x)}if(!K)throw new m.$hhb("Server returned "+X.res.statusCode,T,"Unknown",X.res.statusCode,x);return X}F(T){let M=this.s.get(i,-1);M===void 0&&(M=(0,b.$eg)(),this.s.store(i,M,-1,1)),T["X-Machine-Session-Id"]=M;const U=this.s.get(n,-1);U!==void 0&&(T["X-User-Session-Id"]=U)}};e.$CEb=y,e.$CEb=y=ye([Y(1,w.$qj),Y(2,c.$To),Y(3,m.$qhb),Y(4,$.$Xh),Y(5,p.$_j),Y(6,f.$7o)],y);let h=class extends y{constructor(T,M,U,z,Z,X,x){super(T.userDataSyncStore?.url,M,U,z,Z,X,x),this.B(T.onDidChangeUserDataSyncStore(()=>this.t(T.userDataSyncStore?.url)))}};e.$DEb=h,e.$DEb=h=ye([Y(0,m.$ahb),Y(1,w.$qj),Y(2,c.$To),Y(3,m.$qhb),Y(4,$.$Xh),Y(5,p.$_j),Y(6,f.$7o)],h);class g{constructor(T,M,U,z){this.c=T,this.d=M,this.f=U,this.g=z,this.a=[],this.b=void 0}request(T,M,U){if(this.h()&&this.i(),M.url=T,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new m.$hhb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,T,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(T),this.f.request(M,U)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$EEb=g}),define(ae[259],ce([0,1,3,56,25,21,22,254,24,79,82]),function(te,e,D,F,j,A,I,R,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$49b=void 0;let E=class extends R.$l6b{constructor(l,$,p,w,c,u,f,m,k,s,a){super(l,$,p,w,c,f,m,k,s,a),this.B(D.Event.debounce(D.Event.any(D.Event.map(u.onDidFocusMainWindow,()=>"windowFocus"),D.Event.map(u.onDidOpenMainWindow,()=>"windowOpen")),(n,i)=>n?[...n,i]:[i],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$49b=E,e.$49b=E=ye([Y(0,j.$qj),Y(1,S.$ahb),Y(2,S.$bhb),Y(3,S.$lhb),Y(4,S.$mhb),Y(5,F.$U7b),Y(6,S.$qhb),Y(7,d.$fDb),Y(8,I.$dl),Y(9,P.$1gb),Y(10,A.$7o)],E)}),define(ae[260],ce([0,1,71,23,5,19]),function(te,e,D,F,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p7b=e.$o7b=e.$n7b=e.$m7b=void 0,e.$m7b=128/4;function I(d){function P(){let E=d.scheme===F.Schemas.file?(0,A.$jg)(d):d.toString();return j.$l||(E=E.toLowerCase()),(0,D.createHash)("md5").update(E).digest("hex")}return{id:P(),configPath:d}}e.$n7b=I;function R(d,P){function E(){if(d.scheme!==F.Schemas.file)return(0,D.createHash)("md5").update(d.toString()).digest("hex");if(!P)return;let l;return j.$l?l=P.ino:j.$k?l=P.birthtime.getTime():j.$j&&(typeof P.birthtimeMs=="number"?l=Math.floor(P.birthtimeMs):l=P.birthtime.getTime()),(0,D.createHash)("md5").update(d.fsPath).update(l?String(l):"").digest("hex")}const b=E();if(typeof b=="string")return{id:b,uri:d}}e.$o7b=R;function S(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$p7b=S}),define(ae[261],ce([0,1,6,7,2,16,31,14,8,76,112,260,56,55,23]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x9b=void 0;let p=class extends j.$Rc{constructor(c,u,f,m){super(),this.a=c,this.b=u,this.c=f,this.f=m,this.B(new D.$7g(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const c=this.a.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,u=await I.Promises.readdir(c),f=new d.$QDb(this.f.getChannel("storage"));await Promise.all(u.map(async m=>{const k=(0,A.$ic)(c,m);m.length===E.$m7b||m===P.$3h.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===m)||await f.isUsed(k)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${m} as it seems to be an unused empty workspace.`),await I.Promises.rm(k))}))}catch(c){(0,F.$Z)(c)}}};e.$x9b=p,e.$x9b=p=ye([Y(0,R.$Yh),Y(1,S.$$i),Y(2,b.$U7b),Y(3,l.$98b)],p)}),define(ae[83],ce([0,1,53,6,16,12,31,147,272,273]),function(te,e,D,F,j,A,I,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.zip=e.$mp=e.$lp=void 0,e.$lp="end of central directory record signature not found";const P=new RegExp(e.$lp);class E extends Error{constructor(a,n){let i=n.message;switch(a){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=a,this.cause=n}}e.$mp=E;function b(s){const a=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>a&n).reduce((n,i)=>n+i,a&61440)}function l(s){if(s instanceof E)return s;let a;return P.test(s.message)&&(a="CorruptZip"),new E(a,s)}function $(s,a,n,i,t,r){const o=j.$lc(a),v=j.$ic(i,o);if(!v.startsWith(i))return Promise.reject(new Error(R.localize(0,null,a)));const y=j.$ic(i,a);let h;return r.onCancellationRequested(()=>{h?.destroy()}),Promise.resolve(I.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise((g,O)=>{if(!r.isCancellationRequested)try{h=(0,D.createWriteStream)(y,{mode:n}),h.once("close",()=>g()),h.once("error",O),s.once("error",O),s.pipe(h)}catch(T){O(T)}}))}function p(s,a,n,i){let t=(0,F.$Hg)(()=>Promise.resolve()),r=0;const o=i.onCancellationRequested(()=>{t.cancel(),s.close()});return new Promise((v,y)=>{const h=new F.$Og,g=O=>{O.isCancellationRequested||(r++,s.readEntry())};s.once("error",y),s.once("close",()=>t.then(()=>{i.isCancellationRequested||s.entryCount===r?v():y(new E("Incomplete",new Error(R.localize(1,null,r,s.entryCount))))},y)),s.readEntry(),s.on("entry",O=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(O.fileName)){g(i);return}const T=O.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(T)){const z=j.$ic(a,T);t=(0,F.$Hg)(Z=>I.Promises.mkdir(z,{recursive:!0}).then(()=>g(Z)).then(void 0,y));return}const M=c(s,O),U=b(O);t=(0,F.$Hg)(z=>h.queue(()=>M.then(Z=>$(Z,T,U,a,n,z).then(()=>g(z)))).then(null,y))})}).finally(()=>o.dispose())}function w(s,a=!1){return new Promise((n,i)=>{(0,S.open)(s,a?{lazyEntries:!0}:void 0,(t,r)=>{t?i(l(t)):n((0,A.$Jf)(r))})})}function c(s,a){return new Promise((n,i)=>{s.openReadStream(a,(t,r)=>{t?i(l(t)):n((0,A.$Jf)(r))})})}function u(s,a){return new Promise((n,i)=>{const t=new d.ZipFile;a.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const r=(0,D.createWriteStream)(s);t.outputStream.pipe(r),t.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>n(s))})}e.zip=u;function f(s,a,n={},i){const t=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=w(s,!0);return n.overwrite&&(r=r.then(o=>I.Promises.rm(a).then(()=>o))),r.then(o=>p(o,a,{sourcePathRegex:t},i))}e.$op=f;function m(s,a){return w(s).then(n=>new Promise((i,t)=>{n.on("entry",r=>{r.fileName===a&&c(n,r).then(o=>i(o),o=>t(o))}),n.once("close",()=>t(new Error(R.localize(2,null,a))))}))}function k(s,a){return m(s,a).then(n=>new Promise((i,t)=>{const r=[];n.once("error",t),n.on("data",o=>r.push(o)),n.on("end",()=>i(Buffer.concat(r)))}))}e.$pp=k}),define(ae[262],ce([0,1,6,7,2,23,19,54,12,32,31,83,20,14,29,33,97,11,8]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w,c,u){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;let m=class extends j.$Rc{static{f=this}static{this.c=".sigzip"}constructor(s,a,n,i,t,r){super(),this.h=a,this.j=n,this.m=i,this.n=t,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,a,n){await this.g;const i=(0,I.$vg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,a))}catch(r){throw new $.$_n(r.message,$.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(s)){const r=await this.u(s);try{t=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===u.LogLevel.Trace)}catch(o){const v=o;if(t=v.code,v.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${v.output}`),t===$.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===$.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new $.$_n(E.$lp,$.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(o){this.r.error(o)}}}return t===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${s.identifier.id}`),{location:i,verificationStatus:t}}t(s){if(!s.isSigned)return!1;const a=this.m.getValue("extensions.verifySignature");return(0,S.$Ef)(a)?a:!0}async u(s){await this.g;const a=(0,I.$vg)(this.extensionsDownloadDir,`${this.z(s)}${f.c}`);return await this.w(s,a,n=>this.j.downloadSignatureArchive(s,n)),a}async w(s,a,n){if(await this.h.exists(a))return;if(a.scheme!==A.Schemas.file){await n(a);return}const i=(0,I.$vg)(this.extensionsDownloadDir,`.${(0,d.$eg)()}`);await this.h.exists(i)||await n(i);try{await P.Promises.rename(i.fsPath,a.fsPath,2*60*1e3)}catch(t){try{await this.h.del(i)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,a.path);else throw this.r.info(`Rename failed because of ${(0,F.$9)(t)}. Deleted the file from downloaded location`,i.path),t}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const a=[],n=[],i=[];for(const o of s.children)if(o.name.endsWith(f.c))i.push(o.resource);else{const v=p.$Bo.parse(o.name);v&&n.push([v,o])}const t=(0,p.$Go)(n,([o])=>o),r=[];for(const o of t)o.sort((v,y)=>R.rcompare(v[0].version,y[0].version)),a.push(...o.slice(1).map(v=>v[1].resource)),r.push(o[0][1]);r.sort((o,v)=>o.mtime-v.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.f)).map(o=>o.resource)),a.push(...i),await D.Promises.settled(a.map(o=>(this.r.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(s){this.r.error(s)}}z(s){return this.f?p.$Bo.create(s).toString().toLowerCase():(0,d.$eg)()}};e.$Ep=m,e.$Ep=m=f=ye([Y(0,l.$Yh),Y(1,c.$_j),Y(2,$.$$n),Y(3,b.$ki),Y(4,w.$fp),Y(5,u.$$i)],m)}),define(ae[263],ce([0,1,83,156]),function(te,e,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=void 0;function j(A){return(0,D.$pp)(A,"extension/package.json").then(I=>{try{return JSON.parse(I.toString("utf8"))}catch{throw new Error((0,F.localize)(0,null))}})}e.$Gp=j}),define(ae[121],ce([0,1,6,15,26,38,7,3,52,2,34,23,16,19,54,12,10,32,31,83,155,96,14,242,29,33,51,80,262,243,263,212,223,69,11,4,8,25,22,28,17]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w,c,u,f,m,k,s,a,n,i,t,r,o,v,y,h,g,O,T,M,U,z,Z,X,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=e.$Lp=e.$Kp=e.$Jp=void 0,e.$Jp=(0,M.$Rh)(n.$ao);const H=".vsctmp";let K=class extends a.$qp{constructor(Q,q,C,L,B,N,W,G,ie,oe,ue,he){super(Q,q,ue,C,oe,he),this.fb=B,this.gb=N,this.hb=W,this.ib=ie,this.eb=new Map,this.rb=new P.$Ac;const $e=this.B(G.createInstance(v.$Fp));this.bb=this.B(G.createInstance(J,we=>$e.postUninstall(we))),this.cb=this.B(new h.$Hp(he,ie,ue,this,this.F)),this.db=this.B(G.createInstance(o.$Ep));const de=this.B(new g.$Ip(this,this.fb,he,N,ue,ie,C));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.qb(we))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Lo)(this.ib,this.F)),this.jb}async zip(Q){this.F.trace("ExtensionManagementService#zip",Q.identifier.id);const q=await this.pb(Q),C=await(0,f.zip)((0,l.$vg)(this.db.extensionsDownloadDir,(0,c.$eg)()).fsPath,q);return w.URI.file(C)}async unzip(Q){return this.F.trace("ExtensionManagementService#unzip",Q.toString()),(await this.install(Q)).identifier}async getManifest(Q){const{location:q,cleanup:C}=await this.lb(Q),L=b.$jc(q.fsPath);try{return await(0,y.$Gp)(L)}finally{await C()}}getInstalled(Q,q=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(Q??null,q)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(Q){return this.bb.scanUserExtensionAtLocation(Q)}async install(Q,q={}){this.F.trace("ExtensionManagementService#install",Q.toString());const{location:C,cleanup:L}=await this.lb(Q);try{const B=await(0,y.$Gp)(b.$jc(C.fsPath)),N=(0,i.$Fo)(B.publisher,B.name);if(B.engines&&B.engines.vscode&&!(0,O.$So)(B.engines.vscode,this.G.version,this.G.date))throw new Error(m.localize(0,null,N,this.G.version));const G=(await this.I([{manifest:B,extension:C,options:q}])).find(({identifier:ie})=>(0,i.$Ao)(ie,{id:N}));if(G?.local)return G.local;throw G?.error?G.error:(0,a.$sp)(new Error(`Unknown error while installing extension ${N}`))}finally{await L()}}async installFromLocation(Q,q){this.F.trace("ExtensionManagementService#installFromLocation",Q.toString());const C=await this.bb.scanUserExtensionAtLocation(Q);if(!C)throw new Error(`Cannot find a valid extension from the location ${Q.toString()}`);return await this.ub([[C,void 0]],q),this.F.info("Successfully installed extension",C.identifier.id,q.toString()),C}async installExtensionsFromProfile(Q,q,C){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",Q,q.toString(),C.toString());const L=(await this.bb.scanExtensions(1,q)).filter(B=>Q.some(N=>(0,i.$Ao)(N,B.identifier)));if(L.length){const B=await Promise.all(L.map(N=>this.bb.scanMetadata(N,q)));await this.ub(L.map((N,W)=>[N,B[W]]),C),this.F.info("Successfully installed extensions",L.map(N=>N.identifier.id),C.toString())}return L}async updateMetadata(Q,q,C=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",Q.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0),q.isMachineScoped===!1&&(q.isMachineScoped=void 0),q.isBuiltin===!1&&(q.isBuiltin=void 0),q.pinned===!1&&(q.pinned=void 0),Q=await this.bb.updateMetadata(Q,q,C),this.cb.invalidate(C),this.w.fire(Q),Q}async reinstallFromGallery(Q){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",Q.identifier.id),!this.z.isEnabled())throw new Error(m.localize(1,null));const q=await this.getTargetPlatform(),[C]=await this.z.getExtensions([{...Q.identifier,preRelease:Q.preRelease}],{targetPlatform:q,compatible:!0},j.CancellationToken.None);if(!C)throw new Error(m.localize(2,null));await this.bb.setUninstalled(Q);try{await this.bb.removeUninstalledExtension(Q)}catch(L){throw new Error(m.localize(3,null,(0,A.$Bi)(L)))}return this.installFromGallery(C)}ab(Q,q,C,L){return this.bb.copyExtension(Q,q,C,L)}copyExtensions(Q,q){return this.bb.copyExtensions(Q,q)}markAsUninstalled(...Q){return this.bb.setUninstalled(...Q)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(Q){this.F.error(Q)}}async download(Q,q,C){const{location:L}=await this.db.download(Q,q,!C);return L}async lb(Q){if(Q.scheme===E.Schemas.file)return{location:Q,async cleanup(){}};this.F.trace("Downloading extension from",Q.toString());const q=(0,l.$vg)(this.db.extensionsDownloadDir,(0,c.$eg)());return await this.hb.download(Q,q),this.F.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.ib.del(q)}catch(L){this.F.error(L)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(Q,q,C){if(w.URI.isUri(q))return new ne(Q,q,C,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const L=i.$Bo.create(q).toString();let B=this.eb.get(L);return B||(this.eb.set(L,B=new ee(Q,q,C,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),B.waitUntilTaskIsFinished().finally(()=>this.eb.delete(L))),B}$(Q,q){return new _(Q,q.profileLocation,this.gb)}async pb(Q){const q=async L=>{let B=await u.Promises.readdir(L);B=B.map(G=>b.$ic(L,G));const N=await Promise.all(B.map(G=>u.Promises.stat(G)));let W=Promise.resolve([]);return N.forEach((G,ie)=>{const oe=B[ie];G.isFile()&&(W=W.then(ue=>[...ue,oe])),G.isDirectory()&&(W=W.then(ue=>q(oe).then(he=>[...ue,...he])))}),W};return(await q(Q.location.fsPath)).map(L=>({path:`extension/${b.$kc(Q.location.fsPath,L)}`,localPath:L}))}async qb({added:Q,removed:q}){if(q){const C=Q&&this.D.extUri.isEqual(q.profileLocation,Q.profileLocation)?q.extensions.filter(L=>Q.extensions.every(B=>!(0,i.$Ao)(B,L))):q.extensions;for(const L of C)this.F.info("Extensions removed from another source",L.id,q.profileLocation.toString()),this.u.fire({identifier:L,profileLocation:q.profileLocation})}if(Q){const L=(await this.bb.scanExtensions(1,Q.profileLocation)).filter(B=>Q.extensions.some(N=>(0,i.$Ao)(N,B.identifier)));this.s.fire(L.map(B=>(this.F.info("Extensions added from another source",B.identifier.id,Q.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:Q.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(q=>this.rb.add(q)));const Q=await this.ib.resolve(this.fb.userExtensionsLocation);for(const q of Q.children??[])q.isDirectory&&this.rb.add(q.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(q=>this.tb(q)))}async tb(Q){if(!Q.affects(this.fb.userExtensionsLocation,1))return;const q=[];for(const C of Q.rawAdded){if(this.rb.has(C)||!this.D.extUri.isEqual(this.D.extUri.dirname(C),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(C,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(C).startsWith(".")||!(await this.ib.stat(C)).isDirectory)continue;const L=await this.bb.scanUserExtensionAtLocation(C);L&&L.installedTimestamp===void 0&&(this.rb.add(C),q.push(L))}q.length&&(await this.ub(q.map(C=>[C,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",q.map(C=>C.identifier.id)))}async ub(Q,q){const C=Q.map(L=>L[0]);await this.vb(C),await this.gb.addExtensionsToProfile(Q,q),this.s.fire(C.map(L=>({local:L,identifier:L.identifier,operation:1,profileLocation:q})))}async vb(Q){const q=await this.bb.getUninstalledExtensions();for(const C of Q){const L=i.$Bo.create(C);q[L.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",L.id),await this.bb.setInstalled(L),this.F.info("Removed the extension from uninstalled list:",L.id))}}};e.$Kp=K,e.$Kp=K=ye([Y(0,n.$$n),Y(1,Z.$dl),Y(2,U.$$i),Y(3,s.$Yh),Y(4,r.$zp),Y(5,t.$vp),Y(6,k.$Pn),Y(7,M.$Ph),Y(8,T.$_j),Y(9,z.$qj),Y(10,X.$Jk),Y(11,x.$Lk)],K);let J=class extends d.$Rc{constructor(Q,q,C,L,B,N){super(),this.j=Q,this.m=q,this.n=C,this.s=L,this.t=B,this.u=N,this.h=this.B(new R.$Nd),this.onExtract=this.h.event,this.c=(0,l.$vg)(this.n.userExtensionsLocation,".obsolete"),this.g=new D.$2g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(Q,q){const C={includeInvalid:!0,profileLocation:q};let L=[];return Q===null||Q===0?L.push(...await this.n.scanAllExtensions({includeInvalid:!0},C,!1)):Q===1&&L.push(...await this.n.scanUserExtensions(C)),L=Q!==null?L.filter(B=>B.type===Q):L,Promise.all(L.map(B=>this.F(B)))}async scanAllUserExtensions(Q){const q=await this.n.scanUserExtensions({includeAllVersions:!Q,includeInvalid:!0});return Promise.all(q.map(C=>this.F(C)))}async scanUserExtensionAtLocation(Q){try{const q=await this.n.scanExistingExtension(Q,1,{includeInvalid:!0});if(q)return await this.F(q)}catch(q){this.u.error(q)}return null}async extractUserExtension(Q,q,C,L,B){const N=Q.toString(),W=w.URI.file(b.$ic(this.n.userExtensionsLocation.fsPath,`.${(0,c.$eg)()}`)),G=w.URI.file(b.$ic(this.n.userExtensionsLocation.fsPath,N));let ie=await this.m.exists(G);if(ie&&L){try{await this.y(Q.id,G,"removeExisting")}catch{throw new n.$_n(m.localize(4,null,G.fsPath,Q.id),n.ExtensionManagementErrorCode.Delete)}ie=!1}if(!ie)try{try{this.u.trace(`Started extracting the extension from ${q} to ${G.fsPath}`),await(0,f.$op)(q,W.fsPath,{sourcePath:"extension",overwrite:!0},B),this.u.info(`Extracted extension to ${G}:`,Q.id)}catch(oe){let ue=n.ExtensionManagementErrorCode.Extract;throw oe instanceof f.$mp&&(oe.type==="CorruptZip"?ue=n.ExtensionManagementErrorCode.CorruptZip:oe.type==="Incomplete"&&(ue=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$_n(oe.message,ue)}await this.n.updateMetadata(W,C);try{this.u.trace(`Started renaming the extension from ${W.fsPath} to ${G.fsPath}`),await this.C(W.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(oe){if(oe.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",Q.id);else throw this.u.info(`Rename failed because of ${(0,I.$9)(oe)}. Deleted from extracted location`,W),oe}this.h.fire(G)}catch(oe){try{await this.m.del(W,{recursive:!0})}catch{}throw oe}return this.D(G,1)}async scanMetadata(Q,q){return q?(await this.w(Q,q))?.metadata:this.n.scanMetadata(Q.location)}async w(Q,q){return(await this.s.scanProfileExtensions(q)).find(L=>(0,i.$Ao)(L.identifier,Q.identifier))}async updateMetadata(Q,q,C){return C?await this.s.updateMetadata([[Q,q]],C):await this.n.updateMetadata(Q.location,q),this.D(Q.location,Q.type,C)}getUninstalledExtensions(){return this.z()}async setUninstalled(...Q){const q=Q.map(C=>i.$Bo.create(C));await this.z(C=>q.forEach(L=>{C[L.toString()]=!0,this.u.info("Marked extension as uninstalled",L.toString())}))}async setInstalled(Q){await this.z(q=>delete q[Q.toString()])}async removeExtension(Q,q){if(this.t.extUri.isEqualOrParent(Q.location,this.n.userExtensionsLocation))return this.y(Q.identifier.id,Q.location,q)}async removeUninstalledExtension(Q){await this.removeExtension(Q,"uninstalled"),await this.z(q=>delete q[i.$Bo.create(Q).toString()])}async copyExtension(Q,q,C,L){const B=await this.w(Q,q),N=await this.w(Q,C);return L={...B?.metadata,...L},N?await this.s.updateMetadata([[Q,{...N.metadata,...L}]],C):await this.s.addExtensionsToProfile([[Q,L]],C),this.D(Q.location,Q.type,C)}async copyExtensions(Q,q){const C=await this.scanExtensions(1,Q),L=await Promise.all(C.filter(B=>!B.isApplicationScoped).map(async B=>[B,await this.scanMetadata(B,Q)]));await this.s.addExtensionsToProfile(L,q)}async y(Q,q,C){this.u.trace(`Deleting ${C} extension from disk`,Q,q.fsPath);const L=this.t.extUri.joinPath(this.t.extUri.dirname(q),`${this.t.extUri.basename(q)}.${(0,S.$Ei)((0,c.$eg)()).toString(16)}${H}`);await this.C(q.fsPath,L.fsPath),await this.m.del(L,{recursive:!0}),this.u.info(`Deleted ${C} extension from disk`,Q,q.fsPath)}async z(Q){return this.g.queue(async()=>{let q;try{q=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(L){if((0,T.$qk)(L)!==1)throw L}let C={};if(q)try{C=JSON.parse(q)}catch{}return Q&&(Q(C),Object.keys(C).length?await this.m.writeFile(this.c,F.$be.fromString(JSON.stringify(C))):await this.m.del(this.c)),C})}async C(Q,q){try{await u.Promises.rename(Q,q,2*60*1e3)}catch(C){throw new n.$_n(C.message||m.localize(5,null,Q,q),C.code||n.ExtensionManagementErrorCode.Rename)}}async D(Q,q,C){if(C){const B=(await this.n.scanUserExtensions({profileLocation:C})).find(N=>this.t.extUri.isEqual(N.location,Q));if(B)return this.F(B)}else{const L=await this.n.scanExistingExtension(Q,q,{includeInvalid:!0});if(L)return this.F(L)}throw new Error(m.localize(6,null,Q.path))}async F(Q){const q=await this.m.resolve(Q.location);let C,L;return q.children&&(C=q.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,L=q.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:Q.identifier,type:Q.type,isBuiltin:Q.isBuiltin||!!Q.metadata?.isBuiltin,location:Q.location,manifest:Q.manifest,targetPlatform:Q.targetPlatform,validations:Q.validations,isValid:Q.isValid,readmeUrl:C,changelogUrl:L,publisherDisplayName:Q.metadata?.publisherDisplayName||null,publisherId:Q.metadata?.publisherId||null,isApplicationScoped:!!Q.metadata?.isApplicationScoped,isMachineScoped:!!Q.metadata?.isMachineScoped,isPreReleaseVersion:!!Q.metadata?.isPreReleaseVersion,preRelease:!!Q.metadata?.preRelease,installedTimestamp:Q.metadata?.installedTimestamp,updated:!!Q.metadata?.updated,pinned:!!Q.metadata?.pinned}}async G(){const Q=await this.getUninstalledExtensions();if(Object.keys(Q).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(Q));const q=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),C=new Set;for(const B of q)Q[i.$Bo.create(B).toString()]||C.add(B.identifier.id.toLowerCase());try{const B=(0,i.$Go)(q,N=>N.identifier);await D.Promises.settled(B.map(async N=>{const W=N.sort((G,ie)=>$.rcompare(G.manifest.version,ie.manifest.version))[0];C.has(W.identifier.id.toLowerCase())||await this.j(await this.F(W))}))}catch(B){this.u.error(B)}const L=q.filter(B=>B.metadata&&Q[i.$Bo.create(B).toString()]);await Promise.allSettled(L.map(B=>this.removeUninstalledExtension(B)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let Q;try{Q=await this.m.resolve(this.n.userExtensionsLocation)}catch(q){(0,T.$qk)(q)!==1&&this.u.error(q);return}if(Q?.children)try{await Promise.allSettled(Q.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(H))){this.u.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.m.del(q.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(C){(0,T.$qk)(C)!==1&&this.u.error(C)}}}))}catch{}}};e.$Lp=J,e.$Lp=J=ye([Y(1,T.$_j),Y(2,r.$zp),Y(3,t.$vp),Y(4,X.$Jk),Y(5,U.$$i)],J);class V extends a.$tp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,p.$Ff)(this.options.operation)?this.l:this.options.operation}constructor(Q,q,C,L,B,N,W,G,ie){super(),this.identifier=Q,this.source=q,this.options=C,this.m=L,this.n=B,this.o=N,this.p=W,this.q=G,this.s=ie,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(Q){const[q,C]=await this.x(Q);return this.j=q.isBuiltin||q.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[q,C]],this.j),q}async u({zipPath:Q,key:q,metadata:C},L,B){let N=await this.v(q);return N||(this.s.trace("Extracting extension...",q.id),N=await this.m.extractUserExtension(q,Q,C,L,B),this.s.info("Extracting extension completed.",q.id)),N}async v(Q){return await this.w(Q)?(this.s.trace("Removing the extension from uninstalled list:",Q.id),await this.m.setInstalled(Q),this.s.info("Removed the extension from uninstalled list:",Q.id),(await this.m.scanAllUserExtensions(!0)).find(L=>i.$Bo.create(L).equals(Q))):void 0}async w(Q){return!!(await this.m.getUninstalledExtensions())[Q.toString()]}}class ee extends V{constructor(Q,q,C,L,B,N,W,G,ie,oe){super(q.identifier,q,C,B,N,W,G,ie,oe),this.y=q,this.z=L}async x(Q){const C=(await this.m.scanExtensions(null,this.options.profileLocation)).find(W=>(0,i.$Ao)(W.identifier,this.y.identifier));C&&(this.l=3);const L={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||C?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||C?.isMachineScoped,isBuiltin:this.options.isBuiltin||C?.isBuiltin,isSystem:C?.type===0?!0:void 0,updated:!!C,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,p.$Ef)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:C?.preRelease)};if(C?.manifest.version===this.y.version)return[await this.m.updateMetadata(C,L),L];const{location:B,verificationStatus:N}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=N,this.B(B.fsPath),[await this.u({zipPath:B.fsPath,key:i.$Bo.create(this.y),metadata:L},!1,Q),L]}catch(W){try{await this.z.delete(B)}catch(G){this.s.warn("Error while deleting the downloaded file",B.toString(),(0,I.$9)(G))}throw W}}async B(Q){try{await(0,y.$Gp)(Q)}catch(q){throw new n.$_n((0,a.$rp)(q).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Mp=ee;class ne extends V{constructor(Q,q,C,L,B,N,W,G,ie,oe){super({id:(0,i.$Fo)(Q.publisher,Q.name)},q,C,B,N,W,G,ie,oe),this.y=Q,this.z=q,this.A=L}async h(Q){const q=await super.h(Q);return this.D(q,Q),q}async x(Q){const q=new i.$Bo(this.identifier,this.y.version),L=(await this.m.scanExtensions(1,this.options.profileLocation)).find(W=>(0,i.$Ao)(this.identifier,W.identifier)),B={isApplicationScoped:this.options.isApplicationScoped||L?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||L?.isMachineScoped,isBuiltin:this.options.isBuiltin||L?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(L)if(this.l=3,q.equals(new i.$Bo(L.identifier,L.manifest.version)))try{await this.m.removeExtension(L,"existing")}catch{throw new Error(m.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&$.gt(L.manifest.version,this.y.version)&&await this.m.setUninstalled(L);else{const W=await this.v(q);if(W)try{await this.m.removeExtension(W,"existing")}catch{throw new Error(m.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:b.$jc(this.z.fsPath),key:q,metadata:B},!0,Q),B]}async D(Q,q){try{let[C]=await this.A.getExtensions([{id:Q.identifier.id,version:Q.manifest.version}],q);if(C||([C]=await this.A.getExtensions([{id:Q.identifier.id}],q)),C){const L={id:C.identifier.uuid,publisherDisplayName:C.publisherDisplayName,publisherId:C.publisherId,isPreReleaseVersion:C.properties.isPreReleaseVersion,preRelease:C.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(Q,L,this.options.profileLocation)}}catch{}}}class _ extends a.$tp{constructor(Q,q,C){super(),this.extension=Q,this.j=q,this.k=C}async h(Q){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ae[264],ce([0,1,2,29,81,222,121,8,21]),function(te,e,D,F,j,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X9b=void 0;let d=class extends D.$Rc{constructor(E,b,l,$,p,w){super(),E.cleanUp(),(0,A.$HWb)(E,b,l,$,w),j.$Yu.removeOutdatedExtensionVersions(E,p)}};e.$X9b=d,e.$X9b=d=ye([Y(0,I.$Jp),Y(1,F.$$n),Y(2,j.$Xu),Y(3,F.$do),Y(4,S.$7o),Y(5,R.$$i)],d)}),define(ae[122],ce([0,1,71,63,36,274,15,7,3,2,16,5,32,40,67]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=void 0;class p{traceSocketEvent(h,g){$.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,h,g)}constructor(h,g=""){this.f=!0,this.debugLabel=g,this.socket=h,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,R.$Z)(O)}},this.socket.on("error",this.a),this.b=O=>{this.traceSocketEvent("close",{hadError:O}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(h){const g=O=>{this.traceSocketEvent("read",O),h(I.$be.wrap(O))};return this.socket.on("data",g),{dispose:()=>this.socket.off("data",g)}}onClose(h){const g=O=>{h({type:0,hadError:O,error:void 0})};return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(h){const g=()=>{h()};return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(h){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",h),this.socket.write(h.buffer,g=>{if(g){if(g.code==="EPIPE")return;(0,R.$Z)(g)}})}catch(g){if(g.code==="EPIPE")return;(0,R.$Z)(g)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((h,g)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),h();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),h()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.$Fh=p;var w;(function(y){y[y.MinHeaderByteSize=2]="MinHeaderByteSize",y[y.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var c;(function(y){y[y.PeekHeader=1]="PeekHeader",y[y.ReadHeader=2]="ReadHeader",y[y.ReadBody=3]="ReadBody",y[y.Fin=4]="Fin"})(c||(c={}));class u extends d.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(h,g){this.socket.traceSocketEvent(h,g)}constructor(h,g,O,T){super(),this.f=this.B(new S.$Nd),this.g=this.B(new S.$Nd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=h,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:g,inflateBytesLength:O?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new f(this,g,O,T,this.f,(M,U)=>this.m(M,U))),this.B(this.a.onError(M=>{console.error(M),(0,R.$Z)(M),this.g.fire({type:0,hadError:!0,error:M})})),this.b=new $.$Ah,this.B(this.socket.onData(M=>this.n(M))),this.B(this.socket.onClose(async M=>{this.a.isProcessingReadQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(M)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this.f.event(h)}onClose(h){return this.g.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){let g=0;for(;g<h.byteLength;)this.a.writeMessage(h.slice(g,Math.min(g+262144,h.byteLength)),{compressed:!0,opcode:2}),g+=262144}m(h,{compressed:g,opcode:O}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",h);let T=2;h.byteLength<126?T+=0:h.byteLength<2**16?T+=2:T+=8;const M=I.$be.alloc(T),U=g?64:0,z=O&15;if(M.writeUInt8(128|U|z,0),h.byteLength<126)M.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){M.writeUInt8(126,1);let Z=1;M.writeUInt8(h.byteLength>>>8&255,++Z),M.writeUInt8(h.byteLength>>>0&255,++Z)}else{M.writeUInt8(127,1);let Z=1;M.writeUInt8(0,++Z),M.writeUInt8(0,++Z),M.writeUInt8(0,++Z),M.writeUInt8(0,++Z),M.writeUInt8(h.byteLength>>>24&255,++Z),M.writeUInt8(h.byteLength>>>16&255,++Z),M.writeUInt8(h.byteLength>>>8&255,++Z),M.writeUInt8(h.byteLength>>>0&255,++Z)}this.socket.write(I.$be.concat([M,h]))}end(){this.h=!0,this.socket.end()}n(h){if(h.byteLength!==0){for(this.b.acceptChunk(h);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const g=this.b.peek(this.j.readLen),O=g.readUInt8(0),T=(O&128)>>>7,M=(O&64)>>>6,U=O&15,z=g.readUInt8(1),Z=(z&128)>>>7,X=z&127;this.j.state=2,this.j.readLen=2+(Z?4:0)+(X===126?2:0)+(X===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!M),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.j.opcode=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const g=this.b.read(this.j.readLen),O=g.readUInt8(1),T=(O&128)>>>7;let M=O&127,U=1;M===126?M=g.readUInt8(++U)*2**8+g.readUInt8(++U):M===127&&(M=g.readUInt8(++U)*0+g.readUInt8(++U)*0+g.readUInt8(++U)*0+g.readUInt8(++U)*0+g.readUInt8(++U)*2**24+g.readUInt8(++U)*2**16+g.readUInt8(++U)*2**8+g.readUInt8(++U));let z=0;T&&(z=g.readUInt8(++U)*2**24+g.readUInt8(++U)*2**16+g.readUInt8(++U)*2**8+g.readUInt8(++U)),this.j.state=3,this.j.readLen=M,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const g=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",g),s(g,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",g),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(g,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(g,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Gh=u;class f extends d.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.$be.alloc(0)}constructor(h,g,O,T,M,U){super(),this.n=h,this.r=M,this.s=U,this.a=this.B(new S.$Nd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new S.$Nd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new S.$Nd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,g?(this.b=this.B(new m(this.n,T,O,{windowBits:15})),this.f=this.B(new k(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(h,g){this.g.push({data:h,options:g}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:h,options:g}=this.g.shift();if(this.f&&g.compressed){const O=await this.w(this.f,h);this.s(O,g)}else this.s(h,{...g,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(h,g){return new Promise((O,T)=>{h.write(g),h.flush(M=>O(M))})}acceptFrame(h,g,O){this.h.push({data:h,isCompressed:g,isLastFrameOfMessage:O}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const h=this.h.shift();if(this.b&&h.isCompressed){const g=await this.C(this.b,h.data,h.isLastFrameOfMessage);this.r.fire(g)}else this.r.fire(h.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(h,g,O){return new Promise((T,M)=>{h.write(g),O&&h.write(I.$be.fromByteArray([0,0,255,255])),h.flush(U=>T(U))})}}class m extends d.$Rc{get recordedInflateBytes(){return this.j?I.$be.concat(this.f):I.$be.alloc(0)}constructor(h,g,O,T){super(),this.h=h,this.j=g,this.a=this.B(new S.$Nd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(T),this.b.on("error",M=>{this.h.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.h.traceSocketEvent("zlibInflateData",M),this.g.push(I.$be.wrap(M))}),O&&(this.h.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this.b.write(O.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(h){this.j&&this.f.push(h.clone()),this.h.traceSocketEvent("zlibInflateWrite",h),this.b.write(h.buffer)}flush(h){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const g=I.$be.concat(this.g);this.g.length=0,h(g)})}}class k extends d.$Rc{constructor(h,g){super(),this.g=h,this.a=this.B(new S.$Nd),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",O=>{this.g.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.g.traceSocketEvent("zlibDeflateData",O),this.f.push(I.$be.wrap(O))})}write(h){this.g.traceSocketEvent("zlibDeflateWrite",h.buffer),this.b.write(h.buffer)}flush(h){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let g=I.$be.concat(this.f);this.f.length=0,g=g.slice(0,g.byteLength-4),h(g)})}}function s(y,h){if(h===0)return;const g=y.byteLength>>>2;for(let Z=0;Z<g;Z++){const X=y.readUInt32BE(Z*4);y.writeUInt32BE(X^h,Z*4)}const O=g*4,T=y.byteLength-O,M=h>>>24&255,U=h>>>16&255,z=h>>>8&255;T>=1&&y.writeUInt8(y.readUInt8(O)^M,O),T>=2&&y.writeUInt8(y.readUInt8(O+1)^U,O+1),T>=3&&y.writeUInt8(y.readUInt8(O+2)^z,O+2)}e.$Hh=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function n(){const y=(0,b.$eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${y}-sock`;const h=process.platform!=="darwin"&&e.$Hh?e.$Hh:(0,j.tmpdir)(),g=(0,P.$ic)(h,`vscode-ipc-${y}.sock`);return t(g),g}e.$Ih=n;function i(y,h,g){const O=(0,D.createHash)("md5").update(y).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${g}-${h}-sock`;const T=g.substr(0,4),M=h.substr(0,6),U=O.substr(0,8);let z;return process.platform!=="darwin"&&e.$Hh&&!process.env.VSCODE_PORTABLE?z=(0,P.$ic)(e.$Hh,`vscode-${U}-${T}-${M}.sock`):z=(0,P.$ic)(y,`${T}-${M}.sock`),t(z),z}e.$Jh=i;function t(y){const h=a[E.$u];typeof h=="number"&&y.length>=h&&console.warn(`WARNING: IPC handle "${y}" is longer than ${h} chars, try a shorter --user-data-dir`)}class r extends l.$uh{static b(h){const g=S.Event.fromNodeEventEmitter(h,"connection");return S.Event.map(g,O=>({protocol:new $.$Bh(new p(O,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(O,"close"))}))}constructor(h){super(r.b(h)),this.d=h}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Kh=r;function o(y){return new Promise((h,g)=>{const O=(0,F.createServer)();O.on("error",g),O.listen(y,()=>{O.removeListener("error",g),h(new r(O))})})}e.$Lh=o;function v(y,h){return new Promise((g,O)=>{const T=(0,F.createConnection)(y,()=>{T.removeListener("error",O),g($.$Ch.fromSocket(new p(T,`ipc-client${h}`),h))});T.once("error",O)})}e.$Mh=v}),define(ae[265],ce([0,1,63,122,210]),function(te,e,D,F,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$79b=void 0,e.$79b=new class{supports(A){return!0}connect({host:A,port:I},R,S,d){return new Promise((P,E)=>{const b=D.createConnection({host:A,port:I},()=>{b.removeListener("error",E),b.write((0,j.$Tpb)(R,S,d));const l=$=>{$.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",l),P(new F.$Fh(b,d)))};b.on("data",l)});b.setNoDelay(!0),b.once("error",E)})}}}),define(ae[266],ce([0,1,63,36,132,122,6,2,5,20,8,25,213,104,106,77,15]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$38b=e.$28b=e.$18b=e.$Z8b=void 0;async function c(s,a,n,i,t){let r;for(let o=3;o&&(r?.dispose(),r=await new u(s,a,n,i,t).waitForReady(),!(t&&j.$hg[t]||!j.$hg[r.tunnelLocalPort]));o--);return r}class u extends R.$Rc{constructor(a,n,i,t,r){super(),this.m=n,this.n=r,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=a,this.b=D.createServer(),this.c=new I.$Sg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.r(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const a=this.n??this.tunnelRemotePort,n=(0,p.$fv)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,j.$ig)(a,2,1e3,n),t=null;return this.b.listen(i,this.m),await this.c.wait(),t=this.b.address(),t||(i=0,this.b.listen(i,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(a){a.pause();const n=(0,p.$dv)(this.tunnelRemoteHost)||(0,p.$fv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,b.$7k)(this.a,n,this.tunnelRemotePort),t=i.getSocket(),r=i.readEntireBuffer();i.dispose(),r.byteLength>0&&a.write(r.buffer),a.on("end",()=>{a.localAddress&&this.j.delete(a.localAddress),t.end()}),a.on("close",()=>t.end()),a.on("error",()=>{a.localAddress&&this.j.delete(a.localAddress),t instanceof A.$Fh?t.socket.destroy():t.end()}),t instanceof A.$Fh?this.t(a,t):this.s(a,t),a.localAddress&&this.j.set(a.localAddress,()=>{a.end(),t.end()})}s(a,n){n.onClose(()=>a.destroy()),n.onEnd(()=>a.end()),n.onData(i=>a.write(i.buffer)),a.on("data",i=>n.write(w.$be.wrap(i))),a.resume()}t(a,n){const i=n.socket;i.on("end",()=>a.end()),i.on("close",()=>a.end()),i.on("error",()=>{a.destroy()}),i.pipe(a),a.pipe(i)}}e.$Z8b=u;let f=class extends p.$iv{constructor(a,n,i,t,r){super(n,r),this.u=a,this.v=i,this.w=t}isPortPrivileged(a){return(0,p.$gv)(a,this.l,S.OS,F.release())}s(a,n,i,t,r,o,v,y){const h=this.r(n,i);if(h)return++h.refcount,h.value;if((0,p.$av)(a))return this.t(a,n,i,r,o,v,y);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${i} on local port ${r}.`);const g={commit:this.w.commit,quality:this.w.quality,addressProvider:a,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},O=c(g,t,n,i,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(n,i,O),O}}};e.$18b=f,e.$18b=f=ye([Y(0,l.$1k),Y(1,P.$$i),Y(2,$.$4k),Y(3,E.$qj),Y(4,d.$ki)],f);let m=class extends f{constructor(a,n,i,t,r){super(a,n,i,t,r)}};e.$28b=m,e.$28b=m=ye([Y(0,l.$1k),Y(1,P.$$i),Y(2,$.$4k),Y(3,E.$qj),Y(4,d.$ki)],m);let k=class extends R.$Rc{constructor(a,n,i,t,r){super(),this.b=a,this.c=n,this.f=i,this.g=t,this.h=r,this.a=new Map}async openTunnel(a,n,i,t,r,o,v,y,h){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${t} on local port ${o}.`),!this.a.has(a)){const g=new m(this.b,this.c,this.g,this.f,this.h);this.B(g),this.a.set(a,g),g.onTunnelClosed(async()=>{(await g.tunnels).length===0&&(g.dispose(),this.a.delete(a))})}return this.a.get(a).openTunnel(n,i,t,r,o,v,y,h)}};e.$38b=k,e.$38b=k=ye([Y(0,l.$1k),Y(1,P.$$i),Y(2,E.$qj),Y(3,$.$4k),Y(4,d.$ki)],k)}),define(ae[275],ce([0,1,36,38,7,2,23,10,18,3,40,146,204,205,195,196,261,186,188,20,209,95,220,96,215,14,113,246,29,97,187,121,98,11,198,199,70,4,194,72,73,225,8,200,102,25,58,21,107,22,108,109,110,45,228,81,111,24,79,253,238,239,82,252,256,257,258,59,251,240,106,219,77,266,214,229,28,230,5,231,189,207,206,80,245,17,51,203,57,250,227,241,105,255,264,9,201,101,248,244,216,183,56,202,259,247,55,249,104,265,181,217]),function(te,e,D,F,j,A,I,R,S,d,P,E,b,l,$,p,w,c,u,f,m,k,s,a,n,i,t,r,o,v,y,h,g,O,T,M,U,z,Z,X,x,H,K,J,V,ee,ne,_,se,Q,q,C,L,B,N,W,G,ie,oe,ue,he,$e,de,we,ve,Ie,Le,Me,le,ge,be,Se,Ce,Ue,je,qe,Te,re,fe,me,pe,ke,Re,Pe,De,Oe,Ne,Fe,Be,ze,Ve,_e,ut,pt,vt,Et,kt,ft,St,Pt,Ct,Rt,It,Dt,Ot,jt,dt,At,$t,Nt,Lt,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ft extends A.$Rc{constructor(Ee){super(),this.f=Ee,this.a=this.B(new E.$WT(this)),this.b=void 0,this.c=this.B(new d.$Nd),this.g()}g(){let Ee=!1;const Ae=()=>{Ee||(Ee=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ae),(0,E.$XT)(process.parentPort,it.$c8b.exit,Ae)}async init(){const Ee=await this.h();(0,ie.$8gb)(),Ee.invokeFunction(Ae=>{const Qe=Ae.get(K.$$i),We=Ae.get(Q.$dl),Xe=Ae.get(Oe.$Lk);Qe.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Ae),this.m(Qe),this.n(We,Xe),this.B(Xe.onDidChangeProfiles(()=>this.n(We,Xe)))}),this.B((0,A.$Oc)(Ee.createInstance(b.$t9b,this.f.codeCachePath),Ee.createInstance(l.$u9b),Ee.createInstance(w.$x9b),Ee.createInstance(p.$w9b),Ee.createInstance($.$v9b),Ee.createInstance(vt.$X9b),Ee.createInstance(_e.$P9b)))}async h(){const Ee=new X.$Oh,Ae={_serviceBrand:void 0,...V.default};Ee.set(ee.$qj,Ae);const Qe=new P.$yh(He=>He==="main"),We=new dt.$08b(this.a,Qe);Ee.set(dt.$98b,We);const Xe=this.f.policiesData?new Fe.$F8b(this.f.policiesData,We.getChannel("policy")):new Be.$ln;Ee.set(Be.$jn,Xe);const Ge=new Lt.$km(this.f.args,Ae);Ee.set(i.$Yh,Ge);const xe=new J.$_q(void 0,this.f.logLevel,Ge.logsHome,this.f.loggers.map(He=>({...He,resource:R.URI.revive(He.resource)})),We.getChannel("logger"));Ee.set(K.$_i,xe);const st=this.B(xe.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),ct=this.B(new K.$gj(st.getLevel())),Je=this.B(new kt.$RN(st,[ct]));Ee.set(K.$$i,Je),this.b=this.B(new ft.$Z9b(Je)),Ee.set(ft.$Y9b,this.b);const Ke=this.B(new T.$Op(Je));Ee.set(O.$_j,Ke);const lt=this.B(new M.$bq(Je));Ke.registerProvider(I.Schemas.file,lt);const rt=new re.$Ar(Ke);Ee.set(Te.$Jk,rt);const Ye=this.B(new ze.$YN(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),We.getChannel("userDataProfiles")));Ee.set(Oe.$Lk,Ye);const ht=this.B(new me.$88b(I.Schemas.file,this.B(new pe.$AN(We.getChannel(pe.$zN),{pathCaseSensitive:fe.$l})),I.Schemas.vscodeUserData,Ye,rt,Je));Ke.registerProvider(I.Schemas.vscodeUserData,ht);const Ze=this.B(new m.$Ln(Ye.defaultProfile.settingsResource,Ke,Xe,Je));Ee.set(f.$ki,Ze);const et=new At.$69b(void 0,{defaultProfile:Ye.defaultProfile,currentProfile:Ye.defaultProfile},We,Ge);Ee.set(_.$7o,et),this.B((0,A.$Pc)(()=>et.flush())),await Promise.all([Ze.initialize(),et.initialize()]);const mt=new Ct.$Xq(We.getChannel("request"));Ee.set(ne.$To,mt),Ee.set(c.$y9b,new U.$Nh(u.$z9b,void 0,!1)),Ee.set(Re.$$E,new U.$Nh(ke.$O9b,void 0,!1));const bt=new Dt.$c9b(-1,We);Ee.set(It.$U7b,bt),Ee.set(a.$Pn,new U.$Nh(n.$7N,void 0,!0));const Tt=this.B(new ge.$C8b(bt)),Mt=new P.$yh(He=>Tt.getActiveClientId().then(at=>He===at));Ee.set(g.$rWb,new Rt.$29b(this.a.getChannel("extensionRecommendationNotification",Mt)));let ot;const tt=[],wt=(0,B.$xo)(Ae,Ze);if((0,B.$so)(Ae,Ge)){const He=new C.$D5b(Je,xe,Ge,Ae);if(tt.push(He),!(0,B.$to)(Ae,Ge)&&Ae.aiConfig?.ariaKey){const at=new Ve.$FN(mt,wt,"monacoworkbench",null,Ae.aiConfig.ariaKey);this.B((0,A.$Pc)(()=>at.flush())),tt.push(at)}ot=new L.$2q({appenders:tt,commonProperties:(0,se.$io)((0,D.release)(),(0,D.hostname)(),process.arch,Ae.commit,Ae.version,this.f.machineId,this.f.sqmId,wt),sendErrorTelemetry:!0,piiPaths:(0,B.$yo)(Ge)},Ze,Ae)}else{ot=B.$mo;const He=B.$qo;tt.push(He)}this.a.registerChannel("telemetryAppender",new q.$h8b(tt)),Ee.set(Q.$dl,ot);const Ut=new N.$A9b(Ze,ot,Je,xe,Ge,Ae);Ee.set(Q.$el,Ut),Ee.set(Ne.$vp,new U.$Nh(Pt.$QN,void 0,!0)),Ee.set(Pe.$zp,new U.$Nh(De.$G8b,void 0,!0)),Ee.set(v.$fp,new U.$Nh(v.$gp,void 0,!0)),Ee.set(h.$Jp,new U.$Nh(h.$Kp,void 0,!0)),Ee.set(o.$$n,new U.$Nh(r.$dp,void 0,!0)),Ee.set(o.$eo,new U.$Nh(jt.$59b,void 0,!1)),Ee.set(x.$Tq,new U.$Nh(H.$Vq,void 0,!1)),Ee.set(k.$rm,new U.$Nh(s.$Hr,void 0,!1)),Ee.set(oe.$fDb,new U.$Nh(oe.$gDb,void 0,!0)),Ee.set(ie.$qhb,new U.$Nh($e.$sFb,void 0,!0)),Ee.set(ie.$phb,new he.$D9b(this.a.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),Ee.set(o.$do,new U.$Nh(t.$dDb,void 0,!1)),Ee.set(G.$qFb,new U.$Nh(G.$rFb,void 0,!0)),Ee.set(W.$Xu,new U.$Nh(W.$Yu)),Ee.set(ie.$ahb,new U.$Nh(Le.$BEb,void 0,!0)),Ee.set(ie.$bhb,new U.$Nh(Le.$DEb,void 0,!0)),Ee.set(de.$1gb,new U.$Nh(de.$3gb,void 0,!0)),Ee.set(ie.$chb,new U.$Nh(ue.$f6b,void 0,!1)),Ee.set(ie.$lhb,new U.$Nh(we.$75b,void 0,!0)),Ee.set(ie.$mhb,new U.$Nh(ve.$k6b,void 0,!1)),Ee.set(Me.$RDb,new U.$Nh(le.$K9b,void 0,!0)),Ee.set(ie.$nhb,new U.$Nh(pt.$V6b,void 0,!0)),Ee.set(be.$4k,new U.$Nh(Se.$58b,void 0,!1));const yt=new $t.$2k;return Ee.set($t.$1k,yt),yt.register(0,Nt.$79b),Ee.set(Ce.$_u,new U.$Nh(Ue.$38b)),Ee.set(je.$L9b,new U.$Nh(qe.$N9b)),Ee.set(ut.$Q9b,new U.$Nh(St.$19b)),new Z.$eq(Ee)}j(Ee){const Ae=this.B(new A.$Qc),Qe=new y.$ip(Ee.get(o.$ao),()=>null);this.a.registerChannel("extensions",Qe);const We=P.ProxyChannel.fromService(Ee.get(x.$Tq),Ae);this.a.registerChannel("languagePacks",We);const Xe=P.ProxyChannel.fromService(Ee.get(k.$rm),Ae);this.a.registerChannel("diagnostics",Xe);const Ge=new y.$kp(Ee.get(o.$eo));this.a.registerChannel("extensionTipsService",Ge);const xe=P.ProxyChannel.fromService(Ee.get(c.$y9b),Ae);this.a.registerChannel("checksum",xe);const st=P.ProxyChannel.fromService(Ee.get(Re.$$E),Ae);this.a.registerChannel("v8InspectProfiling",st);const ct=new he.$E9b(Ee.get(de.$1gb));this.a.registerChannel("userDataSyncMachines",ct);const Je=P.ProxyChannel.fromService(Ee.get(Q.$el),Ae);this.a.registerChannel("customEndpointTelemetry",Je);const Ke=new he.$F9b(Ee.get(oe.$fDb));this.a.registerChannel("userDataSyncAccount",Ke);const lt=new he.$G9b(Ee.get(ie.$ahb));this.a.registerChannel("userDataSyncStoreManagement",lt);const rt=new Ie.$I9b(Ee.get(ie.$mhb),Ee.get(Oe.$Lk),Ee.get(K.$$i));this.a.registerChannel("userDataSync",rt);const Ye=this.B(Ee.get(z.$Ph).createInstance(Ot.$49b)),ht=new he.$B9b(Ye);this.a.registerChannel("userDataAutoSync",ht),this.a.registerChannel("IUserDataSyncResourceProviderService",P.ProxyChannel.fromService(Ee.get(ie.$nhb),Ae));const Ze=P.ProxyChannel.fromService(Ee.get(je.$L9b),Ae);this.a.registerChannel(je.$M9b,Ze);const et=P.ProxyChannel.fromService(Ee.get(ut.$Q9b),Ae);this.a.registerChannel("remoteTunnel",et)}m(Ee){process.on("uncaughtException",Ae=>(0,j.$Z)(Ae)),process.on("unhandledRejection",Ae=>(0,j.$Z)(Ae)),(0,j.setUnexpectedErrorHandler)(Ae=>{const Qe=(0,F.$Bi)(Ae,!0);Qe&&Ee.error(`[uncaught exception in sharedProcess]: ${Qe}`)})}n(Ee,Ae){Ee.publicLog2("profilesInfo",{count:Ae.profiles.length})}handledClientConnection(Ee){if(Ee.data!==it.$e8b.response)return!1;const Ae=(0,S.$Nb)(Ee.ports);return Ae?(this.c.fire(Ae),!0):!1}}async function gt(nt){const Ee=new Ft(nt);process.parentPort.postMessage(it.$c8b.ipcReady),await Ee.init(),process.parentPort.postMessage(it.$c8b.initDone)}e.main=gt,process.parentPort.once("message",nt=>{gt(nt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c97d74fba0df6c8da3e0e469a4f37c4ed9612682/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
